/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/sharedGalleryImagesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a SharedGalleryImages. */
var SharedGalleryImages = /** @class */ (function () {
    /**
     * Create a SharedGalleryImages.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    function SharedGalleryImages(client) {
        this.client = client;
    }
    SharedGalleryImages.prototype.list = function (location, galleryUniqueName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            galleryUniqueName: galleryUniqueName,
            options: options
        }, listOperationSpec, callback);
    };
    SharedGalleryImages.prototype.get = function (location, galleryUniqueName, galleryImageName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            galleryUniqueName: galleryUniqueName,
            galleryImageName: galleryImageName,
            options: options
        }, getOperationSpec, callback);
    };
    SharedGalleryImages.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return SharedGalleryImages;
}());
export { SharedGalleryImages };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/sharedGalleries/{galleryUniqueName}/images",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.location0,
        Parameters.galleryUniqueName
    ],
    queryParameters: [
        Parameters.apiVersion3,
        Parameters.sharedTo
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SharedGalleryImageList
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/sharedGalleries/{galleryUniqueName}/images/{galleryImageName}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.location0,
        Parameters.galleryUniqueName,
        Parameters.galleryImageName
    ],
    queryParameters: [
        Parameters.apiVersion3
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SharedGalleryImage
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion3,
        Parameters.sharedTo
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SharedGalleryImageList
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=sharedGalleryImages.js.map