import * as msRest from "@azure/ms-rest-js";
import { TokenCredential } from "@azure/core-auth";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { KeyVaultManagementClientContext } from "./keyVaultManagementClientContext";
declare class KeyVaultManagementClient extends KeyVaultManagementClientContext {
    vaults: operations.Vaults;
    operations: operations.Operations;
    /**
     * Initializes a new instance of the KeyVaultManagementClient class.
     * @param credentials Credentials needed for the client to connect to Azure. Credentials
     * implementing the TokenCredential interface from the @azure/identity package are recommended. For
     * more information about these credentials, see
     * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
     * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
     * @azure/ms-rest-browserauth are also supported.
     * @param subscriptionId Subscription credentials which uniquely identify Microsoft Azure
     * subscription. The subscription ID forms part of the URI for every service call.
     * @param [options] The parameter options
     */
    constructor(credentials: msRest.ServiceClientCredentials | TokenCredential, subscriptionId: string, options?: Models.KeyVaultManagementClientOptions);
}
export { KeyVaultManagementClient, KeyVaultManagementClientContext, Models as KeyVaultManagementModels, Mappers as KeyVaultManagementMappers };
export * from "./operations";
//# sourceMappingURL=keyVaultManagementClient.d.ts.map