/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@azure/ms-rest-azure-js'), require('@azure/ms-rest-js')) :
    typeof define === 'function' && define.amd ? define(['exports', '@azure/ms-rest-azure-js', '@azure/ms-rest-js'], factory) :
    (factory((global.Azure = global.Azure || {}, global.Azure.ArmLocks = {}),global.msRestAzure,global.msRest));
}(this, (function (exports,msRestAzure,msRest) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var index = /*#__PURE__*/Object.freeze({

    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */
    var CloudError = msRestAzure.CloudErrorMapper;
    var BaseResource = msRestAzure.BaseResourceMapper;
    var ManagementLockOwner = {
        serializedName: "ManagementLockOwner",
        type: {
            name: "Composite",
            className: "ManagementLockOwner",
            modelProperties: {
                applicationId: {
                    serializedName: "applicationId",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ManagementLockObject = {
        serializedName: "ManagementLockObject",
        type: {
            name: "Composite",
            className: "ManagementLockObject",
            modelProperties: {
                level: {
                    required: true,
                    serializedName: "properties.level",
                    type: {
                        name: "String"
                    }
                },
                notes: {
                    serializedName: "properties.notes",
                    type: {
                        name: "String"
                    }
                },
                owners: {
                    serializedName: "properties.owners",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ManagementLockOwner"
                            }
                        }
                    }
                },
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var OperationDisplay = {
        serializedName: "Operation_display",
        type: {
            name: "Composite",
            className: "OperationDisplay",
            modelProperties: {
                provider: {
                    serializedName: "provider",
                    type: {
                        name: "String"
                    }
                },
                resource: {
                    serializedName: "resource",
                    type: {
                        name: "String"
                    }
                },
                operation: {
                    serializedName: "operation",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var Operation = {
        serializedName: "Operation",
        type: {
            name: "Composite",
            className: "Operation",
            modelProperties: {
                name: {
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                display: {
                    serializedName: "display",
                    type: {
                        name: "Composite",
                        className: "OperationDisplay"
                    }
                }
            }
        }
    };
    var OperationListResult = {
        serializedName: "OperationListResult",
        type: {
            name: "Composite",
            className: "OperationListResult",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "Operation"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ManagementLockListResult = {
        serializedName: "ManagementLockListResult",
        type: {
            name: "Composite",
            className: "ManagementLockListResult",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ManagementLockObject"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };

    var mappers = /*#__PURE__*/Object.freeze({
        CloudError: CloudError,
        BaseResource: BaseResource,
        ManagementLockOwner: ManagementLockOwner,
        ManagementLockObject: ManagementLockObject,
        OperationDisplay: OperationDisplay,
        Operation: Operation,
        OperationListResult: OperationListResult,
        ManagementLockListResult: ManagementLockListResult
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers = /*#__PURE__*/Object.freeze({
        CloudError: CloudError,
        Operation: Operation,
        OperationDisplay: OperationDisplay,
        OperationListResult: OperationListResult
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var acceptLanguage = {
        parameterPath: "acceptLanguage",
        mapper: {
            serializedName: "accept-language",
            defaultValue: 'en-US',
            type: {
                name: "String"
            }
        }
    };
    var apiVersion = {
        parameterPath: "apiVersion",
        mapper: {
            required: true,
            serializedName: "api-version",
            type: {
                name: "String"
            }
        }
    };
    var filter = {
        parameterPath: [
            "options",
            "filter"
        ],
        mapper: {
            serializedName: "$filter",
            type: {
                name: "String"
            }
        }
    };
    var lockName = {
        parameterPath: "lockName",
        mapper: {
            required: true,
            serializedName: "lockName",
            type: {
                name: "String"
            }
        }
    };
    var nextPageLink = {
        parameterPath: "nextPageLink",
        mapper: {
            required: true,
            serializedName: "nextLink",
            type: {
                name: "String"
            }
        },
        skipEncoding: true
    };
    var parentResourcePath = {
        parameterPath: "parentResourcePath",
        mapper: {
            required: true,
            serializedName: "parentResourcePath",
            type: {
                name: "String"
            }
        },
        skipEncoding: true
    };
    var resourceGroupName = {
        parameterPath: "resourceGroupName",
        mapper: {
            required: true,
            serializedName: "resourceGroupName",
            constraints: {
                MaxLength: 90,
                MinLength: 1,
                Pattern: /^[-\w\._\(\)]+$/
            },
            type: {
                name: "String"
            }
        }
    };
    var resourceName = {
        parameterPath: "resourceName",
        mapper: {
            required: true,
            serializedName: "resourceName",
            type: {
                name: "String"
            }
        }
    };
    var resourceProviderNamespace = {
        parameterPath: "resourceProviderNamespace",
        mapper: {
            required: true,
            serializedName: "resourceProviderNamespace",
            type: {
                name: "String"
            }
        }
    };
    var resourceType = {
        parameterPath: "resourceType",
        mapper: {
            required: true,
            serializedName: "resourceType",
            type: {
                name: "String"
            }
        },
        skipEncoding: true
    };
    var scope = {
        parameterPath: "scope",
        mapper: {
            required: true,
            serializedName: "scope",
            type: {
                name: "String"
            }
        }
    };
    var subscriptionId = {
        parameterPath: "subscriptionId",
        mapper: {
            required: true,
            serializedName: "subscriptionId",
            type: {
                name: "String"
            }
        }
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a AuthorizationOperations. */
    var AuthorizationOperations = /** @class */ (function () {
        /**
         * Create a AuthorizationOperations.
         * @param {ManagementLockClientContext} client Reference to the service client.
         */
        function AuthorizationOperations(client) {
            this.client = client;
        }
        AuthorizationOperations.prototype.list = function (options, callback) {
            return this.client.sendOperationRequest({
                options: options
            }, listOperationSpec, callback);
        };
        AuthorizationOperations.prototype.listNext = function (nextPageLink$$1, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink$$1,
                options: options
            }, listNextOperationSpec, callback);
        };
        return AuthorizationOperations;
    }());
    // Operation Specifications
    var serializer = new msRest.Serializer(Mappers);
    var listOperationSpec = {
        httpMethod: "GET",
        path: "providers/Microsoft.Authorization/operations",
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: OperationListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer
    };
    var listNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: OperationListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$1 = /*#__PURE__*/Object.freeze({
        BaseResource: BaseResource,
        CloudError: CloudError,
        ManagementLockListResult: ManagementLockListResult,
        ManagementLockObject: ManagementLockObject,
        ManagementLockOwner: ManagementLockOwner
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a ManagementLocks. */
    var ManagementLocks = /** @class */ (function () {
        /**
         * Create a ManagementLocks.
         * @param {ManagementLockClientContext} client Reference to the service client.
         */
        function ManagementLocks(client) {
            this.client = client;
        }
        ManagementLocks.prototype.createOrUpdateAtResourceGroupLevel = function (resourceGroupName$$1, lockName$$1, parameters, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                lockName: lockName$$1,
                parameters: parameters,
                options: options
            }, createOrUpdateAtResourceGroupLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.deleteAtResourceGroupLevel = function (resourceGroupName$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                lockName: lockName$$1,
                options: options
            }, deleteAtResourceGroupLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.getAtResourceGroupLevel = function (resourceGroupName$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                lockName: lockName$$1,
                options: options
            }, getAtResourceGroupLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.createOrUpdateByScope = function (scope$$1, lockName$$1, parameters, options, callback) {
            return this.client.sendOperationRequest({
                scope: scope$$1,
                lockName: lockName$$1,
                parameters: parameters,
                options: options
            }, createOrUpdateByScopeOperationSpec, callback);
        };
        ManagementLocks.prototype.deleteByScope = function (scope$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                scope: scope$$1,
                lockName: lockName$$1,
                options: options
            }, deleteByScopeOperationSpec, callback);
        };
        ManagementLocks.prototype.getByScope = function (scope$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                scope: scope$$1,
                lockName: lockName$$1,
                options: options
            }, getByScopeOperationSpec, callback);
        };
        ManagementLocks.prototype.createOrUpdateAtResourceLevel = function (resourceGroupName$$1, resourceProviderNamespace$$1, parentResourcePath$$1, resourceType$$1, resourceName$$1, lockName$$1, parameters, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                resourceProviderNamespace: resourceProviderNamespace$$1,
                parentResourcePath: parentResourcePath$$1,
                resourceType: resourceType$$1,
                resourceName: resourceName$$1,
                lockName: lockName$$1,
                parameters: parameters,
                options: options
            }, createOrUpdateAtResourceLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.deleteAtResourceLevel = function (resourceGroupName$$1, resourceProviderNamespace$$1, parentResourcePath$$1, resourceType$$1, resourceName$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                resourceProviderNamespace: resourceProviderNamespace$$1,
                parentResourcePath: parentResourcePath$$1,
                resourceType: resourceType$$1,
                resourceName: resourceName$$1,
                lockName: lockName$$1,
                options: options
            }, deleteAtResourceLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.getAtResourceLevel = function (resourceGroupName$$1, resourceProviderNamespace$$1, parentResourcePath$$1, resourceType$$1, resourceName$$1, lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                resourceProviderNamespace: resourceProviderNamespace$$1,
                parentResourcePath: parentResourcePath$$1,
                resourceType: resourceType$$1,
                resourceName: resourceName$$1,
                lockName: lockName$$1,
                options: options
            }, getAtResourceLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.createOrUpdateAtSubscriptionLevel = function (lockName$$1, parameters, options, callback) {
            return this.client.sendOperationRequest({
                lockName: lockName$$1,
                parameters: parameters,
                options: options
            }, createOrUpdateAtSubscriptionLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.deleteAtSubscriptionLevel = function (lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                lockName: lockName$$1,
                options: options
            }, deleteAtSubscriptionLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.getAtSubscriptionLevel = function (lockName$$1, options, callback) {
            return this.client.sendOperationRequest({
                lockName: lockName$$1,
                options: options
            }, getAtSubscriptionLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtResourceGroupLevel = function (resourceGroupName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                options: options
            }, listAtResourceGroupLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtResourceLevel = function (resourceGroupName$$1, resourceProviderNamespace$$1, parentResourcePath$$1, resourceType$$1, resourceName$$1, options, callback) {
            return this.client.sendOperationRequest({
                resourceGroupName: resourceGroupName$$1,
                resourceProviderNamespace: resourceProviderNamespace$$1,
                parentResourcePath: parentResourcePath$$1,
                resourceType: resourceType$$1,
                resourceName: resourceName$$1,
                options: options
            }, listAtResourceLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtSubscriptionLevel = function (options, callback) {
            return this.client.sendOperationRequest({
                options: options
            }, listAtSubscriptionLevelOperationSpec, callback);
        };
        ManagementLocks.prototype.listByScope = function (scope$$1, options, callback) {
            return this.client.sendOperationRequest({
                scope: scope$$1,
                options: options
            }, listByScopeOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtResourceGroupLevelNext = function (nextPageLink$$1, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink$$1,
                options: options
            }, listAtResourceGroupLevelNextOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtResourceLevelNext = function (nextPageLink$$1, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink$$1,
                options: options
            }, listAtResourceLevelNextOperationSpec, callback);
        };
        ManagementLocks.prototype.listAtSubscriptionLevelNext = function (nextPageLink$$1, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink$$1,
                options: options
            }, listAtSubscriptionLevelNextOperationSpec, callback);
        };
        ManagementLocks.prototype.listByScopeNext = function (nextPageLink$$1, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink$$1,
                options: options
            }, listByScopeNextOperationSpec, callback);
        };
        return ManagementLocks;
    }());
    // Operation Specifications
    var serializer$1 = new msRest.Serializer(Mappers$1);
    var createOrUpdateAtResourceGroupLevelOperationSpec = {
        httpMethod: "PUT",
        path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "parameters",
            mapper: __assign(__assign({}, ManagementLockObject), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            201: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var deleteAtResourceGroupLevelOperationSpec = {
        httpMethod: "DELETE",
        path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {},
            204: {},
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var getAtResourceGroupLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var createOrUpdateByScopeOperationSpec = {
        httpMethod: "PUT",
        path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            scope,
            lockName
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "parameters",
            mapper: __assign(__assign({}, ManagementLockObject), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            201: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var deleteByScopeOperationSpec = {
        httpMethod: "DELETE",
        path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            scope,
            lockName
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {},
            204: {},
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var getByScopeOperationSpec = {
        httpMethod: "GET",
        path: "{scope}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            scope,
            lockName
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var createOrUpdateAtResourceLevelOperationSpec = {
        httpMethod: "PUT",
        path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            resourceProviderNamespace,
            parentResourcePath,
            resourceType,
            resourceName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "parameters",
            mapper: __assign(__assign({}, ManagementLockObject), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            201: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var deleteAtResourceLevelOperationSpec = {
        httpMethod: "DELETE",
        path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            resourceProviderNamespace,
            parentResourcePath,
            resourceType,
            resourceName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {},
            204: {},
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var getAtResourceLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            resourceGroupName,
            resourceProviderNamespace,
            parentResourcePath,
            resourceType,
            resourceName,
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var createOrUpdateAtSubscriptionLevelOperationSpec = {
        httpMethod: "PUT",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "parameters",
            mapper: __assign(__assign({}, ManagementLockObject), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            201: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var deleteAtSubscriptionLevelOperationSpec = {
        httpMethod: "DELETE",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {},
            204: {},
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var getAtSubscriptionLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks/{lockName}",
        urlParameters: [
            lockName,
            subscriptionId
        ],
        queryParameters: [
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockObject
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtResourceGroupLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Authorization/locks",
        urlParameters: [
            resourceGroupName,
            subscriptionId
        ],
        queryParameters: [
            filter,
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtResourceLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}/providers/Microsoft.Authorization/locks",
        urlParameters: [
            resourceGroupName,
            resourceProviderNamespace,
            parentResourcePath,
            resourceType,
            resourceName,
            subscriptionId
        ],
        queryParameters: [
            filter,
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtSubscriptionLevelOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Authorization/locks",
        urlParameters: [
            subscriptionId
        ],
        queryParameters: [
            filter,
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listByScopeOperationSpec = {
        httpMethod: "GET",
        path: "{scope}/providers/Microsoft.Authorization/locks",
        urlParameters: [
            scope
        ],
        queryParameters: [
            filter,
            apiVersion
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtResourceGroupLevelNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtResourceLevelNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listAtSubscriptionLevelNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };
    var listByScopeNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ManagementLockListResult
            },
            default: {
                bodyMapper: CloudError
            }
        },
        serializer: serializer$1
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var packageName = "@azure/arm-locks";
    var packageVersion = "1.2.1";
    var ManagementLockClientContext = /** @class */ (function (_super) {
        __extends(ManagementLockClientContext, _super);
        /**
         * Initializes a new instance of the ManagementLockClient class.
         * @param credentials Credentials needed for the client to connect to Azure. Credentials
         * implementing the TokenCredential interface from the @azure/identity package are recommended. For
         * more information about these credentials, see
         * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
         * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
         * @azure/ms-rest-browserauth are also supported.
         * @param subscriptionId The ID of the target subscription.
         * @param [options] The parameter options
         */
        function ManagementLockClientContext(credentials, subscriptionId, options) {
            var _this = this;
            if (credentials == undefined) {
                throw new Error('\'credentials\' cannot be null.');
            }
            if (subscriptionId == undefined) {
                throw new Error('\'subscriptionId\' cannot be null.');
            }
            if (!options) {
                options = {};
            }
            if (!options.userAgent) {
                var defaultUserAgent = msRestAzure.getDefaultUserAgentValue();
                options.userAgent = packageName + "/" + packageVersion + " " + defaultUserAgent;
            }
            _this = _super.call(this, credentials, options) || this;
            _this.apiVersion = '2016-09-01';
            _this.acceptLanguage = 'en-US';
            _this.longRunningOperationRetryTimeout = 30;
            _this.baseUri = options.baseUri || _this.baseUri || "https://management.azure.com";
            _this.requestContentType = "application/json; charset=utf-8";
            _this.credentials = credentials;
            _this.subscriptionId = subscriptionId;
            if (options.acceptLanguage !== null && options.acceptLanguage !== undefined) {
                _this.acceptLanguage = options.acceptLanguage;
            }
            if (options.longRunningOperationRetryTimeout !== null && options.longRunningOperationRetryTimeout !== undefined) {
                _this.longRunningOperationRetryTimeout = options.longRunningOperationRetryTimeout;
            }
            return _this;
        }
        return ManagementLockClientContext;
    }(msRestAzure.AzureServiceClient));

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var ManagementLockClient = /** @class */ (function (_super) {
        __extends(ManagementLockClient, _super);
        /**
         * Initializes a new instance of the ManagementLockClient class.
         * @param credentials Credentials needed for the client to connect to Azure. Credentials
         * implementing the TokenCredential interface from the @azure/identity package are recommended. For
         * more information about these credentials, see
         * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
         * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
         * @azure/ms-rest-browserauth are also supported.
         * @param subscriptionId The ID of the target subscription.
         * @param [options] The parameter options
         */
        function ManagementLockClient(credentials, subscriptionId, options) {
            var _this = _super.call(this, credentials, subscriptionId, options) || this;
            _this.authorizationOperations = new AuthorizationOperations(_this);
            _this.managementLocks = new ManagementLocks(_this);
            return _this;
        }
        return ManagementLockClient;
    }(ManagementLockClientContext));

    exports.ManagementLockClient = ManagementLockClient;
    exports.ManagementLockClientContext = ManagementLockClientContext;
    exports.ManagementLockModels = index;
    exports.ManagementLockMappers = mappers;
    exports.AuthorizationOperations = AuthorizationOperations;
    exports.ManagementLocks = ManagementLocks;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=arm-locks.js.map
