/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
export var acceptLanguage = {
    parameterPath: "acceptLanguage",
    mapper: {
        serializedName: "accept-language",
        defaultValue: 'en-US',
        type: {
            name: "String"
        }
    }
};
export var apiVersion0 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "api-version",
        defaultValue: '2021-02-01',
        type: {
            name: "String"
        }
    }
};
export var apiVersion1 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "api-version",
        defaultValue: '2018-10-01',
        type: {
            name: "String"
        }
    }
};
export var applicationGatewayName = {
    parameterPath: "applicationGatewayName",
    mapper: {
        required: true,
        serializedName: "applicationGatewayName",
        type: {
            name: "String"
        }
    }
};
export var applicationSecurityGroupName = {
    parameterPath: "applicationSecurityGroupName",
    mapper: {
        required: true,
        serializedName: "applicationSecurityGroupName",
        type: {
            name: "String"
        }
    }
};
export var authorizationName = {
    parameterPath: "authorizationName",
    mapper: {
        required: true,
        serializedName: "authorizationName",
        type: {
            name: "String"
        }
    }
};
export var azureFirewallName0 = {
    parameterPath: "azureFirewallName",
    mapper: {
        required: true,
        serializedName: "azureFirewallName",
        type: {
            name: "String"
        }
    }
};
export var azureFirewallName1 = {
    parameterPath: "azureFirewallName",
    mapper: {
        required: true,
        serializedName: "azureFirewallName",
        constraints: {
            MaxLength: 56,
            MinLength: 1
        },
        type: {
            name: "String"
        }
    }
};
export var backendAddressPoolName = {
    parameterPath: "backendAddressPoolName",
    mapper: {
        required: true,
        serializedName: "backendAddressPoolName",
        type: {
            name: "String"
        }
    }
};
export var bastionHostName = {
    parameterPath: "bastionHostName",
    mapper: {
        required: true,
        serializedName: "bastionHostName",
        type: {
            name: "String"
        }
    }
};
export var circuitName = {
    parameterPath: "circuitName",
    mapper: {
        required: true,
        serializedName: "circuitName",
        type: {
            name: "String"
        }
    }
};
export var cloudServiceName = {
    parameterPath: "cloudServiceName",
    mapper: {
        required: true,
        serializedName: "cloudServiceName",
        type: {
            name: "String"
        }
    }
};
export var connectionMonitorName = {
    parameterPath: "connectionMonitorName",
    mapper: {
        required: true,
        serializedName: "connectionMonitorName",
        type: {
            name: "String"
        }
    }
};
export var connectionName = {
    parameterPath: "connectionName",
    mapper: {
        required: true,
        serializedName: "connectionName",
        type: {
            name: "String"
        }
    }
};
export var crossConnectionName = {
    parameterPath: "crossConnectionName",
    mapper: {
        required: true,
        serializedName: "crossConnectionName",
        type: {
            name: "String"
        }
    }
};
export var customIpPrefixName = {
    parameterPath: "customIpPrefixName",
    mapper: {
        required: true,
        serializedName: "customIpPrefixName",
        type: {
            name: "String"
        }
    }
};
export var ddosCustomPolicyName = {
    parameterPath: "ddosCustomPolicyName",
    mapper: {
        required: true,
        serializedName: "ddosCustomPolicyName",
        type: {
            name: "String"
        }
    }
};
export var ddosProtectionPlanName = {
    parameterPath: "ddosProtectionPlanName",
    mapper: {
        required: true,
        serializedName: "ddosProtectionPlanName",
        type: {
            name: "String"
        }
    }
};
export var defaultSecurityRuleName = {
    parameterPath: "defaultSecurityRuleName",
    mapper: {
        required: true,
        serializedName: "defaultSecurityRuleName",
        type: {
            name: "String"
        }
    }
};
export var devicePath = {
    parameterPath: "devicePath",
    mapper: {
        required: true,
        serializedName: "devicePath",
        type: {
            name: "String"
        }
    }
};
export var domainNameLabel = {
    parameterPath: "domainNameLabel",
    mapper: {
        required: true,
        serializedName: "domainNameLabel",
        type: {
            name: "String"
        }
    }
};
export var dscpConfigurationName = {
    parameterPath: "dscpConfigurationName",
    mapper: {
        required: true,
        serializedName: "dscpConfigurationName",
        type: {
            name: "String"
        }
    }
};
export var expand = {
    parameterPath: [
        "options",
        "expand"
    ],
    mapper: {
        serializedName: "$expand",
        type: {
            name: "String"
        }
    }
};
export var expressRouteGatewayName = {
    parameterPath: "expressRouteGatewayName",
    mapper: {
        required: true,
        serializedName: "expressRouteGatewayName",
        type: {
            name: "String"
        }
    }
};
export var expressRoutePortName = {
    parameterPath: "expressRoutePortName",
    mapper: {
        required: true,
        serializedName: "expressRoutePortName",
        type: {
            name: "String"
        }
    }
};
export var firewallPolicyName = {
    parameterPath: "firewallPolicyName",
    mapper: {
        required: true,
        serializedName: "firewallPolicyName",
        type: {
            name: "String"
        }
    }
};
export var flowLogName = {
    parameterPath: "flowLogName",
    mapper: {
        required: true,
        serializedName: "flowLogName",
        type: {
            name: "String"
        }
    }
};
export var frontendIPConfigurationName = {
    parameterPath: "frontendIPConfigurationName",
    mapper: {
        required: true,
        serializedName: "frontendIPConfigurationName",
        type: {
            name: "String"
        }
    }
};
export var gatewayName = {
    parameterPath: "gatewayName",
    mapper: {
        required: true,
        serializedName: "gatewayName",
        type: {
            name: "String"
        }
    }
};
export var gatewayVip = {
    parameterPath: [
        "options",
        "gatewayVip"
    ],
    mapper: {
        serializedName: "gatewayVip",
        type: {
            name: "String"
        }
    }
};
export var hubName = {
    parameterPath: "hubName",
    mapper: {
        required: true,
        serializedName: "hubName",
        type: {
            name: "String"
        }
    }
};
export var inboundNatRuleName = {
    parameterPath: "inboundNatRuleName",
    mapper: {
        required: true,
        serializedName: "inboundNatRuleName",
        type: {
            name: "String"
        }
    }
};
export var ipAddress = {
    parameterPath: "ipAddress",
    mapper: {
        required: true,
        serializedName: "ipAddress",
        type: {
            name: "String"
        }
    }
};
export var ipAllocationName = {
    parameterPath: "ipAllocationName",
    mapper: {
        required: true,
        serializedName: "ipAllocationName",
        type: {
            name: "String"
        }
    }
};
export var ipConfigName = {
    parameterPath: "ipConfigName",
    mapper: {
        required: true,
        serializedName: "ipConfigName",
        type: {
            name: "String"
        }
    }
};
export var ipConfigurationName = {
    parameterPath: "ipConfigurationName",
    mapper: {
        required: true,
        serializedName: "ipConfigurationName",
        type: {
            name: "String"
        }
    }
};
export var ipGroupsName = {
    parameterPath: "ipGroupsName",
    mapper: {
        required: true,
        serializedName: "ipGroupsName",
        type: {
            name: "String"
        }
    }
};
export var linkConnectionName = {
    parameterPath: "linkConnectionName",
    mapper: {
        required: true,
        serializedName: "linkConnectionName",
        type: {
            name: "String"
        }
    }
};
export var linkName = {
    parameterPath: "linkName",
    mapper: {
        required: true,
        serializedName: "linkName",
        type: {
            name: "String"
        }
    }
};
export var loadBalancerName = {
    parameterPath: "loadBalancerName",
    mapper: {
        required: true,
        serializedName: "loadBalancerName",
        type: {
            name: "String"
        }
    }
};
export var loadBalancingRuleName = {
    parameterPath: "loadBalancingRuleName",
    mapper: {
        required: true,
        serializedName: "loadBalancingRuleName",
        type: {
            name: "String"
        }
    }
};
export var localNetworkGatewayName = {
    parameterPath: "localNetworkGatewayName",
    mapper: {
        required: true,
        serializedName: "localNetworkGatewayName",
        constraints: {
            MinLength: 1
        },
        type: {
            name: "String"
        }
    }
};
export var location0 = {
    parameterPath: "location",
    mapper: {
        required: true,
        serializedName: "location",
        type: {
            name: "String"
        }
    }
};
export var location1 = {
    parameterPath: "location",
    mapper: {
        required: true,
        serializedName: "location",
        constraints: {
            Pattern: /^[-\w\._ ]+$/
        },
        type: {
            name: "String"
        }
    }
};
export var locationName = {
    parameterPath: "locationName",
    mapper: {
        required: true,
        serializedName: "locationName",
        type: {
            name: "String"
        }
    }
};
export var migrate = {
    parameterPath: [
        "options",
        "migrate"
    ],
    mapper: {
        serializedName: "migrate",
        type: {
            name: "String"
        }
    }
};
export var name = {
    parameterPath: "name",
    mapper: {
        required: true,
        serializedName: "name",
        type: {
            name: "String"
        }
    }
};
export var natGatewayName = {
    parameterPath: "natGatewayName",
    mapper: {
        required: true,
        serializedName: "natGatewayName",
        type: {
            name: "String"
        }
    }
};
export var natRuleName = {
    parameterPath: "natRuleName",
    mapper: {
        required: true,
        serializedName: "natRuleName",
        type: {
            name: "String"
        }
    }
};
export var networkInterfaceName = {
    parameterPath: "networkInterfaceName",
    mapper: {
        required: true,
        serializedName: "networkInterfaceName",
        type: {
            name: "String"
        }
    }
};
export var networkProfileName = {
    parameterPath: "networkProfileName",
    mapper: {
        required: true,
        serializedName: "networkProfileName",
        type: {
            name: "String"
        }
    }
};
export var networkSecurityGroupName = {
    parameterPath: "networkSecurityGroupName",
    mapper: {
        required: true,
        serializedName: "networkSecurityGroupName",
        type: {
            name: "String"
        }
    }
};
export var networkVirtualApplianceName = {
    parameterPath: "networkVirtualApplianceName",
    mapper: {
        required: true,
        serializedName: "networkVirtualApplianceName",
        type: {
            name: "String"
        }
    }
};
export var networkWatcherName = {
    parameterPath: "networkWatcherName",
    mapper: {
        required: true,
        serializedName: "networkWatcherName",
        type: {
            name: "String"
        }
    }
};
export var nextPageLink = {
    parameterPath: "nextPageLink",
    mapper: {
        required: true,
        serializedName: "nextLink",
        type: {
            name: "String"
        }
    },
    skipEncoding: true
};
export var outboundRuleName = {
    parameterPath: "outboundRuleName",
    mapper: {
        required: true,
        serializedName: "outboundRuleName",
        type: {
            name: "String"
        }
    }
};
export var p2sVpnGatewayName = {
    parameterPath: "p2sVpnGatewayName",
    mapper: {
        required: true,
        serializedName: "p2sVpnGatewayName",
        type: {
            name: "String"
        }
    }
};
export var packetCaptureName = {
    parameterPath: "packetCaptureName",
    mapper: {
        required: true,
        serializedName: "packetCaptureName",
        type: {
            name: "String"
        }
    }
};
export var peConnectionName = {
    parameterPath: "peConnectionName",
    mapper: {
        required: true,
        serializedName: "peConnectionName",
        type: {
            name: "String"
        }
    }
};
export var peer0 = {
    parameterPath: [
        "options",
        "peer"
    ],
    mapper: {
        serializedName: "peer",
        type: {
            name: "String"
        }
    }
};
export var peer1 = {
    parameterPath: "peer",
    mapper: {
        required: true,
        serializedName: "peer",
        type: {
            name: "String"
        }
    }
};
export var peeringName = {
    parameterPath: "peeringName",
    mapper: {
        required: true,
        serializedName: "peeringName",
        type: {
            name: "String"
        }
    }
};
export var policyName = {
    parameterPath: "policyName",
    mapper: {
        required: true,
        serializedName: "policyName",
        constraints: {
            MaxLength: 128
        },
        type: {
            name: "String"
        }
    }
};
export var predefinedPolicyName = {
    parameterPath: "predefinedPolicyName",
    mapper: {
        required: true,
        serializedName: "predefinedPolicyName",
        type: {
            name: "String"
        }
    }
};
export var privateDnsZoneGroupName = {
    parameterPath: "privateDnsZoneGroupName",
    mapper: {
        required: true,
        serializedName: "privateDnsZoneGroupName",
        type: {
            name: "String"
        }
    }
};
export var privateEndpointName = {
    parameterPath: "privateEndpointName",
    mapper: {
        required: true,
        serializedName: "privateEndpointName",
        type: {
            name: "String"
        }
    }
};
export var probeName = {
    parameterPath: "probeName",
    mapper: {
        required: true,
        serializedName: "probeName",
        type: {
            name: "String"
        }
    }
};
export var publicIpAddressName = {
    parameterPath: "publicIpAddressName",
    mapper: {
        required: true,
        serializedName: "publicIpAddressName",
        type: {
            name: "String"
        }
    }
};
export var publicIpPrefixName = {
    parameterPath: "publicIpPrefixName",
    mapper: {
        required: true,
        serializedName: "publicIpPrefixName",
        type: {
            name: "String"
        }
    }
};
export var resourceGroupName = {
    parameterPath: "resourceGroupName",
    mapper: {
        required: true,
        serializedName: "resourceGroupName",
        type: {
            name: "String"
        }
    }
};
export var roleInstanceName = {
    parameterPath: "roleInstanceName",
    mapper: {
        required: true,
        serializedName: "roleInstanceName",
        type: {
            name: "String"
        }
    }
};
export var routeFilterName = {
    parameterPath: "routeFilterName",
    mapper: {
        required: true,
        serializedName: "routeFilterName",
        type: {
            name: "String"
        }
    }
};
export var routeName = {
    parameterPath: "routeName",
    mapper: {
        required: true,
        serializedName: "routeName",
        type: {
            name: "String"
        }
    }
};
export var routeTableName = {
    parameterPath: "routeTableName",
    mapper: {
        required: true,
        serializedName: "routeTableName",
        type: {
            name: "String"
        }
    }
};
export var ruleCollectionGroupName = {
    parameterPath: "ruleCollectionGroupName",
    mapper: {
        required: true,
        serializedName: "ruleCollectionGroupName",
        type: {
            name: "String"
        }
    }
};
export var ruleCollectionName = {
    parameterPath: "ruleCollectionName",
    mapper: {
        required: true,
        serializedName: "ruleCollectionName",
        type: {
            name: "String"
        }
    }
};
export var ruleName = {
    parameterPath: "ruleName",
    mapper: {
        required: true,
        serializedName: "ruleName",
        type: {
            name: "String"
        }
    }
};
export var securityPartnerProviderName = {
    parameterPath: "securityPartnerProviderName",
    mapper: {
        required: true,
        serializedName: "securityPartnerProviderName",
        type: {
            name: "String"
        }
    }
};
export var securityRuleName = {
    parameterPath: "securityRuleName",
    mapper: {
        required: true,
        serializedName: "securityRuleName",
        type: {
            name: "String"
        }
    }
};
export var serviceEndpointPolicyDefinitionName = {
    parameterPath: "serviceEndpointPolicyDefinitionName",
    mapper: {
        required: true,
        serializedName: "serviceEndpointPolicyDefinitionName",
        type: {
            name: "String"
        }
    }
};
export var serviceEndpointPolicyName = {
    parameterPath: "serviceEndpointPolicyName",
    mapper: {
        required: true,
        serializedName: "serviceEndpointPolicyName",
        type: {
            name: "String"
        }
    }
};
export var serviceName = {
    parameterPath: "serviceName",
    mapper: {
        required: true,
        serializedName: "serviceName",
        type: {
            name: "String"
        }
    }
};
export var siteName = {
    parameterPath: "siteName",
    mapper: {
        required: true,
        serializedName: "siteName",
        type: {
            name: "String"
        }
    }
};
export var skuName = {
    parameterPath: "skuName",
    mapper: {
        required: true,
        serializedName: "skuName",
        type: {
            name: "String"
        }
    }
};
export var subnetName = {
    parameterPath: "subnetName",
    mapper: {
        required: true,
        serializedName: "subnetName",
        type: {
            name: "String"
        }
    }
};
export var subscriptionId = {
    parameterPath: "subscriptionId",
    mapper: {
        required: true,
        serializedName: "subscriptionId",
        type: {
            name: "String"
        }
    }
};
export var syncRemoteAddressSpace = {
    parameterPath: [
        "options",
        "syncRemoteAddressSpace"
    ],
    mapper: {
        serializedName: "syncRemoteAddressSpace",
        type: {
            name: "String"
        }
    }
};
export var tapConfigurationName = {
    parameterPath: "tapConfigurationName",
    mapper: {
        required: true,
        serializedName: "tapConfigurationName",
        type: {
            name: "String"
        }
    }
};
export var tapName = {
    parameterPath: "tapName",
    mapper: {
        required: true,
        serializedName: "tapName",
        type: {
            name: "String"
        }
    }
};
export var virtualHubName = {
    parameterPath: "virtualHubName",
    mapper: {
        required: true,
        serializedName: "virtualHubName",
        type: {
            name: "String"
        }
    }
};
export var virtualmachineIndex = {
    parameterPath: "virtualmachineIndex",
    mapper: {
        required: true,
        serializedName: "virtualmachineIndex",
        type: {
            name: "String"
        }
    }
};
export var virtualMachineScaleSetName = {
    parameterPath: "virtualMachineScaleSetName",
    mapper: {
        required: true,
        serializedName: "virtualMachineScaleSetName",
        type: {
            name: "String"
        }
    }
};
export var virtualNetworkGatewayConnectionName = {
    parameterPath: "virtualNetworkGatewayConnectionName",
    mapper: {
        required: true,
        serializedName: "virtualNetworkGatewayConnectionName",
        type: {
            name: "String"
        }
    }
};
export var virtualNetworkGatewayName = {
    parameterPath: "virtualNetworkGatewayName",
    mapper: {
        required: true,
        serializedName: "virtualNetworkGatewayName",
        type: {
            name: "String"
        }
    }
};
export var virtualNetworkName = {
    parameterPath: "virtualNetworkName",
    mapper: {
        required: true,
        serializedName: "virtualNetworkName",
        type: {
            name: "String"
        }
    }
};
export var virtualNetworkPeeringName = {
    parameterPath: "virtualNetworkPeeringName",
    mapper: {
        required: true,
        serializedName: "virtualNetworkPeeringName",
        type: {
            name: "String"
        }
    }
};
export var virtualRouterName = {
    parameterPath: "virtualRouterName",
    mapper: {
        required: true,
        serializedName: "virtualRouterName",
        type: {
            name: "String"
        }
    }
};
export var virtualWANName0 = {
    parameterPath: "virtualWANName",
    mapper: {
        required: true,
        serializedName: "virtualWANName",
        type: {
            name: "String"
        }
    }
};
export var virtualWANName1 = {
    parameterPath: "virtualWANName",
    mapper: {
        required: true,
        serializedName: "VirtualWANName",
        type: {
            name: "String"
        }
    }
};
export var vpnConnectionName = {
    parameterPath: "vpnConnectionName",
    mapper: {
        required: true,
        serializedName: "vpnConnectionName",
        type: {
            name: "String"
        }
    }
};
export var vpnServerConfigurationName = {
    parameterPath: "vpnServerConfigurationName",
    mapper: {
        required: true,
        serializedName: "vpnServerConfigurationName",
        type: {
            name: "String"
        }
    }
};
export var vpnSiteLinkName = {
    parameterPath: "vpnSiteLinkName",
    mapper: {
        required: true,
        serializedName: "vpnSiteLinkName",
        type: {
            name: "String"
        }
    }
};
export var vpnSiteName = {
    parameterPath: "vpnSiteName",
    mapper: {
        required: true,
        serializedName: "vpnSiteName",
        type: {
            name: "String"
        }
    }
};
//# sourceMappingURL=parameters.js.map