import * as msRest from "@azure/ms-rest-js";
import { TokenCredential } from "@azure/core-auth";
import * as msRestAzure from "@azure/ms-rest-azure-js";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { NetworkManagementClientContext } from "./networkManagementClientContext";
declare class NetworkManagementClient extends NetworkManagementClientContext {
    applicationGateways: operations.ApplicationGateways;
    applicationGatewayPrivateLinkResources: operations.ApplicationGatewayPrivateLinkResources;
    applicationGatewayPrivateEndpointConnections: operations.ApplicationGatewayPrivateEndpointConnections;
    applicationSecurityGroups: operations.ApplicationSecurityGroups;
    availableDelegations: operations.AvailableDelegations;
    availableResourceGroupDelegations: operations.AvailableResourceGroupDelegations;
    availableServiceAliases: operations.AvailableServiceAliases;
    azureFirewalls: operations.AzureFirewalls;
    azureFirewallFqdnTags: operations.AzureFirewallFqdnTags;
    webCategories: operations.WebCategories;
    bastionHosts: operations.BastionHosts;
    networkInterfaces: operations.NetworkInterfaces;
    publicIPAddresses: operations.PublicIPAddresses;
    customIPPrefixes: operations.CustomIPPrefixes;
    ddosCustomPolicies: operations.DdosCustomPolicies;
    ddosProtectionPlans: operations.DdosProtectionPlans;
    dscpConfiguration: operations.DscpConfigurationOperations;
    availableEndpointServices: operations.AvailableEndpointServices;
    expressRouteCircuitAuthorizations: operations.ExpressRouteCircuitAuthorizations;
    expressRouteCircuitPeerings: operations.ExpressRouteCircuitPeerings;
    expressRouteCircuitConnections: operations.ExpressRouteCircuitConnections;
    peerExpressRouteCircuitConnections: operations.PeerExpressRouteCircuitConnections;
    expressRouteCircuits: operations.ExpressRouteCircuits;
    expressRouteServiceProviders: operations.ExpressRouteServiceProviders;
    expressRouteCrossConnections: operations.ExpressRouteCrossConnections;
    expressRouteCrossConnectionPeerings: operations.ExpressRouteCrossConnectionPeerings;
    expressRoutePortsLocations: operations.ExpressRoutePortsLocations;
    expressRoutePorts: operations.ExpressRoutePorts;
    expressRouteLinks: operations.ExpressRouteLinks;
    firewallPolicies: operations.FirewallPolicies;
    firewallPolicyRuleCollectionGroups: operations.FirewallPolicyRuleCollectionGroups;
    ipAllocations: operations.IpAllocations;
    ipGroups: operations.IpGroups;
    loadBalancers: operations.LoadBalancers;
    loadBalancerBackendAddressPools: operations.LoadBalancerBackendAddressPools;
    loadBalancerFrontendIPConfigurations: operations.LoadBalancerFrontendIPConfigurations;
    inboundNatRules: operations.InboundNatRules;
    loadBalancerLoadBalancingRules: operations.LoadBalancerLoadBalancingRules;
    loadBalancerOutboundRules: operations.LoadBalancerOutboundRules;
    loadBalancerNetworkInterfaces: operations.LoadBalancerNetworkInterfaces;
    loadBalancerProbes: operations.LoadBalancerProbes;
    natGateways: operations.NatGateways;
    networkInterfaceIPConfigurations: operations.NetworkInterfaceIPConfigurations;
    networkInterfaceLoadBalancers: operations.NetworkInterfaceLoadBalancers;
    networkInterfaceTapConfigurations: operations.NetworkInterfaceTapConfigurations;
    networkProfiles: operations.NetworkProfiles;
    networkSecurityGroups: operations.NetworkSecurityGroups;
    securityRules: operations.SecurityRules;
    defaultSecurityRules: operations.DefaultSecurityRules;
    networkVirtualAppliances: operations.NetworkVirtualAppliances;
    virtualApplianceSites: operations.VirtualApplianceSites;
    virtualApplianceSkus: operations.VirtualApplianceSkus;
    inboundSecurityRule: operations.InboundSecurityRuleOperations;
    networkWatchers: operations.NetworkWatchers;
    packetCaptures: operations.PacketCaptures;
    connectionMonitors: operations.ConnectionMonitors;
    flowLogs: operations.FlowLogs;
    operations: operations.Operations;
    privateEndpoints: operations.PrivateEndpoints;
    availablePrivateEndpointTypes: operations.AvailablePrivateEndpointTypes;
    privateDnsZoneGroups: operations.PrivateDnsZoneGroups;
    privateLinkServices: operations.PrivateLinkServices;
    publicIPPrefixes: operations.PublicIPPrefixes;
    routeFilters: operations.RouteFilters;
    routeFilterRules: operations.RouteFilterRules;
    routeTables: operations.RouteTables;
    routes: operations.Routes;
    securityPartnerProviders: operations.SecurityPartnerProviders;
    bgpServiceCommunities: operations.BgpServiceCommunities;
    serviceEndpointPolicies: operations.ServiceEndpointPolicies;
    serviceEndpointPolicyDefinitions: operations.ServiceEndpointPolicyDefinitions;
    serviceTags: operations.ServiceTags;
    usages: operations.Usages;
    virtualNetworks: operations.VirtualNetworks;
    subnets: operations.Subnets;
    resourceNavigationLinks: operations.ResourceNavigationLinks;
    serviceAssociationLinks: operations.ServiceAssociationLinks;
    virtualNetworkPeerings: operations.VirtualNetworkPeerings;
    virtualNetworkGateways: operations.VirtualNetworkGateways;
    virtualNetworkGatewayConnections: operations.VirtualNetworkGatewayConnections;
    localNetworkGateways: operations.LocalNetworkGateways;
    virtualNetworkGatewayNatRules: operations.VirtualNetworkGatewayNatRules;
    virtualNetworkTaps: operations.VirtualNetworkTaps;
    virtualRouters: operations.VirtualRouters;
    virtualRouterPeerings: operations.VirtualRouterPeerings;
    virtualWans: operations.VirtualWans;
    vpnSites: operations.VpnSites;
    vpnSiteLinks: operations.VpnSiteLinks;
    vpnSitesConfiguration: operations.VpnSitesConfiguration;
    vpnServerConfigurations: operations.VpnServerConfigurations;
    virtualHubs: operations.VirtualHubs;
    hubVirtualNetworkConnections: operations.HubVirtualNetworkConnections;
    vpnGateways: operations.VpnGateways;
    vpnLinkConnections: operations.VpnLinkConnections;
    vpnConnections: operations.VpnConnections;
    vpnSiteLinkConnections: operations.VpnSiteLinkConnections;
    natRules: operations.NatRules;
    p2sVpnGateways: operations.P2sVpnGateways;
    vpnServerConfigurationsAssociatedWithVirtualWan: operations.VpnServerConfigurationsAssociatedWithVirtualWan;
    virtualHubRouteTableV2s: operations.VirtualHubRouteTableV2s;
    expressRouteGateways: operations.ExpressRouteGateways;
    expressRouteConnections: operations.ExpressRouteConnections;
    virtualHubBgpConnection: operations.VirtualHubBgpConnection;
    virtualHubBgpConnections: operations.VirtualHubBgpConnections;
    virtualHubIpConfiguration: operations.VirtualHubIpConfiguration;
    hubRouteTables: operations.HubRouteTables;
    webApplicationFirewallPolicies: operations.WebApplicationFirewallPolicies;
    /**
     * Initializes a new instance of the NetworkManagementClient class.
     * @param credentials Credentials needed for the client to connect to Azure. Credentials
     * implementing the TokenCredential interface from the @azure/identity package are recommended. For
     * more information about these credentials, see
     * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
     * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
     * @azure/ms-rest-browserauth are also supported.
     * @param subscriptionId The subscription credentials which uniquely identify the Microsoft Azure
     * subscription. The subscription ID forms part of the URI for every service call.
     * @param [options] The parameter options
     */
    constructor(credentials: msRest.ServiceClientCredentials | TokenCredential, subscriptionId: string, options?: Models.NetworkManagementClientOptions);
    /**
     * Creates a Bastion Shareable Links for all the VMs specified in the request.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param [options] The optional parameters
     * @returns Promise<Models.PutBastionShareableLinkResponse>
     */
    putBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options?: msRest.RequestOptionsBase): Promise<Models.PutBastionShareableLinkResponse>;
    /**
     * Deletes the Bastion Shareable Links for all the VMs specified in the request.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param [options] The optional parameters
     * @returns Promise<msRest.RestResponse>
     */
    deleteBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
    /**
     * Return the Bastion Shareable Links for all the VMs specified in the request.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param [options] The optional parameters
     * @returns Promise<Models.GetBastionShareableLinkResponse>
     */
    getBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options?: msRest.RequestOptionsBase): Promise<Models.GetBastionShareableLinkResponse>;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param callback The callback
     */
    getBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, callback: msRest.ServiceCallback<Models.BastionShareableLinkListResult>): void;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param options The optional parameters
     * @param callback The callback
     */
    getBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BastionShareableLinkListResult>): void;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param [options] The optional parameters
     * @returns Promise<Models.GetActiveSessionsResponse>
     */
    getActiveSessions(resourceGroupName: string, bastionHostName: string, options?: msRest.RequestOptionsBase): Promise<Models.GetActiveSessionsResponse>;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param sessionIds The list of sessionids to disconnect.
     * @param [options] The optional parameters
     * @returns Promise<Models.DisconnectActiveSessionsResponse>
     */
    disconnectActiveSessions(resourceGroupName: string, bastionHostName: string, sessionIds: Models.SessionIds, options?: msRest.RequestOptionsBase): Promise<Models.DisconnectActiveSessionsResponse>;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param sessionIds The list of sessionids to disconnect.
     * @param callback The callback
     */
    disconnectActiveSessions(resourceGroupName: string, bastionHostName: string, sessionIds: Models.SessionIds, callback: msRest.ServiceCallback<Models.BastionSessionDeleteResult>): void;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param sessionIds The list of sessionids to disconnect.
     * @param options The optional parameters
     * @param callback The callback
     */
    disconnectActiveSessions(resourceGroupName: string, bastionHostName: string, sessionIds: Models.SessionIds, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BastionSessionDeleteResult>): void;
    /**
     * Checks whether a domain name in the cloudapp.azure.com zone is available for use.
     * @param location The location of the domain name.
     * @param domainNameLabel The domain name to be verified. It must conform to the following regular
     * expression: ^[a-z][a-z0-9-]{1,61}[a-z0-9]$.
     * @param [options] The optional parameters
     * @returns Promise<Models.CheckDnsNameAvailabilityResponse>
     */
    checkDnsNameAvailability(location: string, domainNameLabel: string, options?: msRest.RequestOptionsBase): Promise<Models.CheckDnsNameAvailabilityResponse>;
    /**
     * @param location The location of the domain name.
     * @param domainNameLabel The domain name to be verified. It must conform to the following regular
     * expression: ^[a-z][a-z0-9-]{1,61}[a-z0-9]$.
     * @param callback The callback
     */
    checkDnsNameAvailability(location: string, domainNameLabel: string, callback: msRest.ServiceCallback<Models.DnsNameAvailabilityResult>): void;
    /**
     * @param location The location of the domain name.
     * @param domainNameLabel The domain name to be verified. It must conform to the following regular
     * expression: ^[a-z][a-z0-9-]{1,61}[a-z0-9]$.
     * @param options The optional parameters
     * @param callback The callback
     */
    checkDnsNameAvailability(location: string, domainNameLabel: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.DnsNameAvailabilityResult>): void;
    /**
     * Gives the supported security providers for the virtual wan.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN for which supported security providers are
     * needed.
     * @param [options] The optional parameters
     * @returns Promise<Models.SupportedSecurityProvidersResponse>
     */
    supportedSecurityProviders(resourceGroupName: string, virtualWANName: string, options?: msRest.RequestOptionsBase): Promise<Models.SupportedSecurityProvidersResponse>;
    /**
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN for which supported security providers are
     * needed.
     * @param callback The callback
     */
    supportedSecurityProviders(resourceGroupName: string, virtualWANName: string, callback: msRest.ServiceCallback<Models.VirtualWanSecurityProviders>): void;
    /**
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN for which supported security providers are
     * needed.
     * @param options The optional parameters
     * @param callback The callback
     */
    supportedSecurityProviders(resourceGroupName: string, virtualWANName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.VirtualWanSecurityProviders>): void;
    /**
     * Generates a unique VPN profile for P2S clients for VirtualWan and associated
     * VpnServerConfiguration combination in the specified resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param vpnClientParams Parameters supplied to the generate VirtualWan VPN profile generation
     * operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.GeneratevirtualwanvpnserverconfigurationvpnprofileResponse>
     */
    generatevirtualwanvpnserverconfigurationvpnprofile(resourceGroupName: string, virtualWANName: string, vpnClientParams: Models.VirtualWanVpnProfileParameters, options?: msRest.RequestOptionsBase): Promise<Models.GeneratevirtualwanvpnserverconfigurationvpnprofileResponse>;
    /**
     * Creates a Bastion Shareable Links for all the VMs specified in the request.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginPutBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
    /**
     * Deletes the Bastion Shareable Links for all the VMs specified in the request.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param bslRequest Post request for all the Bastion Shareable Link endpoints.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginDeleteBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: Models.BastionShareableLinkListRequest, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param resourceGroupName The name of the resource group.
     * @param bastionHostName The name of the Bastion Host.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginGetActiveSessions(resourceGroupName: string, bastionHostName: string, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
    /**
     * Generates a unique VPN profile for P2S clients for VirtualWan and associated
     * VpnServerConfiguration combination in the specified resource group.
     * @param resourceGroupName The resource group name.
     * @param virtualWANName The name of the VirtualWAN whose associated VpnServerConfigurations is
     * needed.
     * @param vpnClientParams Parameters supplied to the generate VirtualWan VPN profile generation
     * operation.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginGeneratevirtualwanvpnserverconfigurationvpnprofile(resourceGroupName: string, virtualWANName: string, vpnClientParams: Models.VirtualWanVpnProfileParameters, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
    /**
     * Creates a Bastion Shareable Links for all the VMs specified in the request.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.PutBastionShareableLinkNextResponse>
     */
    putBastionShareableLinkNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.PutBastionShareableLinkNextResponse>;
    /**
     * Return the Bastion Shareable Links for all the VMs specified in the request.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.GetBastionShareableLinkNextResponse>
     */
    getBastionShareableLinkNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.GetBastionShareableLinkNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    getBastionShareableLinkNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.BastionShareableLinkListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    getBastionShareableLinkNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BastionShareableLinkListResult>): void;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.GetActiveSessionsNextResponse>
     */
    getActiveSessionsNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.GetActiveSessionsNextResponse>;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.DisconnectActiveSessionsNextResponse>
     */
    disconnectActiveSessionsNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.DisconnectActiveSessionsNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    disconnectActiveSessionsNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.BastionSessionDeleteResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    disconnectActiveSessionsNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BastionSessionDeleteResult>): void;
    /**
     * Creates a Bastion Shareable Links for all the VMs specified in the request.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginPutBastionShareableLinkNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
    /**
     * Returns the list of currently active sessions on the Bastion.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginGetActiveSessionsNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
}
export { NetworkManagementClient, NetworkManagementClientContext, Models as NetworkManagementModels, Mappers as NetworkManagementMappers };
export * from "./operations";
//# sourceMappingURL=networkManagementClient.d.ts.map