import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a AvailableEndpointServices. */
export declare class AvailableEndpointServices {
    private readonly client;
    /**
     * Create a AvailableEndpointServices.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * List what values of endpoint services are available for use.
     * @param location The location to check available endpoint services.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableEndpointServicesListResponse>
     */
    list(location: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableEndpointServicesListResponse>;
    /**
     * @param location The location to check available endpoint services.
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.EndpointServicesListResult>): void;
    /**
     * @param location The location to check available endpoint services.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.EndpointServicesListResult>): void;
    /**
     * List what values of endpoint services are available for use.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailableEndpointServicesListNextResponse>
     */
    listNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailableEndpointServicesListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.EndpointServicesListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.EndpointServicesListResult>): void;
}
//# sourceMappingURL=availableEndpointServices.d.ts.map