/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/defaultSecurityRulesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a DefaultSecurityRules. */
var DefaultSecurityRules = /** @class */ (function () {
    /**
     * Create a DefaultSecurityRules.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function DefaultSecurityRules(client) {
        this.client = client;
    }
    DefaultSecurityRules.prototype.list = function (resourceGroupName, networkSecurityGroupName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            networkSecurityGroupName: networkSecurityGroupName,
            options: options
        }, listOperationSpec, callback);
    };
    DefaultSecurityRules.prototype.get = function (resourceGroupName, networkSecurityGroupName, defaultSecurityRuleName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            networkSecurityGroupName: networkSecurityGroupName,
            defaultSecurityRuleName: defaultSecurityRuleName,
            options: options
        }, getOperationSpec, callback);
    };
    DefaultSecurityRules.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return DefaultSecurityRules;
}());
export { DefaultSecurityRules };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/defaultSecurityRules",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.networkSecurityGroupName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SecurityRuleListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/defaultSecurityRules/{defaultSecurityRuleName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.networkSecurityGroupName,
        Parameters.defaultSecurityRuleName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SecurityRule
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.SecurityRuleListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=defaultSecurityRules.js.map