import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a WebCategories. */
export declare class WebCategories {
    private readonly client;
    /**
     * Create a WebCategories.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets the specified Azure Web Category.
     * @param name The name of the azureWebCategory.
     * @param [options] The optional parameters
     * @returns Promise<Models.WebCategoriesGetResponse>
     */
    get(name: string, options?: Models.WebCategoriesGetOptionalParams): Promise<Models.WebCategoriesGetResponse>;
    /**
     * @param name The name of the azureWebCategory.
     * @param callback The callback
     */
    get(name: string, callback: msRest.ServiceCallback<Models.AzureWebCategory>): void;
    /**
     * @param name The name of the azureWebCategory.
     * @param options The optional parameters
     * @param callback The callback
     */
    get(name: string, options: Models.WebCategoriesGetOptionalParams, callback: msRest.ServiceCallback<Models.AzureWebCategory>): void;
    /**
     * Gets all the Azure Web Categories in a subscription.
     * @param [options] The optional parameters
     * @returns Promise<Models.WebCategoriesListBySubscriptionResponse>
     */
    listBySubscription(options?: msRest.RequestOptionsBase): Promise<Models.WebCategoriesListBySubscriptionResponse>;
    /**
     * @param callback The callback
     */
    listBySubscription(callback: msRest.ServiceCallback<Models.AzureWebCategoryListResult>): void;
    /**
     * @param options The optional parameters
     * @param callback The callback
     */
    listBySubscription(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AzureWebCategoryListResult>): void;
    /**
     * Gets all the Azure Web Categories in a subscription.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.WebCategoriesListBySubscriptionNextResponse>
     */
    listBySubscriptionNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.WebCategoriesListBySubscriptionNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listBySubscriptionNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AzureWebCategoryListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listBySubscriptionNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AzureWebCategoryListResult>): void;
}
//# sourceMappingURL=webCategories.d.ts.map