import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { StorageManagementClientContext } from "../storageManagementClientContext";
/** Class representing a Skus. */
export declare class Skus {
    private readonly client;
    /**
     * Create a Skus.
     * @param {StorageManagementClientContext} client Reference to the service client.
     */
    constructor(client: StorageManagementClientContext);
    /**
     * Lists the available SKUs supported by Microsoft.Storage for given subscription.
     * @param [options] The optional parameters
     * @returns Promise<Models.SkusListResponse>
     */
    list(options?: msRest.RequestOptionsBase): Promise<Models.SkusListResponse>;
    /**
     * @param callback The callback
     */
    list(callback: msRest.ServiceCallback<Models.StorageSkuListResult>): void;
    /**
     * @param options The optional parameters
     * @param callback The callback
     */
    list(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.StorageSkuListResult>): void;
}
//# sourceMappingURL=skus.d.ts.map