import * as msRest from "@azure/ms-rest-js";
import { TokenCredential } from "@azure/core-auth";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { StorageManagementClientContext } from "./storageManagementClientContext";
declare class StorageManagementClient extends StorageManagementClientContext {
    operations: operations.Operations;
    skus: operations.Skus;
    storageAccounts: operations.StorageAccounts;
    deletedAccounts: operations.DeletedAccounts;
    usages: operations.Usages;
    managementPolicies: operations.ManagementPolicies;
    blobInventoryPolicies: operations.BlobInventoryPolicies;
    privateEndpointConnections: operations.PrivateEndpointConnections;
    privateLinkResources: operations.PrivateLinkResources;
    objectReplicationPolicies: operations.ObjectReplicationPoliciesOperations;
    encryptionScopes: operations.EncryptionScopes;
    blobServices: operations.BlobServices;
    blobContainers: operations.BlobContainers;
    fileServices: operations.FileServices;
    fileShares: operations.FileShares;
    queueServices: operations.QueueServices;
    queue: operations.Queue;
    tableServices: operations.TableServices;
    table: operations.TableOperations;
    /**
     * Initializes a new instance of the StorageManagementClient class.
     * @param credentials Credentials needed for the client to connect to Azure. Credentials
     * implementing the TokenCredential interface from the @azure/identity package are recommended. For
     * more information about these credentials, see
     * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
     * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
     * @azure/ms-rest-browserauth are also supported.
     * @param subscriptionId The ID of the target subscription.
     * @param [options] The parameter options
     */
    constructor(credentials: msRest.ServiceClientCredentials | TokenCredential, subscriptionId: string, options?: Models.StorageManagementClientOptions);
}
export { StorageManagementClient, StorageManagementClientContext, Models as StorageManagementModels, Mappers as StorageManagementMappers };
export * from "./operations";
//# sourceMappingURL=storageManagementClient.d.ts.map