/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __assign } from "tslib";
import { CloudErrorMapper, BaseResourceMapper } from "@azure/ms-rest-azure-js";
export var CloudError = CloudErrorMapper;
export var BaseResource = BaseResourceMapper;
export var RestorePointCollectionSourceProperties = {
    serializedName: "RestorePointCollectionSourceProperties",
    type: {
        name: "Composite",
        className: "RestorePointCollectionSourceProperties",
        modelProperties: {
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApiEntityReference = {
    serializedName: "ApiEntityReference",
    type: {
        name: "Composite",
        className: "ApiEntityReference",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var HardwareProfile = {
    serializedName: "HardwareProfile",
    type: {
        name: "Composite",
        className: "HardwareProfile",
        modelProperties: {
            vmSize: {
                serializedName: "vmSize",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SubResource = {
    serializedName: "SubResource",
    type: {
        name: "Composite",
        className: "SubResource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var KeyVaultSecretReference = {
    serializedName: "KeyVaultSecretReference",
    type: {
        name: "Composite",
        className: "KeyVaultSecretReference",
        modelProperties: {
            secretUrl: {
                required: true,
                serializedName: "secretUrl",
                type: {
                    name: "String"
                }
            },
            sourceVault: {
                required: true,
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var KeyVaultKeyReference = {
    serializedName: "KeyVaultKeyReference",
    type: {
        name: "Composite",
        className: "KeyVaultKeyReference",
        modelProperties: {
            keyUrl: {
                required: true,
                serializedName: "keyUrl",
                type: {
                    name: "String"
                }
            },
            sourceVault: {
                required: true,
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var DiskEncryptionSettings = {
    serializedName: "DiskEncryptionSettings",
    type: {
        name: "Composite",
        className: "DiskEncryptionSettings",
        modelProperties: {
            diskEncryptionKey: {
                serializedName: "diskEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultSecretReference"
                }
            },
            keyEncryptionKey: {
                serializedName: "keyEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultKeyReference"
                }
            },
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var DiskEncryptionSetParameters = {
    serializedName: "DiskEncryptionSetParameters",
    type: {
        name: "Composite",
        className: "DiskEncryptionSetParameters",
        modelProperties: __assign({}, SubResource.type.modelProperties)
    }
};
export var ManagedDiskParameters = {
    serializedName: "ManagedDiskParameters",
    type: {
        name: "Composite",
        className: "ManagedDiskParameters",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            }, diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            } })
    }
};
export var RestorePointSourceVMOSDisk = {
    serializedName: "RestorePointSourceVMOSDisk",
    type: {
        name: "Composite",
        className: "RestorePointSourceVMOSDisk",
        modelProperties: {
            osType: {
                serializedName: "osType",
                type: {
                    name: "String"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSettings"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            diskRestorePoint: {
                serializedName: "diskRestorePoint",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }
        }
    }
};
export var RestorePointSourceVMDataDisk = {
    serializedName: "RestorePointSourceVMDataDisk",
    type: {
        name: "Composite",
        className: "RestorePointSourceVMDataDisk",
        modelProperties: {
            lun: {
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            diskRestorePoint: {
                serializedName: "diskRestorePoint",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }
        }
    }
};
export var RestorePointSourceVMStorageProfile = {
    serializedName: "RestorePointSourceVMStorageProfile",
    type: {
        name: "Composite",
        className: "RestorePointSourceVMStorageProfile",
        modelProperties: {
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceVMOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePointSourceVMDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export var AdditionalUnattendContent = {
    serializedName: "AdditionalUnattendContent",
    type: {
        name: "Composite",
        className: "AdditionalUnattendContent",
        modelProperties: {
            passName: {
                serializedName: "passName",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "OobeSystem"
                    ]
                }
            },
            componentName: {
                serializedName: "componentName",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Microsoft-Windows-Shell-Setup"
                    ]
                }
            },
            settingName: {
                serializedName: "settingName",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "AutoLogon",
                        "FirstLogonCommands"
                    ]
                }
            },
            content: {
                serializedName: "content",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PatchSettings = {
    serializedName: "PatchSettings",
    type: {
        name: "Composite",
        className: "PatchSettings",
        modelProperties: {
            patchMode: {
                serializedName: "patchMode",
                type: {
                    name: "String"
                }
            },
            enableHotpatching: {
                serializedName: "enableHotpatching",
                type: {
                    name: "Boolean"
                }
            },
            assessmentMode: {
                serializedName: "assessmentMode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var WinRMListener = {
    serializedName: "WinRMListener",
    type: {
        name: "Composite",
        className: "WinRMListener",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Http",
                        "Https"
                    ]
                }
            },
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var WinRMConfiguration = {
    serializedName: "WinRMConfiguration",
    type: {
        name: "Composite",
        className: "WinRMConfiguration",
        modelProperties: {
            listeners: {
                serializedName: "listeners",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "WinRMListener"
                        }
                    }
                }
            }
        }
    }
};
export var WindowsConfiguration = {
    serializedName: "WindowsConfiguration",
    type: {
        name: "Composite",
        className: "WindowsConfiguration",
        modelProperties: {
            provisionVMAgent: {
                serializedName: "provisionVMAgent",
                type: {
                    name: "Boolean"
                }
            },
            enableAutomaticUpdates: {
                serializedName: "enableAutomaticUpdates",
                type: {
                    name: "Boolean"
                }
            },
            timeZone: {
                serializedName: "timeZone",
                type: {
                    name: "String"
                }
            },
            additionalUnattendContent: {
                serializedName: "additionalUnattendContent",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AdditionalUnattendContent"
                        }
                    }
                }
            },
            patchSettings: {
                serializedName: "patchSettings",
                type: {
                    name: "Composite",
                    className: "PatchSettings"
                }
            },
            winRM: {
                serializedName: "winRM",
                type: {
                    name: "Composite",
                    className: "WinRMConfiguration"
                }
            }
        }
    }
};
export var SshPublicKey = {
    serializedName: "SshPublicKey",
    type: {
        name: "Composite",
        className: "SshPublicKey",
        modelProperties: {
            path: {
                serializedName: "path",
                type: {
                    name: "String"
                }
            },
            keyData: {
                serializedName: "keyData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SshConfiguration = {
    serializedName: "SshConfiguration",
    type: {
        name: "Composite",
        className: "SshConfiguration",
        modelProperties: {
            publicKeys: {
                serializedName: "publicKeys",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SshPublicKey"
                        }
                    }
                }
            }
        }
    }
};
export var LinuxPatchSettings = {
    serializedName: "LinuxPatchSettings",
    type: {
        name: "Composite",
        className: "LinuxPatchSettings",
        modelProperties: {
            patchMode: {
                serializedName: "patchMode",
                type: {
                    name: "String"
                }
            },
            assessmentMode: {
                serializedName: "assessmentMode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LinuxConfiguration = {
    serializedName: "LinuxConfiguration",
    type: {
        name: "Composite",
        className: "LinuxConfiguration",
        modelProperties: {
            disablePasswordAuthentication: {
                serializedName: "disablePasswordAuthentication",
                type: {
                    name: "Boolean"
                }
            },
            ssh: {
                serializedName: "ssh",
                type: {
                    name: "Composite",
                    className: "SshConfiguration"
                }
            },
            provisionVMAgent: {
                serializedName: "provisionVMAgent",
                type: {
                    name: "Boolean"
                }
            },
            patchSettings: {
                serializedName: "patchSettings",
                type: {
                    name: "Composite",
                    className: "LinuxPatchSettings"
                }
            }
        }
    }
};
export var VaultCertificate = {
    serializedName: "VaultCertificate",
    type: {
        name: "Composite",
        className: "VaultCertificate",
        modelProperties: {
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            },
            certificateStore: {
                serializedName: "certificateStore",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VaultSecretGroup = {
    serializedName: "VaultSecretGroup",
    type: {
        name: "Composite",
        className: "VaultSecretGroup",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            vaultCertificates: {
                serializedName: "vaultCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultCertificate"
                        }
                    }
                }
            }
        }
    }
};
export var OSProfile = {
    serializedName: "OSProfile",
    type: {
        name: "Composite",
        className: "OSProfile",
        modelProperties: {
            computerName: {
                serializedName: "computerName",
                type: {
                    name: "String"
                }
            },
            adminUsername: {
                serializedName: "adminUsername",
                type: {
                    name: "String"
                }
            },
            adminPassword: {
                serializedName: "adminPassword",
                type: {
                    name: "String"
                }
            },
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            },
            allowExtensionOperations: {
                serializedName: "allowExtensionOperations",
                type: {
                    name: "Boolean"
                }
            },
            requireGuestProvisionSignal: {
                serializedName: "requireGuestProvisionSignal",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var BootDiagnostics = {
    serializedName: "BootDiagnostics",
    type: {
        name: "Composite",
        className: "BootDiagnostics",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            storageUri: {
                serializedName: "storageUri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiagnosticsProfile = {
    serializedName: "DiagnosticsProfile",
    type: {
        name: "Composite",
        className: "DiagnosticsProfile",
        modelProperties: {
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnostics"
                }
            }
        }
    }
};
export var UefiSettings = {
    serializedName: "UefiSettings",
    type: {
        name: "Composite",
        className: "UefiSettings",
        modelProperties: {
            secureBootEnabled: {
                serializedName: "secureBootEnabled",
                type: {
                    name: "Boolean"
                }
            },
            vTpmEnabled: {
                serializedName: "vTpmEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var SecurityProfile = {
    serializedName: "SecurityProfile",
    type: {
        name: "Composite",
        className: "SecurityProfile",
        modelProperties: {
            uefiSettings: {
                serializedName: "uefiSettings",
                type: {
                    name: "Composite",
                    className: "UefiSettings"
                }
            },
            encryptionAtHost: {
                serializedName: "encryptionAtHost",
                type: {
                    name: "Boolean"
                }
            },
            securityType: {
                serializedName: "securityType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RestorePointSourceMetadata = {
    serializedName: "RestorePointSourceMetadata",
    type: {
        name: "Composite",
        className: "RestorePointSourceMetadata",
        modelProperties: {
            hardwareProfile: {
                serializedName: "hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceVMStorageProfile"
                }
            },
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            vmId: {
                serializedName: "vmId",
                type: {
                    name: "String"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RestorePointProvisioningDetails = {
    serializedName: "RestorePointProvisioningDetails",
    type: {
        name: "Composite",
        className: "RestorePointProvisioningDetails",
        modelProperties: {
            creationTime: {
                serializedName: "creationTime",
                type: {
                    name: "DateTime"
                }
            },
            totalUsedSizeInBytes: {
                serializedName: "totalUsedSizeInBytes",
                type: {
                    name: "Number"
                }
            },
            statusCode: {
                serializedName: "statusCode",
                type: {
                    name: "Number"
                }
            },
            statusMessage: {
                serializedName: "statusMessage",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ProxyResource = {
    serializedName: "ProxyResource",
    type: {
        name: "Composite",
        className: "ProxyResource",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RestorePoint = {
    serializedName: "RestorePoint",
    type: {
        name: "Composite",
        className: "RestorePoint",
        modelProperties: __assign(__assign({}, ProxyResource.type.modelProperties), { excludeDisks: {
                serializedName: "properties.excludeDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApiEntityReference"
                        }
                    }
                }
            }, sourceMetadata: {
                readOnly: true,
                serializedName: "properties.sourceMetadata",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceMetadata"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, consistencyMode: {
                readOnly: true,
                serializedName: "properties.consistencyMode",
                type: {
                    name: "String"
                }
            }, provisioningDetails: {
                readOnly: true,
                serializedName: "properties.provisioningDetails",
                type: {
                    name: "Composite",
                    className: "RestorePointProvisioningDetails"
                }
            } })
    }
};
export var Resource = {
    serializedName: "Resource",
    type: {
        name: "Composite",
        className: "Resource",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                required: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var RestorePointCollection = {
    serializedName: "RestorePointCollection",
    type: {
        name: "Composite",
        className: "RestorePointCollection",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "RestorePointCollectionSourceProperties"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, restorePointCollectionId: {
                readOnly: true,
                serializedName: "properties.restorePointCollectionId",
                type: {
                    name: "String"
                }
            }, restorePoints: {
                readOnly: true,
                serializedName: "properties.restorePoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePoint"
                        }
                    }
                }
            } })
    }
};
export var UpdateResource = {
    serializedName: "UpdateResource",
    type: {
        name: "Composite",
        className: "UpdateResource",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var RestorePointCollectionUpdate = {
    serializedName: "RestorePointCollectionUpdate",
    type: {
        name: "Composite",
        className: "RestorePointCollectionUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "RestorePointCollectionSourceProperties"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, restorePointCollectionId: {
                readOnly: true,
                serializedName: "properties.restorePointCollectionId",
                type: {
                    name: "String"
                }
            }, restorePoints: {
                readOnly: true,
                serializedName: "properties.restorePoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePoint"
                        }
                    }
                }
            } })
    }
};
export var ComputeOperationValue = {
    serializedName: "ComputeOperationValue",
    type: {
        name: "Composite",
        className: "ComputeOperationValue",
        modelProperties: {
            origin: {
                readOnly: true,
                serializedName: "origin",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            operation: {
                readOnly: true,
                serializedName: "display.operation",
                type: {
                    name: "String"
                }
            },
            resource: {
                readOnly: true,
                serializedName: "display.resource",
                type: {
                    name: "String"
                }
            },
            description: {
                readOnly: true,
                serializedName: "display.description",
                type: {
                    name: "String"
                }
            },
            provider: {
                readOnly: true,
                serializedName: "display.provider",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DisallowedConfiguration = {
    serializedName: "DisallowedConfiguration",
    type: {
        name: "Composite",
        className: "DisallowedConfiguration",
        modelProperties: {
            vmDiskType: {
                serializedName: "vmDiskType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RetrieveBootDiagnosticsDataResult = {
    serializedName: "RetrieveBootDiagnosticsDataResult",
    type: {
        name: "Composite",
        className: "RetrieveBootDiagnosticsDataResult",
        modelProperties: {
            consoleScreenshotBlobUri: {
                readOnly: true,
                serializedName: "consoleScreenshotBlobUri",
                type: {
                    name: "String"
                }
            },
            serialConsoleLogBlobUri: {
                readOnly: true,
                serializedName: "serialConsoleLogBlobUri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var InstanceViewStatus = {
    serializedName: "InstanceViewStatus",
    type: {
        name: "Composite",
        className: "InstanceViewStatus",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            level: {
                serializedName: "level",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Info",
                        "Warning",
                        "Error"
                    ]
                }
            },
            displayStatus: {
                serializedName: "displayStatus",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            },
            time: {
                serializedName: "time",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export var Sku = {
    serializedName: "Sku",
    type: {
        name: "Composite",
        className: "Sku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AvailabilitySet = {
    serializedName: "AvailabilitySet",
    type: {
        name: "Composite",
        className: "AvailabilitySet",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { platformUpdateDomainCount: {
                serializedName: "properties.platformUpdateDomainCount",
                type: {
                    name: "Number"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, statuses: {
                readOnly: true,
                serializedName: "properties.statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            } })
    }
};
export var AvailabilitySetUpdate = {
    serializedName: "AvailabilitySetUpdate",
    type: {
        name: "Composite",
        className: "AvailabilitySetUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { platformUpdateDomainCount: {
                serializedName: "properties.platformUpdateDomainCount",
                type: {
                    name: "Number"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, statuses: {
                readOnly: true,
                serializedName: "properties.statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            } })
    }
};
export var SubResourceWithColocationStatus = {
    serializedName: "SubResourceWithColocationStatus",
    type: {
        name: "Composite",
        className: "SubResourceWithColocationStatus",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { colocationStatus: {
                serializedName: "colocationStatus",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            } })
    }
};
export var ProximityPlacementGroup = {
    serializedName: "ProximityPlacementGroup",
    type: {
        name: "Composite",
        className: "ProximityPlacementGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { proximityPlacementGroupType: {
                serializedName: "properties.proximityPlacementGroupType",
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                readOnly: true,
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, virtualMachineScaleSets: {
                readOnly: true,
                serializedName: "properties.virtualMachineScaleSets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, availabilitySets: {
                readOnly: true,
                serializedName: "properties.availabilitySets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, colocationStatus: {
                serializedName: "properties.colocationStatus",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            } })
    }
};
export var ProximityPlacementGroupUpdate = {
    serializedName: "ProximityPlacementGroupUpdate",
    type: {
        name: "Composite",
        className: "ProximityPlacementGroupUpdate",
        modelProperties: __assign({}, UpdateResource.type.modelProperties)
    }
};
export var DedicatedHostInstanceView = {
    serializedName: "DedicatedHostInstanceView",
    type: {
        name: "Composite",
        className: "DedicatedHostInstanceView",
        modelProperties: {
            assetId: {
                readOnly: true,
                serializedName: "assetId",
                type: {
                    name: "String"
                }
            },
            availableCapacity: {
                serializedName: "availableCapacity",
                type: {
                    name: "Composite",
                    className: "DedicatedHostAvailableCapacity"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var DedicatedHostInstanceViewWithName = {
    serializedName: "DedicatedHostInstanceViewWithName",
    type: {
        name: "Composite",
        className: "DedicatedHostInstanceViewWithName",
        modelProperties: __assign(__assign({}, DedicatedHostInstanceView.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            } })
    }
};
export var DedicatedHostGroupInstanceView = {
    serializedName: "DedicatedHostGroupInstanceView",
    type: {
        name: "Composite",
        className: "DedicatedHostGroupInstanceView",
        modelProperties: {
            hosts: {
                serializedName: "hosts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostInstanceViewWithName"
                        }
                    }
                }
            }
        }
    }
};
export var SubResourceReadOnly = {
    serializedName: "SubResourceReadOnly",
    type: {
        name: "Composite",
        className: "SubResourceReadOnly",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DedicatedHostGroup = {
    serializedName: "DedicatedHostGroup",
    type: {
        name: "Composite",
        className: "DedicatedHostGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { platformFaultDomainCount: {
                required: true,
                serializedName: "properties.platformFaultDomainCount",
                constraints: {
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, hosts: {
                readOnly: true,
                serializedName: "properties.hosts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostGroupInstanceView"
                }
            }, supportAutomaticPlacement: {
                serializedName: "properties.supportAutomaticPlacement",
                type: {
                    name: "Boolean"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var DedicatedHostGroupUpdate = {
    serializedName: "DedicatedHostGroupUpdate",
    type: {
        name: "Composite",
        className: "DedicatedHostGroupUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { platformFaultDomainCount: {
                required: true,
                serializedName: "properties.platformFaultDomainCount",
                constraints: {
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, hosts: {
                readOnly: true,
                serializedName: "properties.hosts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostGroupInstanceView"
                }
            }, supportAutomaticPlacement: {
                serializedName: "properties.supportAutomaticPlacement",
                type: {
                    name: "Boolean"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var DedicatedHostAllocatableVM = {
    serializedName: "DedicatedHostAllocatableVM",
    type: {
        name: "Composite",
        className: "DedicatedHostAllocatableVM",
        modelProperties: {
            vmSize: {
                serializedName: "vmSize",
                type: {
                    name: "String"
                }
            },
            count: {
                serializedName: "count",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var DedicatedHostAvailableCapacity = {
    serializedName: "DedicatedHostAvailableCapacity",
    type: {
        name: "Composite",
        className: "DedicatedHostAvailableCapacity",
        modelProperties: {
            allocatableVMs: {
                serializedName: "allocatableVMs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostAllocatableVM"
                        }
                    }
                }
            }
        }
    }
};
export var DedicatedHost = {
    serializedName: "DedicatedHost",
    type: {
        name: "Composite",
        className: "DedicatedHost",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                constraints: {
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, autoReplaceOnFailure: {
                serializedName: "properties.autoReplaceOnFailure",
                type: {
                    name: "Boolean"
                }
            }, hostId: {
                readOnly: true,
                serializedName: "properties.hostId",
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                readOnly: true,
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "Windows_Server_Hybrid",
                        "Windows_Server_Perpetual"
                    ]
                }
            }, provisioningTime: {
                readOnly: true,
                serializedName: "properties.provisioningTime",
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostInstanceView"
                }
            }, sku: {
                required: true,
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            } })
    }
};
export var DedicatedHostUpdate = {
    serializedName: "DedicatedHostUpdate",
    type: {
        name: "Composite",
        className: "DedicatedHostUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                constraints: {
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, autoReplaceOnFailure: {
                serializedName: "properties.autoReplaceOnFailure",
                type: {
                    name: "Boolean"
                }
            }, hostId: {
                readOnly: true,
                serializedName: "properties.hostId",
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                readOnly: true,
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "Windows_Server_Hybrid",
                        "Windows_Server_Perpetual"
                    ]
                }
            }, provisioningTime: {
                readOnly: true,
                serializedName: "properties.provisioningTime",
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostInstanceView"
                }
            } })
    }
};
export var CapacityReservationInstanceView = {
    serializedName: "CapacityReservationInstanceView",
    type: {
        name: "Composite",
        className: "CapacityReservationInstanceView",
        modelProperties: {
            utilizationInfo: {
                serializedName: "utilizationInfo",
                type: {
                    name: "Composite",
                    className: "CapacityReservationUtilization"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var CapacityReservationInstanceViewWithName = {
    serializedName: "CapacityReservationInstanceViewWithName",
    type: {
        name: "Composite",
        className: "CapacityReservationInstanceViewWithName",
        modelProperties: __assign(__assign({}, CapacityReservationInstanceView.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            } })
    }
};
export var CapacityReservationGroupInstanceView = {
    serializedName: "CapacityReservationGroupInstanceView",
    type: {
        name: "Composite",
        className: "CapacityReservationGroupInstanceView",
        modelProperties: {
            capacityReservations: {
                readOnly: true,
                serializedName: "capacityReservations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservationInstanceViewWithName"
                        }
                    }
                }
            }
        }
    }
};
export var CapacityReservationGroup = {
    serializedName: "CapacityReservationGroup",
    type: {
        name: "Composite",
        className: "CapacityReservationGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { capacityReservations: {
                readOnly: true,
                serializedName: "properties.capacityReservations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, virtualMachinesAssociated: {
                readOnly: true,
                serializedName: "properties.virtualMachinesAssociated",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationGroupInstanceView"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var CapacityReservationGroupUpdate = {
    serializedName: "CapacityReservationGroupUpdate",
    type: {
        name: "Composite",
        className: "CapacityReservationGroupUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { capacityReservations: {
                readOnly: true,
                serializedName: "properties.capacityReservations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, virtualMachinesAssociated: {
                readOnly: true,
                serializedName: "properties.virtualMachinesAssociated",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationGroupInstanceView"
                }
            } })
    }
};
export var CapacityReservationUtilization = {
    serializedName: "CapacityReservationUtilization",
    type: {
        name: "Composite",
        className: "CapacityReservationUtilization",
        modelProperties: {
            virtualMachinesAllocated: {
                readOnly: true,
                serializedName: "virtualMachinesAllocated",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }
        }
    }
};
export var CapacityReservation = {
    serializedName: "CapacityReservation",
    type: {
        name: "Composite",
        className: "CapacityReservation",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { reservationId: {
                readOnly: true,
                serializedName: "properties.reservationId",
                type: {
                    name: "String"
                }
            }, virtualMachinesAssociated: {
                readOnly: true,
                serializedName: "properties.virtualMachinesAssociated",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, provisioningTime: {
                readOnly: true,
                serializedName: "properties.provisioningTime",
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationInstanceView"
                }
            }, sku: {
                required: true,
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var CapacityReservationUpdate = {
    serializedName: "CapacityReservationUpdate",
    type: {
        name: "Composite",
        className: "CapacityReservationUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { reservationId: {
                readOnly: true,
                serializedName: "properties.reservationId",
                type: {
                    name: "String"
                }
            }, virtualMachinesAssociated: {
                readOnly: true,
                serializedName: "properties.virtualMachinesAssociated",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, provisioningTime: {
                readOnly: true,
                serializedName: "properties.provisioningTime",
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationInstanceView"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            } })
    }
};
export var SshPublicKeyGenerateKeyPairResult = {
    serializedName: "SshPublicKeyGenerateKeyPairResult",
    type: {
        name: "Composite",
        className: "SshPublicKeyGenerateKeyPairResult",
        modelProperties: {
            privateKey: {
                required: true,
                serializedName: "privateKey",
                type: {
                    name: "String"
                }
            },
            publicKey: {
                required: true,
                serializedName: "publicKey",
                type: {
                    name: "String"
                }
            },
            id: {
                required: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SshPublicKeyResource = {
    serializedName: "SshPublicKeyResource",
    type: {
        name: "Composite",
        className: "SshPublicKeyResource",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { publicKey: {
                serializedName: "properties.publicKey",
                type: {
                    name: "String"
                }
            } })
    }
};
export var SshPublicKeyUpdateResource = {
    serializedName: "SshPublicKeyUpdateResource",
    type: {
        name: "Composite",
        className: "SshPublicKeyUpdateResource",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { publicKey: {
                serializedName: "properties.publicKey",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualMachineSize = {
    serializedName: "VirtualMachineSize",
    type: {
        name: "Composite",
        className: "VirtualMachineSize",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            numberOfCores: {
                serializedName: "numberOfCores",
                type: {
                    name: "Number"
                }
            },
            osDiskSizeInMB: {
                serializedName: "osDiskSizeInMB",
                type: {
                    name: "Number"
                }
            },
            resourceDiskSizeInMB: {
                serializedName: "resourceDiskSizeInMB",
                type: {
                    name: "Number"
                }
            },
            memoryInMB: {
                serializedName: "memoryInMB",
                type: {
                    name: "Number"
                }
            },
            maxDataDiskCount: {
                serializedName: "maxDataDiskCount",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VirtualMachineExtensionImage = {
    serializedName: "VirtualMachineExtensionImage",
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionImage",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { operatingSystem: {
                required: true,
                serializedName: "properties.operatingSystem",
                type: {
                    name: "String"
                }
            }, computeRole: {
                required: true,
                serializedName: "properties.computeRole",
                type: {
                    name: "String"
                }
            }, handlerSchema: {
                required: true,
                serializedName: "properties.handlerSchema",
                type: {
                    name: "String"
                }
            }, vmScaleSetEnabled: {
                serializedName: "properties.vmScaleSetEnabled",
                type: {
                    name: "Boolean"
                }
            }, supportsMultipleExtensions: {
                serializedName: "properties.supportsMultipleExtensions",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export var ExtendedLocation = {
    serializedName: "ExtendedLocation",
    type: {
        name: "Composite",
        className: "ExtendedLocation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineImageResource = {
    serializedName: "VirtualMachineImageResource",
    type: {
        name: "Composite",
        className: "VirtualMachineImageResource",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, location: {
                required: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            }, tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            } })
    }
};
export var VirtualMachineExtensionInstanceView = {
    serializedName: "VirtualMachineExtensionInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionInstanceView",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            substatuses: {
                serializedName: "substatuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineExtension = {
    serializedName: "VirtualMachineExtension",
    type: {
        name: "Composite",
        className: "VirtualMachineExtension",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, virtualMachineExtensionType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineExtensionInstanceView"
                }
            } })
    }
};
export var VirtualMachineScaleSetVMExtension = {
    serializedName: "VirtualMachineScaleSetVMExtension",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtension",
        modelProperties: __assign(__assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type1: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineExtensionInstanceView"
                }
            } })
    }
};
export var VirtualMachineExtensionUpdate = {
    serializedName: "VirtualMachineExtensionUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            } })
    }
};
export var VirtualMachineScaleSetVMExtensionUpdate = {
    serializedName: "VirtualMachineScaleSetVMExtensionUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionUpdate",
        modelProperties: __assign(__assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type1: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            } })
    }
};
export var VirtualMachineExtensionsListResult = {
    serializedName: "VirtualMachineExtensionsListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionsListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMExtensionsListResult = {
    serializedName: "VirtualMachineScaleSetVMExtensionsListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionsListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVMExtension"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineSoftwarePatchProperties = {
    serializedName: "VirtualMachineSoftwarePatchProperties",
    type: {
        name: "Composite",
        className: "VirtualMachineSoftwarePatchProperties",
        modelProperties: {
            patchId: {
                readOnly: true,
                serializedName: "patchId",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            version: {
                readOnly: true,
                serializedName: "version",
                type: {
                    name: "String"
                }
            },
            kbId: {
                readOnly: true,
                serializedName: "kbId",
                type: {
                    name: "String"
                }
            },
            classifications: {
                readOnly: true,
                serializedName: "classifications",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            rebootBehavior: {
                readOnly: true,
                serializedName: "rebootBehavior",
                type: {
                    name: "String"
                }
            },
            activityId: {
                readOnly: true,
                serializedName: "activityId",
                type: {
                    name: "String"
                }
            },
            publishedDate: {
                readOnly: true,
                serializedName: "publishedDate",
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedDateTime: {
                readOnly: true,
                serializedName: "lastModifiedDateTime",
                type: {
                    name: "DateTime"
                }
            },
            assessmentState: {
                readOnly: true,
                serializedName: "assessmentState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApiErrorBase = {
    serializedName: "ApiErrorBase",
    type: {
        name: "Composite",
        className: "ApiErrorBase",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var InnerError = {
    serializedName: "InnerError",
    type: {
        name: "Composite",
        className: "InnerError",
        modelProperties: {
            exceptiontype: {
                serializedName: "exceptiontype",
                type: {
                    name: "String"
                }
            },
            errordetail: {
                serializedName: "errordetail",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApiError = {
    serializedName: "ApiError",
    type: {
        name: "Composite",
        className: "ApiError",
        modelProperties: {
            details: {
                serializedName: "details",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApiErrorBase"
                        }
                    }
                }
            },
            innererror: {
                serializedName: "innererror",
                type: {
                    name: "Composite",
                    className: "InnerError"
                }
            },
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineAssessPatchesResult = {
    serializedName: "VirtualMachineAssessPatchesResult",
    type: {
        name: "Composite",
        className: "VirtualMachineAssessPatchesResult",
        modelProperties: {
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            assessmentActivityId: {
                readOnly: true,
                serializedName: "assessmentActivityId",
                type: {
                    name: "String"
                }
            },
            rebootPending: {
                readOnly: true,
                serializedName: "rebootPending",
                type: {
                    name: "Boolean"
                }
            },
            criticalAndSecurityPatchCount: {
                readOnly: true,
                serializedName: "criticalAndSecurityPatchCount",
                type: {
                    name: "Number"
                }
            },
            otherPatchCount: {
                readOnly: true,
                serializedName: "otherPatchCount",
                type: {
                    name: "Number"
                }
            },
            startDateTime: {
                readOnly: true,
                serializedName: "startDateTime",
                type: {
                    name: "DateTime"
                }
            },
            availablePatches: {
                readOnly: true,
                serializedName: "availablePatches",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineSoftwarePatchProperties"
                        }
                    }
                }
            },
            error: {
                readOnly: true,
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export var WindowsParameters = {
    serializedName: "WindowsParameters",
    type: {
        name: "Composite",
        className: "WindowsParameters",
        modelProperties: {
            classificationsToInclude: {
                serializedName: "classificationsToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            kbNumbersToInclude: {
                serializedName: "kbNumbersToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            kbNumbersToExclude: {
                serializedName: "kbNumbersToExclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            excludeKbsRequiringReboot: {
                serializedName: "excludeKbsRequiringReboot",
                type: {
                    name: "Boolean"
                }
            },
            maxPatchPublishDate: {
                serializedName: "maxPatchPublishDate",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export var LinuxParameters = {
    serializedName: "LinuxParameters",
    type: {
        name: "Composite",
        className: "LinuxParameters",
        modelProperties: {
            classificationsToInclude: {
                serializedName: "classificationsToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            packageNameMasksToInclude: {
                serializedName: "packageNameMasksToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            packageNameMasksToExclude: {
                serializedName: "packageNameMasksToExclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            maintenanceRunId: {
                serializedName: "maintenanceRunId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineInstallPatchesParameters = {
    serializedName: "VirtualMachineInstallPatchesParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineInstallPatchesParameters",
        modelProperties: {
            maximumDuration: {
                required: true,
                serializedName: "maximumDuration",
                type: {
                    name: "String"
                }
            },
            rebootSetting: {
                required: true,
                serializedName: "rebootSetting",
                type: {
                    name: "String"
                }
            },
            windowsParameters: {
                serializedName: "windowsParameters",
                type: {
                    name: "Composite",
                    className: "WindowsParameters"
                }
            },
            linuxParameters: {
                serializedName: "linuxParameters",
                type: {
                    name: "Composite",
                    className: "LinuxParameters"
                }
            }
        }
    }
};
export var PatchInstallationDetail = {
    serializedName: "PatchInstallationDetail",
    type: {
        name: "Composite",
        className: "PatchInstallationDetail",
        modelProperties: {
            patchId: {
                readOnly: true,
                serializedName: "patchId",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            version: {
                readOnly: true,
                serializedName: "version",
                type: {
                    name: "String"
                }
            },
            kbId: {
                readOnly: true,
                serializedName: "kbId",
                type: {
                    name: "String"
                }
            },
            classifications: {
                readOnly: true,
                serializedName: "classifications",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            installationState: {
                readOnly: true,
                serializedName: "installationState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineInstallPatchesResult = {
    serializedName: "VirtualMachineInstallPatchesResult",
    type: {
        name: "Composite",
        className: "VirtualMachineInstallPatchesResult",
        modelProperties: {
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            installationActivityId: {
                readOnly: true,
                serializedName: "installationActivityId",
                type: {
                    name: "String"
                }
            },
            rebootStatus: {
                readOnly: true,
                serializedName: "rebootStatus",
                type: {
                    name: "String"
                }
            },
            maintenanceWindowExceeded: {
                readOnly: true,
                serializedName: "maintenanceWindowExceeded",
                type: {
                    name: "Boolean"
                }
            },
            excludedPatchCount: {
                readOnly: true,
                serializedName: "excludedPatchCount",
                type: {
                    name: "Number"
                }
            },
            notSelectedPatchCount: {
                readOnly: true,
                serializedName: "notSelectedPatchCount",
                type: {
                    name: "Number"
                }
            },
            pendingPatchCount: {
                readOnly: true,
                serializedName: "pendingPatchCount",
                type: {
                    name: "Number"
                }
            },
            installedPatchCount: {
                readOnly: true,
                serializedName: "installedPatchCount",
                type: {
                    name: "Number"
                }
            },
            failedPatchCount: {
                readOnly: true,
                serializedName: "failedPatchCount",
                type: {
                    name: "Number"
                }
            },
            patches: {
                readOnly: true,
                serializedName: "patches",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PatchInstallationDetail"
                        }
                    }
                }
            },
            startDateTime: {
                readOnly: true,
                serializedName: "startDateTime",
                type: {
                    name: "DateTime"
                }
            },
            error: {
                readOnly: true,
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export var PurchasePlan = {
    serializedName: "PurchasePlan",
    type: {
        name: "Composite",
        className: "PurchasePlan",
        modelProperties: {
            publisher: {
                required: true,
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            product: {
                required: true,
                serializedName: "product",
                type: {
                    name: "String"
                }
            },
            promotionCode: {
                serializedName: "promotionCode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSDiskImage = {
    serializedName: "OSDiskImage",
    type: {
        name: "Composite",
        className: "OSDiskImage",
        modelProperties: {
            operatingSystem: {
                required: true,
                serializedName: "operatingSystem",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }
        }
    }
};
export var DataDiskImage = {
    serializedName: "DataDiskImage",
    type: {
        name: "Composite",
        className: "DataDiskImage",
        modelProperties: {
            lun: {
                readOnly: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AutomaticOSUpgradeProperties = {
    serializedName: "AutomaticOSUpgradeProperties",
    type: {
        name: "Composite",
        className: "AutomaticOSUpgradeProperties",
        modelProperties: {
            automaticOSUpgradeSupported: {
                required: true,
                serializedName: "automaticOSUpgradeSupported",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var VirtualMachineImageFeature = {
    serializedName: "VirtualMachineImageFeature",
    type: {
        name: "Composite",
        className: "VirtualMachineImageFeature",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineImage = {
    serializedName: "VirtualMachineImage",
    type: {
        name: "Composite",
        className: "VirtualMachineImage",
        modelProperties: __assign(__assign({}, VirtualMachineImageResource.type.modelProperties), { plan: {
                serializedName: "properties.plan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            }, osDiskImage: {
                serializedName: "properties.osDiskImage",
                type: {
                    name: "Composite",
                    className: "OSDiskImage"
                }
            }, dataDiskImages: {
                serializedName: "properties.dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDiskImage"
                        }
                    }
                }
            }, automaticOSUpgradeProperties: {
                serializedName: "properties.automaticOSUpgradeProperties",
                type: {
                    name: "Composite",
                    className: "AutomaticOSUpgradeProperties"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "DisallowedConfiguration"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageFeature"
                        }
                    }
                }
            } })
    }
};
export var UsageName = {
    serializedName: "UsageName",
    type: {
        name: "Composite",
        className: "UsageName",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            },
            localizedValue: {
                serializedName: "localizedValue",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Usage = {
    serializedName: "Usage",
    type: {
        name: "Composite",
        className: "Usage",
        modelProperties: {
            unit: {
                required: true,
                isConstant: true,
                serializedName: "unit",
                defaultValue: 'Count',
                type: {
                    name: "String"
                }
            },
            currentValue: {
                required: true,
                serializedName: "currentValue",
                type: {
                    name: "Number"
                }
            },
            limit: {
                required: true,
                serializedName: "limit",
                type: {
                    name: "Number"
                }
            },
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "Composite",
                    className: "UsageName"
                }
            }
        }
    }
};
export var VirtualMachineReimageParameters = {
    serializedName: "VirtualMachineReimageParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineReimageParameters",
        modelProperties: {
            tempDisk: {
                serializedName: "tempDisk",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var VirtualMachineCaptureParameters = {
    serializedName: "VirtualMachineCaptureParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineCaptureParameters",
        modelProperties: {
            vhdPrefix: {
                required: true,
                serializedName: "vhdPrefix",
                type: {
                    name: "String"
                }
            },
            destinationContainerName: {
                required: true,
                serializedName: "destinationContainerName",
                type: {
                    name: "String"
                }
            },
            overwriteVhds: {
                required: true,
                serializedName: "overwriteVhds",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var VirtualMachineCaptureResult = {
    serializedName: "VirtualMachineCaptureResult",
    type: {
        name: "Composite",
        className: "VirtualMachineCaptureResult",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { schema: {
                readOnly: true,
                serializedName: "$schema",
                type: {
                    name: "String"
                }
            }, contentVersion: {
                readOnly: true,
                serializedName: "contentVersion",
                type: {
                    name: "String"
                }
            }, parameters: {
                readOnly: true,
                serializedName: "parameters",
                type: {
                    name: "Object"
                }
            }, resources: {
                readOnly: true,
                serializedName: "resources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Object"
                        }
                    }
                }
            } })
    }
};
export var Plan = {
    serializedName: "Plan",
    type: {
        name: "Composite",
        className: "Plan",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                type: {
                    name: "String"
                }
            },
            promotionCode: {
                serializedName: "promotionCode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ImageReference = {
    serializedName: "ImageReference",
    type: {
        name: "Composite",
        className: "ImageReference",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            }, offer: {
                serializedName: "offer",
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "String"
                }
            }, version: {
                serializedName: "version",
                type: {
                    name: "String"
                }
            }, exactVersion: {
                readOnly: true,
                serializedName: "exactVersion",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualHardDisk = {
    serializedName: "VirtualHardDisk",
    type: {
        name: "Composite",
        className: "VirtualHardDisk",
        modelProperties: {
            uri: {
                serializedName: "uri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiffDiskSettings = {
    serializedName: "DiffDiskSettings",
    type: {
        name: "Composite",
        className: "DiffDiskSettings",
        modelProperties: {
            option: {
                serializedName: "option",
                type: {
                    name: "String"
                }
            },
            placement: {
                serializedName: "placement",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSDisk = {
    serializedName: "OSDisk",
    type: {
        name: "Composite",
        className: "OSDisk",
        modelProperties: {
            osType: {
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSettings"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            vhd: {
                serializedName: "vhd",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            diffDiskSettings: {
                serializedName: "diffDiskSettings",
                type: {
                    name: "Composite",
                    className: "DiffDiskSettings"
                }
            },
            createOption: {
                required: true,
                serializedName: "createOption",
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            deleteOption: {
                serializedName: "deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DataDisk = {
    serializedName: "DataDisk",
    type: {
        name: "Composite",
        className: "DataDisk",
        modelProperties: {
            lun: {
                required: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            vhd: {
                serializedName: "vhd",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                required: true,
                serializedName: "createOption",
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            toBeDetached: {
                serializedName: "toBeDetached",
                type: {
                    name: "Boolean"
                }
            },
            diskIOPSReadWrite: {
                readOnly: true,
                serializedName: "diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                readOnly: true,
                serializedName: "diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            },
            detachOption: {
                serializedName: "detachOption",
                type: {
                    name: "String"
                }
            },
            deleteOption: {
                serializedName: "deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CapacityReservationProfile = {
    serializedName: "CapacityReservationProfile",
    type: {
        name: "Composite",
        className: "CapacityReservationProfile",
        modelProperties: {
            capacityReservationGroup: {
                serializedName: "capacityReservationGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var StorageProfile = {
    serializedName: "StorageProfile",
    type: {
        name: "Composite",
        className: "StorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "OSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDisk"
                        }
                    }
                }
            }
        }
    }
};
export var AdditionalCapabilities = {
    serializedName: "AdditionalCapabilities",
    type: {
        name: "Composite",
        className: "AdditionalCapabilities",
        modelProperties: {
            ultraSSDEnabled: {
                serializedName: "ultraSSDEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var AutomaticRepairsPolicy = {
    serializedName: "AutomaticRepairsPolicy",
    type: {
        name: "Composite",
        className: "AutomaticRepairsPolicy",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            gracePeriod: {
                serializedName: "gracePeriod",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceReference = {
    serializedName: "NetworkInterfaceReference",
    type: {
        name: "Composite",
        className: "NetworkInterfaceReference",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualMachineIpTag = {
    serializedName: "VirtualMachineIpTag",
    type: {
        name: "Composite",
        className: "VirtualMachineIpTag",
        modelProperties: {
            ipTagType: {
                serializedName: "ipTagType",
                type: {
                    name: "String"
                }
            },
            tag: {
                serializedName: "tag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachinePublicIPAddressDnsSettingsConfiguration = {
    serializedName: "VirtualMachinePublicIPAddressDnsSettingsConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachinePublicIPAddressDnsSettingsConfiguration",
        modelProperties: {
            domainNameLabel: {
                required: true,
                serializedName: "domainNameLabel",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPAddressSku = {
    serializedName: "PublicIPAddressSku",
    type: {
        name: "Composite",
        className: "PublicIPAddressSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachinePublicIPAddressConfiguration = {
    serializedName: "VirtualMachinePublicIPAddressConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachinePublicIPAddressConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePublicIPAddressDnsSettingsConfiguration"
                }
            },
            ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineIpTag"
                        }
                    }
                }
            },
            publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            publicIPAllocationMethod: {
                serializedName: "properties.publicIPAllocationMethod",
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressSku"
                }
            }
        }
    }
};
export var VirtualMachineNetworkInterfaceIPConfiguration = {
    serializedName: "VirtualMachineNetworkInterfaceIPConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceIPConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            },
            publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePublicIPAddressConfiguration"
                }
            },
            privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            },
            applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            },
            loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineNetworkInterfaceDnsSettingsConfiguration = {
    serializedName: "VirtualMachineNetworkInterfaceDnsSettingsConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceDnsSettingsConfiguration",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineNetworkInterfaceConfiguration = {
    serializedName: "VirtualMachineNetworkInterfaceConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            },
            enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            },
            enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            },
            enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            },
            networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineNetworkInterfaceDnsSettingsConfiguration"
                }
            },
            ipConfigurations: {
                required: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineNetworkInterfaceIPConfiguration"
                        }
                    }
                }
            },
            dscpConfiguration: {
                serializedName: "properties.dscpConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var NetworkProfile = {
    serializedName: "NetworkProfile",
    type: {
        name: "Composite",
        className: "NetworkProfile",
        modelProperties: {
            networkInterfaces: {
                serializedName: "networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceReference"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineNetworkInterfaceConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export var BillingProfile = {
    serializedName: "BillingProfile",
    type: {
        name: "Composite",
        className: "BillingProfile",
        modelProperties: {
            maxPrice: {
                serializedName: "maxPrice",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VirtualMachineExtensionHandlerInstanceView = {
    serializedName: "VirtualMachineExtensionHandlerInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionHandlerInstanceView",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            status: {
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export var VirtualMachineAgentInstanceView = {
    serializedName: "VirtualMachineAgentInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineAgentInstanceView",
        modelProperties: {
            vmAgentVersion: {
                serializedName: "vmAgentVersion",
                type: {
                    name: "String"
                }
            },
            extensionHandlers: {
                serializedName: "extensionHandlers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionHandlerInstanceView"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var DiskInstanceView = {
    serializedName: "DiskInstanceView",
    type: {
        name: "Composite",
        className: "DiskInstanceView",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskEncryptionSettings"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var BootDiagnosticsInstanceView = {
    serializedName: "BootDiagnosticsInstanceView",
    type: {
        name: "Composite",
        className: "BootDiagnosticsInstanceView",
        modelProperties: {
            consoleScreenshotBlobUri: {
                readOnly: true,
                serializedName: "consoleScreenshotBlobUri",
                type: {
                    name: "String"
                }
            },
            serialConsoleLogBlobUri: {
                readOnly: true,
                serializedName: "serialConsoleLogBlobUri",
                type: {
                    name: "String"
                }
            },
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export var VirtualMachineIdentityUserAssignedIdentitiesValue = {
    serializedName: "VirtualMachineIdentity_userAssignedIdentitiesValue",
    type: {
        name: "Composite",
        className: "VirtualMachineIdentityUserAssignedIdentitiesValue",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            clientId: {
                readOnly: true,
                serializedName: "clientId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineIdentity = {
    serializedName: "VirtualMachineIdentity",
    type: {
        name: "Composite",
        className: "VirtualMachineIdentity",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            tenantId: {
                readOnly: true,
                serializedName: "tenantId",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "SystemAssigned",
                        "UserAssigned",
                        "SystemAssigned, UserAssigned",
                        "None"
                    ]
                }
            },
            userAssignedIdentities: {
                serializedName: "userAssignedIdentities",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineIdentityUserAssignedIdentitiesValue"
                        }
                    }
                }
            }
        }
    }
};
export var MaintenanceRedeployStatus = {
    serializedName: "MaintenanceRedeployStatus",
    type: {
        name: "Composite",
        className: "MaintenanceRedeployStatus",
        modelProperties: {
            isCustomerInitiatedMaintenanceAllowed: {
                serializedName: "isCustomerInitiatedMaintenanceAllowed",
                type: {
                    name: "Boolean"
                }
            },
            preMaintenanceWindowStartTime: {
                serializedName: "preMaintenanceWindowStartTime",
                type: {
                    name: "DateTime"
                }
            },
            preMaintenanceWindowEndTime: {
                serializedName: "preMaintenanceWindowEndTime",
                type: {
                    name: "DateTime"
                }
            },
            maintenanceWindowStartTime: {
                serializedName: "maintenanceWindowStartTime",
                type: {
                    name: "DateTime"
                }
            },
            maintenanceWindowEndTime: {
                serializedName: "maintenanceWindowEndTime",
                type: {
                    name: "DateTime"
                }
            },
            lastOperationResultCode: {
                serializedName: "lastOperationResultCode",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "RetryLater",
                        "MaintenanceAborted",
                        "MaintenanceCompleted"
                    ]
                }
            },
            lastOperationMessage: {
                serializedName: "lastOperationMessage",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineHealthStatus = {
    serializedName: "VirtualMachineHealthStatus",
    type: {
        name: "Composite",
        className: "VirtualMachineHealthStatus",
        modelProperties: {
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export var AvailablePatchSummary = {
    serializedName: "AvailablePatchSummary",
    type: {
        name: "Composite",
        className: "AvailablePatchSummary",
        modelProperties: {
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            assessmentActivityId: {
                readOnly: true,
                serializedName: "assessmentActivityId",
                type: {
                    name: "String"
                }
            },
            rebootPending: {
                readOnly: true,
                serializedName: "rebootPending",
                type: {
                    name: "Boolean"
                }
            },
            criticalAndSecurityPatchCount: {
                readOnly: true,
                serializedName: "criticalAndSecurityPatchCount",
                type: {
                    name: "Number"
                }
            },
            otherPatchCount: {
                readOnly: true,
                serializedName: "otherPatchCount",
                type: {
                    name: "Number"
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedTime: {
                readOnly: true,
                serializedName: "lastModifiedTime",
                type: {
                    name: "DateTime"
                }
            },
            error: {
                readOnly: true,
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export var LastPatchInstallationSummary = {
    serializedName: "LastPatchInstallationSummary",
    type: {
        name: "Composite",
        className: "LastPatchInstallationSummary",
        modelProperties: {
            status: {
                readOnly: true,
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            installationActivityId: {
                readOnly: true,
                serializedName: "installationActivityId",
                type: {
                    name: "String"
                }
            },
            maintenanceWindowExceeded: {
                readOnly: true,
                serializedName: "maintenanceWindowExceeded",
                type: {
                    name: "Boolean"
                }
            },
            notSelectedPatchCount: {
                readOnly: true,
                serializedName: "notSelectedPatchCount",
                type: {
                    name: "Number"
                }
            },
            excludedPatchCount: {
                readOnly: true,
                serializedName: "excludedPatchCount",
                type: {
                    name: "Number"
                }
            },
            pendingPatchCount: {
                readOnly: true,
                serializedName: "pendingPatchCount",
                type: {
                    name: "Number"
                }
            },
            installedPatchCount: {
                readOnly: true,
                serializedName: "installedPatchCount",
                type: {
                    name: "Number"
                }
            },
            failedPatchCount: {
                readOnly: true,
                serializedName: "failedPatchCount",
                type: {
                    name: "Number"
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedTime: {
                readOnly: true,
                serializedName: "lastModifiedTime",
                type: {
                    name: "DateTime"
                }
            },
            error: {
                readOnly: true,
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export var VirtualMachinePatchStatus = {
    serializedName: "VirtualMachinePatchStatus",
    type: {
        name: "Composite",
        className: "VirtualMachinePatchStatus",
        modelProperties: {
            availablePatchSummary: {
                serializedName: "availablePatchSummary",
                type: {
                    name: "Composite",
                    className: "AvailablePatchSummary"
                }
            },
            lastPatchInstallationSummary: {
                serializedName: "lastPatchInstallationSummary",
                type: {
                    name: "Composite",
                    className: "LastPatchInstallationSummary"
                }
            },
            configurationStatuses: {
                readOnly: true,
                serializedName: "configurationStatuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineInstanceView = {
    serializedName: "VirtualMachineInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                serializedName: "platformUpdateDomain",
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                serializedName: "platformFaultDomain",
                type: {
                    name: "Number"
                }
            },
            computerName: {
                serializedName: "computerName",
                type: {
                    name: "String"
                }
            },
            osName: {
                serializedName: "osName",
                type: {
                    name: "String"
                }
            },
            osVersion: {
                serializedName: "osVersion",
                type: {
                    name: "String"
                }
            },
            hyperVGeneration: {
                serializedName: "hyperVGeneration",
                type: {
                    name: "String"
                }
            },
            rdpThumbPrint: {
                serializedName: "rdpThumbPrint",
                type: {
                    name: "String"
                }
            },
            vmAgent: {
                serializedName: "vmAgent",
                type: {
                    name: "Composite",
                    className: "VirtualMachineAgentInstanceView"
                }
            },
            maintenanceRedeployStatus: {
                serializedName: "maintenanceRedeployStatus",
                type: {
                    name: "Composite",
                    className: "MaintenanceRedeployStatus"
                }
            },
            disks: {
                serializedName: "disks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskInstanceView"
                        }
                    }
                }
            },
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionInstanceView"
                        }
                    }
                }
            },
            vmHealth: {
                readOnly: true,
                serializedName: "vmHealth",
                type: {
                    name: "Composite",
                    className: "VirtualMachineHealthStatus"
                }
            },
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnosticsInstanceView"
                }
            },
            assignedHost: {
                readOnly: true,
                serializedName: "assignedHost",
                type: {
                    name: "String"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            patchStatus: {
                serializedName: "patchStatus",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePatchStatus"
                }
            }
        }
    }
};
export var TerminateNotificationProfile = {
    serializedName: "TerminateNotificationProfile",
    type: {
        name: "Composite",
        className: "TerminateNotificationProfile",
        modelProperties: {
            notBeforeTimeout: {
                serializedName: "notBeforeTimeout",
                type: {
                    name: "String"
                }
            },
            enable: {
                serializedName: "enable",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ScheduledEventsProfile = {
    serializedName: "ScheduledEventsProfile",
    type: {
        name: "Composite",
        className: "ScheduledEventsProfile",
        modelProperties: {
            terminateNotificationProfile: {
                serializedName: "terminateNotificationProfile",
                type: {
                    name: "Composite",
                    className: "TerminateNotificationProfile"
                }
            }
        }
    }
};
export var VirtualMachine = {
    serializedName: "VirtualMachine",
    type: {
        name: "Composite",
        className: "VirtualMachine",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualMachineScaleSet: {
                serializedName: "properties.virtualMachineScaleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, priority: {
                serializedName: "properties.priority",
                type: {
                    name: "String"
                }
            }, evictionPolicy: {
                serializedName: "properties.evictionPolicy",
                type: {
                    name: "String"
                }
            }, billingProfile: {
                serializedName: "properties.billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            }, host: {
                serializedName: "properties.host",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineInstanceView"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, vmId: {
                readOnly: true,
                serializedName: "properties.vmId",
                type: {
                    name: "String"
                }
            }, extensionsTimeBudget: {
                serializedName: "properties.extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }, platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, scheduledEventsProfile: {
                serializedName: "properties.scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            }, capacityReservation: {
                serializedName: "properties.capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            }, resources: {
                readOnly: true,
                serializedName: "resources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            } })
    }
};
export var VirtualMachineUpdate = {
    serializedName: "VirtualMachineUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualMachineScaleSet: {
                serializedName: "properties.virtualMachineScaleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, priority: {
                serializedName: "properties.priority",
                type: {
                    name: "String"
                }
            }, evictionPolicy: {
                serializedName: "properties.evictionPolicy",
                type: {
                    name: "String"
                }
            }, billingProfile: {
                serializedName: "properties.billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            }, host: {
                serializedName: "properties.host",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineInstanceView"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, vmId: {
                readOnly: true,
                serializedName: "properties.vmId",
                type: {
                    name: "String"
                }
            }, extensionsTimeBudget: {
                serializedName: "properties.extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }, platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, scheduledEventsProfile: {
                serializedName: "properties.scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            }, capacityReservation: {
                serializedName: "properties.capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var AutomaticOSUpgradePolicy = {
    serializedName: "AutomaticOSUpgradePolicy",
    type: {
        name: "Composite",
        className: "AutomaticOSUpgradePolicy",
        modelProperties: {
            enableAutomaticOSUpgrade: {
                serializedName: "enableAutomaticOSUpgrade",
                type: {
                    name: "Boolean"
                }
            },
            disableAutomaticRollback: {
                serializedName: "disableAutomaticRollback",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var RollingUpgradePolicy = {
    serializedName: "RollingUpgradePolicy",
    type: {
        name: "Composite",
        className: "RollingUpgradePolicy",
        modelProperties: {
            maxBatchInstancePercent: {
                serializedName: "maxBatchInstancePercent",
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 5
                },
                type: {
                    name: "Number"
                }
            },
            maxUnhealthyInstancePercent: {
                serializedName: "maxUnhealthyInstancePercent",
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 5
                },
                type: {
                    name: "Number"
                }
            },
            maxUnhealthyUpgradedInstancePercent: {
                serializedName: "maxUnhealthyUpgradedInstancePercent",
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            pauseTimeBetweenBatches: {
                serializedName: "pauseTimeBetweenBatches",
                type: {
                    name: "String"
                }
            },
            enableCrossZoneUpgrade: {
                serializedName: "enableCrossZoneUpgrade",
                type: {
                    name: "Boolean"
                }
            },
            prioritizeUnhealthyInstances: {
                serializedName: "prioritizeUnhealthyInstances",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var UpgradePolicy = {
    serializedName: "UpgradePolicy",
    type: {
        name: "Composite",
        className: "UpgradePolicy",
        modelProperties: {
            mode: {
                serializedName: "mode",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Automatic",
                        "Manual",
                        "Rolling"
                    ]
                }
            },
            rollingUpgradePolicy: {
                serializedName: "rollingUpgradePolicy",
                type: {
                    name: "Composite",
                    className: "RollingUpgradePolicy"
                }
            },
            automaticOSUpgradePolicy: {
                serializedName: "automaticOSUpgradePolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticOSUpgradePolicy"
                }
            }
        }
    }
};
export var ScaleInPolicy = {
    serializedName: "ScaleInPolicy",
    type: {
        name: "Composite",
        className: "ScaleInPolicy",
        modelProperties: {
            rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var SpotRestorePolicy = {
    serializedName: "SpotRestorePolicy",
    type: {
        name: "Composite",
        className: "SpotRestorePolicy",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            restoreTimeout: {
                serializedName: "restoreTimeout",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ImageDisk = {
    serializedName: "ImageDisk",
    type: {
        name: "Composite",
        className: "ImageDisk",
        modelProperties: {
            snapshot: {
                serializedName: "snapshot",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            blobUri: {
                serializedName: "blobUri",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            }
        }
    }
};
export var ImageOSDisk = {
    serializedName: "ImageOSDisk",
    type: {
        name: "Composite",
        className: "ImageOSDisk",
        modelProperties: __assign(__assign({}, ImageDisk.type.modelProperties), { osType: {
                required: true,
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, osState: {
                required: true,
                serializedName: "osState",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Generalized",
                        "Specialized"
                    ]
                }
            } })
    }
};
export var ImageDataDisk = {
    serializedName: "ImageDataDisk",
    type: {
        name: "Composite",
        className: "ImageDataDisk",
        modelProperties: __assign(__assign({}, ImageDisk.type.modelProperties), { lun: {
                required: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            } })
    }
};
export var ImageStorageProfile = {
    serializedName: "ImageStorageProfile",
    type: {
        name: "Composite",
        className: "ImageStorageProfile",
        modelProperties: {
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "ImageOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ImageDataDisk"
                        }
                    }
                }
            },
            zoneResilient: {
                serializedName: "zoneResilient",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var Image = {
    serializedName: "Image",
    type: {
        name: "Composite",
        className: "Image",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { sourceVirtualMachine: {
                serializedName: "properties.sourceVirtualMachine",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "ImageStorageProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            } })
    }
};
export var ImageUpdate = {
    serializedName: "ImageUpdate",
    type: {
        name: "Composite",
        className: "ImageUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { sourceVirtualMachine: {
                serializedName: "properties.sourceVirtualMachine",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "ImageStorageProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue = {
    serializedName: "VirtualMachineScaleSetIdentity_userAssignedIdentitiesValue",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            clientId: {
                readOnly: true,
                serializedName: "clientId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetIdentity = {
    serializedName: "VirtualMachineScaleSetIdentity",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIdentity",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            tenantId: {
                readOnly: true,
                serializedName: "tenantId",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "SystemAssigned",
                        "UserAssigned",
                        "SystemAssigned, UserAssigned",
                        "None"
                    ]
                }
            },
            userAssignedIdentities: {
                serializedName: "userAssignedIdentities",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetOSProfile = {
    serializedName: "VirtualMachineScaleSetOSProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetOSProfile",
        modelProperties: {
            computerNamePrefix: {
                serializedName: "computerNamePrefix",
                type: {
                    name: "String"
                }
            },
            adminUsername: {
                serializedName: "adminUsername",
                type: {
                    name: "String"
                }
            },
            adminPassword: {
                serializedName: "adminPassword",
                type: {
                    name: "String"
                }
            },
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdateOSProfile = {
    serializedName: "VirtualMachineScaleSetUpdateOSProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateOSProfile",
        modelProperties: {
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetManagedDiskParameters = {
    serializedName: "VirtualMachineScaleSetManagedDiskParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetManagedDiskParameters",
        modelProperties: {
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetOSDisk = {
    serializedName: "VirtualMachineScaleSetOSDisk",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetOSDisk",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                required: true,
                serializedName: "createOption",
                type: {
                    name: "String"
                }
            },
            diffDiskSettings: {
                serializedName: "diffDiskSettings",
                type: {
                    name: "Composite",
                    className: "DiffDiskSettings"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            osType: {
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            vhdContainers: {
                serializedName: "vhdContainers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdateOSDisk = {
    serializedName: "VirtualMachineScaleSetUpdateOSDisk",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateOSDisk",
        modelProperties: {
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            vhdContainers: {
                serializedName: "vhdContainers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetDataDisk = {
    serializedName: "VirtualMachineScaleSetDataDisk",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetDataDisk",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            lun: {
                required: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                required: true,
                serializedName: "createOption",
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            },
            diskIOPSReadWrite: {
                serializedName: "diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                serializedName: "diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetStorageProfile = {
    serializedName: "VirtualMachineScaleSetStorageProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetStorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdateStorageProfile = {
    serializedName: "VirtualMachineScaleSetUpdateStorageProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateStorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings = {
    serializedName: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings",
        modelProperties: {
            domainNameLabel: {
                required: true,
                serializedName: "domainNameLabel",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetIpTag = {
    serializedName: "VirtualMachineScaleSetIpTag",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIpTag",
        modelProperties: {
            ipTagType: {
                serializedName: "ipTagType",
                type: {
                    name: "String"
                }
            },
            tag: {
                serializedName: "tag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetPublicIPAddressConfiguration = {
    serializedName: "VirtualMachineScaleSetPublicIPAddressConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetPublicIPAddressConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings"
                }
            },
            ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIpTag"
                        }
                    }
                }
            },
            publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressSku"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdatePublicIPAddressConfiguration = {
    serializedName: "VirtualMachineScaleSetUpdatePublicIPAddressConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdatePublicIPAddressConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetIPConfiguration = {
    serializedName: "VirtualMachineScaleSetIPConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfiguration"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerInboundNatPools: {
                serializedName: "properties.loadBalancerInboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            } })
    }
};
export var VirtualMachineScaleSetUpdateIPConfiguration = {
    serializedName: "VirtualMachineScaleSetUpdateIPConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdatePublicIPAddressConfiguration"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerInboundNatPools: {
                serializedName: "properties.loadBalancerInboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            } })
    }
};
export var VirtualMachineScaleSetNetworkConfigurationDnsSettings = {
    serializedName: "VirtualMachineScaleSetNetworkConfigurationDnsSettings",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetNetworkConfiguration = {
    serializedName: "VirtualMachineScaleSetNetworkConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            }, enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings"
                }
            }, ipConfigurations: {
                required: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIPConfiguration"
                        }
                    }
                }
            }, enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualMachineScaleSetUpdateNetworkConfiguration = {
    serializedName: "VirtualMachineScaleSetUpdateNetworkConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateNetworkConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            }, enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings"
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetUpdateIPConfiguration"
                        }
                    }
                }
            }, enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualMachineScaleSetNetworkProfile = {
    serializedName: "VirtualMachineScaleSetNetworkProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkProfile",
        modelProperties: {
            healthProbe: {
                serializedName: "healthProbe",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetNetworkConfiguration"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdateNetworkProfile = {
    serializedName: "VirtualMachineScaleSetUpdateNetworkProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateNetworkProfile",
        modelProperties: {
            healthProbe: {
                serializedName: "healthProbe",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetUpdateNetworkConfiguration"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetExtension = {
    serializedName: "VirtualMachineScaleSetExtension",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtension",
        modelProperties: __assign(__assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type1: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, provisionAfterExtensions: {
                serializedName: "properties.provisionAfterExtensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var VirtualMachineScaleSetExtensionUpdate = {
    serializedName: "VirtualMachineScaleSetExtensionUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionUpdate",
        modelProperties: __assign(__assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type1: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Object"
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Object"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, provisionAfterExtensions: {
                serializedName: "properties.provisionAfterExtensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var VirtualMachineScaleSetExtensionProfile = {
    serializedName: "VirtualMachineScaleSetExtensionProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionProfile",
        modelProperties: {
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetExtension"
                        }
                    }
                }
            },
            extensionsTimeBudget: {
                serializedName: "extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMProfile = {
    serializedName: "VirtualMachineScaleSetVMProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMProfile",
        modelProperties: {
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetOSProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetStorageProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkProfile"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetExtensionProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            priority: {
                serializedName: "priority",
                type: {
                    name: "String"
                }
            },
            evictionPolicy: {
                serializedName: "evictionPolicy",
                type: {
                    name: "String"
                }
            },
            billingProfile: {
                serializedName: "billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            },
            scheduledEventsProfile: {
                serializedName: "scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            },
            userData: {
                serializedName: "userData",
                type: {
                    name: "String"
                }
            },
            capacityReservation: {
                serializedName: "capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetUpdateVMProfile = {
    serializedName: "VirtualMachineScaleSetUpdateVMProfile",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateVMProfile",
        modelProperties: {
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateOSProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateStorageProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateNetworkProfile"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetExtensionProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            billingProfile: {
                serializedName: "billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            },
            scheduledEventsProfile: {
                serializedName: "scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            },
            userData: {
                serializedName: "userData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSet = {
    serializedName: "VirtualMachineScaleSet",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSet",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, upgradePolicy: {
                serializedName: "properties.upgradePolicy",
                type: {
                    name: "Composite",
                    className: "UpgradePolicy"
                }
            }, automaticRepairsPolicy: {
                serializedName: "properties.automaticRepairsPolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticRepairsPolicy"
                }
            }, virtualMachineProfile: {
                serializedName: "properties.virtualMachineProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, overprovision: {
                serializedName: "properties.overprovision",
                type: {
                    name: "Boolean"
                }
            }, doNotRunExtensionsOnOverprovisionedVMs: {
                serializedName: "properties.doNotRunExtensionsOnOverprovisionedVMs",
                type: {
                    name: "Boolean"
                }
            }, uniqueId: {
                readOnly: true,
                serializedName: "properties.uniqueId",
                type: {
                    name: "String"
                }
            }, singlePlacementGroup: {
                serializedName: "properties.singlePlacementGroup",
                type: {
                    name: "Boolean"
                }
            }, zoneBalance: {
                serializedName: "properties.zoneBalance",
                type: {
                    name: "Boolean"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, scaleInPolicy: {
                serializedName: "properties.scaleInPolicy",
                type: {
                    name: "Composite",
                    className: "ScaleInPolicy"
                }
            }, orchestrationMode: {
                serializedName: "properties.orchestrationMode",
                type: {
                    name: "String"
                }
            }, spotRestorePolicy: {
                serializedName: "properties.spotRestorePolicy",
                type: {
                    name: "Composite",
                    className: "SpotRestorePolicy"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            } })
    }
};
export var VirtualMachineScaleSetVMReimageParameters = {
    serializedName: "VirtualMachineScaleSetVMReimageParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMReimageParameters",
        modelProperties: __assign({}, VirtualMachineReimageParameters.type.modelProperties)
    }
};
export var VirtualMachineScaleSetReimageParameters = {
    serializedName: "VirtualMachineScaleSetReimageParameters",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetReimageParameters",
        modelProperties: __assign(__assign({}, VirtualMachineScaleSetVMReimageParameters.type.modelProperties), { instanceIds: {
                serializedName: "instanceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var VirtualMachineScaleSetUpdate = {
    serializedName: "VirtualMachineScaleSetUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, upgradePolicy: {
                serializedName: "properties.upgradePolicy",
                type: {
                    name: "Composite",
                    className: "UpgradePolicy"
                }
            }, automaticRepairsPolicy: {
                serializedName: "properties.automaticRepairsPolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticRepairsPolicy"
                }
            }, virtualMachineProfile: {
                serializedName: "properties.virtualMachineProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateVMProfile"
                }
            }, overprovision: {
                serializedName: "properties.overprovision",
                type: {
                    name: "Boolean"
                }
            }, doNotRunExtensionsOnOverprovisionedVMs: {
                serializedName: "properties.doNotRunExtensionsOnOverprovisionedVMs",
                type: {
                    name: "Boolean"
                }
            }, singlePlacementGroup: {
                serializedName: "properties.singlePlacementGroup",
                type: {
                    name: "Boolean"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, scaleInPolicy: {
                serializedName: "properties.scaleInPolicy",
                type: {
                    name: "Composite",
                    className: "ScaleInPolicy"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetIdentity"
                }
            } })
    }
};
export var VirtualMachineScaleSetVMInstanceIDs = {
    serializedName: "VirtualMachineScaleSetVMInstanceIDs",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceIDs",
        modelProperties: {
            instanceIds: {
                serializedName: "instanceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMInstanceRequiredIDs = {
    serializedName: "VirtualMachineScaleSetVMInstanceRequiredIDs",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceRequiredIDs",
        modelProperties: {
            instanceIds: {
                required: true,
                serializedName: "instanceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineStatusCodeCount = {
    serializedName: "VirtualMachineStatusCodeCount",
    type: {
        name: "Composite",
        className: "VirtualMachineStatusCodeCount",
        modelProperties: {
            code: {
                readOnly: true,
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            count: {
                readOnly: true,
                serializedName: "count",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetInstanceViewStatusesSummary = {
    serializedName: "VirtualMachineScaleSetInstanceViewStatusesSummary",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetInstanceViewStatusesSummary",
        modelProperties: {
            statusesSummary: {
                readOnly: true,
                serializedName: "statusesSummary",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineStatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMExtensionsSummary = {
    serializedName: "VirtualMachineScaleSetVMExtensionsSummary",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionsSummary",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            statusesSummary: {
                readOnly: true,
                serializedName: "statusesSummary",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineStatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export var OrchestrationServiceSummary = {
    serializedName: "OrchestrationServiceSummary",
    type: {
        name: "Composite",
        className: "OrchestrationServiceSummary",
        modelProperties: {
            serviceName: {
                readOnly: true,
                serializedName: "serviceName",
                type: {
                    name: "String"
                }
            },
            serviceState: {
                readOnly: true,
                serializedName: "serviceState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetInstanceView = {
    serializedName: "VirtualMachineScaleSetInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetInstanceView",
        modelProperties: {
            virtualMachine: {
                readOnly: true,
                serializedName: "virtualMachine",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetInstanceViewStatusesSummary"
                }
            },
            extensions: {
                readOnly: true,
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVMExtensionsSummary"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            orchestrationServices: {
                readOnly: true,
                serializedName: "orchestrationServices",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OrchestrationServiceSummary"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetSkuCapacity = {
    serializedName: "VirtualMachineScaleSetSkuCapacity",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetSkuCapacity",
        modelProperties: {
            minimum: {
                readOnly: true,
                serializedName: "minimum",
                type: {
                    name: "Number"
                }
            },
            maximum: {
                readOnly: true,
                serializedName: "maximum",
                type: {
                    name: "Number"
                }
            },
            defaultCapacity: {
                readOnly: true,
                serializedName: "defaultCapacity",
                type: {
                    name: "Number"
                }
            },
            scaleType: {
                readOnly: true,
                serializedName: "scaleType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Automatic",
                        "None"
                    ]
                }
            }
        }
    }
};
export var VirtualMachineScaleSetSku = {
    serializedName: "VirtualMachineScaleSetSku",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetSku",
        modelProperties: {
            resourceType: {
                readOnly: true,
                serializedName: "resourceType",
                type: {
                    name: "String"
                }
            },
            sku: {
                readOnly: true,
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            },
            capacity: {
                readOnly: true,
                serializedName: "capacity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetSkuCapacity"
                }
            }
        }
    }
};
export var RollbackStatusInfo = {
    serializedName: "RollbackStatusInfo",
    type: {
        name: "Composite",
        className: "RollbackStatusInfo",
        modelProperties: {
            successfullyRolledbackInstanceCount: {
                readOnly: true,
                serializedName: "successfullyRolledbackInstanceCount",
                type: {
                    name: "Number"
                }
            },
            failedRolledbackInstanceCount: {
                readOnly: true,
                serializedName: "failedRolledbackInstanceCount",
                type: {
                    name: "Number"
                }
            },
            rollbackError: {
                readOnly: true,
                serializedName: "rollbackError",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export var UpgradeOperationHistoryStatus = {
    serializedName: "UpgradeOperationHistoryStatus",
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoryStatus",
        modelProperties: {
            code: {
                readOnly: true,
                serializedName: "code",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "RollingForward",
                        "Cancelled",
                        "Completed",
                        "Faulted"
                    ]
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                readOnly: true,
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export var RollingUpgradeProgressInfo = {
    serializedName: "RollingUpgradeProgressInfo",
    type: {
        name: "Composite",
        className: "RollingUpgradeProgressInfo",
        modelProperties: {
            successfulInstanceCount: {
                readOnly: true,
                serializedName: "successfulInstanceCount",
                type: {
                    name: "Number"
                }
            },
            failedInstanceCount: {
                readOnly: true,
                serializedName: "failedInstanceCount",
                type: {
                    name: "Number"
                }
            },
            inProgressInstanceCount: {
                readOnly: true,
                serializedName: "inProgressInstanceCount",
                type: {
                    name: "Number"
                }
            },
            pendingInstanceCount: {
                readOnly: true,
                serializedName: "pendingInstanceCount",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var UpgradeOperationHistoricalStatusInfoProperties = {
    serializedName: "UpgradeOperationHistoricalStatusInfoProperties",
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoricalStatusInfoProperties",
        modelProperties: {
            runningStatus: {
                readOnly: true,
                serializedName: "runningStatus",
                type: {
                    name: "Composite",
                    className: "UpgradeOperationHistoryStatus"
                }
            },
            progress: {
                readOnly: true,
                serializedName: "progress",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeProgressInfo"
                }
            },
            error: {
                readOnly: true,
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            },
            startedBy: {
                readOnly: true,
                serializedName: "startedBy",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Unknown",
                        "User",
                        "Platform"
                    ]
                }
            },
            targetImageReference: {
                readOnly: true,
                serializedName: "targetImageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            rollbackInfo: {
                readOnly: true,
                serializedName: "rollbackInfo",
                type: {
                    name: "Composite",
                    className: "RollbackStatusInfo"
                }
            }
        }
    }
};
export var UpgradeOperationHistoricalStatusInfo = {
    serializedName: "UpgradeOperationHistoricalStatusInfo",
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoricalStatusInfo",
        modelProperties: {
            properties: {
                readOnly: true,
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "UpgradeOperationHistoricalStatusInfoProperties"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMInstanceView = {
    serializedName: "VirtualMachineScaleSetVMInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                serializedName: "platformUpdateDomain",
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                serializedName: "platformFaultDomain",
                type: {
                    name: "Number"
                }
            },
            rdpThumbPrint: {
                serializedName: "rdpThumbPrint",
                type: {
                    name: "String"
                }
            },
            vmAgent: {
                serializedName: "vmAgent",
                type: {
                    name: "Composite",
                    className: "VirtualMachineAgentInstanceView"
                }
            },
            maintenanceRedeployStatus: {
                serializedName: "maintenanceRedeployStatus",
                type: {
                    name: "Composite",
                    className: "MaintenanceRedeployStatus"
                }
            },
            disks: {
                serializedName: "disks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskInstanceView"
                        }
                    }
                }
            },
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionInstanceView"
                        }
                    }
                }
            },
            vmHealth: {
                readOnly: true,
                serializedName: "vmHealth",
                type: {
                    name: "Composite",
                    className: "VirtualMachineHealthStatus"
                }
            },
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnosticsInstanceView"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            assignedHost: {
                readOnly: true,
                serializedName: "assignedHost",
                type: {
                    name: "String"
                }
            },
            placementGroupId: {
                serializedName: "placementGroupId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMNetworkProfileConfiguration = {
    serializedName: "VirtualMachineScaleSetVMNetworkProfileConfiguration",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMNetworkProfileConfiguration",
        modelProperties: {
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetNetworkConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMProtectionPolicy = {
    serializedName: "VirtualMachineScaleSetVMProtectionPolicy",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMProtectionPolicy",
        modelProperties: {
            protectFromScaleIn: {
                serializedName: "protectFromScaleIn",
                type: {
                    name: "Boolean"
                }
            },
            protectFromScaleSetActions: {
                serializedName: "protectFromScaleSetActions",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVM = {
    serializedName: "VirtualMachineScaleSetVM",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVM",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { instanceId: {
                readOnly: true,
                serializedName: "instanceId",
                type: {
                    name: "String"
                }
            }, sku: {
                readOnly: true,
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, latestModelApplied: {
                readOnly: true,
                serializedName: "properties.latestModelApplied",
                type: {
                    name: "Boolean"
                }
            }, vmId: {
                readOnly: true,
                serializedName: "properties.vmId",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMInstanceView"
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, networkProfileConfiguration: {
                serializedName: "properties.networkProfileConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMNetworkProfileConfiguration"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, modelDefinitionApplied: {
                readOnly: true,
                serializedName: "properties.modelDefinitionApplied",
                type: {
                    name: "String"
                }
            }, protectionPolicy: {
                serializedName: "properties.protectionPolicy",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMProtectionPolicy"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, resources: {
                readOnly: true,
                serializedName: "resources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }, zones: {
                readOnly: true,
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var RollingUpgradeRunningStatus = {
    serializedName: "RollingUpgradeRunningStatus",
    type: {
        name: "Composite",
        className: "RollingUpgradeRunningStatus",
        modelProperties: {
            code: {
                readOnly: true,
                serializedName: "code",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "RollingForward",
                        "Cancelled",
                        "Completed",
                        "Faulted"
                    ]
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            lastAction: {
                readOnly: true,
                serializedName: "lastAction",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Start",
                        "Cancel"
                    ]
                }
            },
            lastActionTime: {
                readOnly: true,
                serializedName: "lastActionTime",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export var RollingUpgradeStatusInfo = {
    serializedName: "RollingUpgradeStatusInfo",
    type: {
        name: "Composite",
        className: "RollingUpgradeStatusInfo",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { policy: {
                readOnly: true,
                serializedName: "properties.policy",
                type: {
                    name: "Composite",
                    className: "RollingUpgradePolicy"
                }
            }, runningStatus: {
                readOnly: true,
                serializedName: "properties.runningStatus",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeRunningStatus"
                }
            }, progress: {
                readOnly: true,
                serializedName: "properties.progress",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeProgressInfo"
                }
            }, error: {
                readOnly: true,
                serializedName: "properties.error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            } })
    }
};
export var RecoveryWalkResponse = {
    serializedName: "RecoveryWalkResponse",
    type: {
        name: "Composite",
        className: "RecoveryWalkResponse",
        modelProperties: {
            walkPerformed: {
                readOnly: true,
                serializedName: "walkPerformed",
                type: {
                    name: "Boolean"
                }
            },
            nextPlatformUpdateDomain: {
                readOnly: true,
                serializedName: "nextPlatformUpdateDomain",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var LogAnalyticsInputBase = {
    serializedName: "LogAnalyticsInputBase",
    type: {
        name: "Composite",
        className: "LogAnalyticsInputBase",
        modelProperties: {
            blobContainerSasUri: {
                required: true,
                serializedName: "blobContainerSasUri",
                type: {
                    name: "String"
                }
            },
            fromTime: {
                required: true,
                serializedName: "fromTime",
                type: {
                    name: "DateTime"
                }
            },
            toTime: {
                required: true,
                serializedName: "toTime",
                type: {
                    name: "DateTime"
                }
            },
            groupByThrottlePolicy: {
                serializedName: "groupByThrottlePolicy",
                type: {
                    name: "Boolean"
                }
            },
            groupByOperationName: {
                serializedName: "groupByOperationName",
                type: {
                    name: "Boolean"
                }
            },
            groupByResourceName: {
                serializedName: "groupByResourceName",
                type: {
                    name: "Boolean"
                }
            },
            groupByClientApplicationId: {
                serializedName: "groupByClientApplicationId",
                type: {
                    name: "Boolean"
                }
            },
            groupByUserAgent: {
                serializedName: "groupByUserAgent",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var RequestRateByIntervalInput = {
    serializedName: "RequestRateByIntervalInput",
    type: {
        name: "Composite",
        className: "RequestRateByIntervalInput",
        modelProperties: __assign(__assign({}, LogAnalyticsInputBase.type.modelProperties), { intervalLength: {
                required: true,
                serializedName: "intervalLength",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "ThreeMins",
                        "FiveMins",
                        "ThirtyMins",
                        "SixtyMins"
                    ]
                }
            } })
    }
};
export var ThrottledRequestsInput = {
    serializedName: "ThrottledRequestsInput",
    type: {
        name: "Composite",
        className: "ThrottledRequestsInput",
        modelProperties: __assign({}, LogAnalyticsInputBase.type.modelProperties)
    }
};
export var LogAnalyticsOutput = {
    serializedName: "LogAnalyticsOutput",
    type: {
        name: "Composite",
        className: "LogAnalyticsOutput",
        modelProperties: {
            output: {
                readOnly: true,
                serializedName: "output",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LogAnalyticsOperationResult = {
    serializedName: "LogAnalyticsOperationResult",
    type: {
        name: "Composite",
        className: "LogAnalyticsOperationResult",
        modelProperties: {
            properties: {
                readOnly: true,
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LogAnalyticsOutput"
                }
            }
        }
    }
};
export var VMScaleSetConvertToSinglePlacementGroupInput = {
    serializedName: "VMScaleSetConvertToSinglePlacementGroupInput",
    type: {
        name: "Composite",
        className: "VMScaleSetConvertToSinglePlacementGroupInput",
        modelProperties: {
            activePlacementGroupId: {
                serializedName: "activePlacementGroupId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OrchestrationServiceStateInput = {
    serializedName: "OrchestrationServiceStateInput",
    type: {
        name: "Composite",
        className: "OrchestrationServiceStateInput",
        modelProperties: {
            serviceName: {
                required: true,
                serializedName: "serviceName",
                type: {
                    name: "String"
                }
            },
            action: {
                required: true,
                serializedName: "action",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RunCommandInputParameter = {
    serializedName: "RunCommandInputParameter",
    type: {
        name: "Composite",
        className: "RunCommandInputParameter",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                required: true,
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RunCommandInput = {
    serializedName: "RunCommandInput",
    type: {
        name: "Composite",
        className: "RunCommandInput",
        modelProperties: {
            commandId: {
                required: true,
                serializedName: "commandId",
                type: {
                    name: "String"
                }
            },
            script: {
                serializedName: "script",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            parameters: {
                serializedName: "parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }
        }
    }
};
export var RunCommandParameterDefinition = {
    serializedName: "RunCommandParameterDefinition",
    type: {
        name: "Composite",
        className: "RunCommandParameterDefinition",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                required: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            defaultValue: {
                serializedName: "defaultValue",
                type: {
                    name: "String"
                }
            },
            required: {
                serializedName: "required",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var RunCommandDocumentBase = {
    serializedName: "RunCommandDocumentBase",
    type: {
        name: "Composite",
        className: "RunCommandDocumentBase",
        modelProperties: {
            schema: {
                required: true,
                serializedName: "$schema",
                type: {
                    name: "String"
                }
            },
            id: {
                required: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            osType: {
                required: true,
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            },
            label: {
                required: true,
                serializedName: "label",
                type: {
                    name: "String"
                }
            },
            description: {
                required: true,
                serializedName: "description",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RunCommandDocument = {
    serializedName: "RunCommandDocument",
    type: {
        name: "Composite",
        className: "RunCommandDocument",
        modelProperties: __assign(__assign({}, RunCommandDocumentBase.type.modelProperties), { script: {
                required: true,
                serializedName: "script",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, parameters: {
                serializedName: "parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandParameterDefinition"
                        }
                    }
                }
            } })
    }
};
export var RunCommandResult = {
    serializedName: "RunCommandResult",
    type: {
        name: "Composite",
        className: "RunCommandResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineRunCommandInstanceView = {
    serializedName: "VirtualMachineRunCommandInstanceView",
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandInstanceView",
        modelProperties: {
            executionState: {
                serializedName: "executionState",
                type: {
                    name: "String"
                }
            },
            executionMessage: {
                serializedName: "executionMessage",
                type: {
                    name: "String"
                }
            },
            exitCode: {
                serializedName: "exitCode",
                type: {
                    name: "Number"
                }
            },
            output: {
                serializedName: "output",
                type: {
                    name: "String"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "String"
                }
            },
            startTime: {
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualMachineRunCommandScriptSource = {
    serializedName: "VirtualMachineRunCommandScriptSource",
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandScriptSource",
        modelProperties: {
            script: {
                serializedName: "script",
                type: {
                    name: "String"
                }
            },
            scriptUri: {
                serializedName: "scriptUri",
                type: {
                    name: "String"
                }
            },
            commandId: {
                serializedName: "commandId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineRunCommand = {
    serializedName: "VirtualMachineRunCommand",
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommand",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandScriptSource"
                }
            }, parameters: {
                serializedName: "properties.parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, protectedParameters: {
                serializedName: "properties.protectedParameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, asyncExecution: {
                serializedName: "properties.asyncExecution",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }, runAsUser: {
                serializedName: "properties.runAsUser",
                type: {
                    name: "String"
                }
            }, runAsPassword: {
                serializedName: "properties.runAsPassword",
                type: {
                    name: "String"
                }
            }, timeoutInSeconds: {
                serializedName: "properties.timeoutInSeconds",
                type: {
                    name: "Number"
                }
            }, outputBlobUri: {
                serializedName: "properties.outputBlobUri",
                type: {
                    name: "String"
                }
            }, errorBlobUri: {
                serializedName: "properties.errorBlobUri",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandInstanceView"
                }
            } })
    }
};
export var VirtualMachineRunCommandUpdate = {
    serializedName: "VirtualMachineRunCommandUpdate",
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandUpdate",
        modelProperties: __assign(__assign({}, UpdateResource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandScriptSource"
                }
            }, parameters: {
                serializedName: "properties.parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, protectedParameters: {
                serializedName: "properties.protectedParameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, asyncExecution: {
                serializedName: "properties.asyncExecution",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }, runAsUser: {
                serializedName: "properties.runAsUser",
                type: {
                    name: "String"
                }
            }, runAsPassword: {
                serializedName: "properties.runAsPassword",
                type: {
                    name: "String"
                }
            }, timeoutInSeconds: {
                serializedName: "properties.timeoutInSeconds",
                type: {
                    name: "Number"
                }
            }, outputBlobUri: {
                serializedName: "properties.outputBlobUri",
                type: {
                    name: "String"
                }
            }, errorBlobUri: {
                serializedName: "properties.errorBlobUri",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, instanceView: {
                readOnly: true,
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandInstanceView"
                }
            } })
    }
};
export var ResourceSkuCapacity = {
    serializedName: "ResourceSkuCapacity",
    type: {
        name: "Composite",
        className: "ResourceSkuCapacity",
        modelProperties: {
            minimum: {
                readOnly: true,
                serializedName: "minimum",
                type: {
                    name: "Number"
                }
            },
            maximum: {
                readOnly: true,
                serializedName: "maximum",
                type: {
                    name: "Number"
                }
            },
            default: {
                readOnly: true,
                serializedName: "default",
                type: {
                    name: "Number"
                }
            },
            scaleType: {
                readOnly: true,
                serializedName: "scaleType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Automatic",
                        "Manual",
                        "None"
                    ]
                }
            }
        }
    }
};
export var ResourceSkuCosts = {
    serializedName: "ResourceSkuCosts",
    type: {
        name: "Composite",
        className: "ResourceSkuCosts",
        modelProperties: {
            meterID: {
                readOnly: true,
                serializedName: "meterID",
                type: {
                    name: "String"
                }
            },
            quantity: {
                readOnly: true,
                serializedName: "quantity",
                type: {
                    name: "Number"
                }
            },
            extendedUnit: {
                readOnly: true,
                serializedName: "extendedUnit",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ResourceSkuCapabilities = {
    serializedName: "ResourceSkuCapabilities",
    type: {
        name: "Composite",
        className: "ResourceSkuCapabilities",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                readOnly: true,
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ResourceSkuZoneDetails = {
    serializedName: "ResourceSkuZoneDetails",
    type: {
        name: "Composite",
        className: "ResourceSkuZoneDetails",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            capabilities: {
                readOnly: true,
                serializedName: "capabilities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCapabilities"
                        }
                    }
                }
            }
        }
    }
};
export var ResourceSkuRestrictionInfo = {
    serializedName: "ResourceSkuRestrictionInfo",
    type: {
        name: "Composite",
        className: "ResourceSkuRestrictionInfo",
        modelProperties: {
            locations: {
                readOnly: true,
                serializedName: "locations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            zones: {
                readOnly: true,
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var ResourceSkuRestrictions = {
    serializedName: "ResourceSkuRestrictions",
    type: {
        name: "Composite",
        className: "ResourceSkuRestrictions",
        modelProperties: {
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Location",
                        "Zone"
                    ]
                }
            },
            values: {
                readOnly: true,
                serializedName: "values",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            restrictionInfo: {
                readOnly: true,
                serializedName: "restrictionInfo",
                type: {
                    name: "Composite",
                    className: "ResourceSkuRestrictionInfo"
                }
            },
            reasonCode: {
                readOnly: true,
                serializedName: "reasonCode",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "QuotaId",
                        "NotAvailableForSubscription"
                    ]
                }
            }
        }
    }
};
export var ResourceSkuLocationInfo = {
    serializedName: "ResourceSkuLocationInfo",
    type: {
        name: "Composite",
        className: "ResourceSkuLocationInfo",
        modelProperties: {
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            zones: {
                readOnly: true,
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            zoneDetails: {
                readOnly: true,
                serializedName: "zoneDetails",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuZoneDetails"
                        }
                    }
                }
            }
        }
    }
};
export var ResourceSku = {
    serializedName: "ResourceSku",
    type: {
        name: "Composite",
        className: "ResourceSku",
        modelProperties: {
            resourceType: {
                readOnly: true,
                serializedName: "resourceType",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                readOnly: true,
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            size: {
                readOnly: true,
                serializedName: "size",
                type: {
                    name: "String"
                }
            },
            family: {
                readOnly: true,
                serializedName: "family",
                type: {
                    name: "String"
                }
            },
            kind: {
                readOnly: true,
                serializedName: "kind",
                type: {
                    name: "String"
                }
            },
            capacity: {
                readOnly: true,
                serializedName: "capacity",
                type: {
                    name: "Composite",
                    className: "ResourceSkuCapacity"
                }
            },
            locations: {
                readOnly: true,
                serializedName: "locations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            locationInfo: {
                readOnly: true,
                serializedName: "locationInfo",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuLocationInfo"
                        }
                    }
                }
            },
            apiVersions: {
                readOnly: true,
                serializedName: "apiVersions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            costs: {
                readOnly: true,
                serializedName: "costs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCosts"
                        }
                    }
                }
            },
            capabilities: {
                readOnly: true,
                serializedName: "capabilities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCapabilities"
                        }
                    }
                }
            },
            restrictions: {
                readOnly: true,
                serializedName: "restrictions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuRestrictions"
                        }
                    }
                }
            }
        }
    }
};
export var ProxyOnlyResource = {
    serializedName: "ProxyOnlyResource",
    type: {
        name: "Composite",
        className: "ProxyOnlyResource",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskSku = {
    serializedName: "DiskSku",
    type: {
        name: "Composite",
        className: "DiskSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                readOnly: true,
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ImageDiskReference = {
    serializedName: "ImageDiskReference",
    type: {
        name: "Composite",
        className: "ImageDiskReference",
        modelProperties: {
            id: {
                required: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            lun: {
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var CreationData = {
    serializedName: "CreationData",
    type: {
        name: "Composite",
        className: "CreationData",
        modelProperties: {
            createOption: {
                required: true,
                serializedName: "createOption",
                type: {
                    name: "String"
                }
            },
            storageAccountId: {
                serializedName: "storageAccountId",
                type: {
                    name: "String"
                }
            },
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageDiskReference"
                }
            },
            galleryImageReference: {
                serializedName: "galleryImageReference",
                type: {
                    name: "Composite",
                    className: "ImageDiskReference"
                }
            },
            sourceUri: {
                serializedName: "sourceUri",
                type: {
                    name: "String"
                }
            },
            sourceResourceId: {
                serializedName: "sourceResourceId",
                type: {
                    name: "String"
                }
            },
            sourceUniqueId: {
                readOnly: true,
                serializedName: "sourceUniqueId",
                type: {
                    name: "String"
                }
            },
            uploadSizeBytes: {
                serializedName: "uploadSizeBytes",
                type: {
                    name: "Number"
                }
            },
            logicalSectorSize: {
                serializedName: "logicalSectorSize",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var SourceVault = {
    serializedName: "SourceVault",
    type: {
        name: "Composite",
        className: "SourceVault",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var KeyVaultAndSecretReference = {
    serializedName: "KeyVaultAndSecretReference",
    type: {
        name: "Composite",
        className: "KeyVaultAndSecretReference",
        modelProperties: {
            sourceVault: {
                required: true,
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            secretUrl: {
                required: true,
                serializedName: "secretUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var KeyVaultAndKeyReference = {
    serializedName: "KeyVaultAndKeyReference",
    type: {
        name: "Composite",
        className: "KeyVaultAndKeyReference",
        modelProperties: {
            sourceVault: {
                required: true,
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            keyUrl: {
                required: true,
                serializedName: "keyUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var EncryptionSettingsElement = {
    serializedName: "EncryptionSettingsElement",
    type: {
        name: "Composite",
        className: "EncryptionSettingsElement",
        modelProperties: {
            diskEncryptionKey: {
                serializedName: "diskEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultAndSecretReference"
                }
            },
            keyEncryptionKey: {
                serializedName: "keyEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultAndKeyReference"
                }
            }
        }
    }
};
export var EncryptionSettingsCollection = {
    serializedName: "EncryptionSettingsCollection",
    type: {
        name: "Composite",
        className: "EncryptionSettingsCollection",
        modelProperties: {
            enabled: {
                required: true,
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EncryptionSettingsElement"
                        }
                    }
                }
            },
            encryptionSettingsVersion: {
                serializedName: "encryptionSettingsVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Encryption = {
    serializedName: "Encryption",
    type: {
        name: "Composite",
        className: "Encryption",
        modelProperties: {
            diskEncryptionSetId: {
                serializedName: "diskEncryptionSetId",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ShareInfoElement = {
    serializedName: "ShareInfoElement",
    type: {
        name: "Composite",
        className: "ShareInfoElement",
        modelProperties: {
            vmUri: {
                readOnly: true,
                serializedName: "vmUri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PropertyUpdatesInProgress = {
    serializedName: "PropertyUpdatesInProgress",
    type: {
        name: "Composite",
        className: "PropertyUpdatesInProgress",
        modelProperties: {
            targetTier: {
                serializedName: "targetTier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskSecurityProfile = {
    serializedName: "DiskSecurityProfile",
    type: {
        name: "Composite",
        className: "DiskSecurityProfile",
        modelProperties: {
            securityType: {
                serializedName: "securityType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Disk = {
    serializedName: "Disk",
    type: {
        name: "Composite",
        className: "Disk",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { managedBy: {
                readOnly: true,
                serializedName: "managedBy",
                type: {
                    name: "String"
                }
            }, managedByExtended: {
                readOnly: true,
                serializedName: "managedByExtended",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "DiskSku"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, timeCreated: {
                readOnly: true,
                serializedName: "properties.timeCreated",
                type: {
                    name: "DateTime"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            }, creationData: {
                required: true,
                serializedName: "properties.creationData",
                type: {
                    name: "Composite",
                    className: "CreationData"
                }
            }, diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            }, diskSizeBytes: {
                readOnly: true,
                serializedName: "properties.diskSizeBytes",
                type: {
                    name: "Number"
                }
            }, uniqueId: {
                readOnly: true,
                serializedName: "properties.uniqueId",
                type: {
                    name: "String"
                }
            }, encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, diskIOPSReadWrite: {
                serializedName: "properties.diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            }, diskMBpsReadWrite: {
                serializedName: "properties.diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            }, diskIOPSReadOnly: {
                serializedName: "properties.diskIOPSReadOnly",
                type: {
                    name: "Number"
                }
            }, diskMBpsReadOnly: {
                serializedName: "properties.diskMBpsReadOnly",
                type: {
                    name: "Number"
                }
            }, diskState: {
                serializedName: "properties.diskState",
                type: {
                    name: "String"
                }
            }, encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, maxShares: {
                serializedName: "properties.maxShares",
                type: {
                    name: "Number"
                }
            }, shareInfo: {
                readOnly: true,
                serializedName: "properties.shareInfo",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ShareInfoElement"
                        }
                    }
                }
            }, networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            }, diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            }, tier: {
                serializedName: "properties.tier",
                type: {
                    name: "String"
                }
            }, burstingEnabled: {
                serializedName: "properties.burstingEnabled",
                type: {
                    name: "Boolean"
                }
            }, propertyUpdatesInProgress: {
                readOnly: true,
                serializedName: "properties.propertyUpdatesInProgress",
                type: {
                    name: "Composite",
                    className: "PropertyUpdatesInProgress"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "DiskSecurityProfile"
                }
            } })
    }
};
export var DiskUpdate = {
    serializedName: "DiskUpdate",
    type: {
        name: "Composite",
        className: "DiskUpdate",
        modelProperties: {
            osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            },
            diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            },
            diskIOPSReadWrite: {
                serializedName: "properties.diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                serializedName: "properties.diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskIOPSReadOnly: {
                serializedName: "properties.diskIOPSReadOnly",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadOnly: {
                serializedName: "properties.diskMBpsReadOnly",
                type: {
                    name: "Number"
                }
            },
            maxShares: {
                serializedName: "properties.maxShares",
                type: {
                    name: "Number"
                }
            },
            encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            },
            networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            },
            diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "properties.tier",
                type: {
                    name: "String"
                }
            },
            burstingEnabled: {
                serializedName: "properties.burstingEnabled",
                type: {
                    name: "Boolean"
                }
            },
            purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            },
            propertyUpdatesInProgress: {
                readOnly: true,
                serializedName: "properties.propertyUpdatesInProgress",
                type: {
                    name: "Composite",
                    className: "PropertyUpdatesInProgress"
                }
            },
            supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "DiskSku"
                }
            }
        }
    }
};
export var SnapshotSku = {
    serializedName: "SnapshotSku",
    type: {
        name: "Composite",
        className: "SnapshotSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                readOnly: true,
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var KeyForDiskEncryptionSet = {
    serializedName: "KeyForDiskEncryptionSet",
    type: {
        name: "Composite",
        className: "KeyForDiskEncryptionSet",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            keyUrl: {
                required: true,
                serializedName: "keyUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GrantAccessData = {
    serializedName: "GrantAccessData",
    type: {
        name: "Composite",
        className: "GrantAccessData",
        modelProperties: {
            access: {
                required: true,
                serializedName: "access",
                type: {
                    name: "String"
                }
            },
            durationInSeconds: {
                required: true,
                serializedName: "durationInSeconds",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AccessUri = {
    serializedName: "AccessUri",
    type: {
        name: "Composite",
        className: "AccessUri",
        modelProperties: {
            accessSAS: {
                readOnly: true,
                serializedName: "accessSAS",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Snapshot = {
    serializedName: "Snapshot",
    type: {
        name: "Composite",
        className: "Snapshot",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { managedBy: {
                readOnly: true,
                serializedName: "managedBy",
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "SnapshotSku"
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, timeCreated: {
                readOnly: true,
                serializedName: "properties.timeCreated",
                type: {
                    name: "DateTime"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            }, creationData: {
                required: true,
                serializedName: "properties.creationData",
                type: {
                    name: "Composite",
                    className: "CreationData"
                }
            }, diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            }, diskSizeBytes: {
                readOnly: true,
                serializedName: "properties.diskSizeBytes",
                type: {
                    name: "Number"
                }
            }, diskState: {
                serializedName: "properties.diskState",
                type: {
                    name: "String"
                }
            }, uniqueId: {
                readOnly: true,
                serializedName: "properties.uniqueId",
                type: {
                    name: "String"
                }
            }, encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, incremental: {
                serializedName: "properties.incremental",
                type: {
                    name: "Boolean"
                }
            }, encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            }, diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export var SnapshotUpdate = {
    serializedName: "SnapshotUpdate",
    type: {
        name: "Composite",
        className: "SnapshotUpdate",
        modelProperties: {
            osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            },
            diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            },
            encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            },
            networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            },
            diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            },
            supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "SnapshotSku"
                }
            }
        }
    }
};
export var EncryptionSetIdentity = {
    serializedName: "EncryptionSetIdentity",
    type: {
        name: "Composite",
        className: "EncryptionSetIdentity",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            tenantId: {
                readOnly: true,
                serializedName: "tenantId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskEncryptionSet = {
    serializedName: "DiskEncryptionSet",
    type: {
        name: "Composite",
        className: "DiskEncryptionSet",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "EncryptionSetIdentity"
                }
            }, encryptionType: {
                serializedName: "properties.encryptionType",
                type: {
                    name: "String"
                }
            }, activeKey: {
                serializedName: "properties.activeKey",
                type: {
                    name: "Composite",
                    className: "KeyForDiskEncryptionSet"
                }
            }, previousKeys: {
                readOnly: true,
                serializedName: "properties.previousKeys",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "KeyForDiskEncryptionSet"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, rotationToLatestKeyVersionEnabled: {
                serializedName: "properties.rotationToLatestKeyVersionEnabled",
                type: {
                    name: "Boolean"
                }
            }, lastKeyRotationTimestamp: {
                readOnly: true,
                serializedName: "properties.lastKeyRotationTimestamp",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export var DiskEncryptionSetUpdate = {
    serializedName: "DiskEncryptionSetUpdate",
    type: {
        name: "Composite",
        className: "DiskEncryptionSetUpdate",
        modelProperties: {
            encryptionType: {
                serializedName: "properties.encryptionType",
                type: {
                    name: "String"
                }
            },
            activeKey: {
                serializedName: "properties.activeKey",
                type: {
                    name: "Composite",
                    className: "KeyForDiskEncryptionSet"
                }
            },
            rotationToLatestKeyVersionEnabled: {
                serializedName: "properties.rotationToLatestKeyVersionEnabled",
                type: {
                    name: "Boolean"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "EncryptionSetIdentity"
                }
            }
        }
    }
};
export var PrivateEndpoint = {
    serializedName: "PrivateEndpoint",
    type: {
        name: "Composite",
        className: "PrivateEndpoint",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceConnectionState = {
    serializedName: "PrivateLinkServiceConnectionState",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceConnectionState",
        modelProperties: {
            status: {
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            actionsRequired: {
                serializedName: "actionsRequired",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateEndpointConnection = {
    serializedName: "PrivateEndpointConnection",
    type: {
        name: "Composite",
        className: "PrivateEndpointConnection",
        modelProperties: {
            privateEndpoint: {
                readOnly: true,
                serializedName: "properties.privateEndpoint",
                type: {
                    name: "Composite",
                    className: "PrivateEndpoint"
                }
            },
            privateLinkServiceConnectionState: {
                required: true,
                serializedName: "properties.privateLinkServiceConnectionState",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServiceConnectionState"
                }
            },
            provisioningState: {
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskAccess = {
    serializedName: "DiskAccess",
    type: {
        name: "Composite",
        className: "DiskAccess",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { privateEndpointConnections: {
                readOnly: true,
                serializedName: "properties.privateEndpointConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, timeCreated: {
                readOnly: true,
                serializedName: "properties.timeCreated",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export var DiskAccessUpdate = {
    serializedName: "DiskAccessUpdate",
    type: {
        name: "Composite",
        className: "DiskAccessUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var PrivateLinkResource = {
    serializedName: "PrivateLinkResource",
    type: {
        name: "Composite",
        className: "PrivateLinkResource",
        modelProperties: {
            groupId: {
                readOnly: true,
                serializedName: "properties.groupId",
                type: {
                    name: "String"
                }
            },
            requiredMembers: {
                readOnly: true,
                serializedName: "properties.requiredMembers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            requiredZoneNames: {
                serializedName: "properties.requiredZoneNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskRestorePoint = {
    serializedName: "DiskRestorePoint",
    type: {
        name: "Composite",
        className: "DiskRestorePoint",
        modelProperties: __assign(__assign({}, ProxyOnlyResource.type.modelProperties), { timeCreated: {
                readOnly: true,
                serializedName: "properties.timeCreated",
                type: {
                    name: "DateTime"
                }
            }, sourceResourceId: {
                readOnly: true,
                serializedName: "properties.sourceResourceId",
                type: {
                    name: "String"
                }
            }, osType: {
                readOnly: true,
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            }, familyId: {
                readOnly: true,
                serializedName: "properties.familyId",
                type: {
                    name: "String"
                }
            }, sourceUniqueId: {
                readOnly: true,
                serializedName: "properties.sourceUniqueId",
                type: {
                    name: "String"
                }
            }, encryption: {
                readOnly: true,
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export var PrivateLinkResourceListResult = {
    serializedName: "PrivateLinkResourceListResult",
    type: {
        name: "Composite",
        className: "PrivateLinkResourceListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkResource"
                        }
                    }
                }
            }
        }
    }
};
export var GalleryIdentifier = {
    serializedName: "GalleryIdentifier",
    type: {
        name: "Composite",
        className: "GalleryIdentifier",
        modelProperties: {
            uniqueName: {
                readOnly: true,
                serializedName: "uniqueName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SharingProfileGroup = {
    serializedName: "SharingProfileGroup",
    type: {
        name: "Composite",
        className: "SharingProfileGroup",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            ids: {
                serializedName: "ids",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var SharingProfile = {
    serializedName: "SharingProfile",
    type: {
        name: "Composite",
        className: "SharingProfile",
        modelProperties: {
            permissions: {
                serializedName: "permissions",
                type: {
                    name: "String"
                }
            },
            groups: {
                readOnly: true,
                serializedName: "groups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharingProfileGroup"
                        }
                    }
                }
            }
        }
    }
};
export var Gallery = {
    serializedName: "Gallery",
    type: {
        name: "Composite",
        className: "Gallery",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryIdentifier"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, sharingProfile: {
                serializedName: "properties.sharingProfile",
                type: {
                    name: "Composite",
                    className: "SharingProfile"
                }
            } })
    }
};
export var UpdateResourceDefinition = {
    serializedName: "UpdateResourceDefinition",
    type: {
        name: "Composite",
        className: "UpdateResourceDefinition",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var GalleryUpdate = {
    serializedName: "GalleryUpdate",
    type: {
        name: "Composite",
        className: "GalleryUpdate",
        modelProperties: __assign(__assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryIdentifier"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, sharingProfile: {
                serializedName: "properties.sharingProfile",
                type: {
                    name: "Composite",
                    className: "SharingProfile"
                }
            } })
    }
};
export var GalleryApplication = {
    serializedName: "GalleryApplication",
    type: {
        name: "Composite",
        className: "GalleryApplication",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, supportedOSType: {
                required: true,
                serializedName: "properties.supportedOSType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            } })
    }
};
export var GalleryApplicationUpdate = {
    serializedName: "GalleryApplicationUpdate",
    type: {
        name: "Composite",
        className: "GalleryApplicationUpdate",
        modelProperties: __assign(__assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, supportedOSType: {
                required: true,
                serializedName: "properties.supportedOSType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            } })
    }
};
export var UserArtifactSource = {
    serializedName: "UserArtifactSource",
    type: {
        name: "Composite",
        className: "UserArtifactSource",
        modelProperties: {
            mediaLink: {
                required: true,
                serializedName: "mediaLink",
                type: {
                    name: "String"
                }
            },
            defaultConfigurationLink: {
                serializedName: "defaultConfigurationLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var UserArtifactManage = {
    serializedName: "UserArtifactManage",
    type: {
        name: "Composite",
        className: "UserArtifactManage",
        modelProperties: {
            install: {
                required: true,
                serializedName: "install",
                type: {
                    name: "String"
                }
            },
            remove: {
                required: true,
                serializedName: "remove",
                type: {
                    name: "String"
                }
            },
            update: {
                serializedName: "update",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryArtifactPublishingProfileBase = {
    serializedName: "GalleryArtifactPublishingProfileBase",
    type: {
        name: "Composite",
        className: "GalleryArtifactPublishingProfileBase",
        modelProperties: {
            targetRegions: {
                serializedName: "targetRegions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TargetRegion"
                        }
                    }
                }
            },
            replicaCount: {
                serializedName: "replicaCount",
                type: {
                    name: "Number"
                }
            },
            excludeFromLatest: {
                serializedName: "excludeFromLatest",
                type: {
                    name: "Boolean"
                }
            },
            publishedDate: {
                readOnly: true,
                serializedName: "publishedDate",
                type: {
                    name: "DateTime"
                }
            },
            endOfLifeDate: {
                serializedName: "endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryApplicationVersionPublishingProfile = {
    serializedName: "GalleryApplicationVersionPublishingProfile",
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionPublishingProfile",
        modelProperties: __assign(__assign({}, GalleryArtifactPublishingProfileBase.type.modelProperties), { source: {
                required: true,
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "UserArtifactSource"
                }
            }, manageActions: {
                serializedName: "manageActions",
                type: {
                    name: "Composite",
                    className: "UserArtifactManage"
                }
            }, enableHealthCheck: {
                serializedName: "enableHealthCheck",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export var RegionalReplicationStatus = {
    serializedName: "RegionalReplicationStatus",
    type: {
        name: "Composite",
        className: "RegionalReplicationStatus",
        modelProperties: {
            region: {
                readOnly: true,
                serializedName: "region",
                type: {
                    name: "String"
                }
            },
            state: {
                readOnly: true,
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            details: {
                readOnly: true,
                serializedName: "details",
                type: {
                    name: "String"
                }
            },
            progress: {
                readOnly: true,
                serializedName: "progress",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ReplicationStatus = {
    serializedName: "ReplicationStatus",
    type: {
        name: "Composite",
        className: "ReplicationStatus",
        modelProperties: {
            aggregatedState: {
                readOnly: true,
                serializedName: "aggregatedState",
                type: {
                    name: "String"
                }
            },
            summary: {
                readOnly: true,
                serializedName: "summary",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RegionalReplicationStatus"
                        }
                    }
                }
            }
        }
    }
};
export var GalleryApplicationVersion = {
    serializedName: "GalleryApplicationVersion",
    type: {
        name: "Composite",
        className: "GalleryApplicationVersion",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { publishingProfile: {
                required: true,
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryApplicationVersionPublishingProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, replicationStatus: {
                readOnly: true,
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export var GalleryApplicationVersionUpdate = {
    serializedName: "GalleryApplicationVersionUpdate",
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionUpdate",
        modelProperties: __assign(__assign({}, UpdateResourceDefinition.type.modelProperties), { publishingProfile: {
                required: true,
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryApplicationVersionPublishingProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, replicationStatus: {
                readOnly: true,
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export var GalleryImageIdentifier = {
    serializedName: "GalleryImageIdentifier",
    type: {
        name: "Composite",
        className: "GalleryImageIdentifier",
        modelProperties: {
            publisher: {
                required: true,
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            offer: {
                required: true,
                serializedName: "offer",
                type: {
                    name: "String"
                }
            },
            sku: {
                required: true,
                serializedName: "sku",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ResourceRange = {
    serializedName: "ResourceRange",
    type: {
        name: "Composite",
        className: "ResourceRange",
        modelProperties: {
            min: {
                serializedName: "min",
                type: {
                    name: "Number"
                }
            },
            max: {
                serializedName: "max",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var RecommendedMachineConfiguration = {
    serializedName: "RecommendedMachineConfiguration",
    type: {
        name: "Composite",
        className: "RecommendedMachineConfiguration",
        modelProperties: {
            vCPUs: {
                serializedName: "vCPUs",
                type: {
                    name: "Composite",
                    className: "ResourceRange"
                }
            },
            memory: {
                serializedName: "memory",
                type: {
                    name: "Composite",
                    className: "ResourceRange"
                }
            }
        }
    }
};
export var Disallowed = {
    serializedName: "Disallowed",
    type: {
        name: "Composite",
        className: "Disallowed",
        modelProperties: {
            diskTypes: {
                serializedName: "diskTypes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var ImagePurchasePlan = {
    serializedName: "ImagePurchasePlan",
    type: {
        name: "Composite",
        className: "ImagePurchasePlan",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryImageFeature = {
    serializedName: "GalleryImageFeature",
    type: {
        name: "Composite",
        className: "GalleryImageFeature",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryImage = {
    serializedName: "GalleryImage",
    type: {
        name: "Composite",
        className: "GalleryImage",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, osType: {
                required: true,
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, osState: {
                required: true,
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Generalized",
                        "Specialized"
                    ]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                required: true,
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            } })
    }
};
export var GalleryImageUpdate = {
    serializedName: "GalleryImageUpdate",
    type: {
        name: "Composite",
        className: "GalleryImageUpdate",
        modelProperties: __assign(__assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, osType: {
                required: true,
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, osState: {
                required: true,
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Generalized",
                        "Specialized"
                    ]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                required: true,
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            } })
    }
};
export var GalleryImageVersionPublishingProfile = {
    serializedName: "GalleryImageVersionPublishingProfile",
    type: {
        name: "Composite",
        className: "GalleryImageVersionPublishingProfile",
        modelProperties: __assign({}, GalleryArtifactPublishingProfileBase.type.modelProperties)
    }
};
export var GalleryArtifactVersionSource = {
    serializedName: "GalleryArtifactVersionSource",
    type: {
        name: "Composite",
        className: "GalleryArtifactVersionSource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            uri: {
                serializedName: "uri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryDiskImage = {
    serializedName: "GalleryDiskImage",
    type: {
        name: "Composite",
        className: "GalleryDiskImage",
        modelProperties: {
            sizeInGB: {
                readOnly: true,
                serializedName: "sizeInGB",
                type: {
                    name: "Number"
                }
            },
            hostCaching: {
                serializedName: "hostCaching",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "ReadOnly",
                        "ReadWrite"
                    ]
                }
            },
            source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "GalleryArtifactVersionSource"
                }
            }
        }
    }
};
export var GalleryOSDiskImage = {
    serializedName: "GalleryOSDiskImage",
    type: {
        name: "Composite",
        className: "GalleryOSDiskImage",
        modelProperties: __assign({}, GalleryDiskImage.type.modelProperties)
    }
};
export var GalleryDataDiskImage = {
    serializedName: "GalleryDataDiskImage",
    type: {
        name: "Composite",
        className: "GalleryDataDiskImage",
        modelProperties: __assign(__assign({}, GalleryDiskImage.type.modelProperties), { lun: {
                required: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            } })
    }
};
export var GalleryImageVersionStorageProfile = {
    serializedName: "GalleryImageVersionStorageProfile",
    type: {
        name: "Composite",
        className: "GalleryImageVersionStorageProfile",
        modelProperties: {
            source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "GalleryArtifactVersionSource"
                }
            },
            osDiskImage: {
                serializedName: "osDiskImage",
                type: {
                    name: "Composite",
                    className: "GalleryOSDiskImage"
                }
            },
            dataDiskImages: {
                serializedName: "dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryDataDiskImage"
                        }
                    }
                }
            }
        }
    }
};
export var GalleryImageVersion = {
    serializedName: "GalleryImageVersion",
    type: {
        name: "Composite",
        className: "GalleryImageVersion",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionPublishingProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, storageProfile: {
                required: true,
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionStorageProfile"
                }
            }, replicationStatus: {
                readOnly: true,
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export var GalleryImageVersionUpdate = {
    serializedName: "GalleryImageVersionUpdate",
    type: {
        name: "Composite",
        className: "GalleryImageVersionUpdate",
        modelProperties: __assign(__assign({}, UpdateResourceDefinition.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionPublishingProfile"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, storageProfile: {
                required: true,
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionStorageProfile"
                }
            }, replicationStatus: {
                readOnly: true,
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export var DiskImageEncryption = {
    serializedName: "DiskImageEncryption",
    type: {
        name: "Composite",
        className: "DiskImageEncryption",
        modelProperties: {
            diskEncryptionSetId: {
                serializedName: "diskEncryptionSetId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSDiskImageEncryption = {
    serializedName: "OSDiskImageEncryption",
    type: {
        name: "Composite",
        className: "OSDiskImageEncryption",
        modelProperties: __assign({}, DiskImageEncryption.type.modelProperties)
    }
};
export var DataDiskImageEncryption = {
    serializedName: "DataDiskImageEncryption",
    type: {
        name: "Composite",
        className: "DataDiskImageEncryption",
        modelProperties: __assign(__assign({}, DiskImageEncryption.type.modelProperties), { lun: {
                required: true,
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            } })
    }
};
export var EncryptionImages = {
    serializedName: "EncryptionImages",
    type: {
        name: "Composite",
        className: "EncryptionImages",
        modelProperties: {
            osDiskImage: {
                serializedName: "osDiskImage",
                type: {
                    name: "Composite",
                    className: "OSDiskImageEncryption"
                }
            },
            dataDiskImages: {
                serializedName: "dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDiskImageEncryption"
                        }
                    }
                }
            }
        }
    }
};
export var TargetRegion = {
    serializedName: "TargetRegion",
    type: {
        name: "Composite",
        className: "TargetRegion",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            regionalReplicaCount: {
                serializedName: "regionalReplicaCount",
                type: {
                    name: "Number"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            encryption: {
                serializedName: "encryption",
                type: {
                    name: "Composite",
                    className: "EncryptionImages"
                }
            }
        }
    }
};
export var ManagedArtifact = {
    serializedName: "ManagedArtifact",
    type: {
        name: "Composite",
        className: "ManagedArtifact",
        modelProperties: {
            id: {
                required: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryArtifactSource = {
    serializedName: "GalleryArtifactSource",
    type: {
        name: "Composite",
        className: "GalleryArtifactSource",
        modelProperties: {
            managedImage: {
                required: true,
                serializedName: "managedImage",
                type: {
                    name: "Composite",
                    className: "ManagedArtifact"
                }
            }
        }
    }
};
export var SharingUpdate = {
    serializedName: "SharingUpdate",
    type: {
        name: "Composite",
        className: "SharingUpdate",
        modelProperties: {
            operationType: {
                required: true,
                serializedName: "operationType",
                type: {
                    name: "String"
                }
            },
            groups: {
                serializedName: "groups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharingProfileGroup"
                        }
                    }
                }
            }
        }
    }
};
export var PirResource = {
    serializedName: "PirResource",
    type: {
        name: "Composite",
        className: "PirResource",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PirSharedGalleryResource = {
    serializedName: "PirSharedGalleryResource",
    type: {
        name: "Composite",
        className: "PirSharedGalleryResource",
        modelProperties: __assign(__assign({}, PirResource.type.modelProperties), { uniqueId: {
                serializedName: "identifier.uniqueId",
                type: {
                    name: "String"
                }
            } })
    }
};
export var SharedGallery = {
    serializedName: "SharedGallery",
    type: {
        name: "Composite",
        className: "SharedGallery",
        modelProperties: __assign({}, PirSharedGalleryResource.type.modelProperties)
    }
};
export var SharedGalleryImage = {
    serializedName: "SharedGalleryImage",
    type: {
        name: "Composite",
        className: "SharedGalleryImage",
        modelProperties: __assign(__assign({}, PirSharedGalleryResource.type.modelProperties), { osType: {
                required: true,
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Windows",
                        "Linux"
                    ]
                }
            }, osState: {
                required: true,
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Generalized",
                        "Specialized"
                    ]
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                required: true,
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            } })
    }
};
export var SharedGalleryImageVersion = {
    serializedName: "SharedGalleryImageVersion",
    type: {
        name: "Composite",
        className: "SharedGalleryImageVersion",
        modelProperties: __assign(__assign({}, PirSharedGalleryResource.type.modelProperties), { publishedDate: {
                serializedName: "properties.publishedDate",
                type: {
                    name: "DateTime"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export var InstanceSku = {
    serializedName: "InstanceSku",
    type: {
        name: "Composite",
        className: "InstanceSku",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                readOnly: true,
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RoleInstanceNetworkProfile = {
    serializedName: "RoleInstanceNetworkProfile",
    type: {
        name: "Composite",
        className: "RoleInstanceNetworkProfile",
        modelProperties: {
            networkInterfaces: {
                readOnly: true,
                serializedName: "networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }
        }
    }
};
export var ResourceInstanceViewStatus = {
    serializedName: "ResourceInstanceViewStatus",
    type: {
        name: "Composite",
        className: "ResourceInstanceViewStatus",
        modelProperties: {
            code: {
                readOnly: true,
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            displayStatus: {
                readOnly: true,
                serializedName: "displayStatus",
                type: {
                    name: "String"
                }
            },
            message: {
                readOnly: true,
                serializedName: "message",
                type: {
                    name: "String"
                }
            },
            time: {
                readOnly: true,
                serializedName: "time",
                type: {
                    name: "DateTime"
                }
            },
            level: {
                serializedName: "level",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "Info",
                        "Warning",
                        "Error"
                    ]
                }
            }
        }
    }
};
export var RoleInstanceInstanceView = {
    serializedName: "RoleInstanceInstanceView",
    type: {
        name: "Composite",
        className: "RoleInstanceInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                readOnly: true,
                serializedName: "platformUpdateDomain",
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                readOnly: true,
                serializedName: "platformFaultDomain",
                type: {
                    name: "Number"
                }
            },
            privateId: {
                readOnly: true,
                serializedName: "privateId",
                type: {
                    name: "String"
                }
            },
            statuses: {
                readOnly: true,
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceInstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var RoleInstanceProperties = {
    serializedName: "RoleInstanceProperties",
    type: {
        name: "Composite",
        className: "RoleInstanceProperties",
        modelProperties: {
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "RoleInstanceNetworkProfile"
                }
            },
            instanceView: {
                serializedName: "instanceView",
                type: {
                    name: "Composite",
                    className: "RoleInstanceInstanceView"
                }
            }
        }
    }
};
export var RoleInstance = {
    serializedName: "RoleInstance",
    type: {
        name: "Composite",
        className: "RoleInstance",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                readOnly: true,
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "InstanceSku"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "RoleInstanceProperties"
                }
            }
        }
    }
};
export var CloudServiceRoleSku = {
    serializedName: "CloudServiceRoleSku",
    type: {
        name: "Composite",
        className: "CloudServiceRoleSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var CloudServiceRoleProperties = {
    serializedName: "CloudServiceRoleProperties",
    type: {
        name: "Composite",
        className: "CloudServiceRoleProperties",
        modelProperties: {
            uniqueId: {
                readOnly: true,
                serializedName: "uniqueId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudServiceRole = {
    serializedName: "CloudServiceRole",
    type: {
        name: "Composite",
        className: "CloudServiceRole",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleSku"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleProperties"
                }
            }
        }
    }
};
export var CloudServiceRoleProfileProperties = {
    serializedName: "CloudServiceRoleProfileProperties",
    type: {
        name: "Composite",
        className: "CloudServiceRoleProfileProperties",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleSku"
                }
            }
        }
    }
};
export var CloudServiceRoleProfile = {
    serializedName: "CloudServiceRoleProfile",
    type: {
        name: "Composite",
        className: "CloudServiceRoleProfile",
        modelProperties: {
            roles: {
                serializedName: "roles",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceRoleProfileProperties"
                        }
                    }
                }
            }
        }
    }
};
export var CloudServiceVaultCertificate = {
    serializedName: "CloudServiceVaultCertificate",
    type: {
        name: "Composite",
        className: "CloudServiceVaultCertificate",
        modelProperties: {
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudServiceVaultSecretGroup = {
    serializedName: "CloudServiceVaultSecretGroup",
    type: {
        name: "Composite",
        className: "CloudServiceVaultSecretGroup",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            vaultCertificates: {
                serializedName: "vaultCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceVaultCertificate"
                        }
                    }
                }
            }
        }
    }
};
export var CloudServiceOsProfile = {
    serializedName: "CloudServiceOsProfile",
    type: {
        name: "Composite",
        className: "CloudServiceOsProfile",
        modelProperties: {
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceVaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export var LoadBalancerFrontendIPConfigurationProperties = {
    serializedName: "LoadBalancerFrontendIPConfigurationProperties",
    type: {
        name: "Composite",
        className: "LoadBalancerFrontendIPConfigurationProperties",
        modelProperties: {
            publicIPAddress: {
                serializedName: "publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            subnet: {
                serializedName: "subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            privateIPAddress: {
                serializedName: "privateIPAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerFrontendIPConfiguration = {
    serializedName: "LoadBalancerFrontendIPConfiguration",
    type: {
        name: "Composite",
        className: "LoadBalancerFrontendIPConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            properties: {
                required: true,
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LoadBalancerFrontendIPConfigurationProperties"
                }
            }
        }
    }
};
export var LoadBalancerConfigurationProperties = {
    serializedName: "LoadBalancerConfigurationProperties",
    type: {
        name: "Composite",
        className: "LoadBalancerConfigurationProperties",
        modelProperties: {
            frontendIPConfigurations: {
                required: true,
                serializedName: "frontendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerFrontendIPConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export var LoadBalancerConfiguration = {
    serializedName: "LoadBalancerConfiguration",
    type: {
        name: "Composite",
        className: "LoadBalancerConfiguration",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            properties: {
                required: true,
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LoadBalancerConfigurationProperties"
                }
            }
        }
    }
};
export var CloudServiceNetworkProfile = {
    serializedName: "CloudServiceNetworkProfile",
    type: {
        name: "Composite",
        className: "CloudServiceNetworkProfile",
        modelProperties: {
            loadBalancerConfigurations: {
                serializedName: "loadBalancerConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerConfiguration"
                        }
                    }
                }
            },
            swappableCloudService: {
                serializedName: "swappableCloudService",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var CloudServiceVaultAndSecretReference = {
    serializedName: "CloudServiceVaultAndSecretReference",
    type: {
        name: "Composite",
        className: "CloudServiceVaultAndSecretReference",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            secretUrl: {
                serializedName: "secretUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudServiceExtensionProperties = {
    serializedName: "CloudServiceExtensionProperties",
    type: {
        name: "Composite",
        className: "CloudServiceExtensionProperties",
        modelProperties: {
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            autoUpgradeMinorVersion: {
                serializedName: "autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            },
            settings: {
                serializedName: "settings",
                type: {
                    name: "String"
                }
            },
            protectedSettings: {
                serializedName: "protectedSettings",
                type: {
                    name: "String"
                }
            },
            protectedSettingsFromKeyVault: {
                serializedName: "protectedSettingsFromKeyVault",
                type: {
                    name: "Composite",
                    className: "CloudServiceVaultAndSecretReference"
                }
            },
            forceUpdateTag: {
                serializedName: "forceUpdateTag",
                type: {
                    name: "String"
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "provisioningState",
                type: {
                    name: "String"
                }
            },
            rolesAppliedTo: {
                serializedName: "rolesAppliedTo",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var Extension = {
    serializedName: "Extension",
    type: {
        name: "Composite",
        className: "Extension",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceExtensionProperties"
                }
            }
        }
    }
};
export var CloudServiceExtensionProfile = {
    serializedName: "CloudServiceExtensionProfile",
    type: {
        name: "Composite",
        className: "CloudServiceExtensionProfile",
        modelProperties: {
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Extension"
                        }
                    }
                }
            }
        }
    }
};
export var CloudServiceProperties = {
    serializedName: "CloudServiceProperties",
    type: {
        name: "Composite",
        className: "CloudServiceProperties",
        modelProperties: {
            packageUrl: {
                serializedName: "packageUrl",
                type: {
                    name: "String"
                }
            },
            configuration: {
                serializedName: "configuration",
                type: {
                    name: "String"
                }
            },
            configurationUrl: {
                serializedName: "configurationUrl",
                type: {
                    name: "String"
                }
            },
            startCloudService: {
                serializedName: "startCloudService",
                type: {
                    name: "Boolean"
                }
            },
            allowModelOverride: {
                serializedName: "allowModelOverride",
                type: {
                    name: "Boolean"
                }
            },
            upgradeMode: {
                serializedName: "upgradeMode",
                type: {
                    name: "String"
                }
            },
            roleProfile: {
                serializedName: "roleProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleProfile"
                }
            },
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceOsProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceNetworkProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceExtensionProfile"
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "provisioningState",
                type: {
                    name: "String"
                }
            },
            uniqueId: {
                readOnly: true,
                serializedName: "uniqueId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudService = {
    serializedName: "CloudService",
    type: {
        name: "Composite",
        className: "CloudService",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                required: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceProperties"
                }
            }
        }
    }
};
export var CloudServiceUpdate = {
    serializedName: "CloudServiceUpdate",
    type: {
        name: "Composite",
        className: "CloudServiceUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var StatusCodeCount = {
    serializedName: "StatusCodeCount",
    type: {
        name: "Composite",
        className: "StatusCodeCount",
        modelProperties: {
            code: {
                readOnly: true,
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            count: {
                readOnly: true,
                serializedName: "count",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var InstanceViewStatusesSummary = {
    serializedName: "InstanceViewStatusesSummary",
    type: {
        name: "Composite",
        className: "InstanceViewStatusesSummary",
        modelProperties: {
            statusesSummary: {
                readOnly: true,
                serializedName: "statusesSummary",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "StatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export var CloudServiceInstanceView = {
    serializedName: "CloudServiceInstanceView",
    type: {
        name: "Composite",
        className: "CloudServiceInstanceView",
        modelProperties: {
            roleInstance: {
                serializedName: "roleInstance",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatusesSummary"
                }
            },
            sdkVersion: {
                readOnly: true,
                serializedName: "sdkVersion",
                type: {
                    name: "String"
                }
            },
            privateIds: {
                readOnly: true,
                serializedName: "privateIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            statuses: {
                readOnly: true,
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceInstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export var RoleInstances = {
    serializedName: "RoleInstances",
    type: {
        name: "Composite",
        className: "RoleInstances",
        modelProperties: {
            roleInstances: {
                required: true,
                serializedName: "roleInstances",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var UpdateDomain = {
    serializedName: "UpdateDomain",
    type: {
        name: "Composite",
        className: "UpdateDomain",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSVersionProperties = {
    serializedName: "OSVersionProperties",
    type: {
        name: "Composite",
        className: "OSVersionProperties",
        modelProperties: {
            family: {
                readOnly: true,
                serializedName: "family",
                type: {
                    name: "String"
                }
            },
            familyLabel: {
                readOnly: true,
                serializedName: "familyLabel",
                type: {
                    name: "String"
                }
            },
            version: {
                readOnly: true,
                serializedName: "version",
                type: {
                    name: "String"
                }
            },
            label: {
                readOnly: true,
                serializedName: "label",
                type: {
                    name: "String"
                }
            },
            isDefault: {
                readOnly: true,
                serializedName: "isDefault",
                type: {
                    name: "Boolean"
                }
            },
            isActive: {
                readOnly: true,
                serializedName: "isActive",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var OSVersion = {
    serializedName: "OSVersion",
    type: {
        name: "Composite",
        className: "OSVersion",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "OSVersionProperties"
                }
            }
        }
    }
};
export var OSVersionPropertiesBase = {
    serializedName: "OSVersionPropertiesBase",
    type: {
        name: "Composite",
        className: "OSVersionPropertiesBase",
        modelProperties: {
            version: {
                readOnly: true,
                serializedName: "version",
                type: {
                    name: "String"
                }
            },
            label: {
                readOnly: true,
                serializedName: "label",
                type: {
                    name: "String"
                }
            },
            isDefault: {
                readOnly: true,
                serializedName: "isDefault",
                type: {
                    name: "Boolean"
                }
            },
            isActive: {
                readOnly: true,
                serializedName: "isActive",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var OSFamilyProperties = {
    serializedName: "OSFamilyProperties",
    type: {
        name: "Composite",
        className: "OSFamilyProperties",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            label: {
                readOnly: true,
                serializedName: "label",
                type: {
                    name: "String"
                }
            },
            versions: {
                readOnly: true,
                serializedName: "versions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSVersionPropertiesBase"
                        }
                    }
                }
            }
        }
    }
};
export var OSFamily = {
    serializedName: "OSFamily",
    type: {
        name: "Composite",
        className: "OSFamily",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                readOnly: true,
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "OSFamilyProperties"
                }
            }
        }
    }
};
export var ComputeOperationListResult = {
    serializedName: "ComputeOperationListResult",
    type: {
        name: "Composite",
        className: "ComputeOperationListResult",
        modelProperties: {
            value: {
                readOnly: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ComputeOperationValue"
                        }
                    }
                }
            }
        }
    }
};
export var AvailabilitySetListResult = {
    serializedName: "AvailabilitySetListResult",
    type: {
        name: "Composite",
        className: "AvailabilitySetListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailabilitySet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineSizeListResult = {
    serializedName: "VirtualMachineSizeListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineSizeListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineSize"
                        }
                    }
                }
            }
        }
    }
};
export var ProximityPlacementGroupListResult = {
    serializedName: "ProximityPlacementGroupListResult",
    type: {
        name: "Composite",
        className: "ProximityPlacementGroupListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ProximityPlacementGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DedicatedHostGroupListResult = {
    serializedName: "DedicatedHostGroupListResult",
    type: {
        name: "Composite",
        className: "DedicatedHostGroupListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DedicatedHostListResult = {
    serializedName: "DedicatedHostListResult",
    type: {
        name: "Composite",
        className: "DedicatedHostListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHost"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SshPublicKeysGroupListResult = {
    serializedName: "SshPublicKeysGroupListResult",
    type: {
        name: "Composite",
        className: "SshPublicKeysGroupListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SshPublicKeyResource"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListUsagesResult = {
    serializedName: "ListUsagesResult",
    type: {
        name: "Composite",
        className: "ListUsagesResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Usage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineListResult = {
    serializedName: "VirtualMachineListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachine"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetListResult = {
    serializedName: "VirtualMachineScaleSetListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetListWithLinkResult = {
    serializedName: "VirtualMachineScaleSetListWithLinkResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListWithLinkResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetListSkusResult = {
    serializedName: "VirtualMachineScaleSetListSkusResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListSkusResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetSku"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetListOSUpgradeHistory = {
    serializedName: "VirtualMachineScaleSetListOSUpgradeHistory",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListOSUpgradeHistory",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "UpgradeOperationHistoricalStatusInfo"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ImageListResult = {
    serializedName: "ImageListResult",
    type: {
        name: "Composite",
        className: "ImageListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Image"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RestorePointCollectionListResult = {
    serializedName: "RestorePointCollectionListResult",
    type: {
        name: "Composite",
        className: "RestorePointCollectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePointCollection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CapacityReservationGroupListResult = {
    serializedName: "CapacityReservationGroupListResult",
    type: {
        name: "Composite",
        className: "CapacityReservationGroupListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservationGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CapacityReservationListResult = {
    serializedName: "CapacityReservationListResult",
    type: {
        name: "Composite",
        className: "CapacityReservationListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservation"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetExtensionListResult = {
    serializedName: "VirtualMachineScaleSetExtensionListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetExtension"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineScaleSetVMListResult = {
    serializedName: "VirtualMachineScaleSetVMListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVM"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RunCommandListResult = {
    serializedName: "RunCommandListResult",
    type: {
        name: "Composite",
        className: "RunCommandListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandDocumentBase"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualMachineRunCommandsListResult = {
    serializedName: "VirtualMachineRunCommandsListResult",
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandsListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineRunCommand"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ResourceSkusResult = {
    serializedName: "ResourceSkusResult",
    type: {
        name: "Composite",
        className: "ResourceSkusResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSku"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskList = {
    serializedName: "DiskList",
    type: {
        name: "Composite",
        className: "DiskList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Disk"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SnapshotList = {
    serializedName: "SnapshotList",
    type: {
        name: "Composite",
        className: "SnapshotList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Snapshot"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskEncryptionSetList = {
    serializedName: "DiskEncryptionSetList",
    type: {
        name: "Composite",
        className: "DiskEncryptionSetList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskEncryptionSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ResourceUriList = {
    serializedName: "ResourceUriList",
    type: {
        name: "Composite",
        className: "ResourceUriList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskAccessList = {
    serializedName: "DiskAccessList",
    type: {
        name: "Composite",
        className: "DiskAccessList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskAccess"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateEndpointConnectionListResult = {
    serializedName: "PrivateEndpointConnectionListResult",
    type: {
        name: "Composite",
        className: "PrivateEndpointConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DiskRestorePointList = {
    serializedName: "DiskRestorePointList",
    type: {
        name: "Composite",
        className: "DiskRestorePointList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskRestorePoint"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryList = {
    serializedName: "GalleryList",
    type: {
        name: "Composite",
        className: "GalleryList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Gallery"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryImageList = {
    serializedName: "GalleryImageList",
    type: {
        name: "Composite",
        className: "GalleryImageList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryImageVersionList = {
    serializedName: "GalleryImageVersionList",
    type: {
        name: "Composite",
        className: "GalleryImageVersionList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryApplicationList = {
    serializedName: "GalleryApplicationList",
    type: {
        name: "Composite",
        className: "GalleryApplicationList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryApplication"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GalleryApplicationVersionList = {
    serializedName: "GalleryApplicationVersionList",
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryApplicationVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SharedGalleryList = {
    serializedName: "SharedGalleryList",
    type: {
        name: "Composite",
        className: "SharedGalleryList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGallery"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SharedGalleryImageList = {
    serializedName: "SharedGalleryImageList",
    type: {
        name: "Composite",
        className: "SharedGalleryImageList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGalleryImage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SharedGalleryImageVersionList = {
    serializedName: "SharedGalleryImageVersionList",
    type: {
        name: "Composite",
        className: "SharedGalleryImageVersionList",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGalleryImageVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RoleInstanceListResult = {
    serializedName: "RoleInstanceListResult",
    type: {
        name: "Composite",
        className: "RoleInstanceListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RoleInstance"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudServiceRoleListResult = {
    serializedName: "CloudServiceRoleListResult",
    type: {
        name: "Composite",
        className: "CloudServiceRoleListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceRole"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CloudServiceListResult = {
    serializedName: "CloudServiceListResult",
    type: {
        name: "Composite",
        className: "CloudServiceListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudService"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var UpdateDomainListResult = {
    serializedName: "UpdateDomainListResult",
    type: {
        name: "Composite",
        className: "UpdateDomainListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "UpdateDomain"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSVersionListResult = {
    serializedName: "OSVersionListResult",
    type: {
        name: "Composite",
        className: "OSVersionListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OSFamilyListResult = {
    serializedName: "OSFamilyListResult",
    type: {
        name: "Composite",
        className: "OSFamilyListResult",
        modelProperties: {
            value: {
                required: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSFamily"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
//# sourceMappingURL=mappers.js.map