/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __assign } from "tslib";
import { CloudErrorMapper, BaseResourceMapper } from "@azure/ms-rest-azure-js";
export var CloudError = CloudErrorMapper;
export var BaseResource = BaseResourceMapper;
export var ApplicationGatewayProbeHealthResponseMatch = {
    serializedName: "ApplicationGatewayProbeHealthResponseMatch",
    type: {
        name: "Composite",
        className: "ApplicationGatewayProbeHealthResponseMatch",
        modelProperties: {
            body: {
                serializedName: "body",
                type: {
                    name: "String"
                }
            },
            statusCodes: {
                serializedName: "statusCodes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var SubResource = {
    serializedName: "SubResource",
    type: {
        name: "Composite",
        className: "SubResource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayOnDemandProbe = {
    serializedName: "ApplicationGatewayOnDemandProbe",
    type: {
        name: "Composite",
        className: "ApplicationGatewayOnDemandProbe",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            host: {
                serializedName: "host",
                type: {
                    name: "String"
                }
            },
            path: {
                serializedName: "path",
                type: {
                    name: "String"
                }
            },
            timeout: {
                serializedName: "timeout",
                type: {
                    name: "Number"
                }
            },
            pickHostNameFromBackendHttpSettings: {
                serializedName: "pickHostNameFromBackendHttpSettings",
                type: {
                    name: "Boolean"
                }
            },
            match: {
                serializedName: "match",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayProbeHealthResponseMatch"
                }
            },
            backendAddressPool: {
                serializedName: "backendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            backendHttpSettings: {
                serializedName: "backendHttpSettings",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var NetworkInterfaceTapConfiguration = {
    serializedName: "NetworkInterfaceTapConfiguration",
    type: {
        name: "Composite",
        className: "NetworkInterfaceTapConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { virtualNetworkTap: {
                serializedName: "properties.virtualNetworkTap",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkTap"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Resource = {
    serializedName: "Resource",
    type: {
        name: "Composite",
        className: "Resource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationSecurityGroup = {
    serializedName: "ApplicationSecurityGroup",
    type: {
        name: "Composite",
        className: "ApplicationSecurityGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var SecurityRule = {
    serializedName: "SecurityRule",
    type: {
        name: "Composite",
        className: "SecurityRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, protocol: {
                required: true,
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, sourcePortRange: {
                serializedName: "properties.sourcePortRange",
                type: {
                    name: "String"
                }
            }, destinationPortRange: {
                serializedName: "properties.destinationPortRange",
                type: {
                    name: "String"
                }
            }, sourceAddressPrefix: {
                serializedName: "properties.sourceAddressPrefix",
                type: {
                    name: "String"
                }
            }, sourceAddressPrefixes: {
                serializedName: "properties.sourceAddressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sourceApplicationSecurityGroups: {
                serializedName: "properties.sourceApplicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationSecurityGroup"
                        }
                    }
                }
            }, destinationAddressPrefix: {
                serializedName: "properties.destinationAddressPrefix",
                type: {
                    name: "String"
                }
            }, destinationAddressPrefixes: {
                serializedName: "properties.destinationAddressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationApplicationSecurityGroups: {
                serializedName: "properties.destinationApplicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationSecurityGroup"
                        }
                    }
                }
            }, sourcePortRanges: {
                serializedName: "properties.sourcePortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationPortRanges: {
                serializedName: "properties.destinationPortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, access: {
                required: true,
                serializedName: "properties.access",
                type: {
                    name: "String"
                }
            }, priority: {
                serializedName: "properties.priority",
                type: {
                    name: "Number"
                }
            }, direction: {
                required: true,
                serializedName: "properties.direction",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExtendedLocation = {
    serializedName: "ExtendedLocation",
    type: {
        name: "Composite",
        className: "ExtendedLocation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceConnectionState = {
    serializedName: "PrivateLinkServiceConnectionState",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceConnectionState",
        modelProperties: {
            status: {
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            actionsRequired: {
                serializedName: "actionsRequired",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceConnection = {
    serializedName: "PrivateLinkServiceConnection",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateLinkServiceId: {
                serializedName: "properties.privateLinkServiceId",
                type: {
                    name: "String"
                }
            }, groupIds: {
                serializedName: "properties.groupIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, requestMessage: {
                serializedName: "properties.requestMessage",
                type: {
                    name: "String"
                }
            }, privateLinkServiceConnectionState: {
                serializedName: "properties.privateLinkServiceConnectionState",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServiceConnectionState"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var CustomDnsConfigPropertiesFormat = {
    serializedName: "CustomDnsConfigPropertiesFormat",
    type: {
        name: "Composite",
        className: "CustomDnsConfigPropertiesFormat",
        modelProperties: {
            fqdn: {
                serializedName: "fqdn",
                type: {
                    name: "String"
                }
            },
            ipAddresses: {
                serializedName: "ipAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var PrivateEndpoint = {
    serializedName: "PrivateEndpoint",
    type: {
        name: "Composite",
        className: "PrivateEndpoint",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, networkInterfaces: {
                readOnly: true,
                serializedName: "properties.networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterface"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateLinkServiceConnections: {
                serializedName: "properties.privateLinkServiceConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkServiceConnection"
                        }
                    }
                }
            }, manualPrivateLinkServiceConnections: {
                serializedName: "properties.manualPrivateLinkServiceConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkServiceConnection"
                        }
                    }
                }
            }, customDnsConfigs: {
                serializedName: "properties.customDnsConfigs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CustomDnsConfigPropertiesFormat"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkInterfaceDnsSettings = {
    serializedName: "NetworkInterfaceDnsSettings",
    type: {
        name: "Composite",
        className: "NetworkInterfaceDnsSettings",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            appliedDnsServers: {
                readOnly: true,
                serializedName: "appliedDnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            internalDnsNameLabel: {
                serializedName: "internalDnsNameLabel",
                type: {
                    name: "String"
                }
            },
            internalFqdn: {
                readOnly: true,
                serializedName: "internalFqdn",
                type: {
                    name: "String"
                }
            },
            internalDomainNameSuffix: {
                readOnly: true,
                serializedName: "internalDomainNameSuffix",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceIpConfiguration = {
    serializedName: "PrivateLinkServiceIpConfiguration",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceIpConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PrivateEndpointConnection = {
    serializedName: "PrivateEndpointConnection",
    type: {
        name: "Composite",
        className: "PrivateEndpointConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateEndpoint: {
                readOnly: true,
                serializedName: "properties.privateEndpoint",
                type: {
                    name: "Composite",
                    className: "PrivateEndpoint"
                }
            }, privateLinkServiceConnectionState: {
                serializedName: "properties.privateLinkServiceConnectionState",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServiceConnectionState"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, linkIdentifier: {
                readOnly: true,
                serializedName: "properties.linkIdentifier",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ResourceSet = {
    serializedName: "ResourceSet",
    type: {
        name: "Composite",
        className: "ResourceSet",
        modelProperties: {
            subscriptions: {
                serializedName: "subscriptions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var PrivateLinkServicePropertiesVisibility = {
    serializedName: "PrivateLinkServiceProperties_visibility",
    type: {
        name: "Composite",
        className: "PrivateLinkServicePropertiesVisibility",
        modelProperties: __assign({}, ResourceSet.type.modelProperties)
    }
};
export var PrivateLinkServicePropertiesAutoApproval = {
    serializedName: "PrivateLinkServiceProperties_autoApproval",
    type: {
        name: "Composite",
        className: "PrivateLinkServicePropertiesAutoApproval",
        modelProperties: __assign({}, ResourceSet.type.modelProperties)
    }
};
export var PrivateLinkService = {
    serializedName: "PrivateLinkService",
    type: {
        name: "Composite",
        className: "PrivateLinkService",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, loadBalancerFrontendIpConfigurations: {
                serializedName: "properties.loadBalancerFrontendIpConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FrontendIPConfiguration"
                        }
                    }
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkServiceIpConfiguration"
                        }
                    }
                }
            }, networkInterfaces: {
                readOnly: true,
                serializedName: "properties.networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterface"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateEndpointConnections: {
                readOnly: true,
                serializedName: "properties.privateEndpointConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            }, visibility: {
                serializedName: "properties.visibility",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServicePropertiesVisibility"
                }
            }, autoApproval: {
                serializedName: "properties.autoApproval",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServicePropertiesAutoApproval"
                }
            }, fqdns: {
                serializedName: "properties.fqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, alias: {
                readOnly: true,
                serializedName: "properties.alias",
                type: {
                    name: "String"
                }
            }, enableProxyProtocol: {
                serializedName: "properties.enableProxyProtocol",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkInterface = {
    serializedName: "NetworkInterface",
    type: {
        name: "Composite",
        className: "NetworkInterface",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, virtualMachine: {
                readOnly: true,
                serializedName: "properties.virtualMachine",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "NetworkSecurityGroup"
                }
            }, privateEndpoint: {
                readOnly: true,
                serializedName: "properties.privateEndpoint",
                type: {
                    name: "Composite",
                    className: "PrivateEndpoint"
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceIPConfiguration"
                        }
                    }
                }
            }, tapConfigurations: {
                readOnly: true,
                serializedName: "properties.tapConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceTapConfiguration"
                        }
                    }
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceDnsSettings"
                }
            }, macAddress: {
                readOnly: true,
                serializedName: "properties.macAddress",
                type: {
                    name: "String"
                }
            }, primary: {
                readOnly: true,
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            }, enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            }, hostedWorkloads: {
                readOnly: true,
                serializedName: "properties.hostedWorkloads",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, dscpConfiguration: {
                readOnly: true,
                serializedName: "properties.dscpConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, workloadType: {
                serializedName: "properties.workloadType",
                type: {
                    name: "String"
                }
            }, nicType: {
                serializedName: "properties.nicType",
                type: {
                    name: "String"
                }
            }, privateLinkService: {
                serializedName: "properties.privateLinkService",
                type: {
                    name: "Composite",
                    className: "PrivateLinkService"
                }
            }, migrationPhase: {
                serializedName: "properties.migrationPhase",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var RetentionPolicyParameters = {
    serializedName: "RetentionPolicyParameters",
    type: {
        name: "Composite",
        className: "RetentionPolicyParameters",
        modelProperties: {
            days: {
                serializedName: "days",
                defaultValue: 0,
                type: {
                    name: "Number"
                }
            },
            enabled: {
                serializedName: "enabled",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var FlowLogFormatParameters = {
    serializedName: "FlowLogFormatParameters",
    type: {
        name: "Composite",
        className: "FlowLogFormatParameters",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            version: {
                serializedName: "version",
                defaultValue: 0,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var TrafficAnalyticsConfigurationProperties = {
    serializedName: "TrafficAnalyticsConfigurationProperties",
    type: {
        name: "Composite",
        className: "TrafficAnalyticsConfigurationProperties",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            workspaceId: {
                serializedName: "workspaceId",
                type: {
                    name: "String"
                }
            },
            workspaceRegion: {
                serializedName: "workspaceRegion",
                type: {
                    name: "String"
                }
            },
            workspaceResourceId: {
                serializedName: "workspaceResourceId",
                type: {
                    name: "String"
                }
            },
            trafficAnalyticsInterval: {
                serializedName: "trafficAnalyticsInterval",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var TrafficAnalyticsProperties = {
    serializedName: "TrafficAnalyticsProperties",
    type: {
        name: "Composite",
        className: "TrafficAnalyticsProperties",
        modelProperties: {
            networkWatcherFlowAnalyticsConfiguration: {
                serializedName: "networkWatcherFlowAnalyticsConfiguration",
                type: {
                    name: "Composite",
                    className: "TrafficAnalyticsConfigurationProperties"
                }
            }
        }
    }
};
export var FlowLog = {
    serializedName: "FlowLog",
    type: {
        name: "Composite",
        className: "FlowLog",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { targetResourceId: {
                required: true,
                serializedName: "properties.targetResourceId",
                type: {
                    name: "String"
                }
            }, targetResourceGuid: {
                readOnly: true,
                serializedName: "properties.targetResourceGuid",
                type: {
                    name: "String"
                }
            }, storageId: {
                required: true,
                serializedName: "properties.storageId",
                type: {
                    name: "String"
                }
            }, enabled: {
                serializedName: "properties.enabled",
                type: {
                    name: "Boolean"
                }
            }, retentionPolicy: {
                serializedName: "properties.retentionPolicy",
                type: {
                    name: "Composite",
                    className: "RetentionPolicyParameters"
                }
            }, format: {
                serializedName: "properties.format",
                type: {
                    name: "Composite",
                    className: "FlowLogFormatParameters"
                }
            }, flowAnalyticsConfiguration: {
                serializedName: "properties.flowAnalyticsConfiguration",
                type: {
                    name: "Composite",
                    className: "TrafficAnalyticsProperties"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkSecurityGroup = {
    serializedName: "NetworkSecurityGroup",
    type: {
        name: "Composite",
        className: "NetworkSecurityGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { securityRules: {
                serializedName: "properties.securityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            }, defaultSecurityRules: {
                readOnly: true,
                serializedName: "properties.defaultSecurityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            }, networkInterfaces: {
                readOnly: true,
                serializedName: "properties.networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterface"
                        }
                    }
                }
            }, subnets: {
                readOnly: true,
                serializedName: "properties.subnets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Subnet"
                        }
                    }
                }
            }, flowLogs: {
                readOnly: true,
                serializedName: "properties.flowLogs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FlowLog"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Route = {
    serializedName: "Route",
    type: {
        name: "Composite",
        className: "Route",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, nextHopType: {
                required: true,
                serializedName: "properties.nextHopType",
                type: {
                    name: "String"
                }
            }, nextHopIpAddress: {
                serializedName: "properties.nextHopIpAddress",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, hasBgpOverride: {
                serializedName: "properties.hasBgpOverride",
                type: {
                    name: "Boolean"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var RouteTable = {
    serializedName: "RouteTable",
    type: {
        name: "Composite",
        className: "RouteTable",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { routes: {
                serializedName: "properties.routes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Route"
                        }
                    }
                }
            }, subnets: {
                readOnly: true,
                serializedName: "properties.subnets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Subnet"
                        }
                    }
                }
            }, disableBgpRoutePropagation: {
                serializedName: "properties.disableBgpRoutePropagation",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ServiceEndpointPropertiesFormat = {
    serializedName: "ServiceEndpointPropertiesFormat",
    type: {
        name: "Composite",
        className: "ServiceEndpointPropertiesFormat",
        modelProperties: {
            service: {
                serializedName: "service",
                type: {
                    name: "String"
                }
            },
            locations: {
                serializedName: "locations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "provisioningState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceEndpointPolicyDefinition = {
    serializedName: "ServiceEndpointPolicyDefinition",
    type: {
        name: "Composite",
        className: "ServiceEndpointPolicyDefinition",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, service: {
                serializedName: "properties.service",
                type: {
                    name: "String"
                }
            }, serviceResources: {
                serializedName: "properties.serviceResources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ServiceEndpointPolicy = {
    serializedName: "ServiceEndpointPolicy",
    type: {
        name: "Composite",
        className: "ServiceEndpointPolicy",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { serviceEndpointPolicyDefinitions: {
                serializedName: "properties.serviceEndpointPolicyDefinitions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceEndpointPolicyDefinition"
                        }
                    }
                }
            }, subnets: {
                readOnly: true,
                serializedName: "properties.subnets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Subnet"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, kind: {
                readOnly: true,
                serializedName: "kind",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PublicIPAddressSku = {
    serializedName: "PublicIPAddressSku",
    type: {
        name: "Composite",
        className: "PublicIPAddressSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPAddressDnsSettings = {
    serializedName: "PublicIPAddressDnsSettings",
    type: {
        name: "Composite",
        className: "PublicIPAddressDnsSettings",
        modelProperties: {
            domainNameLabel: {
                serializedName: "domainNameLabel",
                type: {
                    name: "String"
                }
            },
            fqdn: {
                serializedName: "fqdn",
                type: {
                    name: "String"
                }
            },
            reverseFqdn: {
                serializedName: "reverseFqdn",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DdosSettings = {
    serializedName: "DdosSettings",
    type: {
        name: "Composite",
        className: "DdosSettings",
        modelProperties: {
            ddosCustomPolicy: {
                serializedName: "ddosCustomPolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            protectionCoverage: {
                serializedName: "protectionCoverage",
                type: {
                    name: "String"
                }
            },
            protectedIP: {
                serializedName: "protectedIP",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var IpTag = {
    serializedName: "IpTag",
    type: {
        name: "Composite",
        className: "IpTag",
        modelProperties: {
            ipTagType: {
                serializedName: "ipTagType",
                type: {
                    name: "String"
                }
            },
            tag: {
                serializedName: "tag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NatGatewaySku = {
    serializedName: "NatGatewaySku",
    type: {
        name: "Composite",
        className: "NatGatewaySku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NatGateway = {
    serializedName: "NatGateway",
    type: {
        name: "Composite",
        className: "NatGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "NatGatewaySku"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, publicIpAddresses: {
                serializedName: "properties.publicIpAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, publicIpPrefixes: {
                serializedName: "properties.publicIpPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, subnets: {
                readOnly: true,
                serializedName: "properties.subnets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PublicIPAddress = {
    serializedName: "PublicIPAddress",
    type: {
        name: "Composite",
        className: "PublicIPAddress",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressSku"
                }
            }, publicIPAllocationMethod: {
                serializedName: "properties.publicIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            }, ipConfiguration: {
                readOnly: true,
                serializedName: "properties.ipConfiguration",
                type: {
                    name: "Composite",
                    className: "IPConfiguration"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressDnsSettings"
                }
            }, ddosSettings: {
                serializedName: "properties.ddosSettings",
                type: {
                    name: "Composite",
                    className: "DdosSettings"
                }
            }, ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpTag"
                        }
                    }
                }
            }, ipAddress: {
                serializedName: "properties.ipAddress",
                type: {
                    name: "String"
                }
            }, publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, servicePublicIPAddress: {
                serializedName: "properties.servicePublicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, natGateway: {
                serializedName: "properties.natGateway",
                type: {
                    name: "Composite",
                    className: "NatGateway"
                }
            }, migrationPhase: {
                serializedName: "properties.migrationPhase",
                type: {
                    name: "String"
                }
            }, linkedPublicIPAddress: {
                serializedName: "properties.linkedPublicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var IPConfiguration = {
    serializedName: "IPConfiguration",
    type: {
        name: "Composite",
        className: "IPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var IPConfigurationProfile = {
    serializedName: "IPConfigurationProfile",
    type: {
        name: "Composite",
        className: "IPConfigurationProfile",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ResourceNavigationLink = {
    serializedName: "ResourceNavigationLink",
    type: {
        name: "Composite",
        className: "ResourceNavigationLink",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { linkedResourceType: {
                serializedName: "properties.linkedResourceType",
                type: {
                    name: "String"
                }
            }, link: {
                serializedName: "properties.link",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ServiceAssociationLink = {
    serializedName: "ServiceAssociationLink",
    type: {
        name: "Composite",
        className: "ServiceAssociationLink",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { linkedResourceType: {
                serializedName: "properties.linkedResourceType",
                type: {
                    name: "String"
                }
            }, link: {
                serializedName: "properties.link",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, allowDelete: {
                serializedName: "properties.allowDelete",
                type: {
                    name: "Boolean"
                }
            }, locations: {
                serializedName: "properties.locations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Delegation = {
    serializedName: "Delegation",
    type: {
        name: "Composite",
        className: "Delegation",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { serviceName: {
                serializedName: "properties.serviceName",
                type: {
                    name: "String"
                }
            }, actions: {
                readOnly: true,
                serializedName: "properties.actions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayIPConfiguration = {
    serializedName: "ApplicationGatewayIPConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Subnet = {
    serializedName: "Subnet",
    type: {
        name: "Composite",
        className: "Subnet",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, addressPrefixes: {
                serializedName: "properties.addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "NetworkSecurityGroup"
                }
            }, routeTable: {
                serializedName: "properties.routeTable",
                type: {
                    name: "Composite",
                    className: "RouteTable"
                }
            }, natGateway: {
                serializedName: "properties.natGateway",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, serviceEndpoints: {
                serializedName: "properties.serviceEndpoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceEndpointPropertiesFormat"
                        }
                    }
                }
            }, serviceEndpointPolicies: {
                serializedName: "properties.serviceEndpointPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceEndpointPolicy"
                        }
                    }
                }
            }, privateEndpoints: {
                readOnly: true,
                serializedName: "properties.privateEndpoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpoint"
                        }
                    }
                }
            }, ipConfigurations: {
                readOnly: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IPConfiguration"
                        }
                    }
                }
            }, ipConfigurationProfiles: {
                readOnly: true,
                serializedName: "properties.ipConfigurationProfiles",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IPConfigurationProfile"
                        }
                    }
                }
            }, ipAllocations: {
                serializedName: "properties.ipAllocations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, resourceNavigationLinks: {
                readOnly: true,
                serializedName: "properties.resourceNavigationLinks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceNavigationLink"
                        }
                    }
                }
            }, serviceAssociationLinks: {
                readOnly: true,
                serializedName: "properties.serviceAssociationLinks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceAssociationLink"
                        }
                    }
                }
            }, delegations: {
                serializedName: "properties.delegations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Delegation"
                        }
                    }
                }
            }, purpose: {
                readOnly: true,
                serializedName: "properties.purpose",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateEndpointNetworkPolicies: {
                serializedName: "properties.privateEndpointNetworkPolicies",
                defaultValue: 'Enabled',
                type: {
                    name: "String"
                }
            }, privateLinkServiceNetworkPolicies: {
                serializedName: "properties.privateLinkServiceNetworkPolicies",
                defaultValue: 'Enabled',
                type: {
                    name: "String"
                }
            }, applicationGatewayIpConfigurations: {
                serializedName: "properties.applicationGatewayIpConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayIPConfiguration"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var FrontendIPConfiguration = {
    serializedName: "FrontendIPConfiguration",
    type: {
        name: "Composite",
        className: "FrontendIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { inboundNatRules: {
                readOnly: true,
                serializedName: "properties.inboundNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, inboundNatPools: {
                readOnly: true,
                serializedName: "properties.inboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, outboundRules: {
                readOnly: true,
                serializedName: "properties.outboundRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancingRules: {
                readOnly: true,
                serializedName: "properties.loadBalancingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, gatewayLoadBalancer: {
                serializedName: "properties.gatewayLoadBalancer",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var VirtualNetworkTap = {
    serializedName: "VirtualNetworkTap",
    type: {
        name: "Composite",
        className: "VirtualNetworkTap",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { networkInterfaceTapConfigurations: {
                readOnly: true,
                serializedName: "properties.networkInterfaceTapConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceTapConfiguration"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, destinationNetworkInterfaceIPConfiguration: {
                serializedName: "properties.destinationNetworkInterfaceIPConfiguration",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceIPConfiguration"
                }
            }, destinationLoadBalancerFrontEndIPConfiguration: {
                serializedName: "properties.destinationLoadBalancerFrontEndIPConfiguration",
                type: {
                    name: "Composite",
                    className: "FrontendIPConfiguration"
                }
            }, destinationPort: {
                serializedName: "properties.destinationPort",
                type: {
                    name: "Number"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var GatewayLoadBalancerTunnelInterface = {
    serializedName: "GatewayLoadBalancerTunnelInterface",
    type: {
        name: "Composite",
        className: "GatewayLoadBalancerTunnelInterface",
        modelProperties: {
            port: {
                serializedName: "port",
                type: {
                    name: "Number"
                }
            },
            identifier: {
                serializedName: "identifier",
                type: {
                    name: "Number"
                }
            },
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerBackendAddress = {
    serializedName: "LoadBalancerBackendAddress",
    type: {
        name: "Composite",
        className: "LoadBalancerBackendAddress",
        modelProperties: {
            virtualNetwork: {
                serializedName: "properties.virtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            ipAddress: {
                serializedName: "properties.ipAddress",
                type: {
                    name: "String"
                }
            },
            networkInterfaceIPConfiguration: {
                readOnly: true,
                serializedName: "properties.networkInterfaceIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            loadBalancerFrontendIPConfiguration: {
                serializedName: "properties.loadBalancerFrontendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BackendAddressPool = {
    serializedName: "BackendAddressPool",
    type: {
        name: "Composite",
        className: "BackendAddressPool",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { location: {
                serializedName: "properties.location",
                type: {
                    name: "String"
                }
            }, tunnelInterfaces: {
                serializedName: "properties.tunnelInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GatewayLoadBalancerTunnelInterface"
                        }
                    }
                }
            }, loadBalancerBackendAddresses: {
                serializedName: "properties.loadBalancerBackendAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerBackendAddress"
                        }
                    }
                }
            }, backendIPConfigurations: {
                readOnly: true,
                serializedName: "properties.backendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceIPConfiguration"
                        }
                    }
                }
            }, loadBalancingRules: {
                readOnly: true,
                serializedName: "properties.loadBalancingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, outboundRule: {
                readOnly: true,
                serializedName: "properties.outboundRule",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, outboundRules: {
                readOnly: true,
                serializedName: "properties.outboundRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var InboundNatRule = {
    serializedName: "InboundNatRule",
    type: {
        name: "Composite",
        className: "InboundNatRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { frontendIPConfiguration: {
                serializedName: "properties.frontendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, backendIPConfiguration: {
                readOnly: true,
                serializedName: "properties.backendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceIPConfiguration"
                }
            }, protocol: {
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, frontendPort: {
                serializedName: "properties.frontendPort",
                type: {
                    name: "Number"
                }
            }, backendPort: {
                serializedName: "properties.backendPort",
                type: {
                    name: "Number"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, enableFloatingIP: {
                serializedName: "properties.enableFloatingIP",
                type: {
                    name: "Boolean"
                }
            }, enableTcpReset: {
                serializedName: "properties.enableTcpReset",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties = {
    serializedName: "NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties",
    type: {
        name: "Composite",
        className: "NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties",
        modelProperties: {
            groupId: {
                readOnly: true,
                serializedName: "groupId",
                type: {
                    name: "String"
                }
            },
            requiredMemberName: {
                readOnly: true,
                serializedName: "requiredMemberName",
                type: {
                    name: "String"
                }
            },
            fqdns: {
                readOnly: true,
                serializedName: "fqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var NetworkInterfaceIPConfiguration = {
    serializedName: "NetworkInterfaceIPConfiguration",
    type: {
        name: "Composite",
        className: "NetworkInterfaceIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { gatewayLoadBalancer: {
                serializedName: "properties.gatewayLoadBalancer",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualNetworkTaps: {
                serializedName: "properties.virtualNetworkTaps",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkTap"
                        }
                    }
                }
            }, applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendAddressPool"
                        }
                    }
                }
            }, loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BackendAddressPool"
                        }
                    }
                }
            }, loadBalancerInboundNatRules: {
                serializedName: "properties.loadBalancerInboundNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InboundNatRule"
                        }
                    }
                }
            }, privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationSecurityGroup"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateLinkConnectionProperties: {
                readOnly: true,
                serializedName: "properties.privateLinkConnectionProperties",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayBackendAddress = {
    serializedName: "ApplicationGatewayBackendAddress",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendAddress",
        modelProperties: {
            fqdn: {
                serializedName: "fqdn",
                type: {
                    name: "String"
                }
            },
            ipAddress: {
                serializedName: "ipAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayBackendAddressPool = {
    serializedName: "ApplicationGatewayBackendAddressPool",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendAddressPool",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { backendIPConfigurations: {
                readOnly: true,
                serializedName: "properties.backendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceIPConfiguration"
                        }
                    }
                }
            }, backendAddresses: {
                serializedName: "properties.backendAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendAddress"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayConnectionDraining = {
    serializedName: "ApplicationGatewayConnectionDraining",
    type: {
        name: "Composite",
        className: "ApplicationGatewayConnectionDraining",
        modelProperties: {
            enabled: {
                required: true,
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            drainTimeoutInSec: {
                required: true,
                serializedName: "drainTimeoutInSec",
                constraints: {
                    InclusiveMaximum: 3600,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ApplicationGatewayBackendHttpSettings = {
    serializedName: "ApplicationGatewayBackendHttpSettings",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHttpSettings",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { port: {
                serializedName: "properties.port",
                type: {
                    name: "Number"
                }
            }, protocol: {
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, cookieBasedAffinity: {
                serializedName: "properties.cookieBasedAffinity",
                type: {
                    name: "String"
                }
            }, requestTimeout: {
                serializedName: "properties.requestTimeout",
                type: {
                    name: "Number"
                }
            }, probe: {
                serializedName: "properties.probe",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, authenticationCertificates: {
                serializedName: "properties.authenticationCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, trustedRootCertificates: {
                serializedName: "properties.trustedRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, connectionDraining: {
                serializedName: "properties.connectionDraining",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayConnectionDraining"
                }
            }, hostName: {
                serializedName: "properties.hostName",
                type: {
                    name: "String"
                }
            }, pickHostNameFromBackendAddress: {
                serializedName: "properties.pickHostNameFromBackendAddress",
                type: {
                    name: "Boolean"
                }
            }, affinityCookieName: {
                serializedName: "properties.affinityCookieName",
                type: {
                    name: "String"
                }
            }, probeEnabled: {
                serializedName: "properties.probeEnabled",
                type: {
                    name: "Boolean"
                }
            }, path: {
                serializedName: "properties.path",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayBackendHealthServer = {
    serializedName: "ApplicationGatewayBackendHealthServer",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHealthServer",
        modelProperties: {
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            },
            ipConfiguration: {
                serializedName: "ipConfiguration",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceIPConfiguration"
                }
            },
            health: {
                serializedName: "health",
                type: {
                    name: "String"
                }
            },
            healthProbeLog: {
                serializedName: "healthProbeLog",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayBackendHealthHttpSettings = {
    serializedName: "ApplicationGatewayBackendHealthHttpSettings",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHealthHttpSettings",
        modelProperties: {
            backendHttpSettings: {
                serializedName: "backendHttpSettings",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayBackendHttpSettings"
                }
            },
            servers: {
                serializedName: "servers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendHealthServer"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayBackendHealthOnDemand = {
    serializedName: "ApplicationGatewayBackendHealthOnDemand",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHealthOnDemand",
        modelProperties: {
            backendAddressPool: {
                serializedName: "backendAddressPool",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayBackendAddressPool"
                }
            },
            backendHealthHttpSettings: {
                serializedName: "backendHealthHttpSettings",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayBackendHealthHttpSettings"
                }
            }
        }
    }
};
export var ApplicationGatewayBackendHealthPool = {
    serializedName: "ApplicationGatewayBackendHealthPool",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHealthPool",
        modelProperties: {
            backendAddressPool: {
                serializedName: "backendAddressPool",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayBackendAddressPool"
                }
            },
            backendHttpSettingsCollection: {
                serializedName: "backendHttpSettingsCollection",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendHealthHttpSettings"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayBackendHealth = {
    serializedName: "ApplicationGatewayBackendHealth",
    type: {
        name: "Composite",
        className: "ApplicationGatewayBackendHealth",
        modelProperties: {
            backendAddressPools: {
                serializedName: "backendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendHealthPool"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewaySku = {
    serializedName: "ApplicationGatewaySku",
    type: {
        name: "Composite",
        className: "ApplicationGatewaySku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ApplicationGatewaySslPolicy = {
    serializedName: "ApplicationGatewaySslPolicy",
    type: {
        name: "Composite",
        className: "ApplicationGatewaySslPolicy",
        modelProperties: {
            disabledSslProtocols: {
                serializedName: "disabledSslProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            policyType: {
                serializedName: "policyType",
                type: {
                    name: "String"
                }
            },
            policyName: {
                serializedName: "policyName",
                type: {
                    name: "String"
                }
            },
            cipherSuites: {
                serializedName: "cipherSuites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            minProtocolVersion: {
                serializedName: "minProtocolVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayClientAuthConfiguration = {
    serializedName: "ApplicationGatewayClientAuthConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayClientAuthConfiguration",
        modelProperties: {
            verifyClientCertIssuerDN: {
                serializedName: "verifyClientCertIssuerDN",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ApplicationGatewayAuthenticationCertificate = {
    serializedName: "ApplicationGatewayAuthenticationCertificate",
    type: {
        name: "Composite",
        className: "ApplicationGatewayAuthenticationCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { data: {
                serializedName: "properties.data",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayTrustedRootCertificate = {
    serializedName: "ApplicationGatewayTrustedRootCertificate",
    type: {
        name: "Composite",
        className: "ApplicationGatewayTrustedRootCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { data: {
                serializedName: "properties.data",
                type: {
                    name: "String"
                }
            }, keyVaultSecretId: {
                serializedName: "properties.keyVaultSecretId",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayTrustedClientCertificate = {
    serializedName: "ApplicationGatewayTrustedClientCertificate",
    type: {
        name: "Composite",
        className: "ApplicationGatewayTrustedClientCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { data: {
                serializedName: "properties.data",
                type: {
                    name: "String"
                }
            }, validatedCertData: {
                readOnly: true,
                serializedName: "properties.validatedCertData",
                type: {
                    name: "String"
                }
            }, clientCertIssuerDN: {
                readOnly: true,
                serializedName: "properties.clientCertIssuerDN",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewaySslCertificate = {
    serializedName: "ApplicationGatewaySslCertificate",
    type: {
        name: "Composite",
        className: "ApplicationGatewaySslCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { data: {
                serializedName: "properties.data",
                type: {
                    name: "String"
                }
            }, password: {
                serializedName: "properties.password",
                type: {
                    name: "String"
                }
            }, publicCertData: {
                readOnly: true,
                serializedName: "properties.publicCertData",
                type: {
                    name: "String"
                }
            }, keyVaultSecretId: {
                serializedName: "properties.keyVaultSecretId",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayFrontendIPConfiguration = {
    serializedName: "ApplicationGatewayFrontendIPConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFrontendIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, privateLinkConfiguration: {
                serializedName: "properties.privateLinkConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayFrontendPort = {
    serializedName: "ApplicationGatewayFrontendPort",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFrontendPort",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { port: {
                serializedName: "properties.port",
                type: {
                    name: "Number"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewaySslProfile = {
    serializedName: "ApplicationGatewaySslProfile",
    type: {
        name: "Composite",
        className: "ApplicationGatewaySslProfile",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { trustedClientCertificates: {
                serializedName: "properties.trustedClientCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, sslPolicy: {
                serializedName: "properties.sslPolicy",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewaySslPolicy"
                }
            }, clientAuthConfiguration: {
                serializedName: "properties.clientAuthConfiguration",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayClientAuthConfiguration"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayCustomError = {
    serializedName: "ApplicationGatewayCustomError",
    type: {
        name: "Composite",
        className: "ApplicationGatewayCustomError",
        modelProperties: {
            statusCode: {
                serializedName: "statusCode",
                type: {
                    name: "String"
                }
            },
            customErrorPageUrl: {
                serializedName: "customErrorPageUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayHttpListener = {
    serializedName: "ApplicationGatewayHttpListener",
    type: {
        name: "Composite",
        className: "ApplicationGatewayHttpListener",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { frontendIPConfiguration: {
                serializedName: "properties.frontendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, frontendPort: {
                serializedName: "properties.frontendPort",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, protocol: {
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, hostName: {
                serializedName: "properties.hostName",
                type: {
                    name: "String"
                }
            }, sslCertificate: {
                serializedName: "properties.sslCertificate",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, sslProfile: {
                serializedName: "properties.sslProfile",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, requireServerNameIndication: {
                serializedName: "properties.requireServerNameIndication",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, customErrorConfigurations: {
                serializedName: "properties.customErrorConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayCustomError"
                        }
                    }
                }
            }, firewallPolicy: {
                serializedName: "properties.firewallPolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostNames: {
                serializedName: "properties.hostNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayPathRule = {
    serializedName: "ApplicationGatewayPathRule",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPathRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { paths: {
                serializedName: "properties.paths",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, backendAddressPool: {
                serializedName: "properties.backendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, backendHttpSettings: {
                serializedName: "properties.backendHttpSettings",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, redirectConfiguration: {
                serializedName: "properties.redirectConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, rewriteRuleSet: {
                serializedName: "properties.rewriteRuleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, firewallPolicy: {
                serializedName: "properties.firewallPolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayProbe = {
    serializedName: "ApplicationGatewayProbe",
    type: {
        name: "Composite",
        className: "ApplicationGatewayProbe",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { protocol: {
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, host: {
                serializedName: "properties.host",
                type: {
                    name: "String"
                }
            }, path: {
                serializedName: "properties.path",
                type: {
                    name: "String"
                }
            }, interval: {
                serializedName: "properties.interval",
                type: {
                    name: "Number"
                }
            }, timeout: {
                serializedName: "properties.timeout",
                type: {
                    name: "Number"
                }
            }, unhealthyThreshold: {
                serializedName: "properties.unhealthyThreshold",
                type: {
                    name: "Number"
                }
            }, pickHostNameFromBackendHttpSettings: {
                serializedName: "properties.pickHostNameFromBackendHttpSettings",
                type: {
                    name: "Boolean"
                }
            }, minServers: {
                serializedName: "properties.minServers",
                type: {
                    name: "Number"
                }
            }, match: {
                serializedName: "properties.match",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayProbeHealthResponseMatch"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, port: {
                serializedName: "properties.port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayRequestRoutingRule = {
    serializedName: "ApplicationGatewayRequestRoutingRule",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRequestRoutingRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { ruleType: {
                serializedName: "properties.ruleType",
                type: {
                    name: "String"
                }
            }, priority: {
                serializedName: "properties.priority",
                constraints: {
                    InclusiveMaximum: 20000,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, backendAddressPool: {
                serializedName: "properties.backendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, backendHttpSettings: {
                serializedName: "properties.backendHttpSettings",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, httpListener: {
                serializedName: "properties.httpListener",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, urlPathMap: {
                serializedName: "properties.urlPathMap",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, rewriteRuleSet: {
                serializedName: "properties.rewriteRuleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, redirectConfiguration: {
                serializedName: "properties.redirectConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayRewriteRuleCondition = {
    serializedName: "ApplicationGatewayRewriteRuleCondition",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRewriteRuleCondition",
        modelProperties: {
            variable: {
                serializedName: "variable",
                type: {
                    name: "String"
                }
            },
            pattern: {
                serializedName: "pattern",
                type: {
                    name: "String"
                }
            },
            ignoreCase: {
                serializedName: "ignoreCase",
                type: {
                    name: "Boolean"
                }
            },
            negate: {
                serializedName: "negate",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ApplicationGatewayHeaderConfiguration = {
    serializedName: "ApplicationGatewayHeaderConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayHeaderConfiguration",
        modelProperties: {
            headerName: {
                serializedName: "headerName",
                type: {
                    name: "String"
                }
            },
            headerValue: {
                serializedName: "headerValue",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayUrlConfiguration = {
    serializedName: "ApplicationGatewayUrlConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayUrlConfiguration",
        modelProperties: {
            modifiedPath: {
                serializedName: "modifiedPath",
                type: {
                    name: "String"
                }
            },
            modifiedQueryString: {
                serializedName: "modifiedQueryString",
                type: {
                    name: "String"
                }
            },
            reroute: {
                serializedName: "reroute",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ApplicationGatewayRewriteRuleActionSet = {
    serializedName: "ApplicationGatewayRewriteRuleActionSet",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRewriteRuleActionSet",
        modelProperties: {
            requestHeaderConfigurations: {
                serializedName: "requestHeaderConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayHeaderConfiguration"
                        }
                    }
                }
            },
            responseHeaderConfigurations: {
                serializedName: "responseHeaderConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayHeaderConfiguration"
                        }
                    }
                }
            },
            urlConfiguration: {
                serializedName: "urlConfiguration",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayUrlConfiguration"
                }
            }
        }
    }
};
export var ApplicationGatewayRewriteRule = {
    serializedName: "ApplicationGatewayRewriteRule",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRewriteRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            ruleSequence: {
                serializedName: "ruleSequence",
                type: {
                    name: "Number"
                }
            },
            conditions: {
                serializedName: "conditions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayRewriteRuleCondition"
                        }
                    }
                }
            },
            actionSet: {
                serializedName: "actionSet",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayRewriteRuleActionSet"
                }
            }
        }
    }
};
export var ApplicationGatewayRewriteRuleSet = {
    serializedName: "ApplicationGatewayRewriteRuleSet",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRewriteRuleSet",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { rewriteRules: {
                serializedName: "properties.rewriteRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayRewriteRule"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayRedirectConfiguration = {
    serializedName: "ApplicationGatewayRedirectConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayRedirectConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { redirectType: {
                serializedName: "properties.redirectType",
                type: {
                    name: "String"
                }
            }, targetListener: {
                serializedName: "properties.targetListener",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, targetUrl: {
                serializedName: "properties.targetUrl",
                type: {
                    name: "String"
                }
            }, includePath: {
                serializedName: "properties.includePath",
                type: {
                    name: "Boolean"
                }
            }, includeQueryString: {
                serializedName: "properties.includeQueryString",
                type: {
                    name: "Boolean"
                }
            }, requestRoutingRules: {
                serializedName: "properties.requestRoutingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, urlPathMaps: {
                serializedName: "properties.urlPathMaps",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, pathRules: {
                serializedName: "properties.pathRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayPrivateLinkIpConfiguration = {
    serializedName: "ApplicationGatewayPrivateLinkIpConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateLinkIpConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayPrivateLinkConfiguration = {
    serializedName: "ApplicationGatewayPrivateLinkConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateLinkConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPrivateLinkIpConfiguration"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayPrivateLinkResource = {
    serializedName: "ApplicationGatewayPrivateLinkResource",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateLinkResource",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { groupId: {
                readOnly: true,
                serializedName: "properties.groupId",
                type: {
                    name: "String"
                }
            }, requiredMembers: {
                readOnly: true,
                serializedName: "properties.requiredMembers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, requiredZoneNames: {
                serializedName: "properties.requiredZoneNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayPrivateEndpointConnection = {
    serializedName: "ApplicationGatewayPrivateEndpointConnection",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateEndpointConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateEndpoint: {
                readOnly: true,
                serializedName: "properties.privateEndpoint",
                type: {
                    name: "Composite",
                    className: "PrivateEndpoint"
                }
            }, privateLinkServiceConnectionState: {
                serializedName: "properties.privateLinkServiceConnectionState",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServiceConnectionState"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, linkIdentifier: {
                readOnly: true,
                serializedName: "properties.linkIdentifier",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayUrlPathMap = {
    serializedName: "ApplicationGatewayUrlPathMap",
    type: {
        name: "Composite",
        className: "ApplicationGatewayUrlPathMap",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { defaultBackendAddressPool: {
                serializedName: "properties.defaultBackendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, defaultBackendHttpSettings: {
                serializedName: "properties.defaultBackendHttpSettings",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, defaultRewriteRuleSet: {
                serializedName: "properties.defaultRewriteRuleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, defaultRedirectConfiguration: {
                serializedName: "properties.defaultRedirectConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, pathRules: {
                serializedName: "properties.pathRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPathRule"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayFirewallDisabledRuleGroup = {
    serializedName: "ApplicationGatewayFirewallDisabledRuleGroup",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFirewallDisabledRuleGroup",
        modelProperties: {
            ruleGroupName: {
                required: true,
                serializedName: "ruleGroupName",
                type: {
                    name: "String"
                }
            },
            rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Number"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayFirewallExclusion = {
    serializedName: "ApplicationGatewayFirewallExclusion",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFirewallExclusion",
        modelProperties: {
            matchVariable: {
                required: true,
                serializedName: "matchVariable",
                type: {
                    name: "String"
                }
            },
            selectorMatchOperator: {
                required: true,
                serializedName: "selectorMatchOperator",
                type: {
                    name: "String"
                }
            },
            selector: {
                required: true,
                serializedName: "selector",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayWebApplicationFirewallConfiguration = {
    serializedName: "ApplicationGatewayWebApplicationFirewallConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayWebApplicationFirewallConfiguration",
        modelProperties: {
            enabled: {
                required: true,
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            firewallMode: {
                required: true,
                serializedName: "firewallMode",
                type: {
                    name: "String"
                }
            },
            ruleSetType: {
                required: true,
                serializedName: "ruleSetType",
                type: {
                    name: "String"
                }
            },
            ruleSetVersion: {
                required: true,
                serializedName: "ruleSetVersion",
                type: {
                    name: "String"
                }
            },
            disabledRuleGroups: {
                serializedName: "disabledRuleGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFirewallDisabledRuleGroup"
                        }
                    }
                }
            },
            requestBodyCheck: {
                serializedName: "requestBodyCheck",
                type: {
                    name: "Boolean"
                }
            },
            maxRequestBodySize: {
                serializedName: "maxRequestBodySize",
                constraints: {
                    InclusiveMaximum: 128,
                    InclusiveMinimum: 8
                },
                type: {
                    name: "Number"
                }
            },
            maxRequestBodySizeInKb: {
                serializedName: "maxRequestBodySizeInKb",
                constraints: {
                    InclusiveMaximum: 128,
                    InclusiveMinimum: 8
                },
                type: {
                    name: "Number"
                }
            },
            fileUploadLimitInMb: {
                serializedName: "fileUploadLimitInMb",
                constraints: {
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            exclusions: {
                serializedName: "exclusions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFirewallExclusion"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayAutoscaleConfiguration = {
    serializedName: "ApplicationGatewayAutoscaleConfiguration",
    type: {
        name: "Composite",
        className: "ApplicationGatewayAutoscaleConfiguration",
        modelProperties: {
            minCapacity: {
                required: true,
                serializedName: "minCapacity",
                constraints: {
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            maxCapacity: {
                serializedName: "maxCapacity",
                constraints: {
                    InclusiveMinimum: 2
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ManagedServiceIdentityUserAssignedIdentitiesValue = {
    serializedName: "ManagedServiceIdentity_userAssignedIdentitiesValue",
    type: {
        name: "Composite",
        className: "ManagedServiceIdentityUserAssignedIdentitiesValue",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            clientId: {
                readOnly: true,
                serializedName: "clientId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ManagedServiceIdentity = {
    serializedName: "ManagedServiceIdentity",
    type: {
        name: "Composite",
        className: "ManagedServiceIdentity",
        modelProperties: {
            principalId: {
                readOnly: true,
                serializedName: "principalId",
                type: {
                    name: "String"
                }
            },
            tenantId: {
                readOnly: true,
                serializedName: "tenantId",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "SystemAssigned",
                        "UserAssigned",
                        "SystemAssigned, UserAssigned",
                        "None"
                    ]
                }
            },
            userAssignedIdentities: {
                serializedName: "userAssignedIdentities",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Composite",
                            className: "ManagedServiceIdentityUserAssignedIdentitiesValue"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGateway = {
    serializedName: "ApplicationGateway",
    type: {
        name: "Composite",
        className: "ApplicationGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "properties.sku",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewaySku"
                }
            }, sslPolicy: {
                serializedName: "properties.sslPolicy",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewaySslPolicy"
                }
            }, operationalState: {
                readOnly: true,
                serializedName: "properties.operationalState",
                type: {
                    name: "String"
                }
            }, gatewayIPConfigurations: {
                serializedName: "properties.gatewayIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayIPConfiguration"
                        }
                    }
                }
            }, authenticationCertificates: {
                serializedName: "properties.authenticationCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayAuthenticationCertificate"
                        }
                    }
                }
            }, trustedRootCertificates: {
                serializedName: "properties.trustedRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayTrustedRootCertificate"
                        }
                    }
                }
            }, trustedClientCertificates: {
                serializedName: "properties.trustedClientCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayTrustedClientCertificate"
                        }
                    }
                }
            }, sslCertificates: {
                serializedName: "properties.sslCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewaySslCertificate"
                        }
                    }
                }
            }, frontendIPConfigurations: {
                serializedName: "properties.frontendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFrontendIPConfiguration"
                        }
                    }
                }
            }, frontendPorts: {
                serializedName: "properties.frontendPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFrontendPort"
                        }
                    }
                }
            }, probes: {
                serializedName: "properties.probes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayProbe"
                        }
                    }
                }
            }, backendAddressPools: {
                serializedName: "properties.backendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendAddressPool"
                        }
                    }
                }
            }, backendHttpSettingsCollection: {
                serializedName: "properties.backendHttpSettingsCollection",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayBackendHttpSettings"
                        }
                    }
                }
            }, httpListeners: {
                serializedName: "properties.httpListeners",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayHttpListener"
                        }
                    }
                }
            }, sslProfiles: {
                serializedName: "properties.sslProfiles",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewaySslProfile"
                        }
                    }
                }
            }, urlPathMaps: {
                serializedName: "properties.urlPathMaps",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayUrlPathMap"
                        }
                    }
                }
            }, requestRoutingRules: {
                serializedName: "properties.requestRoutingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayRequestRoutingRule"
                        }
                    }
                }
            }, rewriteRuleSets: {
                serializedName: "properties.rewriteRuleSets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayRewriteRuleSet"
                        }
                    }
                }
            }, redirectConfigurations: {
                serializedName: "properties.redirectConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayRedirectConfiguration"
                        }
                    }
                }
            }, webApplicationFirewallConfiguration: {
                serializedName: "properties.webApplicationFirewallConfiguration",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayWebApplicationFirewallConfiguration"
                }
            }, firewallPolicy: {
                serializedName: "properties.firewallPolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, enableHttp2: {
                serializedName: "properties.enableHttp2",
                type: {
                    name: "Boolean"
                }
            }, enableFips: {
                serializedName: "properties.enableFips",
                type: {
                    name: "Boolean"
                }
            }, autoscaleConfiguration: {
                serializedName: "properties.autoscaleConfiguration",
                type: {
                    name: "Composite",
                    className: "ApplicationGatewayAutoscaleConfiguration"
                }
            }, privateLinkConfigurations: {
                serializedName: "properties.privateLinkConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPrivateLinkConfiguration"
                        }
                    }
                }
            }, privateEndpointConnections: {
                readOnly: true,
                serializedName: "properties.privateEndpointConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPrivateEndpointConnection"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, customErrorConfigurations: {
                serializedName: "properties.customErrorConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayCustomError"
                        }
                    }
                }
            }, forceFirewallPolicyAssociation: {
                serializedName: "properties.forceFirewallPolicyAssociation",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "ManagedServiceIdentity"
                }
            } })
    }
};
export var ApplicationGatewayFirewallRule = {
    serializedName: "ApplicationGatewayFirewallRule",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFirewallRule",
        modelProperties: {
            ruleId: {
                required: true,
                serializedName: "ruleId",
                type: {
                    name: "Number"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayFirewallRuleGroup = {
    serializedName: "ApplicationGatewayFirewallRuleGroup",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFirewallRuleGroup",
        modelProperties: {
            ruleGroupName: {
                required: true,
                serializedName: "ruleGroupName",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            rules: {
                required: true,
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFirewallRule"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayFirewallRuleSet = {
    serializedName: "ApplicationGatewayFirewallRuleSet",
    type: {
        name: "Composite",
        className: "ApplicationGatewayFirewallRuleSet",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, ruleSetType: {
                required: true,
                serializedName: "properties.ruleSetType",
                type: {
                    name: "String"
                }
            }, ruleSetVersion: {
                required: true,
                serializedName: "properties.ruleSetVersion",
                type: {
                    name: "String"
                }
            }, ruleGroups: {
                required: true,
                serializedName: "properties.ruleGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFirewallRuleGroup"
                        }
                    }
                }
            } })
    }
};
export var ApplicationGatewayAvailableWafRuleSetsResult = {
    serializedName: "ApplicationGatewayAvailableWafRuleSetsResult",
    type: {
        name: "Composite",
        className: "ApplicationGatewayAvailableWafRuleSetsResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayFirewallRuleSet"
                        }
                    }
                }
            }
        }
    }
};
export var ApplicationGatewayAvailableSslOptions = {
    serializedName: "ApplicationGatewayAvailableSslOptions",
    type: {
        name: "Composite",
        className: "ApplicationGatewayAvailableSslOptions",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { predefinedPolicies: {
                serializedName: "properties.predefinedPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, defaultPolicy: {
                serializedName: "properties.defaultPolicy",
                type: {
                    name: "String"
                }
            }, availableCipherSuites: {
                serializedName: "properties.availableCipherSuites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, availableProtocols: {
                serializedName: "properties.availableProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var ApplicationGatewaySslPredefinedPolicy = {
    serializedName: "ApplicationGatewaySslPredefinedPolicy",
    type: {
        name: "Composite",
        className: "ApplicationGatewaySslPredefinedPolicy",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, cipherSuites: {
                serializedName: "properties.cipherSuites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, minProtocolVersion: {
                serializedName: "properties.minProtocolVersion",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ErrorDetails = {
    serializedName: "ErrorDetails",
    type: {
        name: "Composite",
        className: "ErrorDetails",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ErrorModel = {
    serializedName: "Error",
    type: {
        name: "Composite",
        className: "ErrorModel",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            details: {
                serializedName: "details",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ErrorDetails"
                        }
                    }
                }
            },
            innerError: {
                serializedName: "innerError",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TagsObject = {
    serializedName: "TagsObject",
    type: {
        name: "Composite",
        className: "TagsObject",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableDelegation = {
    serializedName: "AvailableDelegation",
    type: {
        name: "Composite",
        className: "AvailableDelegation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            serviceName: {
                serializedName: "serviceName",
                type: {
                    name: "String"
                }
            },
            actions: {
                serializedName: "actions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableServiceAlias = {
    serializedName: "AvailableServiceAlias",
    type: {
        name: "Composite",
        className: "AvailableServiceAlias",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            resourceName: {
                serializedName: "resourceName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallIPConfiguration = {
    serializedName: "AzureFirewallIPConfiguration",
    type: {
        name: "Composite",
        className: "AzureFirewallIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                readOnly: true,
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureFirewallPublicIPAddress = {
    serializedName: "AzureFirewallPublicIPAddress",
    type: {
        name: "Composite",
        className: "AzureFirewallPublicIPAddress",
        modelProperties: {
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallIpGroups = {
    serializedName: "AzureFirewallIpGroups",
    type: {
        name: "Composite",
        className: "AzureFirewallIpGroups",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            changeNumber: {
                readOnly: true,
                serializedName: "changeNumber",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var HubPublicIPAddresses = {
    serializedName: "HubPublicIPAddresses",
    type: {
        name: "Composite",
        className: "HubPublicIPAddresses",
        modelProperties: {
            addresses: {
                serializedName: "addresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallPublicIPAddress"
                        }
                    }
                }
            },
            count: {
                serializedName: "count",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var HubIPAddresses = {
    serializedName: "HubIPAddresses",
    type: {
        name: "Composite",
        className: "HubIPAddresses",
        modelProperties: {
            publicIPs: {
                serializedName: "publicIPs",
                type: {
                    name: "Composite",
                    className: "HubPublicIPAddresses"
                }
            },
            privateIPAddress: {
                serializedName: "privateIPAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallRCAction = {
    serializedName: "AzureFirewallRCAction",
    type: {
        name: "Composite",
        className: "AzureFirewallRCAction",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallApplicationRuleProtocol = {
    serializedName: "AzureFirewallApplicationRuleProtocol",
    type: {
        name: "Composite",
        className: "AzureFirewallApplicationRuleProtocol",
        modelProperties: {
            protocolType: {
                serializedName: "protocolType",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 64000,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AzureFirewallApplicationRule = {
    serializedName: "AzureFirewallApplicationRule",
    type: {
        name: "Composite",
        className: "AzureFirewallApplicationRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            protocols: {
                serializedName: "protocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallApplicationRuleProtocol"
                        }
                    }
                }
            },
            targetFqdns: {
                serializedName: "targetFqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            fqdnTags: {
                serializedName: "fqdnTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AzureFirewallApplicationRuleCollection = {
    serializedName: "AzureFirewallApplicationRuleCollection",
    type: {
        name: "Composite",
        className: "AzureFirewallApplicationRuleCollection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { priority: {
                serializedName: "properties.priority",
                constraints: {
                    InclusiveMaximum: 65000,
                    InclusiveMinimum: 100
                },
                type: {
                    name: "Number"
                }
            }, action: {
                serializedName: "properties.action",
                type: {
                    name: "Composite",
                    className: "AzureFirewallRCAction"
                }
            }, rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallApplicationRule"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureFirewallNatRCAction = {
    serializedName: "AzureFirewallNatRCAction",
    type: {
        name: "Composite",
        className: "AzureFirewallNatRCAction",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallNatRule = {
    serializedName: "AzureFirewallNatRule",
    type: {
        name: "Composite",
        className: "AzureFirewallNatRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationPorts: {
                serializedName: "destinationPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            protocols: {
                serializedName: "protocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            translatedAddress: {
                serializedName: "translatedAddress",
                type: {
                    name: "String"
                }
            },
            translatedPort: {
                serializedName: "translatedPort",
                type: {
                    name: "String"
                }
            },
            translatedFqdn: {
                serializedName: "translatedFqdn",
                type: {
                    name: "String"
                }
            },
            sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AzureFirewallNatRuleCollection = {
    serializedName: "AzureFirewallNatRuleCollection",
    type: {
        name: "Composite",
        className: "AzureFirewallNatRuleCollection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { priority: {
                serializedName: "properties.priority",
                constraints: {
                    InclusiveMaximum: 65000,
                    InclusiveMinimum: 100
                },
                type: {
                    name: "Number"
                }
            }, action: {
                serializedName: "properties.action",
                type: {
                    name: "Composite",
                    className: "AzureFirewallNatRCAction"
                }
            }, rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallNatRule"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureFirewallNetworkRule = {
    serializedName: "AzureFirewallNetworkRule",
    type: {
        name: "Composite",
        className: "AzureFirewallNetworkRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            protocols: {
                serializedName: "protocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationPorts: {
                serializedName: "destinationPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationFqdns: {
                serializedName: "destinationFqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationIpGroups: {
                serializedName: "destinationIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AzureFirewallNetworkRuleCollection = {
    serializedName: "AzureFirewallNetworkRuleCollection",
    type: {
        name: "Composite",
        className: "AzureFirewallNetworkRuleCollection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { priority: {
                serializedName: "properties.priority",
                constraints: {
                    InclusiveMaximum: 65000,
                    InclusiveMinimum: 100
                },
                type: {
                    name: "Number"
                }
            }, action: {
                serializedName: "properties.action",
                type: {
                    name: "Composite",
                    className: "AzureFirewallRCAction"
                }
            }, rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallNetworkRule"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureFirewallSku = {
    serializedName: "AzureFirewallSku",
    type: {
        name: "Composite",
        className: "AzureFirewallSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewall = {
    serializedName: "AzureFirewall",
    type: {
        name: "Composite",
        className: "AzureFirewall",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { applicationRuleCollections: {
                serializedName: "properties.applicationRuleCollections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallApplicationRuleCollection"
                        }
                    }
                }
            }, natRuleCollections: {
                serializedName: "properties.natRuleCollections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallNatRuleCollection"
                        }
                    }
                }
            }, networkRuleCollections: {
                serializedName: "properties.networkRuleCollections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallNetworkRuleCollection"
                        }
                    }
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallIPConfiguration"
                        }
                    }
                }
            }, managementIpConfiguration: {
                serializedName: "properties.managementIpConfiguration",
                type: {
                    name: "Composite",
                    className: "AzureFirewallIPConfiguration"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, threatIntelMode: {
                serializedName: "properties.threatIntelMode",
                type: {
                    name: "String"
                }
            }, virtualHub: {
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, firewallPolicy: {
                serializedName: "properties.firewallPolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hubIPAddresses: {
                serializedName: "properties.hubIPAddresses",
                type: {
                    name: "Composite",
                    className: "HubIPAddresses"
                }
            }, ipGroups: {
                readOnly: true,
                serializedName: "properties.ipGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallIpGroups"
                        }
                    }
                }
            }, sku: {
                serializedName: "properties.sku",
                type: {
                    name: "Composite",
                    className: "AzureFirewallSku"
                }
            }, additionalProperties: {
                serializedName: "properties.additionalProperties",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureFirewallFqdnTag = {
    serializedName: "AzureFirewallFqdnTag",
    type: {
        name: "Composite",
        className: "AzureFirewallFqdnTag",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, fqdnTagName: {
                readOnly: true,
                serializedName: "properties.fqdnTagName",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var AzureWebCategory = {
    serializedName: "AzureWebCategory",
    type: {
        name: "Composite",
        className: "AzureWebCategory",
        modelProperties: {
            group: {
                readOnly: true,
                serializedName: "properties.group",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Sku = {
    serializedName: "Sku",
    type: {
        name: "Composite",
        className: "Sku",
        modelProperties: {
            name: {
                serializedName: "name",
                defaultValue: 'Standard',
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionHostIPConfiguration = {
    serializedName: "BastionHostIPConfiguration",
    type: {
        name: "Composite",
        className: "BastionHostIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { subnet: {
                required: true,
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, publicIPAddress: {
                required: true,
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var BastionHost = {
    serializedName: "BastionHost",
    type: {
        name: "Composite",
        className: "BastionHost",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionHostIPConfiguration"
                        }
                    }
                }
            }, dnsName: {
                serializedName: "properties.dnsName",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            } })
    }
};
export var VM = {
    serializedName: "VM",
    type: {
        name: "Composite",
        className: "VM",
        modelProperties: __assign({}, Resource.type.modelProperties)
    }
};
export var BastionShareableLink = {
    serializedName: "BastionShareableLink",
    type: {
        name: "Composite",
        className: "BastionShareableLink",
        modelProperties: {
            vm: {
                required: true,
                serializedName: "vm",
                type: {
                    name: "Composite",
                    className: "VM"
                }
            },
            bsl: {
                readOnly: true,
                serializedName: "bsl",
                type: {
                    name: "String"
                }
            },
            createdAt: {
                readOnly: true,
                serializedName: "createdAt",
                type: {
                    name: "String"
                }
            },
            message: {
                readOnly: true,
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionShareableLinkListRequest = {
    serializedName: "BastionShareableLinkListRequest",
    type: {
        name: "Composite",
        className: "BastionShareableLinkListRequest",
        modelProperties: {
            vms: {
                serializedName: "vms",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionShareableLink"
                        }
                    }
                }
            }
        }
    }
};
export var BastionActiveSession = {
    serializedName: "BastionActiveSession",
    type: {
        name: "Composite",
        className: "BastionActiveSession",
        modelProperties: {
            sessionId: {
                readOnly: true,
                serializedName: "sessionId",
                type: {
                    name: "String"
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "startTime",
                type: {
                    name: "Object"
                }
            },
            targetSubscriptionId: {
                readOnly: true,
                serializedName: "targetSubscriptionId",
                type: {
                    name: "String"
                }
            },
            resourceType: {
                readOnly: true,
                serializedName: "resourceType",
                type: {
                    name: "String"
                }
            },
            targetHostName: {
                readOnly: true,
                serializedName: "targetHostName",
                type: {
                    name: "String"
                }
            },
            targetResourceGroup: {
                readOnly: true,
                serializedName: "targetResourceGroup",
                type: {
                    name: "String"
                }
            },
            userName: {
                readOnly: true,
                serializedName: "userName",
                type: {
                    name: "String"
                }
            },
            targetIpAddress: {
                readOnly: true,
                serializedName: "targetIpAddress",
                type: {
                    name: "String"
                }
            },
            protocol: {
                readOnly: true,
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            targetResourceId: {
                readOnly: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            sessionDurationInMins: {
                readOnly: true,
                serializedName: "sessionDurationInMins",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var BastionSessionState = {
    serializedName: "BastionSessionState",
    type: {
        name: "Composite",
        className: "BastionSessionState",
        modelProperties: {
            sessionId: {
                readOnly: true,
                serializedName: "sessionId",
                type: {
                    name: "String"
                }
            },
            message: {
                readOnly: true,
                serializedName: "message",
                type: {
                    name: "String"
                }
            },
            state: {
                readOnly: true,
                serializedName: "state",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SessionIds = {
    serializedName: "SessionIds",
    type: {
        name: "Composite",
        className: "SessionIds",
        modelProperties: {
            sessionIds: {
                serializedName: "sessionIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var DnsNameAvailabilityResult = {
    serializedName: "DnsNameAvailabilityResult",
    type: {
        name: "Composite",
        className: "DnsNameAvailabilityResult",
        modelProperties: {
            available: {
                serializedName: "available",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var CustomIpPrefix = {
    serializedName: "CustomIpPrefix",
    type: {
        name: "Composite",
        className: "CustomIpPrefix",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, cidr: {
                serializedName: "properties.cidr",
                type: {
                    name: "String"
                }
            }, signedMessage: {
                serializedName: "properties.signedMessage",
                type: {
                    name: "String"
                }
            }, authorizationMessage: {
                serializedName: "properties.authorizationMessage",
                type: {
                    name: "String"
                }
            }, customIpPrefixParent: {
                serializedName: "properties.customIpPrefixParent",
                type: {
                    name: "Composite",
                    className: "CustomIpPrefix"
                }
            }, childCustomIpPrefixes: {
                readOnly: true,
                serializedName: "properties.childCustomIpPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CustomIpPrefix"
                        }
                    }
                }
            }, commissionedState: {
                serializedName: "properties.commissionedState",
                type: {
                    name: "String"
                }
            }, publicIpPrefixes: {
                readOnly: true,
                serializedName: "properties.publicIpPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, failedReason: {
                readOnly: true,
                serializedName: "properties.failedReason",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var ProtocolCustomSettingsFormat = {
    serializedName: "ProtocolCustomSettingsFormat",
    type: {
        name: "Composite",
        className: "ProtocolCustomSettingsFormat",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            triggerRateOverride: {
                serializedName: "triggerRateOverride",
                type: {
                    name: "String"
                }
            },
            sourceRateOverride: {
                serializedName: "sourceRateOverride",
                type: {
                    name: "String"
                }
            },
            triggerSensitivityOverride: {
                serializedName: "triggerSensitivityOverride",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DdosCustomPolicy = {
    serializedName: "DdosCustomPolicy",
    type: {
        name: "Composite",
        className: "DdosCustomPolicy",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, publicIPAddresses: {
                readOnly: true,
                serializedName: "properties.publicIPAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, protocolCustomSettings: {
                serializedName: "properties.protocolCustomSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ProtocolCustomSettingsFormat"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var DdosProtectionPlan = {
    serializedName: "DdosProtectionPlan",
    type: {
        name: "Composite",
        className: "DdosProtectionPlan",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            },
            virtualNetworks: {
                readOnly: true,
                serializedName: "properties.virtualNetworks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var QosIpRange = {
    serializedName: "QosIpRange",
    type: {
        name: "Composite",
        className: "QosIpRange",
        modelProperties: {
            startIP: {
                serializedName: "startIP",
                type: {
                    name: "String"
                }
            },
            endIP: {
                serializedName: "endIP",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var QosPortRange = {
    serializedName: "QosPortRange",
    type: {
        name: "Composite",
        className: "QosPortRange",
        modelProperties: {
            start: {
                serializedName: "start",
                type: {
                    name: "Number"
                }
            },
            end: {
                serializedName: "end",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var DscpConfiguration = {
    serializedName: "DscpConfiguration",
    type: {
        name: "Composite",
        className: "DscpConfiguration",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { markings: {
                serializedName: "properties.markings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Number"
                        }
                    }
                }
            }, sourceIpRanges: {
                serializedName: "properties.sourceIpRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "QosIpRange"
                        }
                    }
                }
            }, destinationIpRanges: {
                serializedName: "properties.destinationIpRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "QosIpRange"
                        }
                    }
                }
            }, sourcePortRanges: {
                serializedName: "properties.sourcePortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "QosPortRange"
                        }
                    }
                }
            }, destinationPortRanges: {
                serializedName: "properties.destinationPortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "QosPortRange"
                        }
                    }
                }
            }, protocol: {
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, qosCollectionId: {
                readOnly: true,
                serializedName: "properties.qosCollectionId",
                type: {
                    name: "String"
                }
            }, associatedNetworkInterfaces: {
                readOnly: true,
                serializedName: "properties.associatedNetworkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterface"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var EndpointServiceResult = {
    serializedName: "EndpointServiceResult",
    type: {
        name: "Composite",
        className: "EndpointServiceResult",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCircuitAuthorization = {
    serializedName: "ExpressRouteCircuitAuthorization",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitAuthorization",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { authorizationKey: {
                serializedName: "properties.authorizationKey",
                type: {
                    name: "String"
                }
            }, authorizationUseStatus: {
                serializedName: "properties.authorizationUseStatus",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCircuitPeeringConfig = {
    serializedName: "ExpressRouteCircuitPeeringConfig",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitPeeringConfig",
        modelProperties: {
            advertisedPublicPrefixes: {
                serializedName: "advertisedPublicPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            advertisedCommunities: {
                serializedName: "advertisedCommunities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            advertisedPublicPrefixesState: {
                readOnly: true,
                serializedName: "advertisedPublicPrefixesState",
                type: {
                    name: "String"
                }
            },
            legacyMode: {
                serializedName: "legacyMode",
                type: {
                    name: "Number"
                }
            },
            customerASN: {
                serializedName: "customerASN",
                type: {
                    name: "Number"
                }
            },
            routingRegistryName: {
                serializedName: "routingRegistryName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Ipv6ExpressRouteCircuitPeeringConfig = {
    serializedName: "Ipv6ExpressRouteCircuitPeeringConfig",
    type: {
        name: "Composite",
        className: "Ipv6ExpressRouteCircuitPeeringConfig",
        modelProperties: {
            primaryPeerAddressPrefix: {
                serializedName: "primaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            },
            secondaryPeerAddressPrefix: {
                serializedName: "secondaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            },
            microsoftPeeringConfig: {
                serializedName: "microsoftPeeringConfig",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitPeeringConfig"
                }
            },
            routeFilter: {
                serializedName: "routeFilter",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitStats = {
    serializedName: "ExpressRouteCircuitStats",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitStats",
        modelProperties: {
            primarybytesIn: {
                serializedName: "primarybytesIn",
                type: {
                    name: "Number"
                }
            },
            primarybytesOut: {
                serializedName: "primarybytesOut",
                type: {
                    name: "Number"
                }
            },
            secondarybytesIn: {
                serializedName: "secondarybytesIn",
                type: {
                    name: "Number"
                }
            },
            secondarybytesOut: {
                serializedName: "secondarybytesOut",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ExpressRouteConnectionId = {
    serializedName: "ExpressRouteConnectionId",
    type: {
        name: "Composite",
        className: "ExpressRouteConnectionId",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Ipv6CircuitConnectionConfig = {
    serializedName: "Ipv6CircuitConnectionConfig",
    type: {
        name: "Composite",
        className: "Ipv6CircuitConnectionConfig",
        modelProperties: {
            addressPrefix: {
                serializedName: "addressPrefix",
                type: {
                    name: "String"
                }
            },
            circuitConnectionStatus: {
                readOnly: true,
                serializedName: "circuitConnectionStatus",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitConnection = {
    serializedName: "ExpressRouteCircuitConnection",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { expressRouteCircuitPeering: {
                serializedName: "properties.expressRouteCircuitPeering",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, peerExpressRouteCircuitPeering: {
                serializedName: "properties.peerExpressRouteCircuitPeering",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, authorizationKey: {
                serializedName: "properties.authorizationKey",
                type: {
                    name: "String"
                }
            }, ipv6CircuitConnectionConfig: {
                serializedName: "properties.ipv6CircuitConnectionConfig",
                type: {
                    name: "Composite",
                    className: "Ipv6CircuitConnectionConfig"
                }
            }, circuitConnectionStatus: {
                serializedName: "properties.circuitConnectionStatus",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PeerExpressRouteCircuitConnection = {
    serializedName: "PeerExpressRouteCircuitConnection",
    type: {
        name: "Composite",
        className: "PeerExpressRouteCircuitConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { expressRouteCircuitPeering: {
                serializedName: "properties.expressRouteCircuitPeering",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, peerExpressRouteCircuitPeering: {
                serializedName: "properties.peerExpressRouteCircuitPeering",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, circuitConnectionStatus: {
                serializedName: "properties.circuitConnectionStatus",
                type: {
                    name: "String"
                }
            }, connectionName: {
                serializedName: "properties.connectionName",
                type: {
                    name: "String"
                }
            }, authResourceGuid: {
                serializedName: "properties.authResourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCircuitPeering = {
    serializedName: "ExpressRouteCircuitPeering",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitPeering",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { peeringType: {
                serializedName: "properties.peeringType",
                type: {
                    name: "String"
                }
            }, state: {
                serializedName: "properties.state",
                type: {
                    name: "String"
                }
            }, azureASN: {
                serializedName: "properties.azureASN",
                type: {
                    name: "Number"
                }
            }, peerASN: {
                serializedName: "properties.peerASN",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, primaryPeerAddressPrefix: {
                serializedName: "properties.primaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            }, secondaryPeerAddressPrefix: {
                serializedName: "properties.secondaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            }, primaryAzurePort: {
                serializedName: "properties.primaryAzurePort",
                type: {
                    name: "String"
                }
            }, secondaryAzurePort: {
                serializedName: "properties.secondaryAzurePort",
                type: {
                    name: "String"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, vlanId: {
                serializedName: "properties.vlanId",
                type: {
                    name: "Number"
                }
            }, microsoftPeeringConfig: {
                serializedName: "properties.microsoftPeeringConfig",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitPeeringConfig"
                }
            }, stats: {
                serializedName: "properties.stats",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitStats"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, gatewayManagerEtag: {
                serializedName: "properties.gatewayManagerEtag",
                type: {
                    name: "String"
                }
            }, lastModifiedBy: {
                readOnly: true,
                serializedName: "properties.lastModifiedBy",
                type: {
                    name: "String"
                }
            }, routeFilter: {
                serializedName: "properties.routeFilter",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, ipv6PeeringConfig: {
                serializedName: "properties.ipv6PeeringConfig",
                type: {
                    name: "Composite",
                    className: "Ipv6ExpressRouteCircuitPeeringConfig"
                }
            }, expressRouteConnection: {
                serializedName: "properties.expressRouteConnection",
                type: {
                    name: "Composite",
                    className: "ExpressRouteConnectionId"
                }
            }, connections: {
                serializedName: "properties.connections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitConnection"
                        }
                    }
                }
            }, peeredConnections: {
                readOnly: true,
                serializedName: "properties.peeredConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PeerExpressRouteCircuitConnection"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCircuitSku = {
    serializedName: "ExpressRouteCircuitSku",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            family: {
                serializedName: "family",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitServiceProviderProperties = {
    serializedName: "ExpressRouteCircuitServiceProviderProperties",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitServiceProviderProperties",
        modelProperties: {
            serviceProviderName: {
                serializedName: "serviceProviderName",
                type: {
                    name: "String"
                }
            },
            peeringLocation: {
                serializedName: "peeringLocation",
                type: {
                    name: "String"
                }
            },
            bandwidthInMbps: {
                serializedName: "bandwidthInMbps",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ExpressRouteCircuit = {
    serializedName: "ExpressRouteCircuit",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuit",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitSku"
                }
            }, allowClassicOperations: {
                serializedName: "properties.allowClassicOperations",
                type: {
                    name: "Boolean"
                }
            }, circuitProvisioningState: {
                serializedName: "properties.circuitProvisioningState",
                type: {
                    name: "String"
                }
            }, serviceProviderProvisioningState: {
                serializedName: "properties.serviceProviderProvisioningState",
                type: {
                    name: "String"
                }
            }, authorizations: {
                serializedName: "properties.authorizations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitAuthorization"
                        }
                    }
                }
            }, peerings: {
                serializedName: "properties.peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            }, serviceKey: {
                serializedName: "properties.serviceKey",
                type: {
                    name: "String"
                }
            }, serviceProviderNotes: {
                serializedName: "properties.serviceProviderNotes",
                type: {
                    name: "String"
                }
            }, serviceProviderProperties: {
                serializedName: "properties.serviceProviderProperties",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitServiceProviderProperties"
                }
            }, expressRoutePort: {
                serializedName: "properties.expressRoutePort",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, bandwidthInGbps: {
                serializedName: "properties.bandwidthInGbps",
                type: {
                    name: "Number"
                }
            }, stag: {
                readOnly: true,
                serializedName: "properties.stag",
                type: {
                    name: "Number"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, gatewayManagerEtag: {
                serializedName: "properties.gatewayManagerEtag",
                type: {
                    name: "String"
                }
            }, globalReachEnabled: {
                serializedName: "properties.globalReachEnabled",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCircuitArpTable = {
    serializedName: "ExpressRouteCircuitArpTable",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitArpTable",
        modelProperties: {
            age: {
                serializedName: "age",
                type: {
                    name: "Number"
                }
            },
            interfaceProperty: {
                serializedName: "interface",
                type: {
                    name: "String"
                }
            },
            ipAddress: {
                serializedName: "ipAddress",
                type: {
                    name: "String"
                }
            },
            macAddress: {
                serializedName: "macAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitsArpTableListResult = {
    serializedName: "ExpressRouteCircuitsArpTableListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitsArpTableListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitArpTable"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitRoutesTable = {
    serializedName: "ExpressRouteCircuitRoutesTable",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitRoutesTable",
        modelProperties: {
            network: {
                serializedName: "network",
                type: {
                    name: "String"
                }
            },
            nextHop: {
                serializedName: "nextHop",
                type: {
                    name: "String"
                }
            },
            locPrf: {
                serializedName: "locPrf",
                type: {
                    name: "String"
                }
            },
            weight: {
                serializedName: "weight",
                type: {
                    name: "Number"
                }
            },
            path: {
                serializedName: "path",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitsRoutesTableListResult = {
    serializedName: "ExpressRouteCircuitsRoutesTableListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitsRoutesTableListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitRoutesTable"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitRoutesTableSummary = {
    serializedName: "ExpressRouteCircuitRoutesTableSummary",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitRoutesTableSummary",
        modelProperties: {
            neighbor: {
                serializedName: "neighbor",
                type: {
                    name: "String"
                }
            },
            v: {
                serializedName: "v",
                type: {
                    name: "Number"
                }
            },
            as: {
                serializedName: "as",
                type: {
                    name: "Number"
                }
            },
            upDown: {
                serializedName: "upDown",
                type: {
                    name: "String"
                }
            },
            statePfxRcd: {
                serializedName: "statePfxRcd",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitsRoutesTableSummaryListResult = {
    serializedName: "ExpressRouteCircuitsRoutesTableSummaryListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitsRoutesTableSummaryListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitRoutesTableSummary"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteServiceProviderBandwidthsOffered = {
    serializedName: "ExpressRouteServiceProviderBandwidthsOffered",
    type: {
        name: "Composite",
        className: "ExpressRouteServiceProviderBandwidthsOffered",
        modelProperties: {
            offerName: {
                serializedName: "offerName",
                type: {
                    name: "String"
                }
            },
            valueInMbps: {
                serializedName: "valueInMbps",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ExpressRouteServiceProvider = {
    serializedName: "ExpressRouteServiceProvider",
    type: {
        name: "Composite",
        className: "ExpressRouteServiceProvider",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { peeringLocations: {
                serializedName: "properties.peeringLocations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, bandwidthsOffered: {
                serializedName: "properties.bandwidthsOffered",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteServiceProviderBandwidthsOffered"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCrossConnectionRoutesTableSummary = {
    serializedName: "ExpressRouteCrossConnectionRoutesTableSummary",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnectionRoutesTableSummary",
        modelProperties: {
            neighbor: {
                serializedName: "neighbor",
                type: {
                    name: "String"
                }
            },
            asn: {
                serializedName: "asn",
                type: {
                    name: "Number"
                }
            },
            upDown: {
                serializedName: "upDown",
                type: {
                    name: "String"
                }
            },
            stateOrPrefixesReceived: {
                serializedName: "stateOrPrefixesReceived",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCrossConnectionsRoutesTableSummaryListResult = {
    serializedName: "ExpressRouteCrossConnectionsRoutesTableSummaryListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnectionsRoutesTableSummaryListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCrossConnectionRoutesTableSummary"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitReference = {
    serializedName: "ExpressRouteCircuitReference",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitReference",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCrossConnectionPeering = {
    serializedName: "ExpressRouteCrossConnectionPeering",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnectionPeering",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { peeringType: {
                serializedName: "properties.peeringType",
                type: {
                    name: "String"
                }
            }, state: {
                serializedName: "properties.state",
                type: {
                    name: "String"
                }
            }, azureASN: {
                readOnly: true,
                serializedName: "properties.azureASN",
                type: {
                    name: "Number"
                }
            }, peerASN: {
                serializedName: "properties.peerASN",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }, primaryPeerAddressPrefix: {
                serializedName: "properties.primaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            }, secondaryPeerAddressPrefix: {
                serializedName: "properties.secondaryPeerAddressPrefix",
                type: {
                    name: "String"
                }
            }, primaryAzurePort: {
                readOnly: true,
                serializedName: "properties.primaryAzurePort",
                type: {
                    name: "String"
                }
            }, secondaryAzurePort: {
                readOnly: true,
                serializedName: "properties.secondaryAzurePort",
                type: {
                    name: "String"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, vlanId: {
                serializedName: "properties.vlanId",
                type: {
                    name: "Number"
                }
            }, microsoftPeeringConfig: {
                serializedName: "properties.microsoftPeeringConfig",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitPeeringConfig"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, gatewayManagerEtag: {
                serializedName: "properties.gatewayManagerEtag",
                type: {
                    name: "String"
                }
            }, lastModifiedBy: {
                readOnly: true,
                serializedName: "properties.lastModifiedBy",
                type: {
                    name: "String"
                }
            }, ipv6PeeringConfig: {
                serializedName: "properties.ipv6PeeringConfig",
                type: {
                    name: "Composite",
                    className: "Ipv6ExpressRouteCircuitPeeringConfig"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteCrossConnection = {
    serializedName: "ExpressRouteCrossConnection",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnection",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { primaryAzurePort: {
                readOnly: true,
                serializedName: "properties.primaryAzurePort",
                type: {
                    name: "String"
                }
            }, secondaryAzurePort: {
                readOnly: true,
                serializedName: "properties.secondaryAzurePort",
                type: {
                    name: "String"
                }
            }, sTag: {
                readOnly: true,
                serializedName: "properties.sTag",
                type: {
                    name: "Number"
                }
            }, peeringLocation: {
                readOnly: true,
                serializedName: "properties.peeringLocation",
                type: {
                    name: "String"
                }
            }, bandwidthInMbps: {
                readOnly: true,
                serializedName: "properties.bandwidthInMbps",
                type: {
                    name: "Number"
                }
            }, expressRouteCircuit: {
                serializedName: "properties.expressRouteCircuit",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitReference"
                }
            }, serviceProviderProvisioningState: {
                serializedName: "properties.serviceProviderProvisioningState",
                type: {
                    name: "String"
                }
            }, serviceProviderNotes: {
                serializedName: "properties.serviceProviderNotes",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, peerings: {
                serializedName: "properties.peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCrossConnectionPeering"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRoutePortsLocationBandwidths = {
    serializedName: "ExpressRoutePortsLocationBandwidths",
    type: {
        name: "Composite",
        className: "ExpressRoutePortsLocationBandwidths",
        modelProperties: {
            offerName: {
                readOnly: true,
                serializedName: "offerName",
                type: {
                    name: "String"
                }
            },
            valueInGbps: {
                readOnly: true,
                serializedName: "valueInGbps",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ExpressRoutePortsLocation = {
    serializedName: "ExpressRoutePortsLocation",
    type: {
        name: "Composite",
        className: "ExpressRoutePortsLocation",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { address: {
                readOnly: true,
                serializedName: "properties.address",
                type: {
                    name: "String"
                }
            }, contact: {
                readOnly: true,
                serializedName: "properties.contact",
                type: {
                    name: "String"
                }
            }, availableBandwidths: {
                serializedName: "properties.availableBandwidths",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRoutePortsLocationBandwidths"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteLinkMacSecConfig = {
    serializedName: "ExpressRouteLinkMacSecConfig",
    type: {
        name: "Composite",
        className: "ExpressRouteLinkMacSecConfig",
        modelProperties: {
            cknSecretIdentifier: {
                serializedName: "cknSecretIdentifier",
                type: {
                    name: "String"
                }
            },
            cakSecretIdentifier: {
                serializedName: "cakSecretIdentifier",
                type: {
                    name: "String"
                }
            },
            cipher: {
                serializedName: "cipher",
                type: {
                    name: "String"
                }
            },
            sciState: {
                serializedName: "sciState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteLink = {
    serializedName: "ExpressRouteLink",
    type: {
        name: "Composite",
        className: "ExpressRouteLink",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { routerName: {
                readOnly: true,
                serializedName: "properties.routerName",
                type: {
                    name: "String"
                }
            }, interfaceName: {
                readOnly: true,
                serializedName: "properties.interfaceName",
                type: {
                    name: "String"
                }
            }, patchPanelId: {
                readOnly: true,
                serializedName: "properties.patchPanelId",
                type: {
                    name: "String"
                }
            }, rackId: {
                readOnly: true,
                serializedName: "properties.rackId",
                type: {
                    name: "String"
                }
            }, connectorType: {
                readOnly: true,
                serializedName: "properties.connectorType",
                type: {
                    name: "String"
                }
            }, adminState: {
                serializedName: "properties.adminState",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, macSecConfig: {
                serializedName: "properties.macSecConfig",
                type: {
                    name: "Composite",
                    className: "ExpressRouteLinkMacSecConfig"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRoutePort = {
    serializedName: "ExpressRoutePort",
    type: {
        name: "Composite",
        className: "ExpressRoutePort",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { peeringLocation: {
                serializedName: "properties.peeringLocation",
                type: {
                    name: "String"
                }
            }, bandwidthInGbps: {
                serializedName: "properties.bandwidthInGbps",
                type: {
                    name: "Number"
                }
            }, provisionedBandwidthInGbps: {
                readOnly: true,
                serializedName: "properties.provisionedBandwidthInGbps",
                type: {
                    name: "Number"
                }
            }, mtu: {
                readOnly: true,
                serializedName: "properties.mtu",
                type: {
                    name: "String"
                }
            }, encapsulation: {
                serializedName: "properties.encapsulation",
                type: {
                    name: "String"
                }
            }, etherType: {
                readOnly: true,
                serializedName: "properties.etherType",
                type: {
                    name: "String"
                }
            }, allocationDate: {
                readOnly: true,
                serializedName: "properties.allocationDate",
                type: {
                    name: "String"
                }
            }, links: {
                serializedName: "properties.links",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteLink"
                        }
                    }
                }
            }, circuits: {
                readOnly: true,
                serializedName: "properties.circuits",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "ManagedServiceIdentity"
                }
            } })
    }
};
export var GenerateExpressRoutePortsLOARequest = {
    serializedName: "GenerateExpressRoutePortsLOARequest",
    type: {
        name: "Composite",
        className: "GenerateExpressRoutePortsLOARequest",
        modelProperties: {
            customerName: {
                required: true,
                serializedName: "customerName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var GenerateExpressRoutePortsLOAResult = {
    serializedName: "GenerateExpressRoutePortsLOAResult",
    type: {
        name: "Composite",
        className: "GenerateExpressRoutePortsLOAResult",
        modelProperties: {
            encodedContent: {
                serializedName: "encodedContent",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyThreatIntelWhitelist = {
    serializedName: "FirewallPolicyThreatIntelWhitelist",
    type: {
        name: "Composite",
        className: "FirewallPolicyThreatIntelWhitelist",
        modelProperties: {
            ipAddresses: {
                serializedName: "ipAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            fqdns: {
                serializedName: "fqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var FirewallPolicyLogAnalyticsWorkspace = {
    serializedName: "FirewallPolicyLogAnalyticsWorkspace",
    type: {
        name: "Composite",
        className: "FirewallPolicyLogAnalyticsWorkspace",
        modelProperties: {
            region: {
                serializedName: "region",
                type: {
                    name: "String"
                }
            },
            workspaceId: {
                serializedName: "workspaceId",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var FirewallPolicyLogAnalyticsResources = {
    serializedName: "FirewallPolicyLogAnalyticsResources",
    type: {
        name: "Composite",
        className: "FirewallPolicyLogAnalyticsResources",
        modelProperties: {
            workspaces: {
                serializedName: "workspaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyLogAnalyticsWorkspace"
                        }
                    }
                }
            },
            defaultWorkspaceId: {
                serializedName: "defaultWorkspaceId",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var FirewallPolicyInsights = {
    serializedName: "FirewallPolicyInsights",
    type: {
        name: "Composite",
        className: "FirewallPolicyInsights",
        modelProperties: {
            isEnabled: {
                serializedName: "isEnabled",
                type: {
                    name: "Boolean"
                }
            },
            retentionDays: {
                serializedName: "retentionDays",
                type: {
                    name: "Number"
                }
            },
            logAnalyticsResources: {
                serializedName: "logAnalyticsResources",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyLogAnalyticsResources"
                }
            }
        }
    }
};
export var FirewallPolicySNAT = {
    serializedName: "FirewallPolicySNAT",
    type: {
        name: "Composite",
        className: "FirewallPolicySNAT",
        modelProperties: {
            privateRanges: {
                serializedName: "privateRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var DnsSettings = {
    serializedName: "DnsSettings",
    type: {
        name: "Composite",
        className: "DnsSettings",
        modelProperties: {
            servers: {
                serializedName: "servers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            enableProxy: {
                serializedName: "enableProxy",
                type: {
                    name: "Boolean"
                }
            },
            requireProxyForNetworkRules: {
                nullable: true,
                serializedName: "requireProxyForNetworkRules",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var FirewallPolicyIntrusionDetectionSignatureSpecification = {
    serializedName: "FirewallPolicyIntrusionDetectionSignatureSpecification",
    type: {
        name: "Composite",
        className: "FirewallPolicyIntrusionDetectionSignatureSpecification",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            mode: {
                serializedName: "mode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyIntrusionDetectionBypassTrafficSpecifications = {
    serializedName: "FirewallPolicyIntrusionDetectionBypassTrafficSpecifications",
    type: {
        name: "Composite",
        className: "FirewallPolicyIntrusionDetectionBypassTrafficSpecifications",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationPorts: {
                serializedName: "destinationPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationIpGroups: {
                serializedName: "destinationIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var FirewallPolicyIntrusionDetectionConfiguration = {
    serializedName: "FirewallPolicyIntrusionDetectionConfiguration",
    type: {
        name: "Composite",
        className: "FirewallPolicyIntrusionDetectionConfiguration",
        modelProperties: {
            signatureOverrides: {
                serializedName: "signatureOverrides",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyIntrusionDetectionSignatureSpecification"
                        }
                    }
                }
            },
            bypassTrafficSettings: {
                serializedName: "bypassTrafficSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyIntrusionDetectionBypassTrafficSpecifications"
                        }
                    }
                }
            }
        }
    }
};
export var FirewallPolicyIntrusionDetection = {
    serializedName: "FirewallPolicyIntrusionDetection",
    type: {
        name: "Composite",
        className: "FirewallPolicyIntrusionDetection",
        modelProperties: {
            mode: {
                serializedName: "mode",
                type: {
                    name: "String"
                }
            },
            configuration: {
                serializedName: "configuration",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyIntrusionDetectionConfiguration"
                }
            }
        }
    }
};
export var FirewallPolicyCertificateAuthority = {
    serializedName: "FirewallPolicyCertificateAuthority",
    type: {
        name: "Composite",
        className: "FirewallPolicyCertificateAuthority",
        modelProperties: {
            keyVaultSecretId: {
                serializedName: "keyVaultSecretId",
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyTransportSecurity = {
    serializedName: "FirewallPolicyTransportSecurity",
    type: {
        name: "Composite",
        className: "FirewallPolicyTransportSecurity",
        modelProperties: {
            certificateAuthority: {
                serializedName: "certificateAuthority",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyCertificateAuthority"
                }
            }
        }
    }
};
export var FirewallPolicySku = {
    serializedName: "FirewallPolicySku",
    type: {
        name: "Composite",
        className: "FirewallPolicySku",
        modelProperties: {
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicy = {
    serializedName: "FirewallPolicy",
    type: {
        name: "Composite",
        className: "FirewallPolicy",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { ruleCollectionGroups: {
                readOnly: true,
                serializedName: "properties.ruleCollectionGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, basePolicy: {
                serializedName: "properties.basePolicy",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, firewalls: {
                readOnly: true,
                serializedName: "properties.firewalls",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, childPolicies: {
                readOnly: true,
                serializedName: "properties.childPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, threatIntelMode: {
                serializedName: "properties.threatIntelMode",
                type: {
                    name: "String"
                }
            }, threatIntelWhitelist: {
                serializedName: "properties.threatIntelWhitelist",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyThreatIntelWhitelist"
                }
            }, insights: {
                serializedName: "properties.insights",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyInsights"
                }
            }, snat: {
                serializedName: "properties.snat",
                type: {
                    name: "Composite",
                    className: "FirewallPolicySNAT"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "DnsSettings"
                }
            }, intrusionDetection: {
                serializedName: "properties.intrusionDetection",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyIntrusionDetection"
                }
            }, transportSecurity: {
                serializedName: "properties.transportSecurity",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyTransportSecurity"
                }
            }, sku: {
                serializedName: "properties.sku",
                type: {
                    name: "Composite",
                    className: "FirewallPolicySku"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "ManagedServiceIdentity"
                }
            } })
    }
};
export var FirewallPolicyRuleCollection = {
    serializedName: "FirewallPolicyRuleCollection",
    type: {
        name: "Composite",
        polymorphicDiscriminator: {
            serializedName: "ruleCollectionType",
            clientName: "ruleCollectionType"
        },
        uberParent: "FirewallPolicyRuleCollection",
        className: "FirewallPolicyRuleCollection",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            priority: {
                serializedName: "priority",
                constraints: {
                    InclusiveMaximum: 65000,
                    InclusiveMinimum: 100
                },
                type: {
                    name: "Number"
                }
            },
            ruleCollectionType: {
                required: true,
                serializedName: "ruleCollectionType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyRuleCollectionGroup = {
    serializedName: "FirewallPolicyRuleCollectionGroup",
    type: {
        name: "Composite",
        className: "FirewallPolicyRuleCollectionGroup",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { priority: {
                serializedName: "properties.priority",
                constraints: {
                    InclusiveMaximum: 65000,
                    InclusiveMinimum: 100
                },
                type: {
                    name: "Number"
                }
            }, ruleCollections: {
                serializedName: "properties.ruleCollections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyRuleCollection"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var FirewallPolicyNatRuleCollectionAction = {
    serializedName: "FirewallPolicyNatRuleCollectionAction",
    type: {
        name: "Composite",
        className: "FirewallPolicyNatRuleCollectionAction",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyRule = {
    serializedName: "FirewallPolicyRule",
    type: {
        name: "Composite",
        polymorphicDiscriminator: {
            serializedName: "ruleType",
            clientName: "ruleType"
        },
        uberParent: "FirewallPolicyRule",
        className: "FirewallPolicyRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            ruleType: {
                required: true,
                serializedName: "ruleType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyNatRuleCollection = {
    serializedName: "FirewallPolicyNatRuleCollection",
    type: {
        name: "Composite",
        polymorphicDiscriminator: FirewallPolicyRuleCollection.type.polymorphicDiscriminator,
        uberParent: "FirewallPolicyRuleCollection",
        className: "FirewallPolicyNatRuleCollection",
        modelProperties: __assign(__assign({}, FirewallPolicyRuleCollection.type.modelProperties), { action: {
                serializedName: "action",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyNatRuleCollectionAction"
                }
            }, rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyRule"
                        }
                    }
                }
            } })
    }
};
export var FirewallPolicyFilterRuleCollectionAction = {
    serializedName: "FirewallPolicyFilterRuleCollectionAction",
    type: {
        name: "Composite",
        className: "FirewallPolicyFilterRuleCollectionAction",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyFilterRuleCollection = {
    serializedName: "FirewallPolicyFilterRuleCollection",
    type: {
        name: "Composite",
        polymorphicDiscriminator: FirewallPolicyRuleCollection.type.polymorphicDiscriminator,
        uberParent: "FirewallPolicyRuleCollection",
        className: "FirewallPolicyFilterRuleCollection",
        modelProperties: __assign(__assign({}, FirewallPolicyRuleCollection.type.modelProperties), { action: {
                serializedName: "action",
                type: {
                    name: "Composite",
                    className: "FirewallPolicyFilterRuleCollectionAction"
                }
            }, rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyRule"
                        }
                    }
                }
            } })
    }
};
export var FirewallPolicyRuleApplicationProtocol = {
    serializedName: "FirewallPolicyRuleApplicationProtocol",
    type: {
        name: "Composite",
        className: "FirewallPolicyRuleApplicationProtocol",
        modelProperties: {
            protocolType: {
                serializedName: "protocolType",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 64000,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ApplicationRule = {
    serializedName: "ApplicationRule",
    type: {
        name: "Composite",
        polymorphicDiscriminator: FirewallPolicyRule.type.polymorphicDiscriminator,
        uberParent: "FirewallPolicyRule",
        className: "ApplicationRule",
        modelProperties: __assign(__assign({}, FirewallPolicyRule.type.modelProperties), { sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, protocols: {
                serializedName: "protocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyRuleApplicationProtocol"
                        }
                    }
                }
            }, targetFqdns: {
                serializedName: "targetFqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, targetUrls: {
                serializedName: "targetUrls",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, fqdnTags: {
                serializedName: "fqdnTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, terminateTLS: {
                serializedName: "terminateTLS",
                type: {
                    name: "Boolean"
                }
            }, webCategories: {
                serializedName: "webCategories",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var NatRule = {
    serializedName: "NatRule",
    type: {
        name: "Composite",
        polymorphicDiscriminator: FirewallPolicyRule.type.polymorphicDiscriminator,
        uberParent: "FirewallPolicyRule",
        className: "NatRule",
        modelProperties: __assign(__assign({}, FirewallPolicyRule.type.modelProperties), { ipProtocols: {
                serializedName: "ipProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationPorts: {
                serializedName: "destinationPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, translatedAddress: {
                serializedName: "translatedAddress",
                type: {
                    name: "String"
                }
            }, translatedPort: {
                serializedName: "translatedPort",
                type: {
                    name: "String"
                }
            }, sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, translatedFqdn: {
                serializedName: "translatedFqdn",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkRule = {
    serializedName: "NetworkRule",
    type: {
        name: "Composite",
        polymorphicDiscriminator: FirewallPolicyRule.type.polymorphicDiscriminator,
        uberParent: "FirewallPolicyRule",
        className: "NetworkRule",
        modelProperties: __assign(__assign({}, FirewallPolicyRule.type.modelProperties), { ipProtocols: {
                serializedName: "ipProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sourceAddresses: {
                serializedName: "sourceAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationAddresses: {
                serializedName: "destinationAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationPorts: {
                serializedName: "destinationPorts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sourceIpGroups: {
                serializedName: "sourceIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationIpGroups: {
                serializedName: "destinationIpGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, destinationFqdns: {
                serializedName: "destinationFqdns",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var IpAllocation = {
    serializedName: "IpAllocation",
    type: {
        name: "Composite",
        className: "IpAllocation",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { subnet: {
                readOnly: true,
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualNetwork: {
                readOnly: true,
                serializedName: "properties.virtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, ipAllocationType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, prefix: {
                serializedName: "properties.prefix",
                type: {
                    name: "String"
                }
            }, prefixLength: {
                nullable: true,
                serializedName: "properties.prefixLength",
                defaultValue: 0,
                type: {
                    name: "Number"
                }
            }, prefixType: {
                serializedName: "properties.prefixType",
                type: {
                    name: "String"
                }
            }, ipamAllocationId: {
                serializedName: "properties.ipamAllocationId",
                type: {
                    name: "String"
                }
            }, allocationTags: {
                serializedName: "properties.allocationTags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var IpGroup = {
    serializedName: "IpGroup",
    type: {
        name: "Composite",
        className: "IpGroup",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, ipAddresses: {
                serializedName: "properties.ipAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, firewalls: {
                readOnly: true,
                serializedName: "properties.firewalls",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, firewallPolicies: {
                readOnly: true,
                serializedName: "properties.firewallPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var LoadBalancerSku = {
    serializedName: "LoadBalancerSku",
    type: {
        name: "Composite",
        className: "LoadBalancerSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancingRule = {
    serializedName: "LoadBalancingRule",
    type: {
        name: "Composite",
        className: "LoadBalancingRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { frontendIPConfiguration: {
                serializedName: "properties.frontendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, backendAddressPool: {
                serializedName: "properties.backendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, backendAddressPools: {
                serializedName: "properties.backendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, probe: {
                serializedName: "properties.probe",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, protocol: {
                required: true,
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, loadDistribution: {
                serializedName: "properties.loadDistribution",
                type: {
                    name: "String"
                }
            }, frontendPort: {
                required: true,
                serializedName: "properties.frontendPort",
                type: {
                    name: "Number"
                }
            }, backendPort: {
                serializedName: "properties.backendPort",
                type: {
                    name: "Number"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, enableFloatingIP: {
                serializedName: "properties.enableFloatingIP",
                type: {
                    name: "Boolean"
                }
            }, enableTcpReset: {
                serializedName: "properties.enableTcpReset",
                type: {
                    name: "Boolean"
                }
            }, disableOutboundSnat: {
                serializedName: "properties.disableOutboundSnat",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Probe = {
    serializedName: "Probe",
    type: {
        name: "Composite",
        className: "Probe",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { loadBalancingRules: {
                readOnly: true,
                serializedName: "properties.loadBalancingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, protocol: {
                required: true,
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, port: {
                required: true,
                serializedName: "properties.port",
                type: {
                    name: "Number"
                }
            }, intervalInSeconds: {
                serializedName: "properties.intervalInSeconds",
                type: {
                    name: "Number"
                }
            }, numberOfProbes: {
                serializedName: "properties.numberOfProbes",
                type: {
                    name: "Number"
                }
            }, requestPath: {
                serializedName: "properties.requestPath",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var InboundNatPool = {
    serializedName: "InboundNatPool",
    type: {
        name: "Composite",
        className: "InboundNatPool",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { frontendIPConfiguration: {
                serializedName: "properties.frontendIPConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, protocol: {
                required: true,
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, frontendPortRangeStart: {
                required: true,
                serializedName: "properties.frontendPortRangeStart",
                type: {
                    name: "Number"
                }
            }, frontendPortRangeEnd: {
                required: true,
                serializedName: "properties.frontendPortRangeEnd",
                type: {
                    name: "Number"
                }
            }, backendPort: {
                required: true,
                serializedName: "properties.backendPort",
                type: {
                    name: "Number"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, enableFloatingIP: {
                serializedName: "properties.enableFloatingIP",
                type: {
                    name: "Boolean"
                }
            }, enableTcpReset: {
                serializedName: "properties.enableTcpReset",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var OutboundRule = {
    serializedName: "OutboundRule",
    type: {
        name: "Composite",
        className: "OutboundRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { allocatedOutboundPorts: {
                serializedName: "properties.allocatedOutboundPorts",
                type: {
                    name: "Number"
                }
            }, frontendIPConfigurations: {
                required: true,
                serializedName: "properties.frontendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, backendAddressPool: {
                required: true,
                serializedName: "properties.backendAddressPool",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, protocol: {
                required: true,
                serializedName: "properties.protocol",
                type: {
                    name: "String"
                }
            }, enableTcpReset: {
                serializedName: "properties.enableTcpReset",
                type: {
                    name: "Boolean"
                }
            }, idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var LoadBalancer = {
    serializedName: "LoadBalancer",
    type: {
        name: "Composite",
        className: "LoadBalancer",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "LoadBalancerSku"
                }
            }, frontendIPConfigurations: {
                serializedName: "properties.frontendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FrontendIPConfiguration"
                        }
                    }
                }
            }, backendAddressPools: {
                serializedName: "properties.backendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BackendAddressPool"
                        }
                    }
                }
            }, loadBalancingRules: {
                serializedName: "properties.loadBalancingRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancingRule"
                        }
                    }
                }
            }, probes: {
                serializedName: "properties.probes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Probe"
                        }
                    }
                }
            }, inboundNatRules: {
                serializedName: "properties.inboundNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InboundNatRule"
                        }
                    }
                }
            }, inboundNatPools: {
                serializedName: "properties.inboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InboundNatPool"
                        }
                    }
                }
            }, outboundRules: {
                serializedName: "properties.outboundRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OutboundRule"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var LoadBalancerVipSwapRequestFrontendIPConfiguration = {
    serializedName: "LoadBalancerVipSwapRequestFrontendIPConfiguration",
    type: {
        name: "Composite",
        className: "LoadBalancerVipSwapRequestFrontendIPConfiguration",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var LoadBalancerVipSwapRequest = {
    serializedName: "LoadBalancerVipSwapRequest",
    type: {
        name: "Composite",
        className: "LoadBalancerVipSwapRequest",
        modelProperties: {
            frontendIPConfigurations: {
                serializedName: "frontendIPConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerVipSwapRequestFrontendIPConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export var AzureAsyncOperationResult = {
    serializedName: "AzureAsyncOperationResult",
    type: {
        name: "Composite",
        className: "AzureAsyncOperationResult",
        modelProperties: {
            status: {
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ErrorModel"
                }
            }
        }
    }
};
export var EffectiveNetworkSecurityGroupAssociation = {
    serializedName: "EffectiveNetworkSecurityGroupAssociation",
    type: {
        name: "Composite",
        className: "EffectiveNetworkSecurityGroupAssociation",
        modelProperties: {
            networkManager: {
                serializedName: "networkManager",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            subnet: {
                serializedName: "subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            networkInterface: {
                serializedName: "networkInterface",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var EffectiveNetworkSecurityRule = {
    serializedName: "EffectiveNetworkSecurityRule",
    type: {
        name: "Composite",
        className: "EffectiveNetworkSecurityRule",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            sourcePortRange: {
                serializedName: "sourcePortRange",
                type: {
                    name: "String"
                }
            },
            destinationPortRange: {
                serializedName: "destinationPortRange",
                type: {
                    name: "String"
                }
            },
            sourcePortRanges: {
                serializedName: "sourcePortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationPortRanges: {
                serializedName: "destinationPortRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sourceAddressPrefix: {
                serializedName: "sourceAddressPrefix",
                type: {
                    name: "String"
                }
            },
            destinationAddressPrefix: {
                serializedName: "destinationAddressPrefix",
                type: {
                    name: "String"
                }
            },
            sourceAddressPrefixes: {
                serializedName: "sourceAddressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinationAddressPrefixes: {
                serializedName: "destinationAddressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            expandedSourceAddressPrefix: {
                serializedName: "expandedSourceAddressPrefix",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            expandedDestinationAddressPrefix: {
                serializedName: "expandedDestinationAddressPrefix",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            access: {
                serializedName: "access",
                type: {
                    name: "String"
                }
            },
            priority: {
                serializedName: "priority",
                type: {
                    name: "Number"
                }
            },
            direction: {
                serializedName: "direction",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var EffectiveNetworkSecurityGroup = {
    serializedName: "EffectiveNetworkSecurityGroup",
    type: {
        name: "Composite",
        className: "EffectiveNetworkSecurityGroup",
        modelProperties: {
            networkSecurityGroup: {
                serializedName: "networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            association: {
                serializedName: "association",
                type: {
                    name: "Composite",
                    className: "EffectiveNetworkSecurityGroupAssociation"
                }
            },
            effectiveSecurityRules: {
                serializedName: "effectiveSecurityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EffectiveNetworkSecurityRule"
                        }
                    }
                }
            },
            tagMap: {
                serializedName: "tagMap",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Sequence",
                            element: {
                                type: {
                                    name: "String"
                                }
                            }
                        }
                    }
                }
            }
        }
    }
};
export var EffectiveNetworkSecurityGroupListResult = {
    serializedName: "EffectiveNetworkSecurityGroupListResult",
    type: {
        name: "Composite",
        className: "EffectiveNetworkSecurityGroupListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EffectiveNetworkSecurityGroup"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var EffectiveRoute = {
    serializedName: "EffectiveRoute",
    type: {
        name: "Composite",
        className: "EffectiveRoute",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            disableBgpRoutePropagation: {
                serializedName: "disableBgpRoutePropagation",
                type: {
                    name: "Boolean"
                }
            },
            source: {
                serializedName: "source",
                type: {
                    name: "String"
                }
            },
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            addressPrefix: {
                serializedName: "addressPrefix",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopIpAddress: {
                serializedName: "nextHopIpAddress",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopType: {
                serializedName: "nextHopType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var EffectiveRouteListResult = {
    serializedName: "EffectiveRouteListResult",
    type: {
        name: "Composite",
        className: "EffectiveRouteListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EffectiveRoute"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ContainerNetworkInterfaceConfiguration = {
    serializedName: "ContainerNetworkInterfaceConfiguration",
    type: {
        name: "Composite",
        className: "ContainerNetworkInterfaceConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IPConfigurationProfile"
                        }
                    }
                }
            }, containerNetworkInterfaces: {
                serializedName: "properties.containerNetworkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var Container = {
    serializedName: "Container",
    type: {
        name: "Composite",
        className: "Container",
        modelProperties: __assign({}, SubResource.type.modelProperties)
    }
};
export var ContainerNetworkInterfaceIpConfiguration = {
    serializedName: "ContainerNetworkInterfaceIpConfiguration",
    type: {
        name: "Composite",
        className: "ContainerNetworkInterfaceIpConfiguration",
        modelProperties: {
            provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ContainerNetworkInterface = {
    serializedName: "ContainerNetworkInterface",
    type: {
        name: "Composite",
        className: "ContainerNetworkInterface",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { containerNetworkInterfaceConfiguration: {
                readOnly: true,
                serializedName: "properties.containerNetworkInterfaceConfiguration",
                type: {
                    name: "Composite",
                    className: "ContainerNetworkInterfaceConfiguration"
                }
            }, container: {
                serializedName: "properties.container",
                type: {
                    name: "Composite",
                    className: "Container"
                }
            }, ipConfigurations: {
                readOnly: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ContainerNetworkInterfaceIpConfiguration"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkProfile = {
    serializedName: "NetworkProfile",
    type: {
        name: "Composite",
        className: "NetworkProfile",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { containerNetworkInterfaces: {
                readOnly: true,
                serializedName: "properties.containerNetworkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ContainerNetworkInterface"
                        }
                    }
                }
            }, containerNetworkInterfaceConfigurations: {
                serializedName: "properties.containerNetworkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ContainerNetworkInterfaceConfiguration"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualApplianceSkuProperties = {
    serializedName: "VirtualApplianceSkuProperties",
    type: {
        name: "Composite",
        className: "VirtualApplianceSkuProperties",
        modelProperties: {
            vendor: {
                serializedName: "vendor",
                type: {
                    name: "String"
                }
            },
            bundledScaleUnit: {
                serializedName: "bundledScaleUnit",
                type: {
                    name: "String"
                }
            },
            marketPlaceVersion: {
                serializedName: "marketPlaceVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualApplianceNicProperties = {
    serializedName: "VirtualApplianceNicProperties",
    type: {
        name: "Composite",
        className: "VirtualApplianceNicProperties",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publicIpAddress: {
                readOnly: true,
                serializedName: "publicIpAddress",
                type: {
                    name: "String"
                }
            },
            privateIpAddress: {
                readOnly: true,
                serializedName: "privateIpAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkVirtualAppliance = {
    serializedName: "NetworkVirtualAppliance",
    type: {
        name: "Composite",
        className: "NetworkVirtualAppliance",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { nvaSku: {
                serializedName: "properties.nvaSku",
                type: {
                    name: "Composite",
                    className: "VirtualApplianceSkuProperties"
                }
            }, addressPrefix: {
                readOnly: true,
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, bootStrapConfigurationBlobs: {
                serializedName: "properties.bootStrapConfigurationBlobs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, virtualHub: {
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, cloudInitConfigurationBlobs: {
                serializedName: "properties.cloudInitConfigurationBlobs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, cloudInitConfiguration: {
                serializedName: "properties.cloudInitConfiguration",
                type: {
                    name: "String"
                }
            }, virtualApplianceAsn: {
                serializedName: "properties.virtualApplianceAsn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, virtualApplianceNics: {
                readOnly: true,
                serializedName: "properties.virtualApplianceNics",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualApplianceNicProperties"
                        }
                    }
                }
            }, virtualApplianceSites: {
                readOnly: true,
                serializedName: "properties.virtualApplianceSites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, inboundSecurityRules: {
                readOnly: true,
                serializedName: "properties.inboundSecurityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "ManagedServiceIdentity"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var BreakOutCategoryPolicies = {
    serializedName: "BreakOutCategoryPolicies",
    type: {
        name: "Composite",
        className: "BreakOutCategoryPolicies",
        modelProperties: {
            allow: {
                serializedName: "allow",
                type: {
                    name: "Boolean"
                }
            },
            optimize: {
                serializedName: "optimize",
                type: {
                    name: "Boolean"
                }
            },
            default: {
                serializedName: "default",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var Office365PolicyProperties = {
    serializedName: "Office365PolicyProperties",
    type: {
        name: "Composite",
        className: "Office365PolicyProperties",
        modelProperties: {
            breakOutCategories: {
                serializedName: "breakOutCategories",
                type: {
                    name: "Composite",
                    className: "BreakOutCategoryPolicies"
                }
            }
        }
    }
};
export var VirtualApplianceSite = {
    serializedName: "VirtualApplianceSite",
    type: {
        name: "Composite",
        className: "VirtualApplianceSite",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, o365Policy: {
                serializedName: "properties.o365Policy",
                type: {
                    name: "Composite",
                    className: "Office365PolicyProperties"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkVirtualApplianceSkuInstances = {
    serializedName: "NetworkVirtualApplianceSkuInstances",
    type: {
        name: "Composite",
        className: "NetworkVirtualApplianceSkuInstances",
        modelProperties: {
            scaleUnit: {
                readOnly: true,
                serializedName: "scaleUnit",
                type: {
                    name: "String"
                }
            },
            instanceCount: {
                readOnly: true,
                serializedName: "instanceCount",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var NetworkVirtualApplianceSku = {
    serializedName: "NetworkVirtualApplianceSku",
    type: {
        name: "Composite",
        className: "NetworkVirtualApplianceSku",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { vendor: {
                readOnly: true,
                serializedName: "properties.vendor",
                type: {
                    name: "String"
                }
            }, availableVersions: {
                readOnly: true,
                serializedName: "properties.availableVersions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, availableScaleUnits: {
                serializedName: "properties.availableScaleUnits",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkVirtualApplianceSkuInstances"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var InboundSecurityRules = {
    serializedName: "InboundSecurityRules",
    type: {
        name: "Composite",
        className: "InboundSecurityRules",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            sourceAddressPrefix: {
                serializedName: "sourceAddressPrefix",
                type: {
                    name: "String"
                }
            },
            destinationPortRange: {
                serializedName: "destinationPortRange",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var InboundSecurityRule = {
    serializedName: "InboundSecurityRule",
    type: {
        name: "Composite",
        className: "InboundSecurityRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InboundSecurityRules"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ErrorResponse = {
    serializedName: "ErrorResponse",
    type: {
        name: "Composite",
        className: "ErrorResponse",
        modelProperties: {
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ErrorDetails"
                }
            }
        }
    }
};
export var NetworkWatcher = {
    serializedName: "NetworkWatcher",
    type: {
        name: "Composite",
        className: "NetworkWatcher",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            } })
    }
};
export var TopologyParameters = {
    serializedName: "TopologyParameters",
    type: {
        name: "Composite",
        className: "TopologyParameters",
        modelProperties: {
            targetResourceGroupName: {
                serializedName: "targetResourceGroupName",
                type: {
                    name: "String"
                }
            },
            targetVirtualNetwork: {
                serializedName: "targetVirtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            targetSubnet: {
                serializedName: "targetSubnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export var TopologyAssociation = {
    serializedName: "TopologyAssociation",
    type: {
        name: "Composite",
        className: "TopologyAssociation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            resourceId: {
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            associationType: {
                serializedName: "associationType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TopologyResource = {
    serializedName: "TopologyResource",
    type: {
        name: "Composite",
        className: "TopologyResource",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            associations: {
                serializedName: "associations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TopologyAssociation"
                        }
                    }
                }
            }
        }
    }
};
export var Topology = {
    serializedName: "Topology",
    type: {
        name: "Composite",
        className: "Topology",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            createdDateTime: {
                readOnly: true,
                serializedName: "createdDateTime",
                type: {
                    name: "DateTime"
                }
            },
            lastModified: {
                readOnly: true,
                serializedName: "lastModified",
                type: {
                    name: "DateTime"
                }
            },
            resources: {
                serializedName: "resources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TopologyResource"
                        }
                    }
                }
            }
        }
    }
};
export var VerificationIPFlowParameters = {
    serializedName: "VerificationIPFlowParameters",
    type: {
        name: "Composite",
        className: "VerificationIPFlowParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            direction: {
                required: true,
                serializedName: "direction",
                type: {
                    name: "String"
                }
            },
            protocol: {
                required: true,
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            localPort: {
                required: true,
                serializedName: "localPort",
                type: {
                    name: "String"
                }
            },
            remotePort: {
                required: true,
                serializedName: "remotePort",
                type: {
                    name: "String"
                }
            },
            localIPAddress: {
                required: true,
                serializedName: "localIPAddress",
                type: {
                    name: "String"
                }
            },
            remoteIPAddress: {
                required: true,
                serializedName: "remoteIPAddress",
                type: {
                    name: "String"
                }
            },
            targetNicResourceId: {
                serializedName: "targetNicResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VerificationIPFlowResult = {
    serializedName: "VerificationIPFlowResult",
    type: {
        name: "Composite",
        className: "VerificationIPFlowResult",
        modelProperties: {
            access: {
                serializedName: "access",
                type: {
                    name: "String"
                }
            },
            ruleName: {
                serializedName: "ruleName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NextHopParameters = {
    serializedName: "NextHopParameters",
    type: {
        name: "Composite",
        className: "NextHopParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            sourceIPAddress: {
                required: true,
                serializedName: "sourceIPAddress",
                type: {
                    name: "String"
                }
            },
            destinationIPAddress: {
                required: true,
                serializedName: "destinationIPAddress",
                type: {
                    name: "String"
                }
            },
            targetNicResourceId: {
                serializedName: "targetNicResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NextHopResult = {
    serializedName: "NextHopResult",
    type: {
        name: "Composite",
        className: "NextHopResult",
        modelProperties: {
            nextHopType: {
                serializedName: "nextHopType",
                type: {
                    name: "String"
                }
            },
            nextHopIpAddress: {
                serializedName: "nextHopIpAddress",
                type: {
                    name: "String"
                }
            },
            routeTableId: {
                serializedName: "routeTableId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SecurityGroupViewParameters = {
    serializedName: "SecurityGroupViewParameters",
    type: {
        name: "Composite",
        className: "SecurityGroupViewParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceAssociation = {
    serializedName: "NetworkInterfaceAssociation",
    type: {
        name: "Composite",
        className: "NetworkInterfaceAssociation",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            securityRules: {
                serializedName: "securityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            }
        }
    }
};
export var SubnetAssociation = {
    serializedName: "SubnetAssociation",
    type: {
        name: "Composite",
        className: "SubnetAssociation",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            securityRules: {
                serializedName: "securityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            }
        }
    }
};
export var SecurityRuleAssociations = {
    serializedName: "SecurityRuleAssociations",
    type: {
        name: "Composite",
        className: "SecurityRuleAssociations",
        modelProperties: {
            networkInterfaceAssociation: {
                serializedName: "networkInterfaceAssociation",
                type: {
                    name: "Composite",
                    className: "NetworkInterfaceAssociation"
                }
            },
            subnetAssociation: {
                serializedName: "subnetAssociation",
                type: {
                    name: "Composite",
                    className: "SubnetAssociation"
                }
            },
            defaultSecurityRules: {
                serializedName: "defaultSecurityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            },
            effectiveSecurityRules: {
                serializedName: "effectiveSecurityRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EffectiveNetworkSecurityRule"
                        }
                    }
                }
            }
        }
    }
};
export var SecurityGroupNetworkInterface = {
    serializedName: "SecurityGroupNetworkInterface",
    type: {
        name: "Composite",
        className: "SecurityGroupNetworkInterface",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            securityRuleAssociations: {
                serializedName: "securityRuleAssociations",
                type: {
                    name: "Composite",
                    className: "SecurityRuleAssociations"
                }
            }
        }
    }
};
export var SecurityGroupViewResult = {
    serializedName: "SecurityGroupViewResult",
    type: {
        name: "Composite",
        className: "SecurityGroupViewResult",
        modelProperties: {
            networkInterfaces: {
                serializedName: "networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityGroupNetworkInterface"
                        }
                    }
                }
            }
        }
    }
};
export var PacketCaptureStorageLocation = {
    serializedName: "PacketCaptureStorageLocation",
    type: {
        name: "Composite",
        className: "PacketCaptureStorageLocation",
        modelProperties: {
            storageId: {
                serializedName: "storageId",
                type: {
                    name: "String"
                }
            },
            storagePath: {
                serializedName: "storagePath",
                type: {
                    name: "String"
                }
            },
            filePath: {
                serializedName: "filePath",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PacketCaptureFilter = {
    serializedName: "PacketCaptureFilter",
    type: {
        name: "Composite",
        className: "PacketCaptureFilter",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                defaultValue: 'Any',
                type: {
                    name: "String"
                }
            },
            localIPAddress: {
                serializedName: "localIPAddress",
                type: {
                    name: "String"
                }
            },
            remoteIPAddress: {
                serializedName: "remoteIPAddress",
                type: {
                    name: "String"
                }
            },
            localPort: {
                serializedName: "localPort",
                type: {
                    name: "String"
                }
            },
            remotePort: {
                serializedName: "remotePort",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PacketCaptureParameters = {
    serializedName: "PacketCaptureParameters",
    type: {
        name: "Composite",
        className: "PacketCaptureParameters",
        modelProperties: {
            target: {
                required: true,
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            bytesToCapturePerPacket: {
                serializedName: "bytesToCapturePerPacket",
                defaultValue: 0,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            totalBytesPerSession: {
                serializedName: "totalBytesPerSession",
                defaultValue: 1073741824,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            timeLimitInSeconds: {
                serializedName: "timeLimitInSeconds",
                defaultValue: 18000,
                constraints: {
                    InclusiveMaximum: 18000,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            storageLocation: {
                required: true,
                serializedName: "storageLocation",
                type: {
                    name: "Composite",
                    className: "PacketCaptureStorageLocation"
                }
            },
            filters: {
                serializedName: "filters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PacketCaptureFilter"
                        }
                    }
                }
            }
        }
    }
};
export var PacketCapture = {
    serializedName: "PacketCapture",
    type: {
        name: "Composite",
        className: "PacketCapture",
        modelProperties: {
            target: {
                required: true,
                serializedName: "properties.target",
                type: {
                    name: "String"
                }
            },
            bytesToCapturePerPacket: {
                serializedName: "properties.bytesToCapturePerPacket",
                defaultValue: 0,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            totalBytesPerSession: {
                serializedName: "properties.totalBytesPerSession",
                defaultValue: 1073741824,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            timeLimitInSeconds: {
                serializedName: "properties.timeLimitInSeconds",
                defaultValue: 18000,
                constraints: {
                    InclusiveMaximum: 18000,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            storageLocation: {
                required: true,
                serializedName: "properties.storageLocation",
                type: {
                    name: "Composite",
                    className: "PacketCaptureStorageLocation"
                }
            },
            filters: {
                serializedName: "properties.filters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PacketCaptureFilter"
                        }
                    }
                }
            }
        }
    }
};
export var PacketCaptureResult = {
    serializedName: "PacketCaptureResult",
    type: {
        name: "Composite",
        className: "PacketCaptureResult",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            },
            target: {
                required: true,
                serializedName: "properties.target",
                type: {
                    name: "String"
                }
            },
            bytesToCapturePerPacket: {
                serializedName: "properties.bytesToCapturePerPacket",
                defaultValue: 0,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            totalBytesPerSession: {
                serializedName: "properties.totalBytesPerSession",
                defaultValue: 1073741824,
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            timeLimitInSeconds: {
                serializedName: "properties.timeLimitInSeconds",
                defaultValue: 18000,
                constraints: {
                    InclusiveMaximum: 18000,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            storageLocation: {
                required: true,
                serializedName: "properties.storageLocation",
                type: {
                    name: "Composite",
                    className: "PacketCaptureStorageLocation"
                }
            },
            filters: {
                serializedName: "properties.filters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PacketCaptureFilter"
                        }
                    }
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PacketCaptureQueryStatusResult = {
    serializedName: "PacketCaptureQueryStatusResult",
    type: {
        name: "Composite",
        className: "PacketCaptureQueryStatusResult",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            captureStartTime: {
                serializedName: "captureStartTime",
                type: {
                    name: "DateTime"
                }
            },
            packetCaptureStatus: {
                serializedName: "packetCaptureStatus",
                type: {
                    name: "String"
                }
            },
            stopReason: {
                serializedName: "stopReason",
                type: {
                    name: "String"
                }
            },
            packetCaptureError: {
                serializedName: "packetCaptureError",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var TroubleshootingParameters = {
    serializedName: "TroubleshootingParameters",
    type: {
        name: "Composite",
        className: "TroubleshootingParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            storageId: {
                required: true,
                serializedName: "properties.storageId",
                type: {
                    name: "String"
                }
            },
            storagePath: {
                required: true,
                serializedName: "properties.storagePath",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var QueryTroubleshootingParameters = {
    serializedName: "QueryTroubleshootingParameters",
    type: {
        name: "Composite",
        className: "QueryTroubleshootingParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TroubleshootingRecommendedActions = {
    serializedName: "TroubleshootingRecommendedActions",
    type: {
        name: "Composite",
        className: "TroubleshootingRecommendedActions",
        modelProperties: {
            actionId: {
                serializedName: "actionId",
                type: {
                    name: "String"
                }
            },
            actionText: {
                serializedName: "actionText",
                type: {
                    name: "String"
                }
            },
            actionUri: {
                serializedName: "actionUri",
                type: {
                    name: "String"
                }
            },
            actionUriText: {
                serializedName: "actionUriText",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var TroubleshootingDetails = {
    serializedName: "TroubleshootingDetails",
    type: {
        name: "Composite",
        className: "TroubleshootingDetails",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            reasonType: {
                serializedName: "reasonType",
                type: {
                    name: "String"
                }
            },
            summary: {
                serializedName: "summary",
                type: {
                    name: "String"
                }
            },
            detail: {
                serializedName: "detail",
                type: {
                    name: "String"
                }
            },
            recommendedActions: {
                serializedName: "recommendedActions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TroubleshootingRecommendedActions"
                        }
                    }
                }
            }
        }
    }
};
export var TroubleshootingResult = {
    serializedName: "TroubleshootingResult",
    type: {
        name: "Composite",
        className: "TroubleshootingResult",
        modelProperties: {
            startTime: {
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            },
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            results: {
                serializedName: "results",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TroubleshootingDetails"
                        }
                    }
                }
            }
        }
    }
};
export var FlowLogStatusParameters = {
    serializedName: "FlowLogStatusParameters",
    type: {
        name: "Composite",
        className: "FlowLogStatusParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FlowLogInformation = {
    serializedName: "FlowLogInformation",
    type: {
        name: "Composite",
        className: "FlowLogInformation",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            storageId: {
                required: true,
                serializedName: "properties.storageId",
                type: {
                    name: "String"
                }
            },
            enabled: {
                required: true,
                serializedName: "properties.enabled",
                type: {
                    name: "Boolean"
                }
            },
            retentionPolicy: {
                serializedName: "properties.retentionPolicy",
                type: {
                    name: "Composite",
                    className: "RetentionPolicyParameters"
                }
            },
            format: {
                serializedName: "properties.format",
                type: {
                    name: "Composite",
                    className: "FlowLogFormatParameters"
                }
            },
            flowAnalyticsConfiguration: {
                serializedName: "flowAnalyticsConfiguration",
                type: {
                    name: "Composite",
                    className: "TrafficAnalyticsProperties"
                }
            }
        }
    }
};
export var ConnectivitySource = {
    serializedName: "ConnectivitySource",
    type: {
        name: "Composite",
        className: "ConnectivitySource",
        modelProperties: {
            resourceId: {
                required: true,
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ConnectivityDestination = {
    serializedName: "ConnectivityDestination",
    type: {
        name: "Composite",
        className: "ConnectivityDestination",
        modelProperties: {
            resourceId: {
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var HTTPHeader = {
    serializedName: "HTTPHeader",
    type: {
        name: "Composite",
        className: "HTTPHeader",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var HTTPConfiguration = {
    serializedName: "HTTPConfiguration",
    type: {
        name: "Composite",
        className: "HTTPConfiguration",
        modelProperties: {
            method: {
                serializedName: "method",
                type: {
                    name: "String"
                }
            },
            headers: {
                serializedName: "headers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HTTPHeader"
                        }
                    }
                }
            },
            validStatusCodes: {
                serializedName: "validStatusCodes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Number"
                        }
                    }
                }
            }
        }
    }
};
export var ProtocolConfiguration = {
    serializedName: "ProtocolConfiguration",
    type: {
        name: "Composite",
        className: "ProtocolConfiguration",
        modelProperties: {
            hTTPConfiguration: {
                serializedName: "HTTPConfiguration",
                type: {
                    name: "Composite",
                    className: "HTTPConfiguration"
                }
            }
        }
    }
};
export var ConnectivityParameters = {
    serializedName: "ConnectivityParameters",
    type: {
        name: "Composite",
        className: "ConnectivityParameters",
        modelProperties: {
            source: {
                required: true,
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "ConnectivitySource"
                }
            },
            destination: {
                required: true,
                serializedName: "destination",
                type: {
                    name: "Composite",
                    className: "ConnectivityDestination"
                }
            },
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            protocolConfiguration: {
                serializedName: "protocolConfiguration",
                type: {
                    name: "Composite",
                    className: "ProtocolConfiguration"
                }
            },
            preferredIPVersion: {
                serializedName: "preferredIPVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectivityIssue = {
    serializedName: "ConnectivityIssue",
    type: {
        name: "Composite",
        className: "ConnectivityIssue",
        modelProperties: {
            origin: {
                readOnly: true,
                serializedName: "origin",
                type: {
                    name: "String"
                }
            },
            severity: {
                readOnly: true,
                serializedName: "severity",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            context: {
                readOnly: true,
                serializedName: "context",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Dictionary",
                            value: {
                                type: {
                                    name: "String"
                                }
                            }
                        }
                    }
                }
            }
        }
    }
};
export var HopLink = {
    serializedName: "HopLink",
    type: {
        name: "Composite",
        className: "HopLink",
        modelProperties: {
            nextHopId: {
                readOnly: true,
                serializedName: "nextHopId",
                type: {
                    name: "String"
                }
            },
            linkType: {
                readOnly: true,
                serializedName: "linkType",
                type: {
                    name: "String"
                }
            },
            roundTripTimeMin: {
                readOnly: true,
                serializedName: "properties.roundTripTimeMin",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            roundTripTimeAvg: {
                readOnly: true,
                serializedName: "properties.roundTripTimeAvg",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            roundTripTimeMax: {
                readOnly: true,
                serializedName: "properties.roundTripTimeMax",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            issues: {
                readOnly: true,
                serializedName: "issues",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectivityIssue"
                        }
                    }
                }
            },
            context: {
                readOnly: true,
                serializedName: "context",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            resourceId: {
                readOnly: true,
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectivityHop = {
    serializedName: "ConnectivityHop",
    type: {
        name: "Composite",
        className: "ConnectivityHop",
        modelProperties: {
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            address: {
                readOnly: true,
                serializedName: "address",
                type: {
                    name: "String"
                }
            },
            resourceId: {
                readOnly: true,
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            nextHopIds: {
                readOnly: true,
                serializedName: "nextHopIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            previousHopIds: {
                readOnly: true,
                serializedName: "previousHopIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            links: {
                readOnly: true,
                serializedName: "links",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HopLink"
                        }
                    }
                }
            },
            previousLinks: {
                readOnly: true,
                serializedName: "previousLinks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HopLink"
                        }
                    }
                }
            },
            issues: {
                readOnly: true,
                serializedName: "issues",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectivityIssue"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectivityInformation = {
    serializedName: "ConnectivityInformation",
    type: {
        name: "Composite",
        className: "ConnectivityInformation",
        modelProperties: {
            hops: {
                readOnly: true,
                serializedName: "hops",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectivityHop"
                        }
                    }
                }
            },
            connectionStatus: {
                readOnly: true,
                serializedName: "connectionStatus",
                type: {
                    name: "String"
                }
            },
            avgLatencyInMs: {
                readOnly: true,
                serializedName: "avgLatencyInMs",
                type: {
                    name: "Number"
                }
            },
            minLatencyInMs: {
                readOnly: true,
                serializedName: "minLatencyInMs",
                type: {
                    name: "Number"
                }
            },
            maxLatencyInMs: {
                readOnly: true,
                serializedName: "maxLatencyInMs",
                type: {
                    name: "Number"
                }
            },
            probesSent: {
                readOnly: true,
                serializedName: "probesSent",
                type: {
                    name: "Number"
                }
            },
            probesFailed: {
                readOnly: true,
                serializedName: "probesFailed",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AzureReachabilityReportLocation = {
    serializedName: "AzureReachabilityReportLocation",
    type: {
        name: "Composite",
        className: "AzureReachabilityReportLocation",
        modelProperties: {
            country: {
                required: true,
                serializedName: "country",
                type: {
                    name: "String"
                }
            },
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            city: {
                serializedName: "city",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureReachabilityReportParameters = {
    serializedName: "AzureReachabilityReportParameters",
    type: {
        name: "Composite",
        className: "AzureReachabilityReportParameters",
        modelProperties: {
            providerLocation: {
                required: true,
                serializedName: "providerLocation",
                type: {
                    name: "Composite",
                    className: "AzureReachabilityReportLocation"
                }
            },
            providers: {
                serializedName: "providers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            azureLocations: {
                serializedName: "azureLocations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            startTime: {
                required: true,
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                required: true,
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export var AzureReachabilityReportLatencyInfo = {
    serializedName: "AzureReachabilityReportLatencyInfo",
    type: {
        name: "Composite",
        className: "AzureReachabilityReportLatencyInfo",
        modelProperties: {
            timeStamp: {
                serializedName: "timeStamp",
                type: {
                    name: "DateTime"
                }
            },
            score: {
                serializedName: "score",
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var AzureReachabilityReportItem = {
    serializedName: "AzureReachabilityReportItem",
    type: {
        name: "Composite",
        className: "AzureReachabilityReportItem",
        modelProperties: {
            provider: {
                serializedName: "provider",
                type: {
                    name: "String"
                }
            },
            azureLocation: {
                serializedName: "azureLocation",
                type: {
                    name: "String"
                }
            },
            latencies: {
                serializedName: "latencies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureReachabilityReportLatencyInfo"
                        }
                    }
                }
            }
        }
    }
};
export var AzureReachabilityReport = {
    serializedName: "AzureReachabilityReport",
    type: {
        name: "Composite",
        className: "AzureReachabilityReport",
        modelProperties: {
            aggregationLevel: {
                required: true,
                serializedName: "aggregationLevel",
                type: {
                    name: "String"
                }
            },
            providerLocation: {
                required: true,
                serializedName: "providerLocation",
                type: {
                    name: "Composite",
                    className: "AzureReachabilityReportLocation"
                }
            },
            reachabilityReport: {
                required: true,
                serializedName: "reachabilityReport",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureReachabilityReportItem"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableProvidersListParameters = {
    serializedName: "AvailableProvidersListParameters",
    type: {
        name: "Composite",
        className: "AvailableProvidersListParameters",
        modelProperties: {
            azureLocations: {
                serializedName: "azureLocations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            country: {
                serializedName: "country",
                type: {
                    name: "String"
                }
            },
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            city: {
                serializedName: "city",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AvailableProvidersListCity = {
    serializedName: "AvailableProvidersListCity",
    type: {
        name: "Composite",
        className: "AvailableProvidersListCity",
        modelProperties: {
            cityName: {
                serializedName: "cityName",
                type: {
                    name: "String"
                }
            },
            providers: {
                serializedName: "providers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableProvidersListState = {
    serializedName: "AvailableProvidersListState",
    type: {
        name: "Composite",
        className: "AvailableProvidersListState",
        modelProperties: {
            stateName: {
                serializedName: "stateName",
                type: {
                    name: "String"
                }
            },
            providers: {
                serializedName: "providers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            cities: {
                serializedName: "cities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailableProvidersListCity"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableProvidersListCountry = {
    serializedName: "AvailableProvidersListCountry",
    type: {
        name: "Composite",
        className: "AvailableProvidersListCountry",
        modelProperties: {
            countryName: {
                serializedName: "countryName",
                type: {
                    name: "String"
                }
            },
            providers: {
                serializedName: "providers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            states: {
                serializedName: "states",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailableProvidersListState"
                        }
                    }
                }
            }
        }
    }
};
export var AvailableProvidersList = {
    serializedName: "AvailableProvidersList",
    type: {
        name: "Composite",
        className: "AvailableProvidersList",
        modelProperties: {
            countries: {
                required: true,
                serializedName: "countries",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailableProvidersListCountry"
                        }
                    }
                }
            }
        }
    }
};
export var NetworkConfigurationDiagnosticProfile = {
    serializedName: "NetworkConfigurationDiagnosticProfile",
    type: {
        name: "Composite",
        className: "NetworkConfigurationDiagnosticProfile",
        modelProperties: {
            direction: {
                required: true,
                serializedName: "direction",
                type: {
                    name: "String"
                }
            },
            protocol: {
                required: true,
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            source: {
                required: true,
                serializedName: "source",
                type: {
                    name: "String"
                }
            },
            destination: {
                required: true,
                serializedName: "destination",
                type: {
                    name: "String"
                }
            },
            destinationPort: {
                required: true,
                serializedName: "destinationPort",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkConfigurationDiagnosticParameters = {
    serializedName: "NetworkConfigurationDiagnosticParameters",
    type: {
        name: "Composite",
        className: "NetworkConfigurationDiagnosticParameters",
        modelProperties: {
            targetResourceId: {
                required: true,
                serializedName: "targetResourceId",
                type: {
                    name: "String"
                }
            },
            verbosityLevel: {
                serializedName: "verbosityLevel",
                type: {
                    name: "String"
                }
            },
            profiles: {
                required: true,
                serializedName: "profiles",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkConfigurationDiagnosticProfile"
                        }
                    }
                }
            }
        }
    }
};
export var MatchedRule = {
    serializedName: "MatchedRule",
    type: {
        name: "Composite",
        className: "MatchedRule",
        modelProperties: {
            ruleName: {
                serializedName: "ruleName",
                type: {
                    name: "String"
                }
            },
            action: {
                serializedName: "action",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkSecurityRulesEvaluationResult = {
    serializedName: "NetworkSecurityRulesEvaluationResult",
    type: {
        name: "Composite",
        className: "NetworkSecurityRulesEvaluationResult",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            protocolMatched: {
                serializedName: "protocolMatched",
                type: {
                    name: "Boolean"
                }
            },
            sourceMatched: {
                serializedName: "sourceMatched",
                type: {
                    name: "Boolean"
                }
            },
            sourcePortMatched: {
                serializedName: "sourcePortMatched",
                type: {
                    name: "Boolean"
                }
            },
            destinationMatched: {
                serializedName: "destinationMatched",
                type: {
                    name: "Boolean"
                }
            },
            destinationPortMatched: {
                serializedName: "destinationPortMatched",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var EvaluatedNetworkSecurityGroup = {
    serializedName: "EvaluatedNetworkSecurityGroup",
    type: {
        name: "Composite",
        className: "EvaluatedNetworkSecurityGroup",
        modelProperties: {
            networkSecurityGroupId: {
                serializedName: "networkSecurityGroupId",
                type: {
                    name: "String"
                }
            },
            appliedTo: {
                serializedName: "appliedTo",
                type: {
                    name: "String"
                }
            },
            matchedRule: {
                serializedName: "matchedRule",
                type: {
                    name: "Composite",
                    className: "MatchedRule"
                }
            },
            rulesEvaluationResult: {
                readOnly: true,
                serializedName: "rulesEvaluationResult",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkSecurityRulesEvaluationResult"
                        }
                    }
                }
            }
        }
    }
};
export var NetworkSecurityGroupResult = {
    serializedName: "NetworkSecurityGroupResult",
    type: {
        name: "Composite",
        className: "NetworkSecurityGroupResult",
        modelProperties: {
            securityRuleAccessResult: {
                serializedName: "securityRuleAccessResult",
                type: {
                    name: "String"
                }
            },
            evaluatedNetworkSecurityGroups: {
                readOnly: true,
                serializedName: "evaluatedNetworkSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EvaluatedNetworkSecurityGroup"
                        }
                    }
                }
            }
        }
    }
};
export var NetworkConfigurationDiagnosticResult = {
    serializedName: "NetworkConfigurationDiagnosticResult",
    type: {
        name: "Composite",
        className: "NetworkConfigurationDiagnosticResult",
        modelProperties: {
            profile: {
                serializedName: "profile",
                type: {
                    name: "Composite",
                    className: "NetworkConfigurationDiagnosticProfile"
                }
            },
            networkSecurityGroupResult: {
                serializedName: "networkSecurityGroupResult",
                type: {
                    name: "Composite",
                    className: "NetworkSecurityGroupResult"
                }
            }
        }
    }
};
export var NetworkConfigurationDiagnosticResponse = {
    serializedName: "NetworkConfigurationDiagnosticResponse",
    type: {
        name: "Composite",
        className: "NetworkConfigurationDiagnosticResponse",
        modelProperties: {
            results: {
                readOnly: true,
                serializedName: "results",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkConfigurationDiagnosticResult"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorSource = {
    serializedName: "ConnectionMonitorSource",
    type: {
        name: "Composite",
        className: "ConnectionMonitorSource",
        modelProperties: {
            resourceId: {
                required: true,
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ConnectionMonitorDestination = {
    serializedName: "ConnectionMonitorDestination",
    type: {
        name: "Composite",
        className: "ConnectionMonitorDestination",
        modelProperties: {
            resourceId: {
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            },
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ConnectionMonitorEndpointFilterItem = {
    serializedName: "ConnectionMonitorEndpointFilterItem",
    type: {
        name: "Composite",
        className: "ConnectionMonitorEndpointFilterItem",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorEndpointFilter = {
    serializedName: "ConnectionMonitorEndpointFilter",
    type: {
        name: "Composite",
        className: "ConnectionMonitorEndpointFilter",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            items: {
                serializedName: "items",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpointFilterItem"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorEndpointScopeItem = {
    serializedName: "ConnectionMonitorEndpointScopeItem",
    type: {
        name: "Composite",
        className: "ConnectionMonitorEndpointScopeItem",
        modelProperties: {
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorEndpointScope = {
    serializedName: "ConnectionMonitorEndpointScope",
    type: {
        name: "Composite",
        className: "ConnectionMonitorEndpointScope",
        modelProperties: {
            include: {
                serializedName: "include",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpointScopeItem"
                        }
                    }
                }
            },
            exclude: {
                serializedName: "exclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpointScopeItem"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorEndpoint = {
    serializedName: "ConnectionMonitorEndpoint",
    type: {
        name: "Composite",
        className: "ConnectionMonitorEndpoint",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            resourceId: {
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            address: {
                serializedName: "address",
                type: {
                    name: "String"
                }
            },
            filter: {
                serializedName: "filter",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorEndpointFilter"
                }
            },
            scope: {
                serializedName: "scope",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorEndpointScope"
                }
            },
            coverageLevel: {
                serializedName: "coverageLevel",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorHttpConfiguration = {
    serializedName: "ConnectionMonitorHttpConfiguration",
    type: {
        name: "Composite",
        className: "ConnectionMonitorHttpConfiguration",
        modelProperties: {
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            method: {
                serializedName: "method",
                type: {
                    name: "String"
                }
            },
            path: {
                serializedName: "path",
                type: {
                    name: "String"
                }
            },
            requestHeaders: {
                serializedName: "requestHeaders",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HTTPHeader"
                        }
                    }
                }
            },
            validStatusCodeRanges: {
                serializedName: "validStatusCodeRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            preferHTTPS: {
                serializedName: "preferHTTPS",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ConnectionMonitorTcpConfiguration = {
    serializedName: "ConnectionMonitorTcpConfiguration",
    type: {
        name: "Composite",
        className: "ConnectionMonitorTcpConfiguration",
        modelProperties: {
            port: {
                serializedName: "port",
                constraints: {
                    InclusiveMaximum: 65535,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            disableTraceRoute: {
                serializedName: "disableTraceRoute",
                type: {
                    name: "Boolean"
                }
            },
            destinationPortBehavior: {
                serializedName: "destinationPortBehavior",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorIcmpConfiguration = {
    serializedName: "ConnectionMonitorIcmpConfiguration",
    type: {
        name: "Composite",
        className: "ConnectionMonitorIcmpConfiguration",
        modelProperties: {
            disableTraceRoute: {
                serializedName: "disableTraceRoute",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var ConnectionMonitorSuccessThreshold = {
    serializedName: "ConnectionMonitorSuccessThreshold",
    type: {
        name: "Composite",
        className: "ConnectionMonitorSuccessThreshold",
        modelProperties: {
            checksFailedPercent: {
                serializedName: "checksFailedPercent",
                type: {
                    name: "Number"
                }
            },
            roundTripTimeMs: {
                serializedName: "roundTripTimeMs",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ConnectionMonitorTestConfiguration = {
    serializedName: "ConnectionMonitorTestConfiguration",
    type: {
        name: "Composite",
        className: "ConnectionMonitorTestConfiguration",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            testFrequencySec: {
                serializedName: "testFrequencySec",
                type: {
                    name: "Number"
                }
            },
            protocol: {
                required: true,
                serializedName: "protocol",
                type: {
                    name: "String"
                }
            },
            preferredIPVersion: {
                serializedName: "preferredIPVersion",
                type: {
                    name: "String"
                }
            },
            httpConfiguration: {
                serializedName: "httpConfiguration",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorHttpConfiguration"
                }
            },
            tcpConfiguration: {
                serializedName: "tcpConfiguration",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorTcpConfiguration"
                }
            },
            icmpConfiguration: {
                serializedName: "icmpConfiguration",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorIcmpConfiguration"
                }
            },
            successThreshold: {
                serializedName: "successThreshold",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorSuccessThreshold"
                }
            }
        }
    }
};
export var ConnectionMonitorTestGroup = {
    serializedName: "ConnectionMonitorTestGroup",
    type: {
        name: "Composite",
        className: "ConnectionMonitorTestGroup",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            disable: {
                serializedName: "disable",
                type: {
                    name: "Boolean"
                }
            },
            testConfigurations: {
                required: true,
                serializedName: "testConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            sources: {
                required: true,
                serializedName: "sources",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            destinations: {
                required: true,
                serializedName: "destinations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorWorkspaceSettings = {
    serializedName: "ConnectionMonitorWorkspaceSettings",
    type: {
        name: "Composite",
        className: "ConnectionMonitorWorkspaceSettings",
        modelProperties: {
            workspaceResourceId: {
                serializedName: "workspaceResourceId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorOutput = {
    serializedName: "ConnectionMonitorOutput",
    type: {
        name: "Composite",
        className: "ConnectionMonitorOutput",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            workspaceSettings: {
                serializedName: "workspaceSettings",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorWorkspaceSettings"
                }
            }
        }
    }
};
export var ConnectionMonitorParameters = {
    serializedName: "ConnectionMonitorParameters",
    type: {
        name: "Composite",
        className: "ConnectionMonitorParameters",
        modelProperties: {
            source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorSource"
                }
            },
            destination: {
                serializedName: "destination",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorDestination"
                }
            },
            autoStart: {
                serializedName: "autoStart",
                defaultValue: true,
                type: {
                    name: "Boolean"
                }
            },
            monitoringIntervalInSeconds: {
                serializedName: "monitoringIntervalInSeconds",
                defaultValue: 60,
                constraints: {
                    InclusiveMaximum: 1800,
                    InclusiveMinimum: 30
                },
                type: {
                    name: "Number"
                }
            },
            endpoints: {
                serializedName: "endpoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpoint"
                        }
                    }
                }
            },
            testConfigurations: {
                serializedName: "testConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestConfiguration"
                        }
                    }
                }
            },
            testGroups: {
                serializedName: "testGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestGroup"
                        }
                    }
                }
            },
            outputs: {
                serializedName: "outputs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorOutput"
                        }
                    }
                }
            },
            notes: {
                serializedName: "notes",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitor = {
    serializedName: "ConnectionMonitor",
    type: {
        name: "Composite",
        className: "ConnectionMonitor",
        modelProperties: {
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorSource"
                }
            },
            destination: {
                serializedName: "properties.destination",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorDestination"
                }
            },
            autoStart: {
                serializedName: "properties.autoStart",
                defaultValue: true,
                type: {
                    name: "Boolean"
                }
            },
            monitoringIntervalInSeconds: {
                serializedName: "properties.monitoringIntervalInSeconds",
                defaultValue: 60,
                constraints: {
                    InclusiveMaximum: 1800,
                    InclusiveMinimum: 30
                },
                type: {
                    name: "Number"
                }
            },
            endpoints: {
                serializedName: "properties.endpoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpoint"
                        }
                    }
                }
            },
            testConfigurations: {
                serializedName: "properties.testConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestConfiguration"
                        }
                    }
                }
            },
            testGroups: {
                serializedName: "properties.testGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestGroup"
                        }
                    }
                }
            },
            outputs: {
                serializedName: "properties.outputs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorOutput"
                        }
                    }
                }
            },
            notes: {
                serializedName: "properties.notes",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionStateSnapshot = {
    serializedName: "ConnectionStateSnapshot",
    type: {
        name: "Composite",
        className: "ConnectionStateSnapshot",
        modelProperties: {
            connectionState: {
                serializedName: "connectionState",
                type: {
                    name: "String"
                }
            },
            startTime: {
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            },
            evaluationState: {
                serializedName: "evaluationState",
                type: {
                    name: "String"
                }
            },
            avgLatencyInMs: {
                serializedName: "avgLatencyInMs",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            minLatencyInMs: {
                serializedName: "minLatencyInMs",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            maxLatencyInMs: {
                serializedName: "maxLatencyInMs",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            probesSent: {
                serializedName: "probesSent",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            probesFailed: {
                serializedName: "probesFailed",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            hops: {
                readOnly: true,
                serializedName: "hops",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectivityHop"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorResult = {
    serializedName: "ConnectionMonitorResult",
    type: {
        name: "Composite",
        className: "ConnectionMonitorResult",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorSource"
                }
            },
            destination: {
                serializedName: "properties.destination",
                type: {
                    name: "Composite",
                    className: "ConnectionMonitorDestination"
                }
            },
            autoStart: {
                serializedName: "properties.autoStart",
                defaultValue: true,
                type: {
                    name: "Boolean"
                }
            },
            monitoringIntervalInSeconds: {
                serializedName: "properties.monitoringIntervalInSeconds",
                defaultValue: 60,
                constraints: {
                    InclusiveMaximum: 1800,
                    InclusiveMinimum: 30
                },
                type: {
                    name: "Number"
                }
            },
            endpoints: {
                serializedName: "properties.endpoints",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorEndpoint"
                        }
                    }
                }
            },
            testConfigurations: {
                serializedName: "properties.testConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestConfiguration"
                        }
                    }
                }
            },
            testGroups: {
                serializedName: "properties.testGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorTestGroup"
                        }
                    }
                }
            },
            outputs: {
                serializedName: "properties.outputs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorOutput"
                        }
                    }
                }
            },
            notes: {
                serializedName: "properties.notes",
                type: {
                    name: "String"
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            },
            startTime: {
                readOnly: true,
                serializedName: "properties.startTime",
                type: {
                    name: "DateTime"
                }
            },
            monitoringStatus: {
                readOnly: true,
                serializedName: "properties.monitoringStatus",
                type: {
                    name: "String"
                }
            },
            connectionMonitorType: {
                readOnly: true,
                serializedName: "properties.connectionMonitorType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ConnectionMonitorQueryResult = {
    serializedName: "ConnectionMonitorQueryResult",
    type: {
        name: "Composite",
        className: "ConnectionMonitorQueryResult",
        modelProperties: {
            sourceStatus: {
                serializedName: "sourceStatus",
                type: {
                    name: "String"
                }
            },
            states: {
                serializedName: "states",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionStateSnapshot"
                        }
                    }
                }
            }
        }
    }
};
export var OperationDisplay = {
    serializedName: "Operation_display",
    type: {
        name: "Composite",
        className: "OperationDisplay",
        modelProperties: {
            provider: {
                serializedName: "provider",
                type: {
                    name: "String"
                }
            },
            resource: {
                serializedName: "resource",
                type: {
                    name: "String"
                }
            },
            operation: {
                serializedName: "operation",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Availability = {
    serializedName: "Availability",
    type: {
        name: "Composite",
        className: "Availability",
        modelProperties: {
            timeGrain: {
                serializedName: "timeGrain",
                type: {
                    name: "String"
                }
            },
            retention: {
                serializedName: "retention",
                type: {
                    name: "String"
                }
            },
            blobDuration: {
                serializedName: "blobDuration",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Dimension = {
    serializedName: "Dimension",
    type: {
        name: "Composite",
        className: "Dimension",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            displayName: {
                serializedName: "displayName",
                type: {
                    name: "String"
                }
            },
            internalName: {
                serializedName: "internalName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var MetricSpecification = {
    serializedName: "MetricSpecification",
    type: {
        name: "Composite",
        className: "MetricSpecification",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            displayName: {
                serializedName: "displayName",
                type: {
                    name: "String"
                }
            },
            displayDescription: {
                serializedName: "displayDescription",
                type: {
                    name: "String"
                }
            },
            unit: {
                serializedName: "unit",
                type: {
                    name: "String"
                }
            },
            aggregationType: {
                serializedName: "aggregationType",
                type: {
                    name: "String"
                }
            },
            availabilities: {
                serializedName: "availabilities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Availability"
                        }
                    }
                }
            },
            enableRegionalMdmAccount: {
                serializedName: "enableRegionalMdmAccount",
                type: {
                    name: "Boolean"
                }
            },
            fillGapWithZero: {
                serializedName: "fillGapWithZero",
                type: {
                    name: "Boolean"
                }
            },
            metricFilterPattern: {
                serializedName: "metricFilterPattern",
                type: {
                    name: "String"
                }
            },
            dimensions: {
                serializedName: "dimensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Dimension"
                        }
                    }
                }
            },
            isInternal: {
                serializedName: "isInternal",
                type: {
                    name: "Boolean"
                }
            },
            sourceMdmAccount: {
                serializedName: "sourceMdmAccount",
                type: {
                    name: "String"
                }
            },
            sourceMdmNamespace: {
                serializedName: "sourceMdmNamespace",
                type: {
                    name: "String"
                }
            },
            resourceIdDimensionNameOverride: {
                serializedName: "resourceIdDimensionNameOverride",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LogSpecification = {
    serializedName: "LogSpecification",
    type: {
        name: "Composite",
        className: "LogSpecification",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            displayName: {
                serializedName: "displayName",
                type: {
                    name: "String"
                }
            },
            blobDuration: {
                serializedName: "blobDuration",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OperationPropertiesFormatServiceSpecification = {
    serializedName: "OperationPropertiesFormat_serviceSpecification",
    type: {
        name: "Composite",
        className: "OperationPropertiesFormatServiceSpecification",
        modelProperties: {
            metricSpecifications: {
                serializedName: "metricSpecifications",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "MetricSpecification"
                        }
                    }
                }
            },
            logSpecifications: {
                serializedName: "logSpecifications",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LogSpecification"
                        }
                    }
                }
            }
        }
    }
};
export var Operation = {
    serializedName: "Operation",
    type: {
        name: "Composite",
        className: "Operation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            display: {
                serializedName: "display",
                type: {
                    name: "Composite",
                    className: "OperationDisplay"
                }
            },
            origin: {
                serializedName: "origin",
                type: {
                    name: "String"
                }
            },
            serviceSpecification: {
                serializedName: "properties.serviceSpecification",
                type: {
                    name: "Composite",
                    className: "OperationPropertiesFormatServiceSpecification"
                }
            }
        }
    }
};
export var RecordSet = {
    serializedName: "RecordSet",
    type: {
        name: "Composite",
        className: "RecordSet",
        modelProperties: {
            recordType: {
                serializedName: "recordType",
                type: {
                    name: "String"
                }
            },
            recordSetName: {
                serializedName: "recordSetName",
                type: {
                    name: "String"
                }
            },
            fqdn: {
                serializedName: "fqdn",
                type: {
                    name: "String"
                }
            },
            provisioningState: {
                readOnly: true,
                serializedName: "provisioningState",
                type: {
                    name: "String"
                }
            },
            ttl: {
                serializedName: "ttl",
                type: {
                    name: "Number"
                }
            },
            ipAddresses: {
                serializedName: "ipAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var PrivateDnsZoneConfig = {
    serializedName: "PrivateDnsZoneConfig",
    type: {
        name: "Composite",
        className: "PrivateDnsZoneConfig",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            privateDnsZoneId: {
                serializedName: "properties.privateDnsZoneId",
                type: {
                    name: "String"
                }
            },
            recordSets: {
                readOnly: true,
                serializedName: "properties.recordSets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RecordSet"
                        }
                    }
                }
            }
        }
    }
};
export var PrivateDnsZoneGroup = {
    serializedName: "PrivateDnsZoneGroup",
    type: {
        name: "Composite",
        className: "PrivateDnsZoneGroup",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, privateDnsZoneConfigs: {
                serializedName: "properties.privateDnsZoneConfigs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateDnsZoneConfig"
                        }
                    }
                }
            } })
    }
};
export var AvailablePrivateEndpointType = {
    serializedName: "AvailablePrivateEndpointType",
    type: {
        name: "Composite",
        className: "AvailablePrivateEndpointType",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            resourceName: {
                serializedName: "resourceName",
                type: {
                    name: "String"
                }
            },
            displayName: {
                serializedName: "displayName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CheckPrivateLinkServiceVisibilityRequest = {
    serializedName: "CheckPrivateLinkServiceVisibilityRequest",
    type: {
        name: "Composite",
        className: "CheckPrivateLinkServiceVisibilityRequest",
        modelProperties: {
            privateLinkServiceAlias: {
                serializedName: "privateLinkServiceAlias",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceVisibility = {
    serializedName: "PrivateLinkServiceVisibility",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceVisibility",
        modelProperties: {
            visible: {
                serializedName: "visible",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var AutoApprovedPrivateLinkService = {
    serializedName: "AutoApprovedPrivateLinkService",
    type: {
        name: "Composite",
        className: "AutoApprovedPrivateLinkService",
        modelProperties: {
            privateLinkService: {
                serializedName: "privateLinkService",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPPrefixSku = {
    serializedName: "PublicIPPrefixSku",
    type: {
        name: "Composite",
        className: "PublicIPPrefixSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ReferencedPublicIpAddress = {
    serializedName: "ReferencedPublicIpAddress",
    type: {
        name: "Composite",
        className: "ReferencedPublicIpAddress",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPPrefix = {
    serializedName: "PublicIPPrefix",
    type: {
        name: "Composite",
        className: "PublicIPPrefix",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPPrefixSku"
                }
            }, publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            }, ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpTag"
                        }
                    }
                }
            }, prefixLength: {
                serializedName: "properties.prefixLength",
                type: {
                    name: "Number"
                }
            }, ipPrefix: {
                readOnly: true,
                serializedName: "properties.ipPrefix",
                type: {
                    name: "String"
                }
            }, publicIPAddresses: {
                readOnly: true,
                serializedName: "properties.publicIPAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ReferencedPublicIpAddress"
                        }
                    }
                }
            }, loadBalancerFrontendIpConfiguration: {
                readOnly: true,
                serializedName: "properties.loadBalancerFrontendIpConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, customIPPrefix: {
                serializedName: "properties.customIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, natGateway: {
                serializedName: "properties.natGateway",
                type: {
                    name: "Composite",
                    className: "NatGateway"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var RouteFilterRule = {
    serializedName: "RouteFilterRule",
    type: {
        name: "Composite",
        className: "RouteFilterRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { access: {
                required: true,
                serializedName: "properties.access",
                type: {
                    name: "String"
                }
            }, routeFilterRuleType: {
                required: true,
                isConstant: true,
                serializedName: "properties.routeFilterRuleType",
                defaultValue: 'Community',
                type: {
                    name: "String"
                }
            }, communities: {
                required: true,
                serializedName: "properties.communities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PatchRouteFilterRule = {
    serializedName: "PatchRouteFilterRule",
    type: {
        name: "Composite",
        className: "PatchRouteFilterRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { access: {
                required: true,
                serializedName: "properties.access",
                type: {
                    name: "String"
                }
            }, routeFilterRuleType: {
                required: true,
                isConstant: true,
                serializedName: "properties.routeFilterRuleType",
                defaultValue: 'Community',
                type: {
                    name: "String"
                }
            }, communities: {
                required: true,
                serializedName: "properties.communities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var RouteFilter = {
    serializedName: "RouteFilter",
    type: {
        name: "Composite",
        className: "RouteFilter",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RouteFilterRule"
                        }
                    }
                }
            }, peerings: {
                readOnly: true,
                serializedName: "properties.peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            }, ipv6Peerings: {
                readOnly: true,
                serializedName: "properties.ipv6Peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PatchRouteFilter = {
    serializedName: "PatchRouteFilter",
    type: {
        name: "Composite",
        className: "PatchRouteFilter",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { rules: {
                serializedName: "properties.rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RouteFilterRule"
                        }
                    }
                }
            }, peerings: {
                readOnly: true,
                serializedName: "properties.peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            }, ipv6Peerings: {
                readOnly: true,
                serializedName: "properties.ipv6Peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            }, tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export var SecurityPartnerProvider = {
    serializedName: "SecurityPartnerProvider",
    type: {
        name: "Composite",
        className: "SecurityPartnerProvider",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, securityProviderName: {
                serializedName: "properties.securityProviderName",
                type: {
                    name: "String"
                }
            }, connectionStatus: {
                readOnly: true,
                serializedName: "properties.connectionStatus",
                type: {
                    name: "String"
                }
            }, virtualHub: {
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var BGPCommunity = {
    serializedName: "BGPCommunity",
    type: {
        name: "Composite",
        className: "BGPCommunity",
        modelProperties: {
            serviceSupportedRegion: {
                serializedName: "serviceSupportedRegion",
                type: {
                    name: "String"
                }
            },
            communityName: {
                serializedName: "communityName",
                type: {
                    name: "String"
                }
            },
            communityValue: {
                serializedName: "communityValue",
                type: {
                    name: "String"
                }
            },
            communityPrefixes: {
                serializedName: "communityPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            isAuthorizedToUse: {
                serializedName: "isAuthorizedToUse",
                type: {
                    name: "Boolean"
                }
            },
            serviceGroup: {
                serializedName: "serviceGroup",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BgpServiceCommunity = {
    serializedName: "BgpServiceCommunity",
    type: {
        name: "Composite",
        className: "BgpServiceCommunity",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { serviceName: {
                serializedName: "properties.serviceName",
                type: {
                    name: "String"
                }
            }, bgpCommunities: {
                serializedName: "properties.bgpCommunities",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BGPCommunity"
                        }
                    }
                }
            } })
    }
};
export var ServiceTagInformationPropertiesFormat = {
    serializedName: "ServiceTagInformationPropertiesFormat",
    type: {
        name: "Composite",
        className: "ServiceTagInformationPropertiesFormat",
        modelProperties: {
            changeNumber: {
                readOnly: true,
                serializedName: "changeNumber",
                type: {
                    name: "String"
                }
            },
            region: {
                readOnly: true,
                serializedName: "region",
                type: {
                    name: "String"
                }
            },
            systemService: {
                readOnly: true,
                serializedName: "systemService",
                type: {
                    name: "String"
                }
            },
            addressPrefixes: {
                readOnly: true,
                serializedName: "addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            state: {
                readOnly: true,
                serializedName: "state",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceTagInformation = {
    serializedName: "ServiceTagInformation",
    type: {
        name: "Composite",
        className: "ServiceTagInformation",
        modelProperties: {
            properties: {
                readOnly: true,
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "ServiceTagInformationPropertiesFormat"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceTagsListResult = {
    serializedName: "ServiceTagsListResult",
    type: {
        name: "Composite",
        className: "ServiceTagsListResult",
        modelProperties: {
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            changeNumber: {
                readOnly: true,
                serializedName: "changeNumber",
                type: {
                    name: "String"
                }
            },
            cloud: {
                readOnly: true,
                serializedName: "cloud",
                type: {
                    name: "String"
                }
            },
            values: {
                readOnly: true,
                serializedName: "values",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceTagInformation"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var UsageName = {
    serializedName: "UsageName",
    type: {
        name: "Composite",
        className: "UsageName",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            },
            localizedValue: {
                serializedName: "localizedValue",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var Usage = {
    serializedName: "Usage",
    type: {
        name: "Composite",
        className: "Usage",
        modelProperties: {
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            unit: {
                required: true,
                isConstant: true,
                serializedName: "unit",
                defaultValue: 'Count',
                type: {
                    name: "String"
                }
            },
            currentValue: {
                required: true,
                serializedName: "currentValue",
                type: {
                    name: "Number"
                }
            },
            limit: {
                required: true,
                serializedName: "limit",
                type: {
                    name: "Number"
                }
            },
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "Composite",
                    className: "UsageName"
                }
            }
        }
    }
};
export var AddressSpace = {
    serializedName: "AddressSpace",
    type: {
        name: "Composite",
        className: "AddressSpace",
        modelProperties: {
            addressPrefixes: {
                serializedName: "addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualNetworkBgpCommunities = {
    serializedName: "VirtualNetworkBgpCommunities",
    type: {
        name: "Composite",
        className: "VirtualNetworkBgpCommunities",
        modelProperties: {
            virtualNetworkCommunity: {
                required: true,
                serializedName: "virtualNetworkCommunity",
                type: {
                    name: "String"
                }
            },
            regionalCommunity: {
                readOnly: true,
                serializedName: "regionalCommunity",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkPeering = {
    serializedName: "VirtualNetworkPeering",
    type: {
        name: "Composite",
        className: "VirtualNetworkPeering",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { allowVirtualNetworkAccess: {
                serializedName: "properties.allowVirtualNetworkAccess",
                type: {
                    name: "Boolean"
                }
            }, allowForwardedTraffic: {
                serializedName: "properties.allowForwardedTraffic",
                type: {
                    name: "Boolean"
                }
            }, allowGatewayTransit: {
                serializedName: "properties.allowGatewayTransit",
                type: {
                    name: "Boolean"
                }
            }, useRemoteGateways: {
                serializedName: "properties.useRemoteGateways",
                type: {
                    name: "Boolean"
                }
            }, remoteVirtualNetwork: {
                serializedName: "properties.remoteVirtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, remoteAddressSpace: {
                serializedName: "properties.remoteAddressSpace",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, remoteVirtualNetworkAddressSpace: {
                serializedName: "properties.remoteVirtualNetworkAddressSpace",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, remoteBgpCommunities: {
                serializedName: "properties.remoteBgpCommunities",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkBgpCommunities"
                }
            }, peeringState: {
                serializedName: "properties.peeringState",
                type: {
                    name: "String"
                }
            }, peeringSyncLevel: {
                serializedName: "properties.peeringSyncLevel",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, doNotVerifyRemoteGateways: {
                serializedName: "properties.doNotVerifyRemoteGateways",
                type: {
                    name: "Boolean"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ResourceNavigationLinksListResult = {
    serializedName: "ResourceNavigationLinksListResult",
    type: {
        name: "Composite",
        className: "ResourceNavigationLinksListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceNavigationLink"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceAssociationLinksListResult = {
    serializedName: "ServiceAssociationLinksListResult",
    type: {
        name: "Composite",
        className: "ServiceAssociationLinksListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceAssociationLink"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DhcpOptions = {
    serializedName: "DhcpOptions",
    type: {
        name: "Composite",
        className: "DhcpOptions",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualNetwork = {
    serializedName: "VirtualNetwork",
    type: {
        name: "Composite",
        className: "VirtualNetwork",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, addressSpace: {
                serializedName: "properties.addressSpace",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, dhcpOptions: {
                serializedName: "properties.dhcpOptions",
                type: {
                    name: "Composite",
                    className: "DhcpOptions"
                }
            }, flowTimeoutInMinutes: {
                serializedName: "properties.flowTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            }, subnets: {
                serializedName: "properties.subnets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Subnet"
                        }
                    }
                }
            }, virtualNetworkPeerings: {
                serializedName: "properties.virtualNetworkPeerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkPeering"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, enableDdosProtection: {
                serializedName: "properties.enableDdosProtection",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }, enableVmProtection: {
                serializedName: "properties.enableVmProtection",
                defaultValue: false,
                type: {
                    name: "Boolean"
                }
            }, ddosProtectionPlan: {
                serializedName: "properties.ddosProtectionPlan",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, bgpCommunities: {
                serializedName: "properties.bgpCommunities",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkBgpCommunities"
                }
            }, ipAllocations: {
                serializedName: "properties.ipAllocations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var IPAddressAvailabilityResult = {
    serializedName: "IPAddressAvailabilityResult",
    type: {
        name: "Composite",
        className: "IPAddressAvailabilityResult",
        modelProperties: {
            available: {
                serializedName: "available",
                type: {
                    name: "Boolean"
                }
            },
            availableIPAddresses: {
                serializedName: "availableIPAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            isPlatformReserved: {
                serializedName: "isPlatformReserved",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var VirtualNetworkUsageName = {
    serializedName: "VirtualNetworkUsageName",
    type: {
        name: "Composite",
        className: "VirtualNetworkUsageName",
        modelProperties: {
            localizedValue: {
                readOnly: true,
                serializedName: "localizedValue",
                type: {
                    name: "String"
                }
            },
            value: {
                readOnly: true,
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkUsage = {
    serializedName: "VirtualNetworkUsage",
    type: {
        name: "Composite",
        className: "VirtualNetworkUsage",
        modelProperties: {
            currentValue: {
                readOnly: true,
                serializedName: "currentValue",
                type: {
                    name: "Number"
                }
            },
            id: {
                readOnly: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            limit: {
                readOnly: true,
                serializedName: "limit",
                type: {
                    name: "Number"
                }
            },
            name: {
                readOnly: true,
                serializedName: "name",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkUsageName"
                }
            },
            unit: {
                readOnly: true,
                serializedName: "unit",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkIntentPolicy = {
    serializedName: "NetworkIntentPolicy",
    type: {
        name: "Composite",
        className: "NetworkIntentPolicy",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var NetworkIntentPolicyConfiguration = {
    serializedName: "NetworkIntentPolicyConfiguration",
    type: {
        name: "Composite",
        className: "NetworkIntentPolicyConfiguration",
        modelProperties: {
            networkIntentPolicyName: {
                serializedName: "networkIntentPolicyName",
                type: {
                    name: "String"
                }
            },
            sourceNetworkIntentPolicy: {
                serializedName: "sourceNetworkIntentPolicy",
                type: {
                    name: "Composite",
                    className: "NetworkIntentPolicy"
                }
            }
        }
    }
};
export var PrepareNetworkPoliciesRequest = {
    serializedName: "PrepareNetworkPoliciesRequest",
    type: {
        name: "Composite",
        className: "PrepareNetworkPoliciesRequest",
        modelProperties: {
            serviceName: {
                serializedName: "serviceName",
                type: {
                    name: "String"
                }
            },
            networkIntentPolicyConfigurations: {
                serializedName: "networkIntentPolicyConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkIntentPolicyConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export var UnprepareNetworkPoliciesRequest = {
    serializedName: "UnprepareNetworkPoliciesRequest",
    type: {
        name: "Composite",
        className: "UnprepareNetworkPoliciesRequest",
        modelProperties: {
            serviceName: {
                serializedName: "serviceName",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayIPConfiguration = {
    serializedName: "VirtualNetworkGatewayIPConfiguration",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayIPConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, privateIPAddress: {
                readOnly: true,
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnNatRuleMapping = {
    serializedName: "VpnNatRuleMapping",
    type: {
        name: "Composite",
        className: "VpnNatRuleMapping",
        modelProperties: {
            addressSpace: {
                serializedName: "addressSpace",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayNatRule = {
    serializedName: "VirtualNetworkGatewayNatRule",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayNatRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, virtualNetworkGatewayNatRulePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, mode: {
                serializedName: "properties.mode",
                type: {
                    name: "String"
                }
            }, internalMappings: {
                serializedName: "properties.internalMappings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnNatRuleMapping"
                        }
                    }
                }
            }, externalMappings: {
                serializedName: "properties.externalMappings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnNatRuleMapping"
                        }
                    }
                }
            }, ipConfigurationId: {
                serializedName: "properties.ipConfigurationId",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualNetworkGatewaySku = {
    serializedName: "VirtualNetworkGatewaySku",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewaySku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                readOnly: true,
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VpnClientRootCertificate = {
    serializedName: "VpnClientRootCertificate",
    type: {
        name: "Composite",
        className: "VpnClientRootCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { publicCertData: {
                required: true,
                serializedName: "properties.publicCertData",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnClientRevokedCertificate = {
    serializedName: "VpnClientRevokedCertificate",
    type: {
        name: "Composite",
        className: "VpnClientRevokedCertificate",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { thumbprint: {
                serializedName: "properties.thumbprint",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var IpsecPolicy = {
    serializedName: "IpsecPolicy",
    type: {
        name: "Composite",
        className: "IpsecPolicy",
        modelProperties: {
            saLifeTimeSeconds: {
                required: true,
                serializedName: "saLifeTimeSeconds",
                type: {
                    name: "Number"
                }
            },
            saDataSizeKilobytes: {
                required: true,
                serializedName: "saDataSizeKilobytes",
                type: {
                    name: "Number"
                }
            },
            ipsecEncryption: {
                required: true,
                serializedName: "ipsecEncryption",
                type: {
                    name: "String"
                }
            },
            ipsecIntegrity: {
                required: true,
                serializedName: "ipsecIntegrity",
                type: {
                    name: "String"
                }
            },
            ikeEncryption: {
                required: true,
                serializedName: "ikeEncryption",
                type: {
                    name: "String"
                }
            },
            ikeIntegrity: {
                required: true,
                serializedName: "ikeIntegrity",
                type: {
                    name: "String"
                }
            },
            dhGroup: {
                required: true,
                serializedName: "dhGroup",
                type: {
                    name: "String"
                }
            },
            pfsGroup: {
                required: true,
                serializedName: "pfsGroup",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RadiusServer = {
    serializedName: "RadiusServer",
    type: {
        name: "Composite",
        className: "RadiusServer",
        modelProperties: {
            radiusServerAddress: {
                required: true,
                serializedName: "radiusServerAddress",
                type: {
                    name: "String"
                }
            },
            radiusServerScore: {
                serializedName: "radiusServerScore",
                type: {
                    name: "Number"
                }
            },
            radiusServerSecret: {
                serializedName: "radiusServerSecret",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnClientConfiguration = {
    serializedName: "VpnClientConfiguration",
    type: {
        name: "Composite",
        className: "VpnClientConfiguration",
        modelProperties: {
            vpnClientAddressPool: {
                serializedName: "vpnClientAddressPool",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            },
            vpnClientRootCertificates: {
                serializedName: "vpnClientRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnClientRootCertificate"
                        }
                    }
                }
            },
            vpnClientRevokedCertificates: {
                serializedName: "vpnClientRevokedCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnClientRevokedCertificate"
                        }
                    }
                }
            },
            vpnClientProtocols: {
                serializedName: "vpnClientProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            vpnAuthenticationTypes: {
                serializedName: "vpnAuthenticationTypes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            vpnClientIpsecPolicies: {
                serializedName: "vpnClientIpsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            },
            radiusServerAddress: {
                serializedName: "radiusServerAddress",
                type: {
                    name: "String"
                }
            },
            radiusServerSecret: {
                serializedName: "radiusServerSecret",
                type: {
                    name: "String"
                }
            },
            radiusServers: {
                serializedName: "radiusServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RadiusServer"
                        }
                    }
                }
            },
            aadTenant: {
                serializedName: "aadTenant",
                type: {
                    name: "String"
                }
            },
            aadAudience: {
                serializedName: "aadAudience",
                type: {
                    name: "String"
                }
            },
            aadIssuer: {
                serializedName: "aadIssuer",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var IPConfigurationBgpPeeringAddress = {
    serializedName: "IPConfigurationBgpPeeringAddress",
    type: {
        name: "Composite",
        className: "IPConfigurationBgpPeeringAddress",
        modelProperties: {
            ipconfigurationId: {
                serializedName: "ipconfigurationId",
                type: {
                    name: "String"
                }
            },
            defaultBgpIpAddresses: {
                readOnly: true,
                serializedName: "defaultBgpIpAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            customBgpIpAddresses: {
                serializedName: "customBgpIpAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            tunnelIpAddresses: {
                readOnly: true,
                serializedName: "tunnelIpAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var BgpSettings = {
    serializedName: "BgpSettings",
    type: {
        name: "Composite",
        className: "BgpSettings",
        modelProperties: {
            asn: {
                serializedName: "asn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            bgpPeeringAddress: {
                serializedName: "bgpPeeringAddress",
                type: {
                    name: "String"
                }
            },
            peerWeight: {
                serializedName: "peerWeight",
                type: {
                    name: "Number"
                }
            },
            bgpPeeringAddresses: {
                serializedName: "bgpPeeringAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IPConfigurationBgpPeeringAddress"
                        }
                    }
                }
            }
        }
    }
};
export var BgpPeerStatus = {
    serializedName: "BgpPeerStatus",
    type: {
        name: "Composite",
        className: "BgpPeerStatus",
        modelProperties: {
            localAddress: {
                readOnly: true,
                serializedName: "localAddress",
                type: {
                    name: "String"
                }
            },
            neighbor: {
                readOnly: true,
                serializedName: "neighbor",
                type: {
                    name: "String"
                }
            },
            asn: {
                readOnly: true,
                serializedName: "asn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            },
            state: {
                readOnly: true,
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            connectedDuration: {
                readOnly: true,
                serializedName: "connectedDuration",
                type: {
                    name: "String"
                }
            },
            routesReceived: {
                readOnly: true,
                serializedName: "routesReceived",
                type: {
                    name: "Number"
                }
            },
            messagesSent: {
                readOnly: true,
                serializedName: "messagesSent",
                type: {
                    name: "Number"
                }
            },
            messagesReceived: {
                readOnly: true,
                serializedName: "messagesReceived",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var GatewayRoute = {
    serializedName: "GatewayRoute",
    type: {
        name: "Composite",
        className: "GatewayRoute",
        modelProperties: {
            localAddress: {
                readOnly: true,
                serializedName: "localAddress",
                type: {
                    name: "String"
                }
            },
            network: {
                readOnly: true,
                serializedName: "network",
                type: {
                    name: "String"
                }
            },
            nextHop: {
                readOnly: true,
                serializedName: "nextHop",
                type: {
                    name: "String"
                }
            },
            sourcePeer: {
                readOnly: true,
                serializedName: "sourcePeer",
                type: {
                    name: "String"
                }
            },
            origin: {
                readOnly: true,
                serializedName: "origin",
                type: {
                    name: "String"
                }
            },
            asPath: {
                readOnly: true,
                serializedName: "asPath",
                type: {
                    name: "String"
                }
            },
            weight: {
                readOnly: true,
                serializedName: "weight",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VirtualNetworkGateway = {
    serializedName: "VirtualNetworkGateway",
    type: {
        name: "Composite",
        className: "VirtualNetworkGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGatewayIPConfiguration"
                        }
                    }
                }
            }, gatewayType: {
                serializedName: "properties.gatewayType",
                type: {
                    name: "String"
                }
            }, vpnType: {
                serializedName: "properties.vpnType",
                type: {
                    name: "String"
                }
            }, vpnGatewayGeneration: {
                serializedName: "properties.vpnGatewayGeneration",
                type: {
                    name: "String"
                }
            }, enableBgp: {
                serializedName: "properties.enableBgp",
                type: {
                    name: "Boolean"
                }
            }, enablePrivateIpAddress: {
                serializedName: "properties.enablePrivateIpAddress",
                type: {
                    name: "Boolean"
                }
            }, activeActive: {
                serializedName: "properties.activeActive",
                type: {
                    name: "Boolean"
                }
            }, gatewayDefaultSite: {
                serializedName: "properties.gatewayDefaultSite",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, sku: {
                serializedName: "properties.sku",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkGatewaySku"
                }
            }, vpnClientConfiguration: {
                serializedName: "properties.vpnClientConfiguration",
                type: {
                    name: "Composite",
                    className: "VpnClientConfiguration"
                }
            }, bgpSettings: {
                serializedName: "properties.bgpSettings",
                type: {
                    name: "Composite",
                    className: "BgpSettings"
                }
            }, customRoutes: {
                serializedName: "properties.customRoutes",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, enableDnsForwarding: {
                serializedName: "properties.enableDnsForwarding",
                type: {
                    name: "Boolean"
                }
            }, inboundDnsForwardingEndpoint: {
                readOnly: true,
                serializedName: "properties.inboundDnsForwardingEndpoint",
                type: {
                    name: "String"
                }
            }, vNetExtendedLocationResourceId: {
                serializedName: "properties.vNetExtendedLocationResourceId",
                type: {
                    name: "String"
                }
            }, natRules: {
                serializedName: "properties.natRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGatewayNatRule"
                        }
                    }
                }
            }, enableBgpRouteTranslationForNat: {
                serializedName: "properties.enableBgpRouteTranslationForNat",
                type: {
                    name: "Boolean"
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnClientParameters = {
    serializedName: "VpnClientParameters",
    type: {
        name: "Composite",
        className: "VpnClientParameters",
        modelProperties: {
            processorArchitecture: {
                serializedName: "processorArchitecture",
                type: {
                    name: "String"
                }
            },
            authenticationMethod: {
                serializedName: "authenticationMethod",
                type: {
                    name: "String"
                }
            },
            radiusServerAuthCertificate: {
                serializedName: "radiusServerAuthCertificate",
                type: {
                    name: "String"
                }
            },
            clientRootCertificates: {
                serializedName: "clientRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var BgpPeerStatusListResult = {
    serializedName: "BgpPeerStatusListResult",
    type: {
        name: "Composite",
        className: "BgpPeerStatusListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BgpPeerStatus"
                        }
                    }
                }
            }
        }
    }
};
export var GatewayRouteListResult = {
    serializedName: "GatewayRouteListResult",
    type: {
        name: "Composite",
        className: "GatewayRouteListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GatewayRoute"
                        }
                    }
                }
            }
        }
    }
};
export var TunnelConnectionHealth = {
    serializedName: "TunnelConnectionHealth",
    type: {
        name: "Composite",
        className: "TunnelConnectionHealth",
        modelProperties: {
            tunnel: {
                readOnly: true,
                serializedName: "tunnel",
                type: {
                    name: "String"
                }
            },
            connectionStatus: {
                readOnly: true,
                serializedName: "connectionStatus",
                type: {
                    name: "String"
                }
            },
            ingressBytesTransferred: {
                readOnly: true,
                serializedName: "ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            egressBytesTransferred: {
                readOnly: true,
                serializedName: "egressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            lastConnectionEstablishedUtcTime: {
                readOnly: true,
                serializedName: "lastConnectionEstablishedUtcTime",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LocalNetworkGateway = {
    serializedName: "LocalNetworkGateway",
    type: {
        name: "Composite",
        className: "LocalNetworkGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { localNetworkAddressSpace: {
                serializedName: "properties.localNetworkAddressSpace",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, gatewayIpAddress: {
                serializedName: "properties.gatewayIpAddress",
                type: {
                    name: "String"
                }
            }, fqdn: {
                serializedName: "properties.fqdn",
                type: {
                    name: "String"
                }
            }, bgpSettings: {
                serializedName: "properties.bgpSettings",
                type: {
                    name: "Composite",
                    className: "BgpSettings"
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var TrafficSelectorPolicy = {
    serializedName: "TrafficSelectorPolicy",
    type: {
        name: "Composite",
        className: "TrafficSelectorPolicy",
        modelProperties: {
            localAddressRanges: {
                required: true,
                serializedName: "localAddressRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            remoteAddressRanges: {
                required: true,
                serializedName: "remoteAddressRanges",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualNetworkGatewayConnection = {
    serializedName: "VirtualNetworkGatewayConnection",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayConnection",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { authorizationKey: {
                serializedName: "properties.authorizationKey",
                type: {
                    name: "String"
                }
            }, virtualNetworkGateway1: {
                required: true,
                serializedName: "properties.virtualNetworkGateway1",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkGateway"
                }
            }, virtualNetworkGateway2: {
                serializedName: "properties.virtualNetworkGateway2",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkGateway"
                }
            }, localNetworkGateway2: {
                serializedName: "properties.localNetworkGateway2",
                type: {
                    name: "Composite",
                    className: "LocalNetworkGateway"
                }
            }, ingressNatRules: {
                serializedName: "properties.ingressNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, egressNatRules: {
                serializedName: "properties.egressNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, connectionType: {
                required: true,
                serializedName: "properties.connectionType",
                type: {
                    name: "String"
                }
            }, connectionProtocol: {
                serializedName: "properties.connectionProtocol",
                type: {
                    name: "String"
                }
            }, routingWeight: {
                serializedName: "properties.routingWeight",
                type: {
                    name: "Number"
                }
            }, dpdTimeoutSeconds: {
                serializedName: "properties.dpdTimeoutSeconds",
                type: {
                    name: "Number"
                }
            }, connectionMode: {
                serializedName: "properties.connectionMode",
                type: {
                    name: "String"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, connectionStatus: {
                readOnly: true,
                serializedName: "properties.connectionStatus",
                type: {
                    name: "String"
                }
            }, tunnelConnectionStatus: {
                readOnly: true,
                serializedName: "properties.tunnelConnectionStatus",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TunnelConnectionHealth"
                        }
                    }
                }
            }, egressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.egressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, ingressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, peer: {
                serializedName: "properties.peer",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, enableBgp: {
                serializedName: "properties.enableBgp",
                type: {
                    name: "Boolean"
                }
            }, useLocalAzureIpAddress: {
                serializedName: "properties.useLocalAzureIpAddress",
                type: {
                    name: "Boolean"
                }
            }, usePolicyBasedTrafficSelectors: {
                serializedName: "properties.usePolicyBasedTrafficSelectors",
                type: {
                    name: "Boolean"
                }
            }, ipsecPolicies: {
                serializedName: "properties.ipsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            }, trafficSelectorPolicies: {
                serializedName: "properties.trafficSelectorPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TrafficSelectorPolicy"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, expressRouteGatewayBypass: {
                serializedName: "properties.expressRouteGatewayBypass",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ConnectionResetSharedKey = {
    serializedName: "ConnectionResetSharedKey",
    type: {
        name: "Composite",
        className: "ConnectionResetSharedKey",
        modelProperties: {
            keyLength: {
                required: true,
                serializedName: "keyLength",
                constraints: {
                    InclusiveMaximum: 128,
                    InclusiveMinimum: 1
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ConnectionSharedKey = {
    serializedName: "ConnectionSharedKey",
    type: {
        name: "Composite",
        className: "ConnectionSharedKey",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { value: {
                required: true,
                serializedName: "value",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnClientIPsecParameters = {
    serializedName: "VpnClientIPsecParameters",
    type: {
        name: "Composite",
        className: "VpnClientIPsecParameters",
        modelProperties: {
            saLifeTimeSeconds: {
                required: true,
                serializedName: "saLifeTimeSeconds",
                type: {
                    name: "Number"
                }
            },
            saDataSizeKilobytes: {
                required: true,
                serializedName: "saDataSizeKilobytes",
                type: {
                    name: "Number"
                }
            },
            ipsecEncryption: {
                required: true,
                serializedName: "ipsecEncryption",
                type: {
                    name: "String"
                }
            },
            ipsecIntegrity: {
                required: true,
                serializedName: "ipsecIntegrity",
                type: {
                    name: "String"
                }
            },
            ikeEncryption: {
                required: true,
                serializedName: "ikeEncryption",
                type: {
                    name: "String"
                }
            },
            ikeIntegrity: {
                required: true,
                serializedName: "ikeIntegrity",
                type: {
                    name: "String"
                }
            },
            dhGroup: {
                required: true,
                serializedName: "dhGroup",
                type: {
                    name: "String"
                }
            },
            pfsGroup: {
                required: true,
                serializedName: "pfsGroup",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkConnectionGatewayReference = {
    serializedName: "VirtualNetworkConnectionGatewayReference",
    type: {
        name: "Composite",
        className: "VirtualNetworkConnectionGatewayReference",
        modelProperties: {
            id: {
                required: true,
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayConnectionListEntity = {
    serializedName: "VirtualNetworkGatewayConnectionListEntity",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayConnectionListEntity",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { authorizationKey: {
                serializedName: "properties.authorizationKey",
                type: {
                    name: "String"
                }
            }, virtualNetworkGateway1: {
                required: true,
                serializedName: "properties.virtualNetworkGateway1",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkConnectionGatewayReference"
                }
            }, virtualNetworkGateway2: {
                serializedName: "properties.virtualNetworkGateway2",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkConnectionGatewayReference"
                }
            }, localNetworkGateway2: {
                serializedName: "properties.localNetworkGateway2",
                type: {
                    name: "Composite",
                    className: "VirtualNetworkConnectionGatewayReference"
                }
            }, connectionType: {
                required: true,
                serializedName: "properties.connectionType",
                type: {
                    name: "String"
                }
            }, connectionProtocol: {
                serializedName: "properties.connectionProtocol",
                type: {
                    name: "String"
                }
            }, routingWeight: {
                serializedName: "properties.routingWeight",
                type: {
                    name: "Number"
                }
            }, connectionMode: {
                serializedName: "properties.connectionMode",
                type: {
                    name: "String"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, connectionStatus: {
                readOnly: true,
                serializedName: "properties.connectionStatus",
                type: {
                    name: "String"
                }
            }, tunnelConnectionStatus: {
                readOnly: true,
                serializedName: "properties.tunnelConnectionStatus",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TunnelConnectionHealth"
                        }
                    }
                }
            }, egressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.egressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, ingressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, peer: {
                serializedName: "properties.peer",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, enableBgp: {
                serializedName: "properties.enableBgp",
                type: {
                    name: "Boolean"
                }
            }, usePolicyBasedTrafficSelectors: {
                serializedName: "properties.usePolicyBasedTrafficSelectors",
                type: {
                    name: "Boolean"
                }
            }, ipsecPolicies: {
                serializedName: "properties.ipsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            }, trafficSelectorPolicies: {
                serializedName: "properties.trafficSelectorPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TrafficSelectorPolicy"
                        }
                    }
                }
            }, resourceGuid: {
                readOnly: true,
                serializedName: "properties.resourceGuid",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, expressRouteGatewayBypass: {
                serializedName: "properties.expressRouteGatewayBypass",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnDeviceScriptParameters = {
    serializedName: "VpnDeviceScriptParameters",
    type: {
        name: "Composite",
        className: "VpnDeviceScriptParameters",
        modelProperties: {
            vendor: {
                serializedName: "vendor",
                type: {
                    name: "String"
                }
            },
            deviceFamily: {
                serializedName: "deviceFamily",
                type: {
                    name: "String"
                }
            },
            firmwareVersion: {
                serializedName: "firmwareVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnClientConnectionHealthDetail = {
    serializedName: "VpnClientConnectionHealthDetail",
    type: {
        name: "Composite",
        className: "VpnClientConnectionHealthDetail",
        modelProperties: {
            vpnConnectionId: {
                readOnly: true,
                serializedName: "vpnConnectionId",
                type: {
                    name: "String"
                }
            },
            vpnConnectionDuration: {
                readOnly: true,
                serializedName: "vpnConnectionDuration",
                type: {
                    name: "Number"
                }
            },
            vpnConnectionTime: {
                readOnly: true,
                serializedName: "vpnConnectionTime",
                type: {
                    name: "String"
                }
            },
            publicIpAddress: {
                readOnly: true,
                serializedName: "publicIpAddress",
                type: {
                    name: "String"
                }
            },
            privateIpAddress: {
                readOnly: true,
                serializedName: "privateIpAddress",
                type: {
                    name: "String"
                }
            },
            vpnUserName: {
                readOnly: true,
                serializedName: "vpnUserName",
                type: {
                    name: "String"
                }
            },
            maxBandwidth: {
                readOnly: true,
                serializedName: "maxBandwidth",
                type: {
                    name: "Number"
                }
            },
            egressPacketsTransferred: {
                readOnly: true,
                serializedName: "egressPacketsTransferred",
                type: {
                    name: "Number"
                }
            },
            egressBytesTransferred: {
                readOnly: true,
                serializedName: "egressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            ingressPacketsTransferred: {
                readOnly: true,
                serializedName: "ingressPacketsTransferred",
                type: {
                    name: "Number"
                }
            },
            ingressBytesTransferred: {
                readOnly: true,
                serializedName: "ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            maxPacketsPerSecond: {
                readOnly: true,
                serializedName: "maxPacketsPerSecond",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VpnClientConnectionHealthDetailListResult = {
    serializedName: "VpnClientConnectionHealthDetailListResult",
    type: {
        name: "Composite",
        className: "VpnClientConnectionHealthDetailListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnClientConnectionHealthDetail"
                        }
                    }
                }
            }
        }
    }
};
export var VpnPacketCaptureStopParameters = {
    serializedName: "VpnPacketCaptureStopParameters",
    type: {
        name: "Composite",
        className: "VpnPacketCaptureStopParameters",
        modelProperties: {
            sasUrl: {
                serializedName: "sasUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnPacketCaptureStartParameters = {
    serializedName: "VpnPacketCaptureStartParameters",
    type: {
        name: "Composite",
        className: "VpnPacketCaptureStartParameters",
        modelProperties: {
            filterData: {
                serializedName: "filterData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var P2SVpnConnectionRequest = {
    serializedName: "P2SVpnConnectionRequest",
    type: {
        name: "Composite",
        className: "P2SVpnConnectionRequest",
        modelProperties: {
            vpnConnectionIds: {
                serializedName: "vpnConnectionIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualRouter = {
    serializedName: "VirtualRouter",
    type: {
        name: "Composite",
        className: "VirtualRouter",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { virtualRouterAsn: {
                serializedName: "properties.virtualRouterAsn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, virtualRouterIps: {
                serializedName: "properties.virtualRouterIps",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, hostedSubnet: {
                serializedName: "properties.hostedSubnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostedGateway: {
                serializedName: "properties.hostedGateway",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, peerings: {
                readOnly: true,
                serializedName: "properties.peerings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualRouterPeering = {
    serializedName: "VirtualRouterPeering",
    type: {
        name: "Composite",
        className: "VirtualRouterPeering",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { peerAsn: {
                serializedName: "properties.peerAsn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, peerIp: {
                serializedName: "properties.peerIp",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualWAN = {
    serializedName: "VirtualWAN",
    type: {
        name: "Composite",
        className: "VirtualWAN",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { disableVpnEncryption: {
                serializedName: "properties.disableVpnEncryption",
                type: {
                    name: "Boolean"
                }
            }, virtualHubs: {
                readOnly: true,
                serializedName: "properties.virtualHubs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, vpnSites: {
                readOnly: true,
                serializedName: "properties.vpnSites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, allowBranchToBranchTraffic: {
                serializedName: "properties.allowBranchToBranchTraffic",
                type: {
                    name: "Boolean"
                }
            }, allowVnetToVnetTraffic: {
                serializedName: "properties.allowVnetToVnetTraffic",
                type: {
                    name: "Boolean"
                }
            }, office365LocalBreakoutCategory: {
                serializedName: "properties.office365LocalBreakoutCategory",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, virtualWANType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var DeviceProperties = {
    serializedName: "DeviceProperties",
    type: {
        name: "Composite",
        className: "DeviceProperties",
        modelProperties: {
            deviceVendor: {
                serializedName: "deviceVendor",
                type: {
                    name: "String"
                }
            },
            deviceModel: {
                serializedName: "deviceModel",
                type: {
                    name: "String"
                }
            },
            linkSpeedInMbps: {
                serializedName: "linkSpeedInMbps",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VpnLinkProviderProperties = {
    serializedName: "VpnLinkProviderProperties",
    type: {
        name: "Composite",
        className: "VpnLinkProviderProperties",
        modelProperties: {
            linkProviderName: {
                serializedName: "linkProviderName",
                type: {
                    name: "String"
                }
            },
            linkSpeedInMbps: {
                serializedName: "linkSpeedInMbps",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var VpnLinkBgpSettings = {
    serializedName: "VpnLinkBgpSettings",
    type: {
        name: "Composite",
        className: "VpnLinkBgpSettings",
        modelProperties: {
            asn: {
                serializedName: "asn",
                type: {
                    name: "Number"
                }
            },
            bgpPeeringAddress: {
                serializedName: "bgpPeeringAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnSiteLink = {
    serializedName: "VpnSiteLink",
    type: {
        name: "Composite",
        className: "VpnSiteLink",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { linkProperties: {
                serializedName: "properties.linkProperties",
                type: {
                    name: "Composite",
                    className: "VpnLinkProviderProperties"
                }
            }, ipAddress: {
                serializedName: "properties.ipAddress",
                type: {
                    name: "String"
                }
            }, fqdn: {
                serializedName: "properties.fqdn",
                type: {
                    name: "String"
                }
            }, bgpProperties: {
                serializedName: "properties.bgpProperties",
                type: {
                    name: "Composite",
                    className: "VpnLinkBgpSettings"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var O365BreakOutCategoryPolicies = {
    serializedName: "O365BreakOutCategoryPolicies",
    type: {
        name: "Composite",
        className: "O365BreakOutCategoryPolicies",
        modelProperties: {
            allow: {
                serializedName: "allow",
                type: {
                    name: "Boolean"
                }
            },
            optimize: {
                serializedName: "optimize",
                type: {
                    name: "Boolean"
                }
            },
            default: {
                serializedName: "default",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export var O365PolicyProperties = {
    serializedName: "O365PolicyProperties",
    type: {
        name: "Composite",
        className: "O365PolicyProperties",
        modelProperties: {
            breakOutCategories: {
                serializedName: "breakOutCategories",
                type: {
                    name: "Composite",
                    className: "O365BreakOutCategoryPolicies"
                }
            }
        }
    }
};
export var VpnSite = {
    serializedName: "VpnSite",
    type: {
        name: "Composite",
        className: "VpnSite",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { virtualWan: {
                serializedName: "properties.virtualWan",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, deviceProperties: {
                serializedName: "properties.deviceProperties",
                type: {
                    name: "Composite",
                    className: "DeviceProperties"
                }
            }, ipAddress: {
                serializedName: "properties.ipAddress",
                type: {
                    name: "String"
                }
            }, siteKey: {
                serializedName: "properties.siteKey",
                type: {
                    name: "String"
                }
            }, addressSpace: {
                serializedName: "properties.addressSpace",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, bgpProperties: {
                serializedName: "properties.bgpProperties",
                type: {
                    name: "Composite",
                    className: "BgpSettings"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, isSecuritySite: {
                serializedName: "properties.isSecuritySite",
                type: {
                    name: "Boolean"
                }
            }, vpnSiteLinks: {
                serializedName: "properties.vpnSiteLinks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnSiteLink"
                        }
                    }
                }
            }, o365Policy: {
                serializedName: "properties.o365Policy",
                type: {
                    name: "Composite",
                    className: "O365PolicyProperties"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var GetVpnSitesConfigurationRequest = {
    serializedName: "GetVpnSitesConfigurationRequest",
    type: {
        name: "Composite",
        className: "GetVpnSitesConfigurationRequest",
        modelProperties: {
            vpnSites: {
                serializedName: "vpnSites",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            outputBlobSasUrl: {
                required: true,
                serializedName: "outputBlobSasUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualHubRoute = {
    serializedName: "VirtualHubRoute",
    type: {
        name: "Composite",
        className: "VirtualHubRoute",
        modelProperties: {
            addressPrefixes: {
                serializedName: "addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopIpAddress: {
                serializedName: "nextHopIpAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualHubRouteTable = {
    serializedName: "VirtualHubRouteTable",
    type: {
        name: "Composite",
        className: "VirtualHubRouteTable",
        modelProperties: {
            routes: {
                serializedName: "routes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHubRoute"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualHubRouteV2 = {
    serializedName: "VirtualHubRouteV2",
    type: {
        name: "Composite",
        className: "VirtualHubRouteV2",
        modelProperties: {
            destinationType: {
                serializedName: "destinationType",
                type: {
                    name: "String"
                }
            },
            destinations: {
                serializedName: "destinations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopType: {
                serializedName: "nextHopType",
                type: {
                    name: "String"
                }
            },
            nextHops: {
                serializedName: "nextHops",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualHubRouteTableV2 = {
    serializedName: "VirtualHubRouteTableV2",
    type: {
        name: "Composite",
        className: "VirtualHubRouteTableV2",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { routes: {
                serializedName: "properties.routes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHubRouteV2"
                        }
                    }
                }
            }, attachedConnections: {
                serializedName: "properties.attachedConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var BgpConnection = {
    serializedName: "BgpConnection",
    type: {
        name: "Composite",
        className: "BgpConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { peerAsn: {
                serializedName: "properties.peerAsn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, peerIp: {
                serializedName: "properties.peerIp",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, connectionState: {
                readOnly: true,
                serializedName: "properties.connectionState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PeerRoute = {
    serializedName: "PeerRoute",
    type: {
        name: "Composite",
        className: "PeerRoute",
        modelProperties: {
            localAddress: {
                readOnly: true,
                serializedName: "localAddress",
                type: {
                    name: "String"
                }
            },
            network: {
                readOnly: true,
                serializedName: "network",
                type: {
                    name: "String"
                }
            },
            nextHop: {
                readOnly: true,
                serializedName: "nextHop",
                type: {
                    name: "String"
                }
            },
            sourcePeer: {
                readOnly: true,
                serializedName: "sourcePeer",
                type: {
                    name: "String"
                }
            },
            origin: {
                readOnly: true,
                serializedName: "origin",
                type: {
                    name: "String"
                }
            },
            asPath: {
                readOnly: true,
                serializedName: "asPath",
                type: {
                    name: "String"
                }
            },
            weight: {
                readOnly: true,
                serializedName: "weight",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var PeerRouteList = {
    serializedName: "PeerRouteList",
    type: {
        name: "Composite",
        className: "PeerRouteList",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PeerRoute"
                        }
                    }
                }
            }
        }
    }
};
export var HubIpConfiguration = {
    serializedName: "HubIpConfiguration",
    type: {
        name: "Composite",
        className: "HubIpConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { privateIPAddress: {
                serializedName: "properties.privateIPAddress",
                type: {
                    name: "String"
                }
            }, privateIPAllocationMethod: {
                serializedName: "properties.privateIPAllocationMethod",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "Subnet"
                }
            }, publicIPAddress: {
                serializedName: "properties.publicIPAddress",
                type: {
                    name: "Composite",
                    className: "PublicIPAddress"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VirtualHub = {
    serializedName: "VirtualHub",
    type: {
        name: "Composite",
        className: "VirtualHub",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { virtualWan: {
                serializedName: "properties.virtualWan",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, vpnGateway: {
                serializedName: "properties.vpnGateway",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, p2SVpnGateway: {
                serializedName: "properties.p2SVpnGateway",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, expressRouteGateway: {
                serializedName: "properties.expressRouteGateway",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, azureFirewall: {
                serializedName: "properties.azureFirewall",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, securityPartnerProvider: {
                serializedName: "properties.securityPartnerProvider",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, addressPrefix: {
                serializedName: "properties.addressPrefix",
                type: {
                    name: "String"
                }
            }, routeTable: {
                serializedName: "properties.routeTable",
                type: {
                    name: "Composite",
                    className: "VirtualHubRouteTable"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, securityProviderName: {
                serializedName: "properties.securityProviderName",
                type: {
                    name: "String"
                }
            }, virtualHubRouteTableV2s: {
                serializedName: "properties.virtualHubRouteTableV2s",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHubRouteTableV2"
                        }
                    }
                }
            }, sku: {
                serializedName: "properties.sku",
                type: {
                    name: "String"
                }
            }, routingState: {
                serializedName: "properties.routingState",
                type: {
                    name: "String"
                }
            }, bgpConnections: {
                readOnly: true,
                serializedName: "properties.bgpConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, ipConfigurations: {
                readOnly: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, virtualRouterAsn: {
                serializedName: "properties.virtualRouterAsn",
                constraints: {
                    InclusiveMaximum: 4294967295,
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }, virtualRouterIps: {
                serializedName: "properties.virtualRouterIps",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, allowBranchToBranchTraffic: {
                serializedName: "properties.allowBranchToBranchTraffic",
                type: {
                    name: "Boolean"
                }
            }, preferredRoutingGateway: {
                serializedName: "properties.preferredRoutingGateway",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnSiteLinkConnection = {
    serializedName: "VpnSiteLinkConnection",
    type: {
        name: "Composite",
        className: "VpnSiteLinkConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { vpnSiteLink: {
                serializedName: "properties.vpnSiteLink",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, routingWeight: {
                serializedName: "properties.routingWeight",
                type: {
                    name: "Number"
                }
            }, vpnLinkConnectionMode: {
                serializedName: "properties.vpnLinkConnectionMode",
                type: {
                    name: "String"
                }
            }, connectionStatus: {
                serializedName: "properties.connectionStatus",
                type: {
                    name: "String"
                }
            }, vpnConnectionProtocolType: {
                serializedName: "properties.vpnConnectionProtocolType",
                type: {
                    name: "String"
                }
            }, ingressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, egressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.egressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, connectionBandwidth: {
                serializedName: "properties.connectionBandwidth",
                type: {
                    name: "Number"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, enableBgp: {
                serializedName: "properties.enableBgp",
                type: {
                    name: "Boolean"
                }
            }, usePolicyBasedTrafficSelectors: {
                serializedName: "properties.usePolicyBasedTrafficSelectors",
                type: {
                    name: "Boolean"
                }
            }, ipsecPolicies: {
                serializedName: "properties.ipsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            }, enableRateLimiting: {
                serializedName: "properties.enableRateLimiting",
                type: {
                    name: "Boolean"
                }
            }, useLocalAzureIpAddress: {
                serializedName: "properties.useLocalAzureIpAddress",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, ingressNatRules: {
                serializedName: "properties.ingressNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, egressNatRules: {
                serializedName: "properties.egressNatRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var PropagatedRouteTable = {
    serializedName: "PropagatedRouteTable",
    type: {
        name: "Composite",
        className: "PropagatedRouteTable",
        modelProperties: {
            labels: {
                serializedName: "labels",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            ids: {
                serializedName: "ids",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }
        }
    }
};
export var StaticRoute = {
    serializedName: "StaticRoute",
    type: {
        name: "Composite",
        className: "StaticRoute",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            addressPrefixes: {
                serializedName: "addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopIpAddress: {
                serializedName: "nextHopIpAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VnetRoute = {
    serializedName: "VnetRoute",
    type: {
        name: "Composite",
        className: "VnetRoute",
        modelProperties: {
            staticRoutes: {
                serializedName: "staticRoutes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "StaticRoute"
                        }
                    }
                }
            }
        }
    }
};
export var RoutingConfiguration = {
    serializedName: "RoutingConfiguration",
    type: {
        name: "Composite",
        className: "RoutingConfiguration",
        modelProperties: {
            associatedRouteTable: {
                serializedName: "associatedRouteTable",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            propagatedRouteTables: {
                serializedName: "propagatedRouteTables",
                type: {
                    name: "Composite",
                    className: "PropagatedRouteTable"
                }
            },
            vnetRoutes: {
                serializedName: "vnetRoutes",
                type: {
                    name: "Composite",
                    className: "VnetRoute"
                }
            }
        }
    }
};
export var VpnConnection = {
    serializedName: "VpnConnection",
    type: {
        name: "Composite",
        className: "VpnConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { remoteVpnSite: {
                serializedName: "properties.remoteVpnSite",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, routingWeight: {
                serializedName: "properties.routingWeight",
                type: {
                    name: "Number"
                }
            }, dpdTimeoutSeconds: {
                serializedName: "properties.dpdTimeoutSeconds",
                type: {
                    name: "Number"
                }
            }, connectionStatus: {
                serializedName: "properties.connectionStatus",
                type: {
                    name: "String"
                }
            }, vpnConnectionProtocolType: {
                serializedName: "properties.vpnConnectionProtocolType",
                type: {
                    name: "String"
                }
            }, ingressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.ingressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, egressBytesTransferred: {
                readOnly: true,
                serializedName: "properties.egressBytesTransferred",
                type: {
                    name: "Number"
                }
            }, connectionBandwidth: {
                serializedName: "properties.connectionBandwidth",
                type: {
                    name: "Number"
                }
            }, sharedKey: {
                serializedName: "properties.sharedKey",
                type: {
                    name: "String"
                }
            }, enableBgp: {
                serializedName: "properties.enableBgp",
                type: {
                    name: "Boolean"
                }
            }, usePolicyBasedTrafficSelectors: {
                serializedName: "properties.usePolicyBasedTrafficSelectors",
                type: {
                    name: "Boolean"
                }
            }, ipsecPolicies: {
                serializedName: "properties.ipsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            }, trafficSelectorPolicies: {
                serializedName: "properties.trafficSelectorPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TrafficSelectorPolicy"
                        }
                    }
                }
            }, enableRateLimiting: {
                serializedName: "properties.enableRateLimiting",
                type: {
                    name: "Boolean"
                }
            }, enableInternetSecurity: {
                serializedName: "properties.enableInternetSecurity",
                type: {
                    name: "Boolean"
                }
            }, useLocalAzureIpAddress: {
                serializedName: "properties.useLocalAzureIpAddress",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, vpnLinkConnections: {
                serializedName: "properties.vpnLinkConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnSiteLinkConnection"
                        }
                    }
                }
            }, routingConfiguration: {
                serializedName: "properties.routingConfiguration",
                type: {
                    name: "Composite",
                    className: "RoutingConfiguration"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnGatewayIpConfiguration = {
    serializedName: "VpnGatewayIpConfiguration",
    type: {
        name: "Composite",
        className: "VpnGatewayIpConfiguration",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            publicIpAddress: {
                serializedName: "publicIpAddress",
                type: {
                    name: "String"
                }
            },
            privateIpAddress: {
                serializedName: "privateIpAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnGatewayNatRule = {
    serializedName: "VpnGatewayNatRule",
    type: {
        name: "Composite",
        className: "VpnGatewayNatRule",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, vpnGatewayNatRulePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, mode: {
                serializedName: "properties.mode",
                type: {
                    name: "String"
                }
            }, internalMappings: {
                serializedName: "properties.internalMappings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnNatRuleMapping"
                        }
                    }
                }
            }, externalMappings: {
                serializedName: "properties.externalMappings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnNatRuleMapping"
                        }
                    }
                }
            }, ipConfigurationId: {
                serializedName: "properties.ipConfigurationId",
                type: {
                    name: "String"
                }
            }, egressVpnSiteLinkConnections: {
                readOnly: true,
                serializedName: "properties.egressVpnSiteLinkConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, ingressVpnSiteLinkConnections: {
                readOnly: true,
                serializedName: "properties.ingressVpnSiteLinkConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnGateway = {
    serializedName: "VpnGateway",
    type: {
        name: "Composite",
        className: "VpnGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { virtualHub: {
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, connections: {
                serializedName: "properties.connections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnConnection"
                        }
                    }
                }
            }, bgpSettings: {
                serializedName: "properties.bgpSettings",
                type: {
                    name: "Composite",
                    className: "BgpSettings"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, vpnGatewayScaleUnit: {
                serializedName: "properties.vpnGatewayScaleUnit",
                type: {
                    name: "Number"
                }
            }, ipConfigurations: {
                readOnly: true,
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnGatewayIpConfiguration"
                        }
                    }
                }
            }, isRoutingPreferenceInternet: {
                serializedName: "properties.isRoutingPreferenceInternet",
                type: {
                    name: "Boolean"
                }
            }, natRules: {
                serializedName: "properties.natRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnGatewayNatRule"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnConnectionPacketCaptureStartParameters = {
    serializedName: "VpnConnectionPacketCaptureStartParameters",
    type: {
        name: "Composite",
        className: "VpnConnectionPacketCaptureStartParameters",
        modelProperties: {
            filterData: {
                serializedName: "filterData",
                type: {
                    name: "String"
                }
            },
            linkConnectionNames: {
                serializedName: "linkConnectionNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VpnConnectionPacketCaptureStopParameters = {
    serializedName: "VpnConnectionPacketCaptureStopParameters",
    type: {
        name: "Composite",
        className: "VpnConnectionPacketCaptureStopParameters",
        modelProperties: {
            sasUrl: {
                serializedName: "sasUrl",
                type: {
                    name: "String"
                }
            },
            linkConnectionNames: {
                serializedName: "linkConnectionNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VpnGatewayPacketCaptureStartParameters = {
    serializedName: "VpnGatewayPacketCaptureStartParameters",
    type: {
        name: "Composite",
        className: "VpnGatewayPacketCaptureStartParameters",
        modelProperties: {
            filterData: {
                serializedName: "filterData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnGatewayPacketCaptureStopParameters = {
    serializedName: "VpnGatewayPacketCaptureStopParameters",
    type: {
        name: "Composite",
        className: "VpnGatewayPacketCaptureStopParameters",
        modelProperties: {
            sasUrl: {
                serializedName: "sasUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var HubVirtualNetworkConnection = {
    serializedName: "HubVirtualNetworkConnection",
    type: {
        name: "Composite",
        className: "HubVirtualNetworkConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { remoteVirtualNetwork: {
                serializedName: "properties.remoteVirtualNetwork",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, allowHubToRemoteVnetTransit: {
                serializedName: "properties.allowHubToRemoteVnetTransit",
                type: {
                    name: "Boolean"
                }
            }, allowRemoteVnetToUseHubVnetGateways: {
                serializedName: "properties.allowRemoteVnetToUseHubVnetGateways",
                type: {
                    name: "Boolean"
                }
            }, enableInternetSecurity: {
                serializedName: "properties.enableInternetSecurity",
                type: {
                    name: "Boolean"
                }
            }, routingConfiguration: {
                serializedName: "properties.routingConfiguration",
                type: {
                    name: "Composite",
                    className: "RoutingConfiguration"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var HubRoute = {
    serializedName: "HubRoute",
    type: {
        name: "Composite",
        className: "HubRoute",
        modelProperties: {
            name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            destinationType: {
                required: true,
                serializedName: "destinationType",
                type: {
                    name: "String"
                }
            },
            destinations: {
                required: true,
                serializedName: "destinations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopType: {
                required: true,
                serializedName: "nextHopType",
                type: {
                    name: "String"
                }
            },
            nextHop: {
                required: true,
                serializedName: "nextHop",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var HubRouteTable = {
    serializedName: "HubRouteTable",
    type: {
        name: "Composite",
        className: "HubRouteTable",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { routes: {
                serializedName: "properties.routes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HubRoute"
                        }
                    }
                }
            }, labels: {
                serializedName: "properties.labels",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, associatedConnections: {
                readOnly: true,
                serializedName: "properties.associatedConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, propagatingConnections: {
                readOnly: true,
                serializedName: "properties.propagatingConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            }, type: {
                readOnly: true,
                serializedName: "type",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnSiteId = {
    serializedName: "VpnSiteId",
    type: {
        name: "Composite",
        className: "VpnSiteId",
        modelProperties: {
            vpnSite: {
                readOnly: true,
                serializedName: "vpnSite",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualWanSecurityProvider = {
    serializedName: "VirtualWanSecurityProvider",
    type: {
        name: "Composite",
        className: "VirtualWanSecurityProvider",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            url: {
                serializedName: "url",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualWanSecurityProviders = {
    serializedName: "VirtualWanSecurityProviders",
    type: {
        name: "Composite",
        className: "VirtualWanSecurityProviders",
        modelProperties: {
            supportedProviders: {
                serializedName: "supportedProviders",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualWanSecurityProvider"
                        }
                    }
                }
            }
        }
    }
};
export var VpnServerConfigVpnClientRootCertificate = {
    serializedName: "VpnServerConfigVpnClientRootCertificate",
    type: {
        name: "Composite",
        className: "VpnServerConfigVpnClientRootCertificate",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publicCertData: {
                serializedName: "publicCertData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnServerConfigRadiusServerRootCertificate = {
    serializedName: "VpnServerConfigRadiusServerRootCertificate",
    type: {
        name: "Composite",
        className: "VpnServerConfigRadiusServerRootCertificate",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publicCertData: {
                serializedName: "publicCertData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnServerConfigVpnClientRevokedCertificate = {
    serializedName: "VpnServerConfigVpnClientRevokedCertificate",
    type: {
        name: "Composite",
        className: "VpnServerConfigVpnClientRevokedCertificate",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            thumbprint: {
                serializedName: "thumbprint",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnServerConfigRadiusClientRootCertificate = {
    serializedName: "VpnServerConfigRadiusClientRootCertificate",
    type: {
        name: "Composite",
        className: "VpnServerConfigRadiusClientRootCertificate",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            thumbprint: {
                serializedName: "thumbprint",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AadAuthenticationParameters = {
    serializedName: "AadAuthenticationParameters",
    type: {
        name: "Composite",
        className: "AadAuthenticationParameters",
        modelProperties: {
            aadTenant: {
                serializedName: "aadTenant",
                type: {
                    name: "String"
                }
            },
            aadAudience: {
                serializedName: "aadAudience",
                type: {
                    name: "String"
                }
            },
            aadIssuer: {
                serializedName: "aadIssuer",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var P2SConnectionConfiguration = {
    serializedName: "P2SConnectionConfiguration",
    type: {
        name: "Composite",
        className: "P2SConnectionConfiguration",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { vpnClientAddressPool: {
                serializedName: "properties.vpnClientAddressPool",
                type: {
                    name: "Composite",
                    className: "AddressSpace"
                }
            }, routingConfiguration: {
                serializedName: "properties.routingConfiguration",
                type: {
                    name: "Composite",
                    className: "RoutingConfiguration"
                }
            }, enableInternetSecurity: {
                serializedName: "properties.enableInternetSecurity",
                type: {
                    name: "Boolean"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnClientConnectionHealth = {
    serializedName: "VpnClientConnectionHealth",
    type: {
        name: "Composite",
        className: "VpnClientConnectionHealth",
        modelProperties: {
            totalIngressBytesTransferred: {
                readOnly: true,
                serializedName: "totalIngressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            totalEgressBytesTransferred: {
                readOnly: true,
                serializedName: "totalEgressBytesTransferred",
                type: {
                    name: "Number"
                }
            },
            vpnClientConnectionsCount: {
                serializedName: "vpnClientConnectionsCount",
                type: {
                    name: "Number"
                }
            },
            allocatedIpAddresses: {
                serializedName: "allocatedIpAddresses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var P2SVpnGateway = {
    serializedName: "P2SVpnGateway",
    type: {
        name: "Composite",
        className: "P2SVpnGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { virtualHub: {
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, p2SConnectionConfigurations: {
                serializedName: "properties.p2SConnectionConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "P2SConnectionConfiguration"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, vpnGatewayScaleUnit: {
                serializedName: "properties.vpnGatewayScaleUnit",
                type: {
                    name: "Number"
                }
            }, vpnServerConfiguration: {
                serializedName: "properties.vpnServerConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, vpnClientConnectionHealth: {
                readOnly: true,
                serializedName: "properties.vpnClientConnectionHealth",
                type: {
                    name: "Composite",
                    className: "VpnClientConnectionHealth"
                }
            }, customDnsServers: {
                serializedName: "properties.customDnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, isRoutingPreferenceInternet: {
                serializedName: "properties.isRoutingPreferenceInternet",
                type: {
                    name: "Boolean"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var VpnServerConfiguration = {
    serializedName: "VpnServerConfiguration",
    type: {
        name: "Composite",
        className: "VpnServerConfiguration",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { vpnServerConfigurationName: {
                serializedName: "properties.name",
                type: {
                    name: "String"
                }
            }, vpnProtocols: {
                serializedName: "properties.vpnProtocols",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, vpnAuthenticationTypes: {
                serializedName: "properties.vpnAuthenticationTypes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, vpnClientRootCertificates: {
                serializedName: "properties.vpnClientRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnServerConfigVpnClientRootCertificate"
                        }
                    }
                }
            }, vpnClientRevokedCertificates: {
                serializedName: "properties.vpnClientRevokedCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnServerConfigVpnClientRevokedCertificate"
                        }
                    }
                }
            }, radiusServerRootCertificates: {
                serializedName: "properties.radiusServerRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnServerConfigRadiusServerRootCertificate"
                        }
                    }
                }
            }, radiusClientRootCertificates: {
                serializedName: "properties.radiusClientRootCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnServerConfigRadiusClientRootCertificate"
                        }
                    }
                }
            }, vpnClientIpsecPolicies: {
                serializedName: "properties.vpnClientIpsecPolicies",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpsecPolicy"
                        }
                    }
                }
            }, radiusServerAddress: {
                serializedName: "properties.radiusServerAddress",
                type: {
                    name: "String"
                }
            }, radiusServerSecret: {
                serializedName: "properties.radiusServerSecret",
                type: {
                    name: "String"
                }
            }, radiusServers: {
                serializedName: "properties.radiusServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RadiusServer"
                        }
                    }
                }
            }, aadAuthenticationParameters: {
                serializedName: "properties.aadAuthenticationParameters",
                type: {
                    name: "Composite",
                    className: "AadAuthenticationParameters"
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, p2SVpnGateways: {
                readOnly: true,
                serializedName: "properties.p2SVpnGateways",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "P2SVpnGateway"
                        }
                    }
                }
            }, vpnServerConfigurationPropertiesEtag: {
                readOnly: true,
                serializedName: "properties.etag",
                type: {
                    name: "String"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var P2SVpnProfileParameters = {
    serializedName: "P2SVpnProfileParameters",
    type: {
        name: "Composite",
        className: "P2SVpnProfileParameters",
        modelProperties: {
            authenticationMethod: {
                serializedName: "authenticationMethod",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnProfileResponse = {
    serializedName: "VpnProfileResponse",
    type: {
        name: "Composite",
        className: "VpnProfileResponse",
        modelProperties: {
            profileUrl: {
                serializedName: "profileUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VpnServerConfigurationsResponse = {
    serializedName: "VpnServerConfigurationsResponse",
    type: {
        name: "Composite",
        className: "VpnServerConfigurationsResponse",
        modelProperties: {
            vpnServerConfigurationResourceIds: {
                serializedName: "vpnServerConfigurationResourceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualWanVpnProfileParameters = {
    serializedName: "VirtualWanVpnProfileParameters",
    type: {
        name: "Composite",
        className: "VirtualWanVpnProfileParameters",
        modelProperties: {
            vpnServerConfigurationResourceId: {
                serializedName: "vpnServerConfigurationResourceId",
                type: {
                    name: "String"
                }
            },
            authenticationMethod: {
                serializedName: "authenticationMethod",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var P2SVpnConnectionHealthRequest = {
    serializedName: "P2SVpnConnectionHealthRequest",
    type: {
        name: "Composite",
        className: "P2SVpnConnectionHealthRequest",
        modelProperties: {
            vpnUserNamesFilter: {
                serializedName: "vpnUserNamesFilter",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            outputBlobSasUrl: {
                serializedName: "outputBlobSasUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var P2SVpnConnectionHealth = {
    serializedName: "P2SVpnConnectionHealth",
    type: {
        name: "Composite",
        className: "P2SVpnConnectionHealth",
        modelProperties: {
            sasUrl: {
                serializedName: "sasUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualHubId = {
    serializedName: "VirtualHubId",
    type: {
        name: "Composite",
        className: "VirtualHubId",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitPeeringId = {
    serializedName: "ExpressRouteCircuitPeeringId",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitPeeringId",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds = {
    serializedName: "ExpressRouteGatewayProperties_autoScaleConfiguration_bounds",
    type: {
        name: "Composite",
        className: "ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds",
        modelProperties: {
            min: {
                serializedName: "min",
                type: {
                    name: "Number"
                }
            },
            max: {
                serializedName: "max",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var ExpressRouteGatewayPropertiesAutoScaleConfiguration = {
    serializedName: "ExpressRouteGatewayProperties_autoScaleConfiguration",
    type: {
        name: "Composite",
        className: "ExpressRouteGatewayPropertiesAutoScaleConfiguration",
        modelProperties: {
            bounds: {
                serializedName: "bounds",
                type: {
                    name: "Composite",
                    className: "ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds"
                }
            }
        }
    }
};
export var ExpressRouteConnection = {
    serializedName: "ExpressRouteConnection",
    type: {
        name: "Composite",
        className: "ExpressRouteConnection",
        modelProperties: __assign(__assign({}, SubResource.type.modelProperties), { provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, expressRouteCircuitPeering: {
                required: true,
                serializedName: "properties.expressRouteCircuitPeering",
                type: {
                    name: "Composite",
                    className: "ExpressRouteCircuitPeeringId"
                }
            }, authorizationKey: {
                serializedName: "properties.authorizationKey",
                type: {
                    name: "String"
                }
            }, routingWeight: {
                serializedName: "properties.routingWeight",
                type: {
                    name: "Number"
                }
            }, enableInternetSecurity: {
                serializedName: "properties.enableInternetSecurity",
                type: {
                    name: "Boolean"
                }
            }, expressRouteGatewayBypass: {
                serializedName: "properties.expressRouteGatewayBypass",
                type: {
                    name: "Boolean"
                }
            }, routingConfiguration: {
                serializedName: "properties.routingConfiguration",
                type: {
                    name: "Composite",
                    className: "RoutingConfiguration"
                }
            }, name: {
                required: true,
                serializedName: "name",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteGateway = {
    serializedName: "ExpressRouteGateway",
    type: {
        name: "Composite",
        className: "ExpressRouteGateway",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { autoScaleConfiguration: {
                serializedName: "properties.autoScaleConfiguration",
                type: {
                    name: "Composite",
                    className: "ExpressRouteGatewayPropertiesAutoScaleConfiguration"
                }
            }, expressRouteConnections: {
                readOnly: true,
                serializedName: "properties.expressRouteConnections",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteConnection"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, virtualHub: {
                required: true,
                serializedName: "properties.virtualHub",
                type: {
                    name: "Composite",
                    className: "VirtualHubId"
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ExpressRouteGatewayList = {
    serializedName: "ExpressRouteGatewayList",
    type: {
        name: "Composite",
        className: "ExpressRouteGatewayList",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteGateway"
                        }
                    }
                }
            }
        }
    }
};
export var ExpressRouteConnectionList = {
    serializedName: "ExpressRouteConnectionList",
    type: {
        name: "Composite",
        className: "ExpressRouteConnectionList",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteConnection"
                        }
                    }
                }
            }
        }
    }
};
export var VirtualHubEffectiveRoute = {
    serializedName: "VirtualHubEffectiveRoute",
    type: {
        name: "Composite",
        className: "VirtualHubEffectiveRoute",
        modelProperties: {
            addressPrefixes: {
                serializedName: "addressPrefixes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHops: {
                serializedName: "nextHops",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextHopType: {
                serializedName: "nextHopType",
                type: {
                    name: "String"
                }
            },
            asPath: {
                serializedName: "asPath",
                type: {
                    name: "String"
                }
            },
            routeOrigin: {
                serializedName: "routeOrigin",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualHubEffectiveRouteList = {
    serializedName: "VirtualHubEffectiveRouteList",
    type: {
        name: "Composite",
        className: "VirtualHubEffectiveRouteList",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHubEffectiveRoute"
                        }
                    }
                }
            }
        }
    }
};
export var EffectiveRoutesParameters = {
    serializedName: "EffectiveRoutesParameters",
    type: {
        name: "Composite",
        className: "EffectiveRoutesParameters",
        modelProperties: {
            resourceId: {
                serializedName: "resourceId",
                type: {
                    name: "String"
                }
            },
            virtualWanResourceType: {
                serializedName: "virtualWanResourceType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PolicySettings = {
    serializedName: "PolicySettings",
    type: {
        name: "Composite",
        className: "PolicySettings",
        modelProperties: {
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            },
            mode: {
                serializedName: "mode",
                type: {
                    name: "String"
                }
            },
            requestBodyCheck: {
                serializedName: "requestBodyCheck",
                type: {
                    name: "Boolean"
                }
            },
            maxRequestBodySizeInKb: {
                serializedName: "maxRequestBodySizeInKb",
                constraints: {
                    InclusiveMinimum: 8
                },
                type: {
                    name: "Number"
                }
            },
            fileUploadLimitInMb: {
                serializedName: "fileUploadLimitInMb",
                constraints: {
                    InclusiveMinimum: 0
                },
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export var MatchVariable = {
    serializedName: "MatchVariable",
    type: {
        name: "Composite",
        className: "MatchVariable",
        modelProperties: {
            variableName: {
                required: true,
                serializedName: "variableName",
                type: {
                    name: "String"
                }
            },
            selector: {
                serializedName: "selector",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var MatchCondition = {
    serializedName: "MatchCondition",
    type: {
        name: "Composite",
        className: "MatchCondition",
        modelProperties: {
            matchVariables: {
                required: true,
                serializedName: "matchVariables",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "MatchVariable"
                        }
                    }
                }
            },
            operator: {
                required: true,
                serializedName: "operator",
                type: {
                    name: "String"
                }
            },
            negationConditon: {
                serializedName: "negationConditon",
                type: {
                    name: "Boolean"
                }
            },
            matchValues: {
                required: true,
                serializedName: "matchValues",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            transforms: {
                serializedName: "transforms",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export var WebApplicationFirewallCustomRule = {
    serializedName: "WebApplicationFirewallCustomRule",
    type: {
        name: "Composite",
        className: "WebApplicationFirewallCustomRule",
        modelProperties: {
            name: {
                serializedName: "name",
                constraints: {
                    MaxLength: 128
                },
                type: {
                    name: "String"
                }
            },
            etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            },
            priority: {
                required: true,
                serializedName: "priority",
                type: {
                    name: "Number"
                }
            },
            ruleType: {
                required: true,
                serializedName: "ruleType",
                type: {
                    name: "String"
                }
            },
            matchConditions: {
                required: true,
                serializedName: "matchConditions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "MatchCondition"
                        }
                    }
                }
            },
            action: {
                required: true,
                serializedName: "action",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OwaspCrsExclusionEntry = {
    serializedName: "OwaspCrsExclusionEntry",
    type: {
        name: "Composite",
        className: "OwaspCrsExclusionEntry",
        modelProperties: {
            matchVariable: {
                required: true,
                serializedName: "matchVariable",
                type: {
                    name: "String"
                }
            },
            selectorMatchOperator: {
                required: true,
                serializedName: "selectorMatchOperator",
                type: {
                    name: "String"
                }
            },
            selector: {
                required: true,
                serializedName: "selector",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ManagedRuleOverride = {
    serializedName: "ManagedRuleOverride",
    type: {
        name: "Composite",
        className: "ManagedRuleOverride",
        modelProperties: {
            ruleId: {
                required: true,
                serializedName: "ruleId",
                type: {
                    name: "String"
                }
            },
            state: {
                serializedName: "state",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ManagedRuleGroupOverride = {
    serializedName: "ManagedRuleGroupOverride",
    type: {
        name: "Composite",
        className: "ManagedRuleGroupOverride",
        modelProperties: {
            ruleGroupName: {
                required: true,
                serializedName: "ruleGroupName",
                type: {
                    name: "String"
                }
            },
            rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ManagedRuleOverride"
                        }
                    }
                }
            }
        }
    }
};
export var ManagedRuleSet = {
    serializedName: "ManagedRuleSet",
    type: {
        name: "Composite",
        className: "ManagedRuleSet",
        modelProperties: {
            ruleSetType: {
                required: true,
                serializedName: "ruleSetType",
                type: {
                    name: "String"
                }
            },
            ruleSetVersion: {
                required: true,
                serializedName: "ruleSetVersion",
                type: {
                    name: "String"
                }
            },
            ruleGroupOverrides: {
                serializedName: "ruleGroupOverrides",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ManagedRuleGroupOverride"
                        }
                    }
                }
            }
        }
    }
};
export var ManagedRulesDefinition = {
    serializedName: "ManagedRulesDefinition",
    type: {
        name: "Composite",
        className: "ManagedRulesDefinition",
        modelProperties: {
            exclusions: {
                serializedName: "exclusions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OwaspCrsExclusionEntry"
                        }
                    }
                }
            },
            managedRuleSets: {
                required: true,
                serializedName: "managedRuleSets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ManagedRuleSet"
                        }
                    }
                }
            }
        }
    }
};
export var WebApplicationFirewallPolicy = {
    serializedName: "WebApplicationFirewallPolicy",
    type: {
        name: "Composite",
        className: "WebApplicationFirewallPolicy",
        modelProperties: __assign(__assign({}, Resource.type.modelProperties), { policySettings: {
                serializedName: "properties.policySettings",
                type: {
                    name: "Composite",
                    className: "PolicySettings"
                }
            }, customRules: {
                serializedName: "properties.customRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "WebApplicationFirewallCustomRule"
                        }
                    }
                }
            }, applicationGateways: {
                readOnly: true,
                serializedName: "properties.applicationGateways",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGateway"
                        }
                    }
                }
            }, provisioningState: {
                readOnly: true,
                serializedName: "properties.provisioningState",
                type: {
                    name: "String"
                }
            }, resourceState: {
                readOnly: true,
                serializedName: "properties.resourceState",
                type: {
                    name: "String"
                }
            }, managedRules: {
                required: true,
                serializedName: "properties.managedRules",
                type: {
                    name: "Composite",
                    className: "ManagedRulesDefinition"
                }
            }, httpListeners: {
                readOnly: true,
                serializedName: "properties.httpListeners",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, pathBasedRules: {
                readOnly: true,
                serializedName: "properties.pathBasedRules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, etag: {
                readOnly: true,
                serializedName: "etag",
                type: {
                    name: "String"
                }
            } })
    }
};
export var ApplicationGatewayListResult = {
    serializedName: "ApplicationGatewayListResult",
    type: {
        name: "Composite",
        className: "ApplicationGatewayListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGateway"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayAvailableSslPredefinedPolicies = {
    serializedName: "ApplicationGatewayAvailableSslPredefinedPolicies",
    type: {
        name: "Composite",
        className: "ApplicationGatewayAvailableSslPredefinedPolicies",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewaySslPredefinedPolicy"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayPrivateLinkResourceListResult = {
    serializedName: "ApplicationGatewayPrivateLinkResourceListResult",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateLinkResourceListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPrivateLinkResource"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationGatewayPrivateEndpointConnectionListResult = {
    serializedName: "ApplicationGatewayPrivateEndpointConnectionListResult",
    type: {
        name: "Composite",
        className: "ApplicationGatewayPrivateEndpointConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationGatewayPrivateEndpointConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ApplicationSecurityGroupListResult = {
    serializedName: "ApplicationSecurityGroupListResult",
    type: {
        name: "Composite",
        className: "ApplicationSecurityGroupListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApplicationSecurityGroup"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AvailableDelegationsResult = {
    serializedName: "AvailableDelegationsResult",
    type: {
        name: "Composite",
        className: "AvailableDelegationsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailableDelegation"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AvailableServiceAliasesResult = {
    serializedName: "AvailableServiceAliasesResult",
    type: {
        name: "Composite",
        className: "AvailableServiceAliasesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailableServiceAlias"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallListResult = {
    serializedName: "AzureFirewallListResult",
    type: {
        name: "Composite",
        className: "AzureFirewallListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewall"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureFirewallFqdnTagListResult = {
    serializedName: "AzureFirewallFqdnTagListResult",
    type: {
        name: "Composite",
        className: "AzureFirewallFqdnTagListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureFirewallFqdnTag"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AzureWebCategoryListResult = {
    serializedName: "AzureWebCategoryListResult",
    type: {
        name: "Composite",
        className: "AzureWebCategoryListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AzureWebCategory"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionHostListResult = {
    serializedName: "BastionHostListResult",
    type: {
        name: "Composite",
        className: "BastionHostListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionHost"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionShareableLinkListResult = {
    serializedName: "BastionShareableLinkListResult",
    type: {
        name: "Composite",
        className: "BastionShareableLinkListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionShareableLink"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionActiveSessionListResult = {
    serializedName: "BastionActiveSessionListResult",
    type: {
        name: "Composite",
        className: "BastionActiveSessionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionActiveSession"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BastionSessionDeleteResult = {
    serializedName: "BastionSessionDeleteResult",
    type: {
        name: "Composite",
        className: "BastionSessionDeleteResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BastionSessionState"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceListResult = {
    serializedName: "NetworkInterfaceListResult",
    type: {
        name: "Composite",
        className: "NetworkInterfaceListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterface"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceIPConfigurationListResult = {
    serializedName: "NetworkInterfaceIPConfigurationListResult",
    type: {
        name: "Composite",
        className: "NetworkInterfaceIPConfigurationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceIPConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPAddressListResult = {
    serializedName: "PublicIPAddressListResult",
    type: {
        name: "Composite",
        className: "PublicIPAddressListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PublicIPAddress"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var CustomIpPrefixListResult = {
    serializedName: "CustomIpPrefixListResult",
    type: {
        name: "Composite",
        className: "CustomIpPrefixListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CustomIpPrefix"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DdosProtectionPlanListResult = {
    serializedName: "DdosProtectionPlanListResult",
    type: {
        name: "Composite",
        className: "DdosProtectionPlanListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DdosProtectionPlan"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var DscpConfigurationListResult = {
    serializedName: "DscpConfigurationListResult",
    type: {
        name: "Composite",
        className: "DscpConfigurationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DscpConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var EndpointServicesListResult = {
    serializedName: "EndpointServicesListResult",
    type: {
        name: "Composite",
        className: "EndpointServicesListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EndpointServiceResult"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AuthorizationListResult = {
    serializedName: "AuthorizationListResult",
    type: {
        name: "Composite",
        className: "AuthorizationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitAuthorization"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitPeeringListResult = {
    serializedName: "ExpressRouteCircuitPeeringListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitPeeringListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitPeering"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitConnectionListResult = {
    serializedName: "ExpressRouteCircuitConnectionListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuitConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PeerExpressRouteCircuitConnectionListResult = {
    serializedName: "PeerExpressRouteCircuitConnectionListResult",
    type: {
        name: "Composite",
        className: "PeerExpressRouteCircuitConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PeerExpressRouteCircuitConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCircuitListResult = {
    serializedName: "ExpressRouteCircuitListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCircuitListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCircuit"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteServiceProviderListResult = {
    serializedName: "ExpressRouteServiceProviderListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteServiceProviderListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteServiceProvider"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCrossConnectionListResult = {
    serializedName: "ExpressRouteCrossConnectionListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCrossConnection"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteCrossConnectionPeeringList = {
    serializedName: "ExpressRouteCrossConnectionPeeringList",
    type: {
        name: "Composite",
        className: "ExpressRouteCrossConnectionPeeringList",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteCrossConnectionPeering"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRoutePortsLocationListResult = {
    serializedName: "ExpressRoutePortsLocationListResult",
    type: {
        name: "Composite",
        className: "ExpressRoutePortsLocationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRoutePortsLocation"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRoutePortListResult = {
    serializedName: "ExpressRoutePortListResult",
    type: {
        name: "Composite",
        className: "ExpressRoutePortListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRoutePort"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ExpressRouteLinkListResult = {
    serializedName: "ExpressRouteLinkListResult",
    type: {
        name: "Composite",
        className: "ExpressRouteLinkListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ExpressRouteLink"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyListResult = {
    serializedName: "FirewallPolicyListResult",
    type: {
        name: "Composite",
        className: "FirewallPolicyListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicy"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var FirewallPolicyRuleCollectionGroupListResult = {
    serializedName: "FirewallPolicyRuleCollectionGroupListResult",
    type: {
        name: "Composite",
        className: "FirewallPolicyRuleCollectionGroupListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FirewallPolicyRuleCollectionGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var IpAllocationListResult = {
    serializedName: "IpAllocationListResult",
    type: {
        name: "Composite",
        className: "IpAllocationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpAllocation"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var IpGroupListResult = {
    serializedName: "IpGroupListResult",
    type: {
        name: "Composite",
        className: "IpGroupListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "IpGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerListResult = {
    serializedName: "LoadBalancerListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancer"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerBackendAddressPoolListResult = {
    serializedName: "LoadBalancerBackendAddressPoolListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerBackendAddressPoolListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BackendAddressPool"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerFrontendIPConfigurationListResult = {
    serializedName: "LoadBalancerFrontendIPConfigurationListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerFrontendIPConfigurationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FrontendIPConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var InboundNatRuleListResult = {
    serializedName: "InboundNatRuleListResult",
    type: {
        name: "Composite",
        className: "InboundNatRuleListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InboundNatRule"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerLoadBalancingRuleListResult = {
    serializedName: "LoadBalancerLoadBalancingRuleListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerLoadBalancingRuleListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancingRule"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerOutboundRuleListResult = {
    serializedName: "LoadBalancerOutboundRuleListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerOutboundRuleListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OutboundRule"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LoadBalancerProbeListResult = {
    serializedName: "LoadBalancerProbeListResult",
    type: {
        name: "Composite",
        className: "LoadBalancerProbeListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Probe"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NatGatewayListResult = {
    serializedName: "NatGatewayListResult",
    type: {
        name: "Composite",
        className: "NatGatewayListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NatGateway"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceLoadBalancerListResult = {
    serializedName: "NetworkInterfaceLoadBalancerListResult",
    type: {
        name: "Composite",
        className: "NetworkInterfaceLoadBalancerListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancer"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkInterfaceTapConfigurationListResult = {
    serializedName: "NetworkInterfaceTapConfigurationListResult",
    type: {
        name: "Composite",
        className: "NetworkInterfaceTapConfigurationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceTapConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkProfileListResult = {
    serializedName: "NetworkProfileListResult",
    type: {
        name: "Composite",
        className: "NetworkProfileListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkProfile"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkSecurityGroupListResult = {
    serializedName: "NetworkSecurityGroupListResult",
    type: {
        name: "Composite",
        className: "NetworkSecurityGroupListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkSecurityGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SecurityRuleListResult = {
    serializedName: "SecurityRuleListResult",
    type: {
        name: "Composite",
        className: "SecurityRuleListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityRule"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkVirtualApplianceListResult = {
    serializedName: "NetworkVirtualApplianceListResult",
    type: {
        name: "Composite",
        className: "NetworkVirtualApplianceListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkVirtualAppliance"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkVirtualApplianceSiteListResult = {
    serializedName: "NetworkVirtualApplianceSiteListResult",
    type: {
        name: "Composite",
        className: "NetworkVirtualApplianceSiteListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualApplianceSite"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkVirtualApplianceSkuListResult = {
    serializedName: "NetworkVirtualApplianceSkuListResult",
    type: {
        name: "Composite",
        className: "NetworkVirtualApplianceSkuListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkVirtualApplianceSku"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var NetworkWatcherListResult = {
    serializedName: "NetworkWatcherListResult",
    type: {
        name: "Composite",
        className: "NetworkWatcherListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkWatcher"
                        }
                    }
                }
            }
        }
    }
};
export var PacketCaptureListResult = {
    serializedName: "PacketCaptureListResult",
    type: {
        name: "Composite",
        className: "PacketCaptureListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PacketCaptureResult"
                        }
                    }
                }
            }
        }
    }
};
export var ConnectionMonitorListResult = {
    serializedName: "ConnectionMonitorListResult",
    type: {
        name: "Composite",
        className: "ConnectionMonitorListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ConnectionMonitorResult"
                        }
                    }
                }
            }
        }
    }
};
export var FlowLogListResult = {
    serializedName: "FlowLogListResult",
    type: {
        name: "Composite",
        className: "FlowLogListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "FlowLog"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var OperationListResult = {
    serializedName: "OperationListResult",
    type: {
        name: "Composite",
        className: "OperationListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Operation"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateEndpointListResult = {
    serializedName: "PrivateEndpointListResult",
    type: {
        name: "Composite",
        className: "PrivateEndpointListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpoint"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AvailablePrivateEndpointTypesResult = {
    serializedName: "AvailablePrivateEndpointTypesResult",
    type: {
        name: "Composite",
        className: "AvailablePrivateEndpointTypesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailablePrivateEndpointType"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateDnsZoneGroupListResult = {
    serializedName: "PrivateDnsZoneGroupListResult",
    type: {
        name: "Composite",
        className: "PrivateDnsZoneGroupListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateDnsZoneGroup"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateLinkServiceListResult = {
    serializedName: "PrivateLinkServiceListResult",
    type: {
        name: "Composite",
        className: "PrivateLinkServiceListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkService"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PrivateEndpointConnectionListResult = {
    serializedName: "PrivateEndpointConnectionListResult",
    type: {
        name: "Composite",
        className: "PrivateEndpointConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var AutoApprovedPrivateLinkServicesResult = {
    serializedName: "AutoApprovedPrivateLinkServicesResult",
    type: {
        name: "Composite",
        className: "AutoApprovedPrivateLinkServicesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AutoApprovedPrivateLinkService"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var PublicIPPrefixListResult = {
    serializedName: "PublicIPPrefixListResult",
    type: {
        name: "Composite",
        className: "PublicIPPrefixListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PublicIPPrefix"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RouteFilterListResult = {
    serializedName: "RouteFilterListResult",
    type: {
        name: "Composite",
        className: "RouteFilterListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RouteFilter"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RouteFilterRuleListResult = {
    serializedName: "RouteFilterRuleListResult",
    type: {
        name: "Composite",
        className: "RouteFilterRuleListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RouteFilterRule"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RouteTableListResult = {
    serializedName: "RouteTableListResult",
    type: {
        name: "Composite",
        className: "RouteTableListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RouteTable"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var RouteListResult = {
    serializedName: "RouteListResult",
    type: {
        name: "Composite",
        className: "RouteListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Route"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SecurityPartnerProviderListResult = {
    serializedName: "SecurityPartnerProviderListResult",
    type: {
        name: "Composite",
        className: "SecurityPartnerProviderListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SecurityPartnerProvider"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var BgpServiceCommunityListResult = {
    serializedName: "BgpServiceCommunityListResult",
    type: {
        name: "Composite",
        className: "BgpServiceCommunityListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BgpServiceCommunity"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceEndpointPolicyListResult = {
    serializedName: "ServiceEndpointPolicyListResult",
    type: {
        name: "Composite",
        className: "ServiceEndpointPolicyListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceEndpointPolicy"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ServiceEndpointPolicyDefinitionListResult = {
    serializedName: "ServiceEndpointPolicyDefinitionListResult",
    type: {
        name: "Composite",
        className: "ServiceEndpointPolicyDefinitionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ServiceEndpointPolicyDefinition"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var UsagesListResult = {
    serializedName: "UsagesListResult",
    type: {
        name: "Composite",
        className: "UsagesListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Usage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkListResult = {
    serializedName: "VirtualNetworkListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetwork"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkListUsageResult = {
    serializedName: "VirtualNetworkListUsageResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkListUsageResult",
        modelProperties: {
            value: {
                readOnly: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkUsage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var SubnetListResult = {
    serializedName: "SubnetListResult",
    type: {
        name: "Composite",
        className: "SubnetListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Subnet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkPeeringListResult = {
    serializedName: "VirtualNetworkPeeringListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkPeeringListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkPeering"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayListResult = {
    serializedName: "VirtualNetworkGatewayListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGateway"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayListConnectionsResult = {
    serializedName: "VirtualNetworkGatewayListConnectionsResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayListConnectionsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGatewayConnectionListEntity"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkGatewayConnectionListResult = {
    serializedName: "VirtualNetworkGatewayConnectionListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkGatewayConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGatewayConnection"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var LocalNetworkGatewayListResult = {
    serializedName: "LocalNetworkGatewayListResult",
    type: {
        name: "Composite",
        className: "LocalNetworkGatewayListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LocalNetworkGateway"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualNetworkGatewayNatRulesResult = {
    serializedName: "ListVirtualNetworkGatewayNatRulesResult",
    type: {
        name: "Composite",
        className: "ListVirtualNetworkGatewayNatRulesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkGatewayNatRule"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualNetworkTapListResult = {
    serializedName: "VirtualNetworkTapListResult",
    type: {
        name: "Composite",
        className: "VirtualNetworkTapListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualNetworkTap"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualRouterListResult = {
    serializedName: "VirtualRouterListResult",
    type: {
        name: "Composite",
        className: "VirtualRouterListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualRouter"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var VirtualRouterPeeringListResult = {
    serializedName: "VirtualRouterPeeringListResult",
    type: {
        name: "Composite",
        className: "VirtualRouterPeeringListResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualRouterPeering"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualWANsResult = {
    serializedName: "ListVirtualWANsResult",
    type: {
        name: "Composite",
        className: "ListVirtualWANsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualWAN"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnSitesResult = {
    serializedName: "ListVpnSitesResult",
    type: {
        name: "Composite",
        className: "ListVpnSitesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnSite"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnSiteLinksResult = {
    serializedName: "ListVpnSiteLinksResult",
    type: {
        name: "Composite",
        className: "ListVpnSiteLinksResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnSiteLink"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnServerConfigurationsResult = {
    serializedName: "ListVpnServerConfigurationsResult",
    type: {
        name: "Composite",
        className: "ListVpnServerConfigurationsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnServerConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualHubsResult = {
    serializedName: "ListVirtualHubsResult",
    type: {
        name: "Composite",
        className: "ListVirtualHubsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHub"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListHubVirtualNetworkConnectionsResult = {
    serializedName: "ListHubVirtualNetworkConnectionsResult",
    type: {
        name: "Composite",
        className: "ListHubVirtualNetworkConnectionsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HubVirtualNetworkConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnGatewaysResult = {
    serializedName: "ListVpnGatewaysResult",
    type: {
        name: "Composite",
        className: "ListVpnGatewaysResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnGateway"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnSiteLinkConnectionsResult = {
    serializedName: "ListVpnSiteLinkConnectionsResult",
    type: {
        name: "Composite",
        className: "ListVpnSiteLinkConnectionsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnSiteLinkConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnConnectionsResult = {
    serializedName: "ListVpnConnectionsResult",
    type: {
        name: "Composite",
        className: "ListVpnConnectionsResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVpnGatewayNatRulesResult = {
    serializedName: "ListVpnGatewayNatRulesResult",
    type: {
        name: "Composite",
        className: "ListVpnGatewayNatRulesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VpnGatewayNatRule"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListP2SVpnGatewaysResult = {
    serializedName: "ListP2SVpnGatewaysResult",
    type: {
        name: "Composite",
        className: "ListP2SVpnGatewaysResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "P2SVpnGateway"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualHubRouteTableV2sResult = {
    serializedName: "ListVirtualHubRouteTableV2sResult",
    type: {
        name: "Composite",
        className: "ListVirtualHubRouteTableV2sResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualHubRouteTableV2"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualHubBgpConnectionResults = {
    serializedName: "ListVirtualHubBgpConnectionResults",
    type: {
        name: "Composite",
        className: "ListVirtualHubBgpConnectionResults",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "BgpConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListVirtualHubIpConfigurationResults = {
    serializedName: "ListVirtualHubIpConfigurationResults",
    type: {
        name: "Composite",
        className: "ListVirtualHubIpConfigurationResults",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HubIpConfiguration"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var ListHubRouteTablesResult = {
    serializedName: "ListHubRouteTablesResult",
    type: {
        name: "Composite",
        className: "ListHubRouteTablesResult",
        modelProperties: {
            value: {
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "HubRouteTable"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var WebApplicationFirewallPolicyListResult = {
    serializedName: "WebApplicationFirewallPolicyListResult",
    type: {
        name: "Composite",
        className: "WebApplicationFirewallPolicyListResult",
        modelProperties: {
            value: {
                readOnly: true,
                serializedName: "",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "WebApplicationFirewallPolicy"
                        }
                    }
                }
            },
            nextLink: {
                readOnly: true,
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export var discriminators = {
    'FirewallPolicyRuleCollection': FirewallPolicyRuleCollection,
    'FirewallPolicyRule': FirewallPolicyRule,
    'FirewallPolicyRuleCollection.FirewallPolicyNatRuleCollection': FirewallPolicyNatRuleCollection,
    'FirewallPolicyRuleCollection.FirewallPolicyFilterRuleCollection': FirewallPolicyFilterRuleCollection,
    'FirewallPolicyRule.ApplicationRule': ApplicationRule,
    'FirewallPolicyRule.NatRule': NatRule,
    'FirewallPolicyRule.NetworkRule': NetworkRule
};
//# sourceMappingURL=mappers.js.map